------------------------------------------------------------------------------
--$Date: 2010/03/05 10:19:34 $
--$Revision: 1.3 $
------------------------------------------------------------------------------
--   ____  ____
--  /   /\/   /
-- /___/  \  /
-- \   \   \/     Vendor : Xilinx
--  \   \         Version : 2.1
--  /   /         Application : RocketIO GTP Transceiver Wizard
-- /___/   /\     Filename : test.vho
-- \   \  /  \
--  \___\/\___\
--
--
-- Instantiation Template
-- Generated by Xilinx RocketIO GTP Transceiver Wizard
-- 
-- 
-- (c) Copyright 2006-2010 Xilinx, Inc. All rights reserved.
-- 
-- This file contains confidential and proprietary information
-- of Xilinx, Inc. and is protected under U.S. and
-- international copyright and other intellectual property
-- laws.
-- 
-- DISCLAIMER
-- This disclaimer is not a license and does not grant any
-- rights to the materials distributed herewith. Except as
-- otherwise provided in a valid license issued to you by
-- Xilinx, and to the maximum extent permitted by applicable
-- law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
-- WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
-- AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
-- BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
-- INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
-- (2) Xilinx shall not be liable (whether in contract or tort,
-- including negligence, or under any other theory of
-- liability) for any loss or damage of any kind or nature
-- related to, arising under or in connection with these
-- materials, including for any direct, or any indirect,
-- special, incidental, or consequential loss or damage
-- (including loss of data, profits, goodwill, or any type of
-- loss or damage suffered as a result of any action brought
-- by a third party) even if such damage or loss was
-- reasonably foreseeable or Xilinx had been advised of the
-- possibility of the same.
-- 
-- CRITICAL APPLICATIONS
-- Xilinx products are not designed or intended to be fail-
-- safe, or for use in any application requiring fail-safe
-- performance, such as life-support or safety devices or
-- systems, Class III medical devices, nuclear facilities,
-- applications related to the deployment of airbags, or any
-- other applications that could lead to death, personal
-- injury, or severe property or environmental damage
-- (individually and collectively, "Critical
-- Applications"). Customer assumes the sole risk and
-- liability of any use of Xilinx products in Critical
-- Applications, subject only to applicable laws and
-- regulations governing limitations on product liability.
-- 
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
-- PART OF THIS FILE AT ALL TIMES. 


--**************************Component Declarations*****************************


component TEST 
generic
(
    -- Simulation attributes
    WRAPPER_SIM_GTPRESET_SPEEDUP    : integer   := 0; -- Set to 1 to speed up sim reset
    WRAPPER_SIM_PLL_PERDIV2         : bit_vector:= x"1f4" -- Set to the VCO Unit Interval time
);
port
(
    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE0  (Location)

    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE0_RXUSRCLK0_IN                      : in   std_logic;
    TILE0_RXUSRCLK1_IN                      : in   std_logic;
    TILE0_RXUSRCLK20_IN                     : in   std_logic;
    TILE0_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE0_RXN0_IN                           : in   std_logic;
    TILE0_RXN1_IN                           : in   std_logic;
    TILE0_RXP0_IN                           : in   std_logic;
    TILE0_RXP1_IN                           : in   std_logic;
    --------------------- Shared Ports - Tile and PLL Ports --------------------
    TILE0_CLKIN_IN                          : in   std_logic;
    TILE0_GTPRESET_IN                       : in   std_logic;
    TILE0_PLLLKDET_OUT                      : out  std_logic;
    TILE0_REFCLKOUT_OUT                     : out  std_logic;
    TILE0_RESETDONE0_OUT                    : out  std_logic;
    TILE0_RESETDONE1_OUT                    : out  std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE0_TXUSRCLK0_IN                      : in   std_logic;
    TILE0_TXUSRCLK1_IN                      : in   std_logic;
    TILE0_TXUSRCLK20_IN                     : in   std_logic;
    TILE0_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE0_TXDIFFCTRL0_IN                    : in   std_logic_vector(2 downto 0);
    TILE0_TXDIFFCTRL1_IN                    : in   std_logic_vector(2 downto 0);
    TILE0_TXN0_OUT                          : out  std_logic;
    TILE0_TXN1_OUT                          : out  std_logic;
    TILE0_TXP0_OUT                          : out  std_logic;
    TILE0_TXP1_OUT                          : out  std_logic;
    TILE0_TXPREEMPHASIS0_IN                 : in   std_logic_vector(2 downto 0);
    TILE0_TXPREEMPHASIS1_IN                 : in   std_logic_vector(2 downto 0);


    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE1  (Location)

    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE1_RXUSRCLK0_IN                      : in   std_logic;
    TILE1_RXUSRCLK1_IN                      : in   std_logic;
    TILE1_RXUSRCLK20_IN                     : in   std_logic;
    TILE1_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE1_RXN0_IN                           : in   std_logic;
    TILE1_RXN1_IN                           : in   std_logic;
    TILE1_RXP0_IN                           : in   std_logic;
    TILE1_RXP1_IN                           : in   std_logic;
    --------------------- Shared Ports - Tile and PLL Ports --------------------
    TILE1_CLKIN_IN                          : in   std_logic;
    TILE1_GTPRESET_IN                       : in   std_logic;
    TILE1_PLLLKDET_OUT                      : out  std_logic;
    TILE1_REFCLKOUT_OUT                     : out  std_logic;
    TILE1_RESETDONE0_OUT                    : out  std_logic;
    TILE1_RESETDONE1_OUT                    : out  std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE1_TXUSRCLK0_IN                      : in   std_logic;
    TILE1_TXUSRCLK1_IN                      : in   std_logic;
    TILE1_TXUSRCLK20_IN                     : in   std_logic;
    TILE1_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE1_TXDIFFCTRL0_IN                    : in   std_logic_vector(2 downto 0);
    TILE1_TXDIFFCTRL1_IN                    : in   std_logic_vector(2 downto 0);
    TILE1_TXN0_OUT                          : out  std_logic;
    TILE1_TXN1_OUT                          : out  std_logic;
    TILE1_TXP0_OUT                          : out  std_logic;
    TILE1_TXP1_OUT                          : out  std_logic;
    TILE1_TXPREEMPHASIS0_IN                 : in   std_logic_vector(2 downto 0);
    TILE1_TXPREEMPHASIS1_IN                 : in   std_logic_vector(2 downto 0);


    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE2  (Location)

    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE2_RXUSRCLK0_IN                      : in   std_logic;
    TILE2_RXUSRCLK1_IN                      : in   std_logic;
    TILE2_RXUSRCLK20_IN                     : in   std_logic;
    TILE2_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE2_RXN0_IN                           : in   std_logic;
    TILE2_RXN1_IN                           : in   std_logic;
    TILE2_RXP0_IN                           : in   std_logic;
    TILE2_RXP1_IN                           : in   std_logic;
    --------------------- Shared Ports - Tile and PLL Ports --------------------
    TILE2_CLKIN_IN                          : in   std_logic;
    TILE2_GTPRESET_IN                       : in   std_logic;
    TILE2_PLLLKDET_OUT                      : out  std_logic;
    TILE2_REFCLKOUT_OUT                     : out  std_logic;
    TILE2_RESETDONE0_OUT                    : out  std_logic;
    TILE2_RESETDONE1_OUT                    : out  std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE2_TXUSRCLK0_IN                      : in   std_logic;
    TILE2_TXUSRCLK1_IN                      : in   std_logic;
    TILE2_TXUSRCLK20_IN                     : in   std_logic;
    TILE2_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE2_TXDIFFCTRL0_IN                    : in   std_logic_vector(2 downto 0);
    TILE2_TXDIFFCTRL1_IN                    : in   std_logic_vector(2 downto 0);
    TILE2_TXN0_OUT                          : out  std_logic;
    TILE2_TXN1_OUT                          : out  std_logic;
    TILE2_TXP0_OUT                          : out  std_logic;
    TILE2_TXP1_OUT                          : out  std_logic;
    TILE2_TXPREEMPHASIS0_IN                 : in   std_logic_vector(2 downto 0);
    TILE2_TXPREEMPHASIS1_IN                 : in   std_logic_vector(2 downto 0);


    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE3  (Location)

    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE3_RXUSRCLK0_IN                      : in   std_logic;
    TILE3_RXUSRCLK1_IN                      : in   std_logic;
    TILE3_RXUSRCLK20_IN                     : in   std_logic;
    TILE3_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE3_RXN0_IN                           : in   std_logic;
    TILE3_RXN1_IN                           : in   std_logic;
    TILE3_RXP0_IN                           : in   std_logic;
    TILE3_RXP1_IN                           : in   std_logic;
    --------------------- Shared Ports - Tile and PLL Ports --------------------
    TILE3_CLKIN_IN                          : in   std_logic;
    TILE3_GTPRESET_IN                       : in   std_logic;
    TILE3_PLLLKDET_OUT                      : out  std_logic;
    TILE3_REFCLKOUT_OUT                     : out  std_logic;
    TILE3_RESETDONE0_OUT                    : out  std_logic;
    TILE3_RESETDONE1_OUT                    : out  std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE3_TXUSRCLK0_IN                      : in   std_logic;
    TILE3_TXUSRCLK1_IN                      : in   std_logic;
    TILE3_TXUSRCLK20_IN                     : in   std_logic;
    TILE3_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE3_TXDIFFCTRL0_IN                    : in   std_logic_vector(2 downto 0);
    TILE3_TXDIFFCTRL1_IN                    : in   std_logic_vector(2 downto 0);
    TILE3_TXN0_OUT                          : out  std_logic;
    TILE3_TXN1_OUT                          : out  std_logic;
    TILE3_TXP0_OUT                          : out  std_logic;
    TILE3_TXP1_OUT                          : out  std_logic;
    TILE3_TXPREEMPHASIS0_IN                 : in   std_logic_vector(2 downto 0);
    TILE3_TXPREEMPHASIS1_IN                 : in   std_logic_vector(2 downto 0)


);
end component;










    ----------------------------- The GTP Wrapper -----------------------------


    test_i : TEST
    generic map
    (
        WRAPPER_SIM_GTPRESET_SPEEDUP    =>      1,
        WRAPPER_SIM_PLL_PERDIV2         =>      x"1f4"
    )
    port map
    (
        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE0  (X0Y2)

        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE0_RXUSRCLK0_IN              =>      ,
        TILE0_RXUSRCLK1_IN              =>      ,
        TILE0_RXUSRCLK20_IN             =>      ,
        TILE0_RXUSRCLK21_IN             =>      ,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE0_RXN0_IN                   =>      ,
        TILE0_RXN1_IN                   =>      ,
        TILE0_RXP0_IN                   =>      ,
        TILE0_RXP1_IN                   =>      ,
        --------------------- Shared Ports - Tile and PLL Ports --------------------
        TILE0_CLKIN_IN                  =>      ,
        TILE0_GTPRESET_IN               =>      ,
        TILE0_PLLLKDET_OUT              =>      ,
        TILE0_REFCLKOUT_OUT             =>      ,
        TILE0_RESETDONE0_OUT            =>      ,
        TILE0_RESETDONE1_OUT            =>      ,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE0_TXUSRCLK0_IN              =>      ,
        TILE0_TXUSRCLK1_IN              =>      ,
        TILE0_TXUSRCLK20_IN             =>      ,
        TILE0_TXUSRCLK21_IN             =>      ,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE0_TXDIFFCTRL0_IN            =>      ,
        TILE0_TXDIFFCTRL1_IN            =>      ,
        TILE0_TXN0_OUT                  =>      ,
        TILE0_TXN1_OUT                  =>      ,
        TILE0_TXP0_OUT                  =>      ,
        TILE0_TXP1_OUT                  =>      ,
        TILE0_TXPREEMPHASIS0_IN         =>      ,
        TILE0_TXPREEMPHASIS1_IN         =>      ,


        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE1  (X0Y3)

        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE1_RXUSRCLK0_IN              =>      ,
        TILE1_RXUSRCLK1_IN              =>      ,
        TILE1_RXUSRCLK20_IN             =>      ,
        TILE1_RXUSRCLK21_IN             =>      ,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE1_RXN0_IN                   =>      ,
        TILE1_RXN1_IN                   =>      ,
        TILE1_RXP0_IN                   =>      ,
        TILE1_RXP1_IN                   =>      ,
        --------------------- Shared Ports - Tile and PLL Ports --------------------
        TILE1_CLKIN_IN                  =>      ,
        TILE1_GTPRESET_IN               =>      ,
        TILE1_PLLLKDET_OUT              =>      ,
        TILE1_REFCLKOUT_OUT             =>      ,
        TILE1_RESETDONE0_OUT            =>      ,
        TILE1_RESETDONE1_OUT            =>      ,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE1_TXUSRCLK0_IN              =>      ,
        TILE1_TXUSRCLK1_IN              =>      ,
        TILE1_TXUSRCLK20_IN             =>      ,
        TILE1_TXUSRCLK21_IN             =>      ,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE1_TXDIFFCTRL0_IN            =>      ,
        TILE1_TXDIFFCTRL1_IN            =>      ,
        TILE1_TXN0_OUT                  =>      ,
        TILE1_TXN1_OUT                  =>      ,
        TILE1_TXP0_OUT                  =>      ,
        TILE1_TXP1_OUT                  =>      ,
        TILE1_TXPREEMPHASIS0_IN         =>      ,
        TILE1_TXPREEMPHASIS1_IN         =>      ,


        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE2  (X0Y4)

        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE2_RXUSRCLK0_IN              =>      ,
        TILE2_RXUSRCLK1_IN              =>      ,
        TILE2_RXUSRCLK20_IN             =>      ,
        TILE2_RXUSRCLK21_IN             =>      ,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE2_RXN0_IN                   =>      ,
        TILE2_RXN1_IN                   =>      ,
        TILE2_RXP0_IN                   =>      ,
        TILE2_RXP1_IN                   =>      ,
        --------------------- Shared Ports - Tile and PLL Ports --------------------
        TILE2_CLKIN_IN                  =>      ,
        TILE2_GTPRESET_IN               =>      ,
        TILE2_PLLLKDET_OUT              =>      ,
        TILE2_REFCLKOUT_OUT             =>      ,
        TILE2_RESETDONE0_OUT            =>      ,
        TILE2_RESETDONE1_OUT            =>      ,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE2_TXUSRCLK0_IN              =>      ,
        TILE2_TXUSRCLK1_IN              =>      ,
        TILE2_TXUSRCLK20_IN             =>      ,
        TILE2_TXUSRCLK21_IN             =>      ,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE2_TXDIFFCTRL0_IN            =>      ,
        TILE2_TXDIFFCTRL1_IN            =>      ,
        TILE2_TXN0_OUT                  =>      ,
        TILE2_TXN1_OUT                  =>      ,
        TILE2_TXP0_OUT                  =>      ,
        TILE2_TXP1_OUT                  =>      ,
        TILE2_TXPREEMPHASIS0_IN         =>      ,
        TILE2_TXPREEMPHASIS1_IN         =>      ,


        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE3  (X0Y5)

        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE3_RXUSRCLK0_IN              =>      ,
        TILE3_RXUSRCLK1_IN              =>      ,
        TILE3_RXUSRCLK20_IN             =>      ,
        TILE3_RXUSRCLK21_IN             =>      ,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE3_RXN0_IN                   =>      ,
        TILE3_RXN1_IN                   =>      ,
        TILE3_RXP0_IN                   =>      ,
        TILE3_RXP1_IN                   =>      ,
        --------------------- Shared Ports - Tile and PLL Ports --------------------
        TILE3_CLKIN_IN                  =>      ,
        TILE3_GTPRESET_IN               =>      ,
        TILE3_PLLLKDET_OUT              =>      ,
        TILE3_REFCLKOUT_OUT             =>      ,
        TILE3_RESETDONE0_OUT            =>      ,
        TILE3_RESETDONE1_OUT            =>      ,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE3_TXUSRCLK0_IN              =>      ,
        TILE3_TXUSRCLK1_IN              =>      ,
        TILE3_TXUSRCLK20_IN             =>      ,
        TILE3_TXUSRCLK21_IN             =>      ,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE3_TXDIFFCTRL0_IN            =>      ,
        TILE3_TXDIFFCTRL1_IN            =>      ,
        TILE3_TXN0_OUT                  =>      ,
        TILE3_TXN1_OUT                  =>      ,
        TILE3_TXP0_OUT                  =>      ,
        TILE3_TXP1_OUT                  =>      ,
        TILE3_TXPREEMPHASIS0_IN         =>      ,
        TILE3_TXPREEMPHASIS1_IN         =>      


    );



    -----------------------Dedicated GTP Reference Clock Inputs ---------------
    -- Each dedicated refclk you are using in your design will need its own IBUFDS instance
    
    tile0_refclk_ibufds_i : IBUFDS
    port map
    (
        O                               =>      ,
        I                               =>      ,  -- Connect to package pin AK4
        IB                              =>        -- Connect to package pin AK3
    );

    tile1_refclk_ibufds_i : IBUFDS
    port map
    (
        O                               =>      ,
        I                               =>      ,  -- Connect to package pin AD4
        IB                              =>        -- Connect to package pin AD3
    );

    tile2_refclk_ibufds_i : IBUFDS
    port map
    (
        O                               =>      ,
        I                               =>      ,  -- Connect to package pin V4
        IB                              =>        -- Connect to package pin V3
    );

    tile3_refclk_ibufds_i : IBUFDS
    port map
    (
        O                               =>      ,
        I                               =>      ,  -- Connect to package pin M4
        IB                              =>        -- Connect to package pin M3
    );



















