------------------------------------------------------------------------------
--$Date: 2010/06/25 15:58:07 $
--$Revision: 1.7 $
------------------------------------------------------------------------------
--   ____  ____
--  /   /\/   /
-- /___/  \  /
-- \   \   \/     Vendor : Xilinx
--  \   \         Version : 2.1
--  /   /         Application : RocketIO GTP Transceiver Wizard
-- /___/   /\     Filename : test_top.vhd
-- \   \  /  \
--  \___\/\___\
--
--
-- Module TEST_TOP
-- Generated by Xilinx RocketIO GTP Transceiver Wizard
-- 
-- 
-- (c) Copyright 2006-2010 Xilinx, Inc. All rights reserved.
-- 
-- This file contains confidential and proprietary information
-- of Xilinx, Inc. and is protected under U.S. and
-- international copyright and other intellectual property
-- laws.
-- 
-- DISCLAIMER
-- This disclaimer is not a license and does not grant any
-- rights to the materials distributed herewith. Except as
-- otherwise provided in a valid license issued to you by
-- Xilinx, and to the maximum extent permitted by applicable
-- law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
-- WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
-- AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
-- BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
-- INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
-- (2) Xilinx shall not be liable (whether in contract or tort,
-- including negligence, or under any other theory of
-- liability) for any loss or damage of any kind or nature
-- related to, arising under or in connection with these
-- materials, including for any direct, or any indirect,
-- special, incidental, or consequential loss or damage
-- (including loss of data, profits, goodwill, or any type of
-- loss or damage suffered as a result of any action brought
-- by a third party) even if such damage or loss was
-- reasonably foreseeable or Xilinx had been advised of the
-- possibility of the same.
-- 
-- CRITICAL APPLICATIONS
-- Xilinx products are not designed or intended to be fail-
-- safe, or for use in any application requiring fail-safe
-- performance, such as life-support or safety devices or
-- systems, Class III medical devices, nuclear facilities,
-- applications related to the deployment of airbags, or any
-- other applications that could lead to death, personal
-- injury, or severe property or environmental damage
-- (individually and collectively, "Critical
-- Applications"). Customer assumes the sole risk and
-- liability of any use of Xilinx products in Critical
-- Applications, subject only to applicable laws and
-- regulations governing limitations on product liability.
-- 
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
-- PART OF THIS FILE AT ALL TIMES. 


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;


--***********************************Entity Declaration************************

entity TEST_TOP is
generic
(
    EXAMPLE_CONFIG_INDEPENDENT_LANES        : integer   := 1;
    EXAMPLE_LANE_WITH_START_CHAR            : integer   := 0;
    EXAMPLE_WORDS_IN_BRAM                   : integer   := 512;
    EXAMPLE_SIM_MODE                        : string    := "FAST";
    EXAMPLE_SIM_GTPRESET_SPEEDUP            : integer   := 1;
    EXAMPLE_SIM_PLL_PERDIV2                 : bit_vector:= x"1f4";
    EXAMPLE_USE_CHIPSCOPE                   : integer   := 1     -- Set to 1 to use Chipscope to drive resets
);
port
(
    TILE0_REFCLK_PAD_N_IN                   : in   std_logic;
    TILE0_REFCLK_PAD_P_IN                   : in   std_logic;
    TILE1_REFCLK_PAD_N_IN                   : in   std_logic;
    TILE1_REFCLK_PAD_P_IN                   : in   std_logic;
    TILE2_REFCLK_PAD_N_IN                   : in   std_logic;
    TILE2_REFCLK_PAD_P_IN                   : in   std_logic;
    TILE3_REFCLK_PAD_N_IN                   : in   std_logic;
    TILE3_REFCLK_PAD_P_IN                   : in   std_logic;
    GTPRESET_IN                             : in   std_logic;
    TILE0_PLLLKDET_OUT                      : out  std_logic;
    TILE1_PLLLKDET_OUT                      : out  std_logic;
    TILE2_PLLLKDET_OUT                      : out  std_logic;
    TILE3_PLLLKDET_OUT                      : out  std_logic;
    TRACK_DATA_OUT                          : out  std_logic;
    RXN_IN                                  : in   std_logic_vector(7 downto 0);
    RXP_IN                                  : in   std_logic_vector(7 downto 0);
    TXN_OUT                                 : out  std_logic_vector(7 downto 0);
    TXP_OUT                                 : out  std_logic_vector(7 downto 0)
    
);

    attribute X_CORE_INFO : string;
    attribute X_CORE_INFO of TEST_TOP : entity is "v5_gtpwizard_v2_1, Coregen v12.1";

end TEST_TOP;
    
architecture RTL of TEST_TOP is

--**************************Component Declarations*****************************


component TEST 
generic
(
    -- Simulation attributes
    WRAPPER_SIM_MODE                : string    := "FAST"; -- Set to Fast Functional Simulation Model    
    WRAPPER_SIM_GTPRESET_SPEEDUP    : integer   := 0; -- Set to 1 to speed up sim reset
    WRAPPER_SIM_PLL_PERDIV2         : bit_vector:= x"1f4" -- Set to the VCO Unit Interval time
);
port
(
    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE0  (Location)

    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE0_RXUSRCLK0_IN                      : in   std_logic;
    TILE0_RXUSRCLK1_IN                      : in   std_logic;
    TILE0_RXUSRCLK20_IN                     : in   std_logic;
    TILE0_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE0_RXN0_IN                           : in   std_logic;
    TILE0_RXN1_IN                           : in   std_logic;
    TILE0_RXP0_IN                           : in   std_logic;
    TILE0_RXP1_IN                           : in   std_logic;
    --------------------- Shared Ports - Tile and PLL Ports --------------------
    TILE0_CLKIN_IN                          : in   std_logic;
    TILE0_GTPRESET_IN                       : in   std_logic;
    TILE0_PLLLKDET_OUT                      : out  std_logic;
    TILE0_REFCLKOUT_OUT                     : out  std_logic;
    TILE0_RESETDONE0_OUT                    : out  std_logic;
    TILE0_RESETDONE1_OUT                    : out  std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE0_TXUSRCLK0_IN                      : in   std_logic;
    TILE0_TXUSRCLK1_IN                      : in   std_logic;
    TILE0_TXUSRCLK20_IN                     : in   std_logic;
    TILE0_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE0_TXDIFFCTRL0_IN                    : in   std_logic_vector(2 downto 0);
    TILE0_TXDIFFCTRL1_IN                    : in   std_logic_vector(2 downto 0);
    TILE0_TXN0_OUT                          : out  std_logic;
    TILE0_TXN1_OUT                          : out  std_logic;
    TILE0_TXP0_OUT                          : out  std_logic;
    TILE0_TXP1_OUT                          : out  std_logic;
    TILE0_TXPREEMPHASIS0_IN                 : in   std_logic_vector(2 downto 0);
    TILE0_TXPREEMPHASIS1_IN                 : in   std_logic_vector(2 downto 0);


    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE1  (Location)

    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE1_RXUSRCLK0_IN                      : in   std_logic;
    TILE1_RXUSRCLK1_IN                      : in   std_logic;
    TILE1_RXUSRCLK20_IN                     : in   std_logic;
    TILE1_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE1_RXN0_IN                           : in   std_logic;
    TILE1_RXN1_IN                           : in   std_logic;
    TILE1_RXP0_IN                           : in   std_logic;
    TILE1_RXP1_IN                           : in   std_logic;
    --------------------- Shared Ports - Tile and PLL Ports --------------------
    TILE1_CLKIN_IN                          : in   std_logic;
    TILE1_GTPRESET_IN                       : in   std_logic;
    TILE1_PLLLKDET_OUT                      : out  std_logic;
    TILE1_REFCLKOUT_OUT                     : out  std_logic;
    TILE1_RESETDONE0_OUT                    : out  std_logic;
    TILE1_RESETDONE1_OUT                    : out  std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE1_TXUSRCLK0_IN                      : in   std_logic;
    TILE1_TXUSRCLK1_IN                      : in   std_logic;
    TILE1_TXUSRCLK20_IN                     : in   std_logic;
    TILE1_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE1_TXDIFFCTRL0_IN                    : in   std_logic_vector(2 downto 0);
    TILE1_TXDIFFCTRL1_IN                    : in   std_logic_vector(2 downto 0);
    TILE1_TXN0_OUT                          : out  std_logic;
    TILE1_TXN1_OUT                          : out  std_logic;
    TILE1_TXP0_OUT                          : out  std_logic;
    TILE1_TXP1_OUT                          : out  std_logic;
    TILE1_TXPREEMPHASIS0_IN                 : in   std_logic_vector(2 downto 0);
    TILE1_TXPREEMPHASIS1_IN                 : in   std_logic_vector(2 downto 0);


    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE2  (Location)

    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE2_RXUSRCLK0_IN                      : in   std_logic;
    TILE2_RXUSRCLK1_IN                      : in   std_logic;
    TILE2_RXUSRCLK20_IN                     : in   std_logic;
    TILE2_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE2_RXN0_IN                           : in   std_logic;
    TILE2_RXN1_IN                           : in   std_logic;
    TILE2_RXP0_IN                           : in   std_logic;
    TILE2_RXP1_IN                           : in   std_logic;
    --------------------- Shared Ports - Tile and PLL Ports --------------------
    TILE2_CLKIN_IN                          : in   std_logic;
    TILE2_GTPRESET_IN                       : in   std_logic;
    TILE2_PLLLKDET_OUT                      : out  std_logic;
    TILE2_REFCLKOUT_OUT                     : out  std_logic;
    TILE2_RESETDONE0_OUT                    : out  std_logic;
    TILE2_RESETDONE1_OUT                    : out  std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE2_TXUSRCLK0_IN                      : in   std_logic;
    TILE2_TXUSRCLK1_IN                      : in   std_logic;
    TILE2_TXUSRCLK20_IN                     : in   std_logic;
    TILE2_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE2_TXDIFFCTRL0_IN                    : in   std_logic_vector(2 downto 0);
    TILE2_TXDIFFCTRL1_IN                    : in   std_logic_vector(2 downto 0);
    TILE2_TXN0_OUT                          : out  std_logic;
    TILE2_TXN1_OUT                          : out  std_logic;
    TILE2_TXP0_OUT                          : out  std_logic;
    TILE2_TXP1_OUT                          : out  std_logic;
    TILE2_TXPREEMPHASIS0_IN                 : in   std_logic_vector(2 downto 0);
    TILE2_TXPREEMPHASIS1_IN                 : in   std_logic_vector(2 downto 0);


    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE3  (Location)

    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE3_RXUSRCLK0_IN                      : in   std_logic;
    TILE3_RXUSRCLK1_IN                      : in   std_logic;
    TILE3_RXUSRCLK20_IN                     : in   std_logic;
    TILE3_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE3_RXN0_IN                           : in   std_logic;
    TILE3_RXN1_IN                           : in   std_logic;
    TILE3_RXP0_IN                           : in   std_logic;
    TILE3_RXP1_IN                           : in   std_logic;
    --------------------- Shared Ports - Tile and PLL Ports --------------------
    TILE3_CLKIN_IN                          : in   std_logic;
    TILE3_GTPRESET_IN                       : in   std_logic;
    TILE3_PLLLKDET_OUT                      : out  std_logic;
    TILE3_REFCLKOUT_OUT                     : out  std_logic;
    TILE3_RESETDONE0_OUT                    : out  std_logic;
    TILE3_RESETDONE1_OUT                    : out  std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE3_TXUSRCLK0_IN                      : in   std_logic;
    TILE3_TXUSRCLK1_IN                      : in   std_logic;
    TILE3_TXUSRCLK20_IN                     : in   std_logic;
    TILE3_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE3_TXDIFFCTRL0_IN                    : in   std_logic_vector(2 downto 0);
    TILE3_TXDIFFCTRL1_IN                    : in   std_logic_vector(2 downto 0);
    TILE3_TXN0_OUT                          : out  std_logic;
    TILE3_TXN1_OUT                          : out  std_logic;
    TILE3_TXP0_OUT                          : out  std_logic;
    TILE3_TXP1_OUT                          : out  std_logic;
    TILE3_TXPREEMPHASIS0_IN                 : in   std_logic_vector(2 downto 0);
    TILE3_TXPREEMPHASIS1_IN                 : in   std_logic_vector(2 downto 0)


);
end component;


component MGT_USRCLK_SOURCE 
generic
(
    FREQUENCY_MODE   : string   := "LOW";    
    PERFORMANCE_MODE : string   := "MAX_SPEED"    
);
port
(
    DIV1_OUT                : out std_logic;
    DIV2_OUT                : out std_logic;
    DCM_LOCKED_OUT          : out std_logic;
    CLK_IN                  : in  std_logic;
    DCM_RESET_IN            : in  std_logic

);
end component;

component FRAME_GEN 
generic
(
    WORDS_IN_BRAM : integer    :=   256;
    MEM_00       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_01       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_02       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_03       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_04       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_05       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_06       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_07       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_08       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_09       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0A       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0B       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0C       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0D       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0E       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0F       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_10       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_11       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_12       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_13       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_14       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_15       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_16       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_17       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_18       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_19       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1A       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1B       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1C       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1D       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1E       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1F       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_20       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_21       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_22       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_23       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_24       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_25       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_26       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_27       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_28       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_29       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2A       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2B       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2C       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2D       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2E       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2F       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_30       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_31       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_32       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_33       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_34       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_35       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_36       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_37       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_38       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_39       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3A       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3B       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3C       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3D       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3E       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3F       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_00      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_01      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_02      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_03      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_04      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_05      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_06      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_07      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000"
);    
port
(
    -- User Interface
    TX_DATA             : out   std_logic_vector(31 downto 0);
    TX_CHARISK          : out   std_logic_vector(3 downto 0); 

    -- System Interface
    USER_CLK            : in    std_logic;
    SYSTEM_RESET        : in    std_logic
); 
end component;

component FRAME_CHECK 
generic
(
    RX_DATA_WIDTH            : integer := 16;
    USE_COMMA                : integer := 1;
    WORDS_IN_BRAM            : integer := 256;
    CONFIG_INDEPENDENT_LANES : integer := 0;
    START_OF_PACKET_CHAR     : std_logic_vector := x"55fb";
    MEM_00       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_01       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_02       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_03       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_04       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_05       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_06       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_07       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_08       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_09       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0A       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0B       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0C       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0D       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0E       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0F       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_10       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_11       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_12       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_13       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_14       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_15       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_16       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_17       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_18       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_19       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1A       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1B       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1C       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1D       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1E       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1F       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_20       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_21       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_22       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_23       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_24       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_25       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_26       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_27       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_28       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_29       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2A       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2B       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2C       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2D       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2E       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2F       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_30       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_31       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_32       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_33       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_34       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_35       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_36       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_37       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_38       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_39       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3A       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3B       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3C       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3D       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3E       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3F       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_00      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_01      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_02      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_03      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_04      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_05      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_06      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_07      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000"
);
port
(
    -- User Interface
    RX_DATA                  : in  std_logic_vector((RX_DATA_WIDTH-1) downto 0); 
    RX_ENMCOMMA_ALIGN        : out std_logic;
    RX_ENPCOMMA_ALIGN        : out std_logic;
    RX_ENCHAN_SYNC           : out std_logic; 

    -- Control Interface
    INC_IN                   : in std_logic; 
    INC_OUT                  : out std_logic; 
    PATTERN_MATCH_N          : out std_logic;
    RESET_ON_ERROR           : in std_logic; 
    
    -- Error Monitoring
    ERROR_COUNT              : out std_logic_vector(7 downto 0);

    -- System Interface
    USER_CLK                 : in std_logic;
    SYSTEM_RESET             : in std_logic;
    TRACK_DATA               : out std_logic     
  
);
end component;

component MGT_USRCLK_SOURCE_PLL 
generic
(
    MULT                 : integer          := 2;
    DIVIDE               : integer          := 2;    
    CLK_PERIOD           : real             := 10.0;
    OUT0_DIVIDE          : integer          := 2;
    OUT1_DIVIDE          : integer          := 2;
    OUT2_DIVIDE          : integer          := 2;
    OUT3_DIVIDE          : integer          := 2;
    SIMULATION_P         : integer          := 1;
    LOCK_WAIT_COUNT      : std_logic_vector := "1000001000110101"    
);
port
( 
    CLK0_OUT                : out std_logic;
    CLK1_OUT                : out std_logic;
    CLK2_OUT                : out std_logic;
    CLK3_OUT                : out std_logic;
    CLK_IN                  : in  std_logic;
    PLL_LOCKED_OUT          : out std_logic;
    PLL_RESET_IN            : in  std_logic
);
end component;





-- Chipscope modules
attribute syn_black_box                : boolean;
attribute syn_noprune                  : boolean;


component shared_vio
port
(
    control                 : in  std_logic_vector(35 downto 0);
    async_in                : in  std_logic_vector(31 downto 0);
    async_out               : out std_logic_vector(31 downto 0)
);
end component;
attribute syn_black_box of shared_vio : component is TRUE;
attribute syn_noprune of shared_vio   : component is TRUE;


component icon
port
(
    control0                : out std_logic_vector(35 downto 0);
    control1                : out std_logic_vector(35 downto 0);
    control2                : out std_logic_vector(35 downto 0);
    control3                : out std_logic_vector(35 downto 0);
    control4                : out std_logic_vector(35 downto 0);
    control5                : out std_logic_vector(35 downto 0);
    control6                : out std_logic_vector(35 downto 0)
);
end component;
attribute syn_black_box of icon : component is TRUE;
attribute syn_noprune of icon   : component is TRUE;


component ila
port
(
    control                 : in  std_logic_vector(35 downto 0);
    clk                     : in  std_logic;
    trig0                   : in  std_logic_vector(63 downto 0)
);
end component;
attribute syn_black_box of ila : component is TRUE;
attribute syn_noprune of ila   : component is TRUE;


--***********************************Parameter Declarations********************

    constant DLY : time := 1 ns;
    
--************************** Register Declarations ****************************

    signal     tile0_rx_resetdone0_r           : std_logic;
    signal     tile0_rx_resetdone0_r2          : std_logic;
    signal     tile0_rx_resetdone1_r           : std_logic;
    signal     tile0_rx_resetdone1_r2          : std_logic;
    signal     tile1_rx_resetdone0_r           : std_logic;
    signal     tile1_rx_resetdone0_r2          : std_logic;
    signal     tile1_rx_resetdone1_r           : std_logic;
    signal     tile1_rx_resetdone1_r2          : std_logic;
    signal     tile2_rx_resetdone0_r           : std_logic;
    signal     tile2_rx_resetdone0_r2          : std_logic;
    signal     tile2_rx_resetdone1_r           : std_logic;
    signal     tile2_rx_resetdone1_r2          : std_logic;
    signal     tile3_rx_resetdone0_r           : std_logic;
    signal     tile3_rx_resetdone0_r2          : std_logic;
    signal     tile3_rx_resetdone1_r           : std_logic;
    signal     tile3_rx_resetdone1_r2          : std_logic;
 
    

--**************************** Wire Declarations ******************************

    -------------------------- MGT Wrapper Wires ------------------------------
    --________________________________________________________________________
    --________________________________________________________________________
    --TILE0   (X0Y2)

    --------------------- Shared Ports - Tile and PLL Ports --------------------
    signal  tile0_gtpreset_i                : std_logic;
    signal  tile0_plllkdet_i                : std_logic;
    signal  tile0_refclkout_i               : std_logic;
    signal  tile0_resetdone0_i              : std_logic;
    signal  tile0_resetdone1_i              : std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    signal  tile0_txdiffctrl0_i             : std_logic_vector(2 downto 0);
    signal  tile0_txdiffctrl1_i             : std_logic_vector(2 downto 0);
    signal  tile0_txpreemphasis0_i          : std_logic_vector(2 downto 0);
    signal  tile0_txpreemphasis1_i          : std_logic_vector(2 downto 0);


    --________________________________________________________________________
    --________________________________________________________________________
    --TILE1   (X0Y3)

    --------------------- Shared Ports - Tile and PLL Ports --------------------
    signal  tile1_gtpreset_i                : std_logic;
    signal  tile1_plllkdet_i                : std_logic;
    signal  tile1_refclkout_i               : std_logic;
    signal  tile1_resetdone0_i              : std_logic;
    signal  tile1_resetdone1_i              : std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    signal  tile1_txdiffctrl0_i             : std_logic_vector(2 downto 0);
    signal  tile1_txdiffctrl1_i             : std_logic_vector(2 downto 0);
    signal  tile1_txpreemphasis0_i          : std_logic_vector(2 downto 0);
    signal  tile1_txpreemphasis1_i          : std_logic_vector(2 downto 0);


    --________________________________________________________________________
    --________________________________________________________________________
    --TILE2   (X0Y4)

    --------------------- Shared Ports - Tile and PLL Ports --------------------
    signal  tile2_gtpreset_i                : std_logic;
    signal  tile2_plllkdet_i                : std_logic;
    signal  tile2_refclkout_i               : std_logic;
    signal  tile2_resetdone0_i              : std_logic;
    signal  tile2_resetdone1_i              : std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    signal  tile2_txdiffctrl0_i             : std_logic_vector(2 downto 0);
    signal  tile2_txdiffctrl1_i             : std_logic_vector(2 downto 0);
    signal  tile2_txpreemphasis0_i          : std_logic_vector(2 downto 0);
    signal  tile2_txpreemphasis1_i          : std_logic_vector(2 downto 0);


    --________________________________________________________________________
    --________________________________________________________________________
    --TILE3   (X0Y5)

    --------------------- Shared Ports - Tile and PLL Ports --------------------
    signal  tile3_gtpreset_i                : std_logic;
    signal  tile3_plllkdet_i                : std_logic;
    signal  tile3_refclkout_i               : std_logic;
    signal  tile3_resetdone0_i              : std_logic;
    signal  tile3_resetdone1_i              : std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    signal  tile3_txdiffctrl0_i             : std_logic_vector(2 downto 0);
    signal  tile3_txdiffctrl1_i             : std_logic_vector(2 downto 0);
    signal  tile3_txpreemphasis0_i          : std_logic_vector(2 downto 0);
    signal  tile3_txpreemphasis1_i          : std_logic_vector(2 downto 0);


    ------------------------------- Global Signals -----------------------------
    signal  tile0_tx_system_reset0_c        : std_logic;
    signal  tile0_rx_system_reset0_c        : std_logic;
    signal  tile0_rxreset0_i                : std_logic;
    signal  tile0_txreset0_i                : std_logic;
    signal  tile0_tx_system_reset1_c        : std_logic;
    signal  tile0_rx_system_reset1_c        : std_logic;
    signal  tile0_rxreset1_i                : std_logic;
    signal  tile0_txreset1_i                : std_logic;
    signal  tile1_tx_system_reset0_c        : std_logic;
    signal  tile1_rx_system_reset0_c        : std_logic;
    signal  tile1_rxreset0_i                : std_logic;
    signal  tile1_txreset0_i                : std_logic;
    signal  tile1_tx_system_reset1_c        : std_logic;
    signal  tile1_rx_system_reset1_c        : std_logic;
    signal  tile1_rxreset1_i                : std_logic;
    signal  tile1_txreset1_i                : std_logic;
    signal  tile2_tx_system_reset0_c        : std_logic;
    signal  tile2_rx_system_reset0_c        : std_logic;
    signal  tile2_rxreset0_i                : std_logic;
    signal  tile2_txreset0_i                : std_logic;
    signal  tile2_tx_system_reset1_c        : std_logic;
    signal  tile2_rx_system_reset1_c        : std_logic;
    signal  tile2_rxreset1_i                : std_logic;
    signal  tile2_txreset1_i                : std_logic;
    signal  tile3_tx_system_reset0_c        : std_logic;
    signal  tile3_rx_system_reset0_c        : std_logic;
    signal  tile3_rxreset0_i                : std_logic;
    signal  tile3_txreset0_i                : std_logic;
    signal  tile3_tx_system_reset1_c        : std_logic;
    signal  tile3_rx_system_reset1_c        : std_logic;
    signal  tile3_rxreset1_i                : std_logic;
    signal  tile3_txreset1_i                : std_logic;
    signal  tied_to_ground_i                : std_logic;
    signal  tied_to_ground_vec_i            : std_logic_vector(63 downto 0);
    signal  tied_to_vcc_i                   : std_logic;
    signal  tied_to_vcc_vec_i               : std_logic_vector(7 downto 0);
    signal  drp_clk_in_i                    : std_logic;
    signal  tile0_refclkout_bufg_i          : std_logic;
    
    
    ----------------------------- User Clocks ---------------------------------


    ----------------------- Frame check/gen Module Signals --------------------
    signal  tile0_refclk_i                  : std_logic;
    signal  tile0_matchn0_i                 : std_logic;
    signal  tile0_track_data0_i             : std_logic;    
    signal  tile0_txcharisk0_float_i        : std_logic_vector(2 downto 0);
    signal  tile0_txdata0_float_i           : std_logic_vector(21 downto 0);
    signal  tile0_error_count0_i            : std_logic_vector(7 downto 0);
    signal  tile0_frame_check0_reset_i      : std_logic;
    signal  tile0_inc_in0_i                 : std_logic;
    signal  tile0_inc_out0_i                : std_logic;
    signal  tile0_matchn1_i                 : std_logic;
    signal  tile0_track_data1_i             : std_logic;    
    signal  tile0_txcharisk1_float_i        : std_logic_vector(2 downto 0);
    signal  tile0_txdata1_float_i           : std_logic_vector(21 downto 0);
    signal  tile0_error_count1_i            : std_logic_vector(7 downto 0);
    signal  tile0_frame_check1_reset_i      : std_logic;
    signal  tile0_inc_in1_i                 : std_logic;
    signal  tile0_inc_out1_i                : std_logic;

    signal  tile1_refclk_i                  : std_logic;
    signal  tile1_matchn0_i                 : std_logic;
    signal  tile1_track_data0_i             : std_logic;    
    signal  tile1_txcharisk0_float_i        : std_logic_vector(2 downto 0);
    signal  tile1_txdata0_float_i           : std_logic_vector(21 downto 0);
    signal  tile1_error_count0_i            : std_logic_vector(7 downto 0);
    signal  tile1_frame_check0_reset_i      : std_logic;
    signal  tile1_inc_in0_i                 : std_logic;
    signal  tile1_inc_out0_i                : std_logic;
    signal  tile1_matchn1_i                 : std_logic;
    signal  tile1_track_data1_i             : std_logic;    
    signal  tile1_txcharisk1_float_i        : std_logic_vector(2 downto 0);
    signal  tile1_txdata1_float_i           : std_logic_vector(21 downto 0);
    signal  tile1_error_count1_i            : std_logic_vector(7 downto 0);
    signal  tile1_frame_check1_reset_i      : std_logic;
    signal  tile1_inc_in1_i                 : std_logic;
    signal  tile1_inc_out1_i                : std_logic;

    signal  tile2_refclk_i                  : std_logic;
    signal  tile2_matchn0_i                 : std_logic;
    signal  tile2_track_data0_i             : std_logic;    
    signal  tile2_txcharisk0_float_i        : std_logic_vector(2 downto 0);
    signal  tile2_txdata0_float_i           : std_logic_vector(21 downto 0);
    signal  tile2_error_count0_i            : std_logic_vector(7 downto 0);
    signal  tile2_frame_check0_reset_i      : std_logic;
    signal  tile2_inc_in0_i                 : std_logic;
    signal  tile2_inc_out0_i                : std_logic;
    signal  tile2_matchn1_i                 : std_logic;
    signal  tile2_track_data1_i             : std_logic;    
    signal  tile2_txcharisk1_float_i        : std_logic_vector(2 downto 0);
    signal  tile2_txdata1_float_i           : std_logic_vector(21 downto 0);
    signal  tile2_error_count1_i            : std_logic_vector(7 downto 0);
    signal  tile2_frame_check1_reset_i      : std_logic;
    signal  tile2_inc_in1_i                 : std_logic;
    signal  tile2_inc_out1_i                : std_logic;

    signal  tile3_refclk_i                  : std_logic;
    signal  tile3_matchn0_i                 : std_logic;
    signal  tile3_track_data0_i             : std_logic;    
    signal  tile3_txcharisk0_float_i        : std_logic_vector(2 downto 0);
    signal  tile3_txdata0_float_i           : std_logic_vector(21 downto 0);
    signal  tile3_error_count0_i            : std_logic_vector(7 downto 0);
    signal  tile3_frame_check0_reset_i      : std_logic;
    signal  tile3_inc_in0_i                 : std_logic;
    signal  tile3_inc_out0_i                : std_logic;
    signal  tile3_matchn1_i                 : std_logic;
    signal  tile3_track_data1_i             : std_logic;    
    signal  tile3_txcharisk1_float_i        : std_logic_vector(2 downto 0);
    signal  tile3_txdata1_float_i           : std_logic_vector(21 downto 0);
    signal  tile3_error_count1_i            : std_logic_vector(7 downto 0);
    signal  tile3_frame_check1_reset_i      : std_logic;
    signal  tile3_inc_in1_i                 : std_logic;
    signal  tile3_inc_out1_i                : std_logic;

    signal  reset_on_data_error_i           : std_logic;
    
    ------------------------- Sync Module Signals -----------------------------
    signal  tx_sync_done_i                  : std_logic;
    
    signal  reset_txsync_c                  : std_logic;
    signal    track_data_out_i                : std_logic;

    ----------------------- Chipscope Signals ---------------------------------

    signal  shared_vio_control_i            : std_logic_vector(35 downto 0);
    signal  tx_data_vio_control0_i          : std_logic_vector(35 downto 0);
    signal  rx_data_vio_control0_i          : std_logic_vector(35 downto 0);
    signal  ila_control0_i                  : std_logic_vector(35 downto 0);
    signal  tx_data_vio_control1_i          : std_logic_vector(35 downto 0);
    signal  rx_data_vio_control1_i          : std_logic_vector(35 downto 0);
    signal  ila_control1_i                  : std_logic_vector(35 downto 0);
    signal  shared_vio_in_i                 : std_logic_vector(31 downto 0);
    signal  shared_vio_out_i                : std_logic_vector(31 downto 0);
    signal  tx_data_vio_in0_i               : std_logic_vector(31 downto 0);
    signal  tx_data_vio_out0_i              : std_logic_vector(31 downto 0);
    signal  tx_data_vio_in1_i               : std_logic_vector(31 downto 0);
    signal  tx_data_vio_out1_i              : std_logic_vector(31 downto 0);
    signal  rx_data_vio_in0_i               : std_logic_vector(31 downto 0);
    signal  rx_data_vio_out0_i              : std_logic_vector(31 downto 0);
    signal  rx_data_vio_in1_i               : std_logic_vector(31 downto 0);
    signal  rx_data_vio_out1_i              : std_logic_vector(31 downto 0);
    signal  ila_in0_i                       : std_logic_vector(63 downto 0);
    signal  ila_in1_i                       : std_logic_vector(63 downto 0);

    signal  tile0_tx_data_vio_in0_i         : std_logic_vector(31 downto 0);
    signal  tile0_tx_data_vio_out0_i        : std_logic_vector(31 downto 0);
    signal  tile0_rx_data_vio_in0_i         : std_logic_vector(31 downto 0);
    signal  tile0_rx_data_vio_out0_i        : std_logic_vector(31 downto 0);
    signal  tile0_ila_in0_i                 : std_logic_vector(63 downto 0);
    signal  tile0_tx_data_vio_in1_i         : std_logic_vector(31 downto 0);
    signal  tile0_tx_data_vio_out1_i        : std_logic_vector(31 downto 0);
    signal  tile0_rx_data_vio_in1_i         : std_logic_vector(31 downto 0);
    signal  tile0_rx_data_vio_out1_i        : std_logic_vector(31 downto 0);
    signal  tile0_ila_in1_i                 : std_logic_vector(63 downto 0);

    signal  tile1_tx_data_vio_in0_i         : std_logic_vector(31 downto 0);
    signal  tile1_tx_data_vio_out0_i        : std_logic_vector(31 downto 0);
    signal  tile1_rx_data_vio_in0_i         : std_logic_vector(31 downto 0);
    signal  tile1_rx_data_vio_out0_i        : std_logic_vector(31 downto 0);
    signal  tile1_ila_in0_i                 : std_logic_vector(63 downto 0);
    signal  tile1_tx_data_vio_in1_i         : std_logic_vector(31 downto 0);
    signal  tile1_tx_data_vio_out1_i        : std_logic_vector(31 downto 0);
    signal  tile1_rx_data_vio_in1_i         : std_logic_vector(31 downto 0);
    signal  tile1_rx_data_vio_out1_i        : std_logic_vector(31 downto 0);
    signal  tile1_ila_in1_i                 : std_logic_vector(63 downto 0);

    signal  tile2_tx_data_vio_in0_i         : std_logic_vector(31 downto 0);
    signal  tile2_tx_data_vio_out0_i        : std_logic_vector(31 downto 0);
    signal  tile2_rx_data_vio_in0_i         : std_logic_vector(31 downto 0);
    signal  tile2_rx_data_vio_out0_i        : std_logic_vector(31 downto 0);
    signal  tile2_ila_in0_i                 : std_logic_vector(63 downto 0);
    signal  tile2_tx_data_vio_in1_i         : std_logic_vector(31 downto 0);
    signal  tile2_tx_data_vio_out1_i        : std_logic_vector(31 downto 0);
    signal  tile2_rx_data_vio_in1_i         : std_logic_vector(31 downto 0);
    signal  tile2_rx_data_vio_out1_i        : std_logic_vector(31 downto 0);
    signal  tile2_ila_in1_i                 : std_logic_vector(63 downto 0);

    signal  tile3_tx_data_vio_in0_i         : std_logic_vector(31 downto 0);
    signal  tile3_tx_data_vio_out0_i        : std_logic_vector(31 downto 0);
    signal  tile3_rx_data_vio_in0_i         : std_logic_vector(31 downto 0);
    signal  tile3_rx_data_vio_out0_i        : std_logic_vector(31 downto 0);
    signal  tile3_ila_in0_i                 : std_logic_vector(63 downto 0);
    signal  tile3_tx_data_vio_in1_i         : std_logic_vector(31 downto 0);
    signal  tile3_tx_data_vio_out1_i        : std_logic_vector(31 downto 0);
    signal  tile3_rx_data_vio_in1_i         : std_logic_vector(31 downto 0);
    signal  tile3_rx_data_vio_out1_i        : std_logic_vector(31 downto 0);
    signal  tile3_ila_in1_i                 : std_logic_vector(63 downto 0);


    signal  gtpreset_i                      : std_logic;
    signal  mux_sel_i                       : std_logic_vector(1 downto 0);
    signal  not_mux_sel_i                   : std_logic_vector(1 downto 0);    
    signal  user_tx_reset_i                 : std_logic;
    signal  user_rx_reset_i                 : std_logic;
    signal  ila_clk0_i                      : std_logic;
    signal  ila_clk_mux_out0_i              : std_logic;
    signal  ila_clk1_i                      : std_logic;
    signal  ila_clk_mux_out1_i              : std_logic;


--**************************** Main Body of Code *******************************
begin

    --  Static signal Assigments
    tied_to_ground_i                        <= '0';
    tied_to_ground_vec_i                    <= x"0000000000000000";
    tied_to_vcc_i                           <= '1';
    tied_to_vcc_vec_i                       <= x"ff";


    


    -----------------------Dedicated GTP Reference Clock Inputs ---------------
    -- The dedicated reference clock inputs you selected in the GUI are implemented using
    -- IBUFDS instances.
    --
    -- In the UCF file for this example design, you will see that each of
    -- these IBUFDS instances has been LOCed to a particular set of pins. By LOCing to these
    -- locations, we tell the tools to use the dedicated input buffers to the GTP reference
    -- clock network, rather than general purpose IOs. To select other pins, consult the 
    -- Implementation chapter of UG196, or rerun the wizard.
    --
    -- This network is the highest performace (lowest jitter) option for providing clocks
    -- to the GTP transceivers.
    
    tile0_refclk_ibufds_i : IBUFDS
    port map
    (
        O                               =>      tile0_refclk_i,
        I                               =>      TILE0_REFCLK_PAD_P_IN,
        IB                              =>      TILE0_REFCLK_PAD_N_IN
    );

    tile1_refclk_ibufds_i : IBUFDS
    port map
    (
        O                               =>      tile1_refclk_i,
        I                               =>      TILE1_REFCLK_PAD_P_IN,
        IB                              =>      TILE1_REFCLK_PAD_N_IN
    );

    tile2_refclk_ibufds_i : IBUFDS
    port map
    (
        O                               =>      tile2_refclk_i,
        I                               =>      TILE2_REFCLK_PAD_P_IN,
        IB                              =>      TILE2_REFCLK_PAD_N_IN
    );

    tile3_refclk_ibufds_i : IBUFDS
    port map
    (
        O                               =>      tile3_refclk_i,
        I                               =>      TILE3_REFCLK_PAD_P_IN,
        IB                              =>      TILE3_REFCLK_PAD_N_IN
    );






    ----------------------------------- User Clocks ---------------------------
    
    -- The clock resources in this section were added based on userclk source selections on
    -- the Latency, Buffering, and Clocking page of the GUI. A few notes about user clocks:
    -- * The userclk and userclk2 for each GTP datapath (TX and RX) must be phase aligned to 
    --   avoid data errors in the fabric interface whenever the datapath is wider than 10 bits
    -- * To minimize clock resources, you can share clocks between GTPs. GTPs using the same frequency
    --   or multiples of the same frequency can be accomadated using DCMs and PLLs. Use caution when
    --   using RXRECCLK as a clock source, however - these clocks can typically only be shared if all
    --   the channels using the clock are receiving data from TX channels that share a reference clock 
    --   source with each other.





    ----------------------------- The GTP Wrapper -----------------------------
    
    -- Use the instantiation template in the project directory to add the GTP wrapper to your design.
    -- In this example, the wrapper is wired up for basic operation with a frame generator and frame 
    -- checker. The GTPs will reset, then attempt to align and transmit data. If channel bonding is 
    -- enabled, bonding should occur after alignment.
    
    -- All clock inputs on the individual GTP transceiver must be driven for RESETDONE to work. 
    -- When TX line Rate is set to No Tx, the source of TXUSRCLK(2) is set to rxusrclk(2).
    -- When RX Line Rate is set to No RX, the source of RXUSRCLK(2) is set to txusrclk(2). 

    -- Wire all PLLLKDET signals to the top level as output ports
    TILE0_PLLLKDET_OUT                      <= tile0_plllkdet_i;
    TILE1_PLLLKDET_OUT                      <= tile1_plllkdet_i;
    TILE2_PLLLKDET_OUT                      <= tile2_plllkdet_i;
    TILE3_PLLLKDET_OUT                      <= tile3_plllkdet_i;



    test_i : TEST
    generic map
    (
        WRAPPER_SIM_MODE                =>      EXAMPLE_SIM_MODE,   
        WRAPPER_SIM_GTPRESET_SPEEDUP    =>      EXAMPLE_SIM_GTPRESET_SPEEDUP,
        WRAPPER_SIM_PLL_PERDIV2         =>      EXAMPLE_SIM_PLL_PERDIV2
    )
    port map
    (
    


        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE0  (X0Y2)

        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE0_RXUSRCLK0_IN              =>      tied_to_ground_i,
        TILE0_RXUSRCLK1_IN              =>      tied_to_ground_i,
        TILE0_RXUSRCLK20_IN             =>      tied_to_ground_i,
        TILE0_RXUSRCLK21_IN             =>      tied_to_ground_i,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE0_RXN0_IN                   =>      RXN_IN(0),
        TILE0_RXN1_IN                   =>      RXN_IN(1),
        TILE0_RXP0_IN                   =>      RXP_IN(0),
        TILE0_RXP1_IN                   =>      RXP_IN(1),
        --------------------- Shared Ports - Tile and PLL Ports --------------------
        TILE0_CLKIN_IN                  =>      tile0_refclk_i,
        TILE0_GTPRESET_IN               =>      tile0_gtpreset_i,
        TILE0_PLLLKDET_OUT              =>      tile0_plllkdet_i,
        TILE0_REFCLKOUT_OUT             =>      tile0_refclkout_i,
        TILE0_RESETDONE0_OUT            =>      tile0_resetdone0_i,
        TILE0_RESETDONE1_OUT            =>      tile0_resetdone1_i,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE0_TXUSRCLK0_IN              =>      tied_to_ground_i,
        TILE0_TXUSRCLK1_IN              =>      tied_to_ground_i,
        TILE0_TXUSRCLK20_IN             =>      tied_to_ground_i,
        TILE0_TXUSRCLK21_IN             =>      tied_to_ground_i,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE0_TXDIFFCTRL0_IN            =>      tile0_txdiffctrl0_i,
        TILE0_TXDIFFCTRL1_IN            =>      tile0_txdiffctrl1_i,
        TILE0_TXN0_OUT                  =>      TXN_OUT(0),
        TILE0_TXN1_OUT                  =>      TXN_OUT(1),
        TILE0_TXP0_OUT                  =>      TXP_OUT(0),
        TILE0_TXP1_OUT                  =>      TXP_OUT(1),
        TILE0_TXPREEMPHASIS0_IN         =>      tile0_txpreemphasis0_i,
        TILE0_TXPREEMPHASIS1_IN         =>      tile0_txpreemphasis1_i,


    


        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE1  (X0Y3)

        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE1_RXUSRCLK0_IN              =>      tied_to_ground_i,
        TILE1_RXUSRCLK1_IN              =>      tied_to_ground_i,
        TILE1_RXUSRCLK20_IN             =>      tied_to_ground_i,
        TILE1_RXUSRCLK21_IN             =>      tied_to_ground_i,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE1_RXN0_IN                   =>      RXN_IN(2),
        TILE1_RXN1_IN                   =>      RXN_IN(3),
        TILE1_RXP0_IN                   =>      RXP_IN(2),
        TILE1_RXP1_IN                   =>      RXP_IN(3),
        --------------------- Shared Ports - Tile and PLL Ports --------------------
        TILE1_CLKIN_IN                  =>      tile1_refclk_i,
        TILE1_GTPRESET_IN               =>      tile1_gtpreset_i,
        TILE1_PLLLKDET_OUT              =>      tile1_plllkdet_i,
        TILE1_REFCLKOUT_OUT             =>      tile1_refclkout_i,
        TILE1_RESETDONE0_OUT            =>      tile1_resetdone0_i,
        TILE1_RESETDONE1_OUT            =>      tile1_resetdone1_i,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE1_TXUSRCLK0_IN              =>      tied_to_ground_i,
        TILE1_TXUSRCLK1_IN              =>      tied_to_ground_i,
        TILE1_TXUSRCLK20_IN             =>      tied_to_ground_i,
        TILE1_TXUSRCLK21_IN             =>      tied_to_ground_i,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE1_TXDIFFCTRL0_IN            =>      tile1_txdiffctrl0_i,
        TILE1_TXDIFFCTRL1_IN            =>      tile1_txdiffctrl1_i,
        TILE1_TXN0_OUT                  =>      TXN_OUT(2),
        TILE1_TXN1_OUT                  =>      TXN_OUT(3),
        TILE1_TXP0_OUT                  =>      TXP_OUT(2),
        TILE1_TXP1_OUT                  =>      TXP_OUT(3),
        TILE1_TXPREEMPHASIS0_IN         =>      tile1_txpreemphasis0_i,
        TILE1_TXPREEMPHASIS1_IN         =>      tile1_txpreemphasis1_i,


    


        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE2  (X0Y4)

        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE2_RXUSRCLK0_IN              =>      tied_to_ground_i,
        TILE2_RXUSRCLK1_IN              =>      tied_to_ground_i,
        TILE2_RXUSRCLK20_IN             =>      tied_to_ground_i,
        TILE2_RXUSRCLK21_IN             =>      tied_to_ground_i,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE2_RXN0_IN                   =>      RXN_IN(4),
        TILE2_RXN1_IN                   =>      RXN_IN(5),
        TILE2_RXP0_IN                   =>      RXP_IN(4),
        TILE2_RXP1_IN                   =>      RXP_IN(5),
        --------------------- Shared Ports - Tile and PLL Ports --------------------
        TILE2_CLKIN_IN                  =>      tile2_refclk_i,
        TILE2_GTPRESET_IN               =>      tile2_gtpreset_i,
        TILE2_PLLLKDET_OUT              =>      tile2_plllkdet_i,
        TILE2_REFCLKOUT_OUT             =>      tile2_refclkout_i,
        TILE2_RESETDONE0_OUT            =>      tile2_resetdone0_i,
        TILE2_RESETDONE1_OUT            =>      tile2_resetdone1_i,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE2_TXUSRCLK0_IN              =>      tied_to_ground_i,
        TILE2_TXUSRCLK1_IN              =>      tied_to_ground_i,
        TILE2_TXUSRCLK20_IN             =>      tied_to_ground_i,
        TILE2_TXUSRCLK21_IN             =>      tied_to_ground_i,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE2_TXDIFFCTRL0_IN            =>      tile2_txdiffctrl0_i,
        TILE2_TXDIFFCTRL1_IN            =>      tile2_txdiffctrl1_i,
        TILE2_TXN0_OUT                  =>      TXN_OUT(4),
        TILE2_TXN1_OUT                  =>      TXN_OUT(5),
        TILE2_TXP0_OUT                  =>      TXP_OUT(4),
        TILE2_TXP1_OUT                  =>      TXP_OUT(5),
        TILE2_TXPREEMPHASIS0_IN         =>      tile2_txpreemphasis0_i,
        TILE2_TXPREEMPHASIS1_IN         =>      tile2_txpreemphasis1_i,


    


        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE3  (X0Y5)

        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE3_RXUSRCLK0_IN              =>      tied_to_ground_i,
        TILE3_RXUSRCLK1_IN              =>      tied_to_ground_i,
        TILE3_RXUSRCLK20_IN             =>      tied_to_ground_i,
        TILE3_RXUSRCLK21_IN             =>      tied_to_ground_i,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE3_RXN0_IN                   =>      RXN_IN(6),
        TILE3_RXN1_IN                   =>      RXN_IN(7),
        TILE3_RXP0_IN                   =>      RXP_IN(6),
        TILE3_RXP1_IN                   =>      RXP_IN(7),
        --------------------- Shared Ports - Tile and PLL Ports --------------------
        TILE3_CLKIN_IN                  =>      tile3_refclk_i,
        TILE3_GTPRESET_IN               =>      tile3_gtpreset_i,
        TILE3_PLLLKDET_OUT              =>      tile3_plllkdet_i,
        TILE3_REFCLKOUT_OUT             =>      tile3_refclkout_i,
        TILE3_RESETDONE0_OUT            =>      tile3_resetdone0_i,
        TILE3_RESETDONE1_OUT            =>      tile3_resetdone1_i,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE3_TXUSRCLK0_IN              =>      tied_to_ground_i,
        TILE3_TXUSRCLK1_IN              =>      tied_to_ground_i,
        TILE3_TXUSRCLK20_IN             =>      tied_to_ground_i,
        TILE3_TXUSRCLK21_IN             =>      tied_to_ground_i,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE3_TXDIFFCTRL0_IN            =>      tile3_txdiffctrl0_i,
        TILE3_TXDIFFCTRL1_IN            =>      tile3_txdiffctrl1_i,
        TILE3_TXN0_OUT                  =>      TXN_OUT(6),
        TILE3_TXN1_OUT                  =>      TXN_OUT(7),
        TILE3_TXP0_OUT                  =>      TXP_OUT(6),
        TILE3_TXP1_OUT                  =>      TXP_OUT(7),
        TILE3_TXPREEMPHASIS0_IN         =>      tile3_txpreemphasis0_i,
        TILE3_TXPREEMPHASIS1_IN         =>      tile3_txpreemphasis1_i


    );






    -------------------------- User Module Resets -----------------------------
    -- All the User Modules i.e. FRAME_GEN, FRAME_CHECK and the sync modules
    -- are held in reset till the RESETDONE goes high. 
    -- The RESETDONE is registered a couple of times on USRCLK2 and connected 
    -- to the reset of the modules
    
    





    ---------------------------------- Frame Checkers -------------------------
    -- The example design uses Block RAM based frame checkers to verify incoming  
    -- data. By default the frame generators are loaded with a data sequence that 
    -- matches the outgoing sequence of the frame generators for the TX ports.
    
    -- You can modify the expected data sequence by changing the INIT values of the frame
    -- checkers in this file. Pay careful attention to bit order and the spacing
    -- of your control and alignment characters.
    
    -- When the frame checker receives data, it attempts to synchronise to the 
    -- incoming pattern by looking for the first sequence in the pattern. Once it 
    -- finds the first sequence, it increments through the sequence, and indicates an 
    -- error whenever the next value received does not match the expected value.

     -- This GTP is not active.The match port for pattern checker of this GTP is tied off
    tile0_matchn0_i                         <= '0';

     -- This GTP is not active.The match port for pattern checker of this GTP is tied off
    tile0_matchn1_i                         <= '0';

     -- This GTP is not active.The match port for pattern checker of this GTP is tied off
    tile1_matchn0_i                         <= '0';

     -- This GTP is not active.The match port for pattern checker of this GTP is tied off
    tile1_matchn1_i                         <= '0';

     -- This GTP is not active.The match port for pattern checker of this GTP is tied off
    tile2_matchn0_i                         <= '0';

     -- This GTP is not active.The match port for pattern checker of this GTP is tied off
    tile2_matchn1_i                         <= '0';

     -- This GTP is not active.The match port for pattern checker of this GTP is tied off
    tile3_matchn0_i                         <= '0';

     -- This GTP is not active.The match port for pattern checker of this GTP is tied off
    tile3_matchn1_i                         <= '0';




    TRACK_DATA_OUT                          <= track_data_out_i;
    
    track_data_out_i                        <= 
                                tile0_track_data0_i and
                                tile0_track_data1_i 
 and
                                tile1_track_data0_i and
                                tile1_track_data1_i 
 and
                                tile2_track_data0_i and
                                tile2_track_data1_i 
 and
                                tile3_track_data0_i and
                                tile3_track_data1_i 
 ;

    ----------------------------- Chipscope Connections -----------------------
    -- When the example design is run in hardware, it uses chipscope to allow the
    -- example design and GTP wrapper to be controlled and monitored. The 
    -- EXAMPLE_USE_CHIPSCOPE parameter allows chipscope to be removed for simulation.
    
chipscope : if EXAMPLE_USE_CHIPSCOPE = 1 generate


    -- Shared VIO for all tiles
    shared_vio_i : shared_vio
    port map
    (
        control                         =>      shared_vio_control_i,
        async_in                        =>      shared_vio_in_i,
        async_out                       =>      shared_vio_out_i
    );

    
    -- ICON for all VIOs 
    i_icon : icon
    port map
    (
        control0                        =>      shared_vio_control_i,
        control1                        =>      tx_data_vio_control0_i,
        control2                        =>      rx_data_vio_control0_i,
        control3                        =>      ila_control0_i,
        control4                        =>      tx_data_vio_control1_i,
        control5                        =>      rx_data_vio_control1_i,
        control6                        =>      ila_control1_i
    );

    -- TX VIO 
    tx_data_vio0_i : shared_vio
    port map
    (
        control                         =>      tx_data_vio_control0_i,
        async_in                        =>      tx_data_vio_in0_i,
        async_out                       =>      tx_data_vio_out0_i
    );
    
    -- RX VIO 
    rx_data_vio0_i : shared_vio
    port map
    (
        control                         =>      rx_data_vio_control0_i,
        async_in                        =>      rx_data_vio_in0_i,
        async_out                       =>      rx_data_vio_out0_i
    );
    
    -- RX ILA
    ila0_i : ila
    port map
    (
        control                         =>      ila_control0_i,
        clk                             =>      ila_clk0_i,
        trig0                           =>      ila_in0_i
    );

    -- The RX ILA must use the same clock as the selected transceiver
    ila_clk0_bufg_i : BUFG
    port map
    (
        I => ila_clk_mux_out0_i,
        O => ila_clk0_i
    );

     ila_clk_mux_out0_i<= tied_to_ground_i;

        
    -- TX VIO 
    tx_data_vio1_i : shared_vio
    port map
    (
        control                         =>      tx_data_vio_control1_i,
        async_in                        =>      tx_data_vio_in1_i,
        async_out                       =>      tx_data_vio_out1_i
    );
    
    -- RX VIO 
    rx_data_vio1_i : shared_vio
    port map
    (
        control                         =>      rx_data_vio_control1_i,
        async_in                        =>      rx_data_vio_in1_i,
        async_out                       =>      rx_data_vio_out1_i
    );
    
    -- RX ILA
    ila1_i : ila
    port map
    (
        control                         =>      ila_control1_i,
        clk                             =>      ila_clk1_i,
        trig0                           =>      ila_in1_i
    );

    -- The RX ILA must use the same clock as the selected transceiver
    ila_clk1_bufg_i : BUFG
    port map
    (
        I => ila_clk_mux_out1_i,
        O => ila_clk1_i
    );

     ila_clk_mux_out1_i<= tied_to_ground_i;

        

    -- Connect resets for frame generators


    tile0_gtpreset_i                        <= gtpreset_i;
    tile1_gtpreset_i                        <= gtpreset_i;
    tile2_gtpreset_i                        <= gtpreset_i;
    tile3_gtpreset_i                        <= gtpreset_i;


    -- Shared VIO Outputs
    gtpreset_i                              <= shared_vio_out_i(31);
    user_tx_reset_i                         <= shared_vio_out_i(30);
    user_rx_reset_i                         <= shared_vio_out_i(29);
    mux_sel_i                               <= shared_vio_out_i(28 downto 27);

    -- Shared VIO Inputs
    shared_vio_in_i(31)                     <= tile0_plllkdet_i;
    shared_vio_in_i(30)                     <= tile1_plllkdet_i;
    shared_vio_in_i(29)                     <= tile2_plllkdet_i;
    shared_vio_in_i(28)                     <= tile3_plllkdet_i;
    shared_vio_in_i(27 downto 0)            <= "0000000000000000000000000000";

    -- Chipscope connections for GTP0 on Tile 0
    tile0_tx_data_vio_in0_i(31 downto 0)    <= "00000000000000000000000000000000";
    tile0_txdiffctrl0_i                     <= tx_data_vio_out0_i(31 downto 29);
    tile0_txpreemphasis0_i                  <= tx_data_vio_out0_i(28 downto 26);
    tile0_rx_data_vio_in0_i(31)             <= tile0_resetdone0_i;
    tile0_rx_data_vio_in0_i(30 downto 0)    <= "0000000000000000000000000000000";
    tile0_ila_in0_i(63 downto 56)           <= tile0_error_count0_i;
    tile0_ila_in0_i(55 downto 0)            <= "00000000000000000000000000000000000000000000000000000000";

    -- Chipscope connections for GTP1 on Tile 0
    tile0_tx_data_vio_in1_i(31 downto 0)    <= "00000000000000000000000000000000";
    tile0_txdiffctrl1_i                     <= tx_data_vio_out1_i(31 downto 29);
    tile0_txpreemphasis1_i                  <= tx_data_vio_out1_i(28 downto 26);
    tile0_rx_data_vio_in1_i(31)             <= tile0_resetdone1_i;
    tile0_rx_data_vio_in1_i(30 downto 0)    <= "0000000000000000000000000000000";
    tile0_ila_in1_i(63 downto 56)           <= tile0_error_count1_i;
    tile0_ila_in1_i(55 downto 0)            <= "00000000000000000000000000000000000000000000000000000000";

    -- Chipscope connections for GTP0 on Tile 1
    tile1_tx_data_vio_in0_i(31 downto 0)    <= "00000000000000000000000000000000";
    tile1_txdiffctrl0_i                     <= tx_data_vio_out0_i(31 downto 29);
    tile1_txpreemphasis0_i                  <= tx_data_vio_out0_i(28 downto 26);
    tile1_rx_data_vio_in0_i(31)             <= tile1_resetdone0_i;
    tile1_rx_data_vio_in0_i(30 downto 0)    <= "0000000000000000000000000000000";
    tile1_ila_in0_i(63 downto 56)           <= tile1_error_count0_i;
    tile1_ila_in0_i(55 downto 0)            <= "00000000000000000000000000000000000000000000000000000000";

    -- Chipscope connections for GTP1 on Tile 1
    tile1_tx_data_vio_in1_i(31 downto 0)    <= "00000000000000000000000000000000";
    tile1_txdiffctrl1_i                     <= tx_data_vio_out1_i(31 downto 29);
    tile1_txpreemphasis1_i                  <= tx_data_vio_out1_i(28 downto 26);
    tile1_rx_data_vio_in1_i(31)             <= tile1_resetdone1_i;
    tile1_rx_data_vio_in1_i(30 downto 0)    <= "0000000000000000000000000000000";
    tile1_ila_in1_i(63 downto 56)           <= tile1_error_count1_i;
    tile1_ila_in1_i(55 downto 0)            <= "00000000000000000000000000000000000000000000000000000000";

    -- Chipscope connections for GTP0 on Tile 2
    tile2_tx_data_vio_in0_i(31 downto 0)    <= "00000000000000000000000000000000";
    tile2_txdiffctrl0_i                     <= tx_data_vio_out0_i(31 downto 29);
    tile2_txpreemphasis0_i                  <= tx_data_vio_out0_i(28 downto 26);
    tile2_rx_data_vio_in0_i(31)             <= tile2_resetdone0_i;
    tile2_rx_data_vio_in0_i(30 downto 0)    <= "0000000000000000000000000000000";
    tile2_ila_in0_i(63 downto 56)           <= tile2_error_count0_i;
    tile2_ila_in0_i(55 downto 0)            <= "00000000000000000000000000000000000000000000000000000000";

    -- Chipscope connections for GTP1 on Tile 2
    tile2_tx_data_vio_in1_i(31 downto 0)    <= "00000000000000000000000000000000";
    tile2_txdiffctrl1_i                     <= tx_data_vio_out1_i(31 downto 29);
    tile2_txpreemphasis1_i                  <= tx_data_vio_out1_i(28 downto 26);
    tile2_rx_data_vio_in1_i(31)             <= tile2_resetdone1_i;
    tile2_rx_data_vio_in1_i(30 downto 0)    <= "0000000000000000000000000000000";
    tile2_ila_in1_i(63 downto 56)           <= tile2_error_count1_i;
    tile2_ila_in1_i(55 downto 0)            <= "00000000000000000000000000000000000000000000000000000000";

    -- Chipscope connections for GTP0 on Tile 3
    tile3_tx_data_vio_in0_i(31 downto 0)    <= "00000000000000000000000000000000";
    tile3_txdiffctrl0_i                     <= tx_data_vio_out0_i(31 downto 29);
    tile3_txpreemphasis0_i                  <= tx_data_vio_out0_i(28 downto 26);
    tile3_rx_data_vio_in0_i(31)             <= tile3_resetdone0_i;
    tile3_rx_data_vio_in0_i(30 downto 0)    <= "0000000000000000000000000000000";
    tile3_ila_in0_i(63 downto 56)           <= tile3_error_count0_i;
    tile3_ila_in0_i(55 downto 0)            <= "00000000000000000000000000000000000000000000000000000000";

    -- Chipscope connections for GTP1 on Tile 3
    tile3_tx_data_vio_in1_i(31 downto 0)    <= "00000000000000000000000000000000";
    tile3_txdiffctrl1_i                     <= tx_data_vio_out1_i(31 downto 29);
    tile3_txpreemphasis1_i                  <= tx_data_vio_out1_i(28 downto 26);
    tile3_rx_data_vio_in1_i(31)             <= tile3_resetdone1_i;
    tile3_rx_data_vio_in1_i(30 downto 0)    <= "0000000000000000000000000000000";
    tile3_ila_in1_i(63 downto 56)           <= tile3_error_count1_i;
    tile3_ila_in1_i(55 downto 0)            <= "00000000000000000000000000000000000000000000000000000000";


    --Mux inputs to Chipscope modules based on mux_sel_i
    tx_data_vio_in0_i                   <=      tile0_tx_data_vio_in0_i when (mux_sel_i = "00")
                                        else    tile1_tx_data_vio_in0_i when (mux_sel_i = "01")
                                        else    tile2_tx_data_vio_in0_i when (mux_sel_i = "10")
                                        else    tile3_tx_data_vio_in0_i;


    rx_data_vio_in0_i                   <=      tile0_rx_data_vio_in0_i when (mux_sel_i = "00")
                                        else    tile1_rx_data_vio_in0_i when (mux_sel_i = "01")
                                        else    tile2_rx_data_vio_in0_i when (mux_sel_i = "10")
                                        else    tile3_rx_data_vio_in0_i;


    ila_in0_i                           <=      tile0_ila_in0_i when (mux_sel_i = "00")
                                        else    tile1_ila_in0_i when (mux_sel_i = "01")
                                        else    tile2_ila_in0_i when (mux_sel_i = "10")
                                        else    tile3_ila_in0_i;


    tx_data_vio_in1_i                   <=      tile0_tx_data_vio_in1_i when (mux_sel_i = "00")
                                        else    tile1_tx_data_vio_in1_i when (mux_sel_i = "01")
                                        else    tile2_tx_data_vio_in1_i when (mux_sel_i = "10")
                                        else    tile3_tx_data_vio_in1_i;


    rx_data_vio_in1_i                   <=      tile0_rx_data_vio_in1_i when (mux_sel_i = "00")
                                        else    tile1_rx_data_vio_in1_i when (mux_sel_i = "01")
                                        else    tile2_rx_data_vio_in1_i when (mux_sel_i = "10")
                                        else    tile3_rx_data_vio_in1_i;


    ila_in1_i                           <=      tile0_ila_in1_i when (mux_sel_i = "00")
                                        else    tile1_ila_in1_i when (mux_sel_i = "01")
                                        else    tile2_ila_in1_i when (mux_sel_i = "10")
                                        else    tile3_ila_in1_i;




   
end generate chipscope;


no_chipscope : if EXAMPLE_USE_CHIPSCOPE = 0 generate

    -- If Chipscope is not being used, drive GTP reset signal
    -- from the top level ports
    tile0_gtpreset_i                        <= GTPRESET_IN;
    tile1_gtpreset_i                        <= GTPRESET_IN;
    tile2_gtpreset_i                        <= GTPRESET_IN;
    tile3_gtpreset_i                        <= GTPRESET_IN;

    -- assign resets for frame_gen and frame_check modules



    gtpreset_i                              <= tied_to_ground_i;
    user_tx_reset_i                         <= tied_to_ground_i;
    user_rx_reset_i                         <= tied_to_ground_i;
    mux_sel_i                               <= tied_to_ground_vec_i(1 downto 0);
    tile0_txdiffctrl0_i                     <= tied_to_ground_vec_i(2 downto 0);
    tile0_txpreemphasis0_i                  <= tied_to_ground_vec_i(2 downto 0);
    tile0_txdiffctrl1_i                     <= tied_to_ground_vec_i(2 downto 0);
    tile0_txpreemphasis1_i                  <= tied_to_ground_vec_i(2 downto 0);
    tile1_txdiffctrl0_i                     <= tied_to_ground_vec_i(2 downto 0);
    tile1_txpreemphasis0_i                  <= tied_to_ground_vec_i(2 downto 0);
    tile1_txdiffctrl1_i                     <= tied_to_ground_vec_i(2 downto 0);
    tile1_txpreemphasis1_i                  <= tied_to_ground_vec_i(2 downto 0);
    tile2_txdiffctrl0_i                     <= tied_to_ground_vec_i(2 downto 0);
    tile2_txpreemphasis0_i                  <= tied_to_ground_vec_i(2 downto 0);
    tile2_txdiffctrl1_i                     <= tied_to_ground_vec_i(2 downto 0);
    tile2_txpreemphasis1_i                  <= tied_to_ground_vec_i(2 downto 0);
    tile3_txdiffctrl0_i                     <= tied_to_ground_vec_i(2 downto 0);
    tile3_txpreemphasis0_i                  <= tied_to_ground_vec_i(2 downto 0);
    tile3_txdiffctrl1_i                     <= tied_to_ground_vec_i(2 downto 0);
    tile3_txpreemphasis1_i                  <= tied_to_ground_vec_i(2 downto 0);



end generate no_chipscope;


end RTL;

