library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
Library UNISIM;
use UNISIM.vcomponents.all;

entity top is

Port (led					: out std_logic_vector(4 downto 0);
		clk0_p					: in std_logic;
		clk0_n					: in std_logic;
		clk1_p					: in std_logic;
		clk1_n					: in std_logic;
		clk2_p					: in std_logic;
		clk2_n					: in std_logic;
		clk3_p					: in std_logic;
		clk3_n					: in std_logic;
		clk_test					: out std_logic;
		clk_test_0				: out std_logic;
		clk_test_1				: out std_logic;
		clk_test_2				: out std_logic;
		clk_test_3				: out std_logic;
		clk_50					: in std_logic;
		 TILE0_RXN0_IN				: in std_logic;
       TILE0_RXN1_IN				: in std_logic;
       TILE0_RXP0_IN				: in std_logic;
       TILE0_RXP1_IN				: in std_logic;
		 TILE0_TXN0_OUT			: out std_logic;
       TILE0_TXN1_OUT			: out std_logic;
       TILE0_TXP0_OUT			: out std_logic;
       TILE0_TXP1_OUT			: out std_logic;
		 TILE1_RXN0_IN				: in std_logic;
       TILE1_RXN1_IN				: in std_logic;
       TILE1_RXP0_IN				: in std_logic;
       TILE1_RXP1_IN				: in std_logic;
		 TILE1_TXN0_OUT			: out std_logic;
       TILE1_TXN1_OUT			: out std_logic;
       TILE1_TXP0_OUT			: out std_logic;
       TILE1_TXP1_OUT			: out std_logic;
		 TILE2_RXN0_IN				: in std_logic;
       TILE2_RXN1_IN				: in std_logic;
       TILE2_RXP0_IN				: in std_logic;
       TILE2_RXP1_IN				: in std_logic;
		 TILE2_TXN0_OUT			: out std_logic;
       TILE2_TXN1_OUT			: out std_logic;
       TILE2_TXP0_OUT			: out std_logic;
       TILE2_TXP1_OUT			: out std_logic;
		 TILE3_RXN0_IN				: in std_logic;
       TILE3_RXN1_IN				: in std_logic;
       TILE3_RXP0_IN				: in std_logic;
       TILE3_RXP1_IN				: in std_logic;
		 TILE3_TXN0_OUT			: out std_logic;
       TILE3_TXN1_OUT			: out std_logic;
       TILE3_TXP0_OUT			: out std_logic;
       TILE3_TXP1_OUT			: out std_logic);
end top;

architecture Behavioral of top is


component TEST 
generic
(
    -- Simulation attributes
    WRAPPER_SIM_GTPRESET_SPEEDUP    : integer   := 0; -- Set to 1 to speed up sim reset
    WRAPPER_SIM_PLL_PERDIV2         : bit_vector:= x"1f4" -- Set to the VCO Unit Interval time
);
port
(
    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE0  (Location)

    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE0_RXUSRCLK0_IN                      : in   std_logic;
    TILE0_RXUSRCLK1_IN                      : in   std_logic;
    TILE0_RXUSRCLK20_IN                     : in   std_logic;
    TILE0_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE0_RXN0_IN                           : in   std_logic;
    TILE0_RXN1_IN                           : in   std_logic;
    TILE0_RXP0_IN                           : in   std_logic;
    TILE0_RXP1_IN                           : in   std_logic;
    --------------------- Shared Ports - Tile and PLL Ports --------------------
    TILE0_CLKIN_IN                          : in   std_logic;
    TILE0_GTPRESET_IN                       : in   std_logic;
    TILE0_PLLLKDET_OUT                      : out  std_logic;
    TILE0_REFCLKOUT_OUT                     : out  std_logic;
    TILE0_RESETDONE0_OUT                    : out  std_logic;
    TILE0_RESETDONE1_OUT                    : out  std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE0_TXUSRCLK0_IN                      : in   std_logic;
    TILE0_TXUSRCLK1_IN                      : in   std_logic;
    TILE0_TXUSRCLK20_IN                     : in   std_logic;
    TILE0_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE0_TXDIFFCTRL0_IN                    : in   std_logic_vector(2 downto 0);
    TILE0_TXDIFFCTRL1_IN                    : in   std_logic_vector(2 downto 0);
    TILE0_TXN0_OUT                          : out  std_logic;
    TILE0_TXN1_OUT                          : out  std_logic;
    TILE0_TXP0_OUT                          : out  std_logic;
    TILE0_TXP1_OUT                          : out  std_logic;
    TILE0_TXPREEMPHASIS0_IN                 : in   std_logic_vector(2 downto 0);
    TILE0_TXPREEMPHASIS1_IN                 : in   std_logic_vector(2 downto 0);


    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE1  (Location)

    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE1_RXUSRCLK0_IN                      : in   std_logic;
    TILE1_RXUSRCLK1_IN                      : in   std_logic;
    TILE1_RXUSRCLK20_IN                     : in   std_logic;
    TILE1_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE1_RXN0_IN                           : in   std_logic;
    TILE1_RXN1_IN                           : in   std_logic;
    TILE1_RXP0_IN                           : in   std_logic;
    TILE1_RXP1_IN                           : in   std_logic;
    --------------------- Shared Ports - Tile and PLL Ports --------------------
    TILE1_CLKIN_IN                          : in   std_logic;
    TILE1_GTPRESET_IN                       : in   std_logic;
    TILE1_PLLLKDET_OUT                      : out  std_logic;
    TILE1_REFCLKOUT_OUT                     : out  std_logic;
    TILE1_RESETDONE0_OUT                    : out  std_logic;
    TILE1_RESETDONE1_OUT                    : out  std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE1_TXUSRCLK0_IN                      : in   std_logic;
    TILE1_TXUSRCLK1_IN                      : in   std_logic;
    TILE1_TXUSRCLK20_IN                     : in   std_logic;
    TILE1_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE1_TXDIFFCTRL0_IN                    : in   std_logic_vector(2 downto 0);
    TILE1_TXDIFFCTRL1_IN                    : in   std_logic_vector(2 downto 0);
    TILE1_TXN0_OUT                          : out  std_logic;
    TILE1_TXN1_OUT                          : out  std_logic;
    TILE1_TXP0_OUT                          : out  std_logic;
    TILE1_TXP1_OUT                          : out  std_logic;
    TILE1_TXPREEMPHASIS0_IN                 : in   std_logic_vector(2 downto 0);
    TILE1_TXPREEMPHASIS1_IN                 : in   std_logic_vector(2 downto 0);


    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE2  (Location)

    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE2_RXUSRCLK0_IN                      : in   std_logic;
    TILE2_RXUSRCLK1_IN                      : in   std_logic;
    TILE2_RXUSRCLK20_IN                     : in   std_logic;
    TILE2_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE2_RXN0_IN                           : in   std_logic;
    TILE2_RXN1_IN                           : in   std_logic;
    TILE2_RXP0_IN                           : in   std_logic;
    TILE2_RXP1_IN                           : in   std_logic;
    --------------------- Shared Ports - Tile and PLL Ports --------------------
    TILE2_CLKIN_IN                          : in   std_logic;
    TILE2_GTPRESET_IN                       : in   std_logic;
    TILE2_PLLLKDET_OUT                      : out  std_logic;
    TILE2_REFCLKOUT_OUT                     : out  std_logic;
    TILE2_RESETDONE0_OUT                    : out  std_logic;
    TILE2_RESETDONE1_OUT                    : out  std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE2_TXUSRCLK0_IN                      : in   std_logic;
    TILE2_TXUSRCLK1_IN                      : in   std_logic;
    TILE2_TXUSRCLK20_IN                     : in   std_logic;
    TILE2_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE2_TXDIFFCTRL0_IN                    : in   std_logic_vector(2 downto 0);
    TILE2_TXDIFFCTRL1_IN                    : in   std_logic_vector(2 downto 0);
    TILE2_TXN0_OUT                          : out  std_logic;
    TILE2_TXN1_OUT                          : out  std_logic;
    TILE2_TXP0_OUT                          : out  std_logic;
    TILE2_TXP1_OUT                          : out  std_logic;
    TILE2_TXPREEMPHASIS0_IN                 : in   std_logic_vector(2 downto 0);
    TILE2_TXPREEMPHASIS1_IN                 : in   std_logic_vector(2 downto 0);


    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE3  (Location)

    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE3_RXUSRCLK0_IN                      : in   std_logic;
    TILE3_RXUSRCLK1_IN                      : in   std_logic;
    TILE3_RXUSRCLK20_IN                     : in   std_logic;
    TILE3_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE3_RXN0_IN                           : in   std_logic;
    TILE3_RXN1_IN                           : in   std_logic;
    TILE3_RXP0_IN                           : in   std_logic;
    TILE3_RXP1_IN                           : in   std_logic;
    --------------------- Shared Ports - Tile and PLL Ports --------------------
    TILE3_CLKIN_IN                          : in   std_logic;
    TILE3_GTPRESET_IN                       : in   std_logic;
    TILE3_PLLLKDET_OUT                      : out  std_logic;
    TILE3_REFCLKOUT_OUT                     : out  std_logic;
    TILE3_RESETDONE0_OUT                    : out  std_logic;
    TILE3_RESETDONE1_OUT                    : out  std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE3_TXUSRCLK0_IN                      : in   std_logic;
    TILE3_TXUSRCLK1_IN                      : in   std_logic;
    TILE3_TXUSRCLK20_IN                     : in   std_logic;
    TILE3_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE3_TXDIFFCTRL0_IN                    : in   std_logic_vector(2 downto 0);
    TILE3_TXDIFFCTRL1_IN                    : in   std_logic_vector(2 downto 0);
    TILE3_TXN0_OUT                          : out  std_logic;
    TILE3_TXN1_OUT                          : out  std_logic;
    TILE3_TXP0_OUT                          : out  std_logic;
    TILE3_TXP1_OUT                          : out  std_logic;
    TILE3_TXPREEMPHASIS0_IN                 : in   std_logic_vector(2 downto 0);
    TILE3_TXPREEMPHASIS1_IN                 : in   std_logic_vector(2 downto 0)


);
end component;

signal count,count0,count1,count2,count3: std_logic_vector(25 downto 0);
signal clk_0: std_logic;
signal clk_1: std_logic;
signal clk_2: std_logic;
signal clk_3: std_logic;
signal t_clk_0: std_logic;
signal t_clk_1: std_logic;
signal t_clk_2: std_logic;
signal t_clk_3: std_logic;

begin

	 
   ----------------------------- The GTP Wrapper -----------------------------


    test_i : TEST
    generic map
    (
        WRAPPER_SIM_GTPRESET_SPEEDUP    =>      1,
        WRAPPER_SIM_PLL_PERDIV2         =>      x"1f4"
    )
    port map
    (
        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE0  (X0Y3)

        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE0_RXUSRCLK0_IN              =>      '0',
        TILE0_RXUSRCLK1_IN              =>      '0',
        TILE0_RXUSRCLK20_IN             =>      '0',
        TILE0_RXUSRCLK21_IN             =>      '0',
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE0_RXN0_IN                   =>      TILE0_RXN0_IN,
        TILE0_RXN1_IN                   =>      TILE0_RXN1_IN,
        TILE0_RXP0_IN                   =>      TILE0_RXP0_IN,
        TILE0_RXP1_IN                   =>      TILE0_RXP1_IN,
        --------------------- Shared Ports - Tile and PLL Ports --------------------
        TILE0_CLKIN_IN                  =>      t_clk_0,
        TILE0_GTPRESET_IN               =>      '0',
--        TILE0_PLLLKDET_OUT              =>      ,
        TILE0_REFCLKOUT_OUT             =>      clk_0,
--        TILE0_RESETDONE0_OUT            =>      ,
--        TILE0_RESETDONE1_OUT            =>      ,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE0_TXUSRCLK0_IN              =>      '0',
        TILE0_TXUSRCLK1_IN              =>      '0',
        TILE0_TXUSRCLK20_IN             =>      '0',
        TILE0_TXUSRCLK21_IN             =>      '0',
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE0_TXDIFFCTRL0_IN            =>      "000",
        TILE0_TXDIFFCTRL1_IN            =>      "000",
        TILE0_TXN0_OUT                  =>      TILE0_TXN0_OUT,
        TILE0_TXN1_OUT                  =>      TILE0_TXN1_OUT,
        TILE0_TXP0_OUT                  =>      TILE0_TXP0_OUT,
        TILE0_TXP1_OUT                  =>      TILE0_TXP1_OUT,
        TILE0_TXPREEMPHASIS0_IN         =>      "000",
        TILE0_TXPREEMPHASIS1_IN         =>      "000",


        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE1  (X0Y5)

        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE1_RXUSRCLK0_IN              =>      '0',
        TILE1_RXUSRCLK1_IN              =>      '0',
        TILE1_RXUSRCLK20_IN             =>      '0',
        TILE1_RXUSRCLK21_IN             =>      '0',
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE1_RXN0_IN                   =>      TILE1_RXN0_IN,
        TILE1_RXN1_IN                   =>      TILE1_RXN1_IN,
        TILE1_RXP0_IN                   =>      TILE1_RXP0_IN,
        TILE1_RXP1_IN                   =>      TILE1_RXP1_IN,
        --------------------- Shared Ports - Tile and PLL Ports --------------------
        TILE1_CLKIN_IN                  =>      t_clk_1,
        TILE1_GTPRESET_IN               =>      '0',
--        TILE1_PLLLKDET_OUT              =>      ,
        TILE1_REFCLKOUT_OUT             =>      clk_1,
--        TILE1_RESETDONE0_OUT            =>      ,
--        TILE1_RESETDONE1_OUT            =>      ,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE1_TXUSRCLK0_IN              =>      '0',
        TILE1_TXUSRCLK1_IN              =>      '0',
        TILE1_TXUSRCLK20_IN             =>      '0',
        TILE1_TXUSRCLK21_IN             =>      '0',
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE1_TXDIFFCTRL0_IN            =>      "000",
        TILE1_TXDIFFCTRL1_IN            =>      "000",
        TILE1_TXN0_OUT                  =>      TILE1_TXN0_OUT,
        TILE1_TXN1_OUT                  =>      TILE1_TXN1_OUT,
        TILE1_TXP0_OUT                  =>      TILE1_TXP0_OUT,
        TILE1_TXP1_OUT                  =>      TILE1_TXP1_OUT,
        TILE1_TXPREEMPHASIS0_IN         =>      "000",
        TILE1_TXPREEMPHASIS1_IN         =>      "000",


        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE2  (X0Y5)

        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE2_RXUSRCLK0_IN              =>      '0',
        TILE2_RXUSRCLK1_IN              =>      '0',
        TILE2_RXUSRCLK20_IN             =>      '0',
        TILE2_RXUSRCLK21_IN             =>      '0',
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE2_RXN0_IN                   =>      TILE2_RXN0_IN,
        TILE2_RXN1_IN                   =>      TILE2_RXN1_IN,
        TILE2_RXP0_IN                   =>      TILE2_RXP0_IN,
        TILE2_RXP1_IN                   =>      TILE2_RXP1_IN,
        --------------------- Shared Ports - Tile and PLL Ports --------------------
        TILE2_CLKIN_IN                  =>      t_clk_2,
        TILE2_GTPRESET_IN               =>      '0',
--        TILE2_PLLLKDET_OUT              =>      ,
        TILE2_REFCLKOUT_OUT             =>      clk_2,
--        TILE2_RESETDONE0_OUT            =>      ,
--        TILE2_RESETDONE1_OUT            =>      ,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE2_TXUSRCLK0_IN              =>      '0',
        TILE2_TXUSRCLK1_IN              =>      '0',
        TILE2_TXUSRCLK20_IN             =>      '0',
        TILE2_TXUSRCLK21_IN             =>      '0',
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE2_TXDIFFCTRL0_IN            =>      "000",
        TILE2_TXDIFFCTRL1_IN            =>      "000",
        TILE2_TXN0_OUT                  =>      TILE2_TXN0_OUT,
        TILE2_TXN1_OUT                  =>      TILE2_TXN1_OUT,
        TILE2_TXP0_OUT                  =>      TILE2_TXP0_OUT,
        TILE2_TXP1_OUT                  =>      TILE2_TXP1_OUT,
        TILE2_TXPREEMPHASIS0_IN         =>      "000",
        TILE2_TXPREEMPHASIS1_IN         =>      "000",

		  --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE3  (X0Y5)

        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE3_RXUSRCLK0_IN              =>      '0',
        TILE3_RXUSRCLK1_IN              =>      '0',
        TILE3_RXUSRCLK20_IN             =>      '0',
        TILE3_RXUSRCLK21_IN             =>      '0',
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE3_RXN0_IN                   =>      TILE3_RXN0_IN,
        TILE3_RXN1_IN                   =>      TILE3_RXN1_IN,
        TILE3_RXP0_IN                   =>      TILE3_RXP0_IN,
        TILE3_RXP1_IN                   =>      TILE3_RXP1_IN,
        --------------------- Shared Ports - Tile and PLL Ports --------------------
        TILE3_CLKIN_IN                  =>      t_clk_3,
        TILE3_GTPRESET_IN               =>      '0',
--        TILE3_PLLLKDET_OUT              =>      ,
        TILE3_REFCLKOUT_OUT             =>      clk_3,
--        TILE3_RESETDONE0_OUT            =>      ,
--        TILE3_RESETDONE1_OUT            =>      ,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE3_TXUSRCLK0_IN              =>      '0',
        TILE3_TXUSRCLK1_IN              =>      '0',
        TILE3_TXUSRCLK20_IN             =>      '0',
        TILE3_TXUSRCLK21_IN             =>      '0',
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE3_TXDIFFCTRL0_IN            =>      "000",
        TILE3_TXDIFFCTRL1_IN            =>      "000",
        TILE3_TXN0_OUT                  =>      TILE3_TXN0_OUT,
        TILE3_TXN1_OUT                  =>      TILE3_TXN1_OUT,
        TILE3_TXP0_OUT                  =>      TILE3_TXP0_OUT,
        TILE3_TXP1_OUT                  =>      TILE3_TXP1_OUT,
        TILE3_TXPREEMPHASIS0_IN         =>      "000",
        TILE3_TXPREEMPHASIS1_IN         =>      "000"


    );



    -----------------------Dedicated GTP Reference Clock Inputs ---------------
    -- Each dedicated refclk you are using in your design will need its own IBUFDS instance
    
    tile0_refclk_ibufds_i : IBUFDS
    port map
    (
        O                               =>     t_clk_0 ,
        I                               =>     clk0_p ,  -- Connect to package pin AK4
        IB                              =>     clk0_n   -- Connect to package pin AK3
    );

    tile1_refclk_ibufds_i : IBUFDS
    port map
    (
        O                               =>     t_clk_1 ,
        I                               =>     clk1_p ,  -- Connect to package pin AD4
        IB                              =>     clk1_n   -- Connect to package pin AD3
    );

    tile2_refclk_ibufds_i : IBUFDS
    port map
    (
        O                               =>      t_clk_2,
        I                               =>      clk2_p,  -- Connect to package pin V4
        IB                              =>      clk2_n  -- Connect to package pin V3
	 );	  
		  
	 tile3_refclk_ibufds_i : IBUFDS
    port map
    (
        O                               =>      t_clk_3,
        I                               =>      clk3_p,  -- Connect to package pin M4
        IB                              =>      clk3_n  -- Connect to package pin M3  
		  
    );
	 

count_proc: process(clk_50)
	begin
		if clk_50'event and clk_50 = '1' then
			count <= count + '1';
		end if;
	end process;
	 
count_proc0: process(clk_0)
	begin
		if clk_0'event and clk_0 = '1' then
			count0 <= count0 + '1';
		end if;
	end process;

count_proc1: process(clk_1)
	begin
		if clk_1'event and clk_1 = '1' then
			count1 <= count1 + '1';
		end if;
	end process;
	
count_proc2: process(clk_2)
	begin
		if clk_2'event and clk_2 = '1' then
			count2 <= count2 + '1';
		end if;
	end process;
	
count_proc3: process(clk_3)
	begin
		if clk_3'event and clk_3 = '1' then
			count3 <= count3 + '1';
		end if;
	end process;

clk_test <= count(5);
clk_test_0 <= count0(5);
clk_test_1 <= count1(5);
clk_test_2 <= count2(5);
clk_test_3 <= count3(5);

led(0) <= count(25);
led(1) <= count0(25);
led(2) <= count1(25);
led(3) <= count2(25);
led(4) <= count3(25);

end Behavioral;

