--VGA test signal 800x600 72Hz
--50MHz/1040=48.1KHz
--50MHz/1040/666=72Hz

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity vga is
  Port ( clk : in  STD_LOGIC;
			rst : in  STD_LOGIC;
         red : OUT STD_LOGIC_VECTOR(2 downto 0);
         grn : OUT STD_LOGIC_VECTOR(2 downto 0);
         blu : OUT STD_LOGIC_VECTOR(2 downto 0);
         hs : OUT STD_LOGIC;
         vs : OUT STD_LOGIC);
end vga;

architecture Behavioral of vga is

signal h_scan: STD_LOGIC_VECTOR (10 downto 0);
signal v_scan: STD_LOGIC_VECTOR (9 downto 0);
signal frame,logo,www: STD_LOGIC;

begin

  process(clk)
  begin
    if (clk'event and clk = '1') then
	   if ((rst='0') or (h_scan = 1040)) then
		  h_scan <= (others => '0');
		else
		  h_scan <= h_scan + 1;
		end if;
	 end if;
  end process;

  frame <= '1' when h_scan = 1010 else '0';

   process(frame)
  begin
    if (frame'event and frame = '1') then
      if ((rst='0') or (v_scan = 666)) then
	  	  v_scan <= (others => '0');
      else
		  v_scan <= v_scan + 1;
      end if;
    end if;
  end process;

hs <= '1' when h_scan > 856 and h_scan < 976 else '0';
vs <= '1' when v_scan > 637 and v_scan < 643 else '0';

logo <= '1' when 
(v_scan = 211 and h_scan >=364 and h_scan <= 416) or
(v_scan = 212 and h_scan >=352 and h_scan <= 429) or
(v_scan = 213 and h_scan >=342 and h_scan <= 437) or
(v_scan = 214 and h_scan >=335 and h_scan <= 446) or
(v_scan = 215 and h_scan >=328 and h_scan <= 452) or
(v_scan = 216 and h_scan >=322 and h_scan <= 366) or
(v_scan = 216 and h_scan >=414 and h_scan <= 458) or
(v_scan = 217 and h_scan >=317 and h_scan <= 353) or
(v_scan = 217 and h_scan >=428 and h_scan <= 463) or
(v_scan = 218 and h_scan >=312 and h_scan <= 343) or
(v_scan = 218 and h_scan >=437 and h_scan <= 468) or
(v_scan = 219 and h_scan >=307 and h_scan <= 336) or
(v_scan = 219 and h_scan >=445 and h_scan <= 472) or
(v_scan = 220 and h_scan >=303 and h_scan <= 329) or
(v_scan = 220 and h_scan >=452 and h_scan <= 477) or
(v_scan = 221 and h_scan >=299 and h_scan <= 323) or
(v_scan = 221 and h_scan >=458 and h_scan <= 481) or
(v_scan = 222 and h_scan >=295 and h_scan <= 317) or
(v_scan = 222 and h_scan >=464 and h_scan <= 485) or
(v_scan = 223 and h_scan >=292 and h_scan <= 312) or
(v_scan = 223 and h_scan >=468 and h_scan <= 488) or
(v_scan = 224 and h_scan >=288 and h_scan <= 307) or
(v_scan = 224 and h_scan >=473 and h_scan <= 492) or
(v_scan = 225 and h_scan >=285 and h_scan <= 303) or
(v_scan = 225 and h_scan >=477 and h_scan <= 496) or
(v_scan = 226 and h_scan >=282 and h_scan <= 299) or
(v_scan = 226 and h_scan >=481 and h_scan <= 499) or
(v_scan = 227 and h_scan >=279 and h_scan <= 295) or
(v_scan = 227 and h_scan >=485 and h_scan <= 501) or
(v_scan = 228 and h_scan >=276 and h_scan <= 291) or
(v_scan = 228 and h_scan >=489 and h_scan <= 504) or
(v_scan = 229 and h_scan >=273 and h_scan <= 288) or
(v_scan = 229 and h_scan >=492 and h_scan <= 507) or
(v_scan = 230 and h_scan >=271 and h_scan <= 285) or
(v_scan = 230 and h_scan >=496 and h_scan <= 510) or
(v_scan = 231 and h_scan >=268 and h_scan <= 282) or
(v_scan = 231 and h_scan >=499 and h_scan <= 512) or
(v_scan = 232 and h_scan >=265 and h_scan <= 278) or
(v_scan = 232 and h_scan >=502 and h_scan <= 515) or
(v_scan = 233 and h_scan >=263 and h_scan <= 276) or
(v_scan = 233 and h_scan >=504 and h_scan <= 517) or
(v_scan = 234 and h_scan >=261 and h_scan <= 273) or
(v_scan = 234 and h_scan >=507 and h_scan <= 520) or
(v_scan = 235 and h_scan >=259 and h_scan <= 270) or
(v_scan = 235 and h_scan >=510 and h_scan <= 522) or
(v_scan = 236 and h_scan >=257 and h_scan <= 268) or
(v_scan = 236 and h_scan >=513 and h_scan <= 524) or
(v_scan = 237 and h_scan >=254 and h_scan <= 265) or
(v_scan = 237 and h_scan >=515 and h_scan <= 526) or
(v_scan = 238 and h_scan >=252 and h_scan <= 263) or
(v_scan = 238 and h_scan >=517 and h_scan <= 528) or
(v_scan = 239 and h_scan >=250 and h_scan <= 261) or
(v_scan = 239 and h_scan >=520 and h_scan <= 530) or
(v_scan = 240 and h_scan >=249 and h_scan <= 259) or
(v_scan = 240 and h_scan >=522 and h_scan <= 532) or
(v_scan = 241 and h_scan >=247 and h_scan <= 256) or
(v_scan = 241 and h_scan >=524 and h_scan <= 534) or
(v_scan = 242 and h_scan >=245 and h_scan <= 254) or
(v_scan = 242 and h_scan >=526 and h_scan <= 536) or
(v_scan = 243 and h_scan >=243 and h_scan <= 252) or
(v_scan = 243 and h_scan >=528 and h_scan <= 537) or
(v_scan = 244 and h_scan >=241 and h_scan <= 250) or
(v_scan = 244 and h_scan >=530 and h_scan <= 539) or
(v_scan = 245 and h_scan >=240 and h_scan <= 249) or
(v_scan = 245 and h_scan >=532 and h_scan <= 541) or
(v_scan = 246 and h_scan >=238 and h_scan <= 247) or
(v_scan = 246 and h_scan >=534 and h_scan <= 542) or
(v_scan = 247 and h_scan >=237 and h_scan <= 245) or
(v_scan = 247 and h_scan >=535 and h_scan <= 543) or
(v_scan = 248 and h_scan >=236 and h_scan <= 243) or
(v_scan = 248 and h_scan >=537 and h_scan <= 545) or
(v_scan = 249 and h_scan >=234 and h_scan <= 242) or
(v_scan = 249 and h_scan >=539 and h_scan <= 546) or
(v_scan = 250 and h_scan >=233 and h_scan <= 240) or
(v_scan = 250 and h_scan >=540 and h_scan <= 548) or
(v_scan = 251 and h_scan >=231 and h_scan <= 239) or
(v_scan = 251 and h_scan >=542 and h_scan <= 549) or
(v_scan = 252 and h_scan >=230 and h_scan <= 237) or
(v_scan = 252 and h_scan >=543 and h_scan <= 550) or
(v_scan = 253 and h_scan >=229 and h_scan <= 236) or
(v_scan = 253 and h_scan >=545 and h_scan <= 552) or
(v_scan = 254 and h_scan >=227 and h_scan <= 234) or
(v_scan = 254 and h_scan >=546 and h_scan <= 553) or
(v_scan = 255 and h_scan >=226 and h_scan <= 233) or
(v_scan = 255 and h_scan >=547 and h_scan <= 554) or
(v_scan = 256 and h_scan >=225 and h_scan <= 232) or
(v_scan = 256 and h_scan >=549 and h_scan <= 555) or
(v_scan = 257 and h_scan >=224 and h_scan <= 230) or
(v_scan = 257 and h_scan >=550 and h_scan <= 556) or
(v_scan = 258 and h_scan >=223 and h_scan <= 229) or
(v_scan = 258 and h_scan >=551 and h_scan <= 557) or
(v_scan = 259 and h_scan >=222 and h_scan <= 228) or
(v_scan = 259 and h_scan >=552 and h_scan <= 558) or
(v_scan = 260 and h_scan >=221 and h_scan <= 227) or
(v_scan = 260 and h_scan >=553 and h_scan <= 559) or
(v_scan = 261 and h_scan >=220 and h_scan <= 226) or
(v_scan = 261 and h_scan >=554 and h_scan <= 560) or
(v_scan = 262 and h_scan >=219 and h_scan <= 225) or
(v_scan = 262 and h_scan >=555 and h_scan <= 561) or
(v_scan = 263 and h_scan >=218 and h_scan <= 224) or
(v_scan = 263 and h_scan >=262 and h_scan <= 306) or
(v_scan = 263 and h_scan >=355 and h_scan <= 395) or
(v_scan = 263 and h_scan >=556 and h_scan <= 562) or
(v_scan = 264 and h_scan >=217 and h_scan <= 223) or
(v_scan = 264 and h_scan >=261 and h_scan <= 313) or
(v_scan = 264 and h_scan >=354 and h_scan <= 401) or
(v_scan = 264 and h_scan >=557 and h_scan <= 563) or
(v_scan = 265 and h_scan >=217 and h_scan <= 222) or
(v_scan = 265 and h_scan >=260 and h_scan <= 316) or
(v_scan = 265 and h_scan >=353 and h_scan <= 404) or
(v_scan = 265 and h_scan >=558 and h_scan <= 564) or
(v_scan = 266 and h_scan >=216 and h_scan <= 221) or
(v_scan = 266 and h_scan >=260 and h_scan <= 317) or
(v_scan = 266 and h_scan >=353 and h_scan <= 407) or
(v_scan = 266 and h_scan >=490 and h_scan <= 492) or
(v_scan = 266 and h_scan >=559 and h_scan <= 565) or
(v_scan = 267 and h_scan >=215 and h_scan <= 220) or
(v_scan = 267 and h_scan >=259 and h_scan <= 319) or
(v_scan = 267 and h_scan >=352 and h_scan <= 409) or
(v_scan = 267 and h_scan >=487 and h_scan <= 495) or
(v_scan = 267 and h_scan >=560 and h_scan <= 565) or
(v_scan = 268 and h_scan >=214 and h_scan <= 219) or
(v_scan = 268 and h_scan >=258 and h_scan <= 320) or
(v_scan = 268 and h_scan >=351 and h_scan <= 410) or
(v_scan = 268 and h_scan >=485 and h_scan <= 497) or
(v_scan = 268 and h_scan >=561 and h_scan <= 566) or
(v_scan = 269 and h_scan >=214 and h_scan <= 219) or
(v_scan = 269 and h_scan >=258 and h_scan <= 321) or
(v_scan = 269 and h_scan >=351 and h_scan <= 411) or
(v_scan = 269 and h_scan >=484 and h_scan <= 498) or
(v_scan = 269 and h_scan >=562 and h_scan <= 567) or
(v_scan = 270 and h_scan >=213 and h_scan <= 218) or
(v_scan = 270 and h_scan >=257 and h_scan <= 321) or
(v_scan = 270 and h_scan >=350 and h_scan <= 412) or
(v_scan = 270 and h_scan >=483 and h_scan <= 499) or
(v_scan = 270 and h_scan >=562 and h_scan <= 567) or
(v_scan = 271 and h_scan >=212 and h_scan <= 217) or
(v_scan = 271 and h_scan >=257 and h_scan <= 322) or
(v_scan = 271 and h_scan >=330 and h_scan <= 342) or
(v_scan = 271 and h_scan >=350 and h_scan <= 413) or
(v_scan = 271 and h_scan >=432 and h_scan <= 446) or
(v_scan = 271 and h_scan >=483 and h_scan <= 499) or
(v_scan = 271 and h_scan >=563 and h_scan <= 568) or
(v_scan = 272 and h_scan >=212 and h_scan <= 216) or
(v_scan = 272 and h_scan >=256 and h_scan <= 322) or
(v_scan = 272 and h_scan >=330 and h_scan <= 342) or
(v_scan = 272 and h_scan >=349 and h_scan <= 414) or
(v_scan = 272 and h_scan >=432 and h_scan <= 445) or
(v_scan = 272 and h_scan >=482 and h_scan <= 500) or
(v_scan = 272 and h_scan >=564 and h_scan <= 568) or
(v_scan = 273 and h_scan >=211 and h_scan <= 216) or
(v_scan = 273 and h_scan >=304 and h_scan <= 322) or
(v_scan = 273 and h_scan >=329 and h_scan <= 341) or
(v_scan = 273 and h_scan >=395 and h_scan <= 415) or
(v_scan = 273 and h_scan >=431 and h_scan <= 445) or
(v_scan = 273 and h_scan >=482 and h_scan <= 500) or
(v_scan = 273 and h_scan >=564 and h_scan <= 569) or
(v_scan = 274 and h_scan >=211 and h_scan <= 215) or
(v_scan = 274 and h_scan >=306 and h_scan <= 322) or
(v_scan = 274 and h_scan >=329 and h_scan <= 341) or
(v_scan = 274 and h_scan >=397 and h_scan <= 415) or
(v_scan = 274 and h_scan >=431 and h_scan <= 445) or
(v_scan = 274 and h_scan >=481 and h_scan <= 501) or
(v_scan = 274 and h_scan >=565 and h_scan <= 570) or
(v_scan = 275 and h_scan >=210 and h_scan <= 215) or
(v_scan = 275 and h_scan >=307 and h_scan <= 323) or
(v_scan = 275 and h_scan >=329 and h_scan <= 341) or
(v_scan = 275 and h_scan >=399 and h_scan <= 415) or
(v_scan = 275 and h_scan >=431 and h_scan <= 444) or
(v_scan = 275 and h_scan >=481 and h_scan <= 501) or
(v_scan = 275 and h_scan >=566 and h_scan <= 570) or
(v_scan = 276 and h_scan >=210 and h_scan <= 214) or
(v_scan = 276 and h_scan >=307 and h_scan <= 323) or
(v_scan = 276 and h_scan >=328 and h_scan <= 340) or
(v_scan = 276 and h_scan >=400 and h_scan <= 416) or
(v_scan = 276 and h_scan >=430 and h_scan <= 444) or
(v_scan = 276 and h_scan >=481 and h_scan <= 501) or
(v_scan = 276 and h_scan >=524 and h_scan <= 530) or
(v_scan = 276 and h_scan >=566 and h_scan <= 571) or
(v_scan = 277 and h_scan >=209 and h_scan <= 214) or
(v_scan = 277 and h_scan >=307 and h_scan <= 323) or
(v_scan = 277 and h_scan >=328 and h_scan <= 340) or
(v_scan = 277 and h_scan >=400 and h_scan <= 416) or
(v_scan = 277 and h_scan >=430 and h_scan <= 444) or
(v_scan = 277 and h_scan >=482 and h_scan <= 500) or
(v_scan = 277 and h_scan >=524 and h_scan <= 530) or
(v_scan = 277 and h_scan >=567 and h_scan <= 571) or
(v_scan = 278 and h_scan >=209 and h_scan <= 213) or
(v_scan = 278 and h_scan >=275 and h_scan <= 288) or
(v_scan = 278 and h_scan >=307 and h_scan <= 322) or
(v_scan = 278 and h_scan >=328 and h_scan <= 340) or
(v_scan = 278 and h_scan >=368 and h_scan <= 381) or
(v_scan = 278 and h_scan >=401 and h_scan <= 416) or
(v_scan = 278 and h_scan >=430 and h_scan <= 443) or
(v_scan = 278 and h_scan >=482 and h_scan <= 500) or
(v_scan = 278 and h_scan >=523 and h_scan <= 529) or
(v_scan = 278 and h_scan >=567 and h_scan <= 572) or
(v_scan = 279 and h_scan >=208 and h_scan <= 213) or
(v_scan = 279 and h_scan >=274 and h_scan <= 288) or
(v_scan = 279 and h_scan >=307 and h_scan <= 322) or
(v_scan = 279 and h_scan >=327 and h_scan <= 340) or
(v_scan = 279 and h_scan >=367 and h_scan <= 381) or
(v_scan = 279 and h_scan >=401 and h_scan <= 416) or
(v_scan = 279 and h_scan >=429 and h_scan <= 443) or
(v_scan = 279 and h_scan >=483 and h_scan <= 499) or
(v_scan = 279 and h_scan >=523 and h_scan <= 529) or
(v_scan = 279 and h_scan >=568 and h_scan <= 572) or
(v_scan = 280 and h_scan >=208 and h_scan <= 212) or
(v_scan = 280 and h_scan >=274 and h_scan <= 288) or
(v_scan = 280 and h_scan >=307 and h_scan <= 322) or
(v_scan = 280 and h_scan >=327 and h_scan <= 339) or
(v_scan = 280 and h_scan >=367 and h_scan <= 381) or
(v_scan = 280 and h_scan >=402 and h_scan <= 417) or
(v_scan = 280 and h_scan >=429 and h_scan <= 443) or
(v_scan = 280 and h_scan >=483 and h_scan <= 499) or
(v_scan = 280 and h_scan >=522 and h_scan <= 529) or
(v_scan = 280 and h_scan >=568 and h_scan <= 572) or
(v_scan = 281 and h_scan >=208 and h_scan <= 212) or
(v_scan = 281 and h_scan >=274 and h_scan <= 288) or
(v_scan = 281 and h_scan >=307 and h_scan <= 322) or
(v_scan = 281 and h_scan >=327 and h_scan <= 339) or
(v_scan = 281 and h_scan >=367 and h_scan <= 381) or
(v_scan = 281 and h_scan >=402 and h_scan <= 417) or
(v_scan = 281 and h_scan >=429 and h_scan <= 443) or
(v_scan = 281 and h_scan >=484 and h_scan <= 498) or
(v_scan = 281 and h_scan >=521 and h_scan <= 529) or
(v_scan = 281 and h_scan >=568 and h_scan <= 573) or
(v_scan = 282 and h_scan >=207 and h_scan <= 211) or
(v_scan = 282 and h_scan >=274 and h_scan <= 287) or
(v_scan = 282 and h_scan >=307 and h_scan <= 321) or
(v_scan = 282 and h_scan >=327 and h_scan <= 339) or
(v_scan = 282 and h_scan >=367 and h_scan <= 380) or
(v_scan = 282 and h_scan >=402 and h_scan <= 417) or
(v_scan = 282 and h_scan >=429 and h_scan <= 442) or
(v_scan = 282 and h_scan >=485 and h_scan <= 497) or
(v_scan = 282 and h_scan >=521 and h_scan <= 528) or
(v_scan = 282 and h_scan >=569 and h_scan <= 573) or
(v_scan = 283 and h_scan >=207 and h_scan <= 211) or
(v_scan = 283 and h_scan >=273 and h_scan <= 287) or
(v_scan = 283 and h_scan >=307 and h_scan <= 321) or
(v_scan = 283 and h_scan >=326 and h_scan <= 338) or
(v_scan = 283 and h_scan >=366 and h_scan <= 380) or
(v_scan = 283 and h_scan >=402 and h_scan <= 417) or
(v_scan = 283 and h_scan >=428 and h_scan <= 442) or
(v_scan = 283 and h_scan >=487 and h_scan <= 495) or
(v_scan = 283 and h_scan >=520 and h_scan <= 528) or
(v_scan = 283 and h_scan >=569 and h_scan <= 573) or
(v_scan = 284 and h_scan >=207 and h_scan <= 211) or
(v_scan = 284 and h_scan >=273 and h_scan <= 287) or
(v_scan = 284 and h_scan >=306 and h_scan <= 320) or
(v_scan = 284 and h_scan >=326 and h_scan <= 338) or
(v_scan = 284 and h_scan >=366 and h_scan <= 380) or
(v_scan = 284 and h_scan >=402 and h_scan <= 416) or
(v_scan = 284 and h_scan >=428 and h_scan <= 442) or
(v_scan = 284 and h_scan >=490 and h_scan <= 492) or
(v_scan = 284 and h_scan >=519 and h_scan <= 528) or
(v_scan = 284 and h_scan >=569 and h_scan <= 573) or
(v_scan = 285 and h_scan >=207 and h_scan <= 211) or
(v_scan = 285 and h_scan >=273 and h_scan <= 286) or
(v_scan = 285 and h_scan >=306 and h_scan <= 320) or
(v_scan = 285 and h_scan >=326 and h_scan <= 338) or
(v_scan = 285 and h_scan >=366 and h_scan <= 379) or
(v_scan = 285 and h_scan >=402 and h_scan <= 416) or
(v_scan = 285 and h_scan >=428 and h_scan <= 441) or
(v_scan = 285 and h_scan >=454 and h_scan <= 461) or
(v_scan = 285 and h_scan >=519 and h_scan <= 527) or
(v_scan = 285 and h_scan >=570 and h_scan <= 574) or
(v_scan = 286 and h_scan >=206 and h_scan <= 210) or
(v_scan = 286 and h_scan >=272 and h_scan <= 286) or
(v_scan = 286 and h_scan >=305 and h_scan <= 319) or
(v_scan = 286 and h_scan >=325 and h_scan <= 337) or
(v_scan = 286 and h_scan >=365 and h_scan <= 379) or
(v_scan = 286 and h_scan >=402 and h_scan <= 416) or
(v_scan = 286 and h_scan >=427 and h_scan <= 441) or
(v_scan = 286 and h_scan >=453 and h_scan <= 460) or
(v_scan = 286 and h_scan >=518 and h_scan <= 527) or
(v_scan = 286 and h_scan >=570 and h_scan <= 574) or
(v_scan = 287 and h_scan >=206 and h_scan <= 210) or
(v_scan = 287 and h_scan >=272 and h_scan <= 286) or
(v_scan = 287 and h_scan >=304 and h_scan <= 318) or
(v_scan = 287 and h_scan >=325 and h_scan <= 337) or
(v_scan = 287 and h_scan >=365 and h_scan <= 379) or
(v_scan = 287 and h_scan >=402 and h_scan <= 416) or
(v_scan = 287 and h_scan >=427 and h_scan <= 441) or
(v_scan = 287 and h_scan >=452 and h_scan <= 459) or
(v_scan = 287 and h_scan >=517 and h_scan <= 527) or
(v_scan = 287 and h_scan >=570 and h_scan <= 574) or
(v_scan = 288 and h_scan >=206 and h_scan <= 210) or
(v_scan = 288 and h_scan >=272 and h_scan <= 285) or
(v_scan = 288 and h_scan >=303 and h_scan <= 317) or
(v_scan = 288 and h_scan >=325 and h_scan <= 337) or
(v_scan = 288 and h_scan >=365 and h_scan <= 378) or
(v_scan = 288 and h_scan >=402 and h_scan <= 415) or
(v_scan = 288 and h_scan >=427 and h_scan <= 440) or
(v_scan = 288 and h_scan >=451 and h_scan <= 458) or
(v_scan = 288 and h_scan >=515 and h_scan <= 526) or
(v_scan = 288 and h_scan >=570 and h_scan <= 574) or
(v_scan = 289 and h_scan >=206 and h_scan <= 210) or
(v_scan = 289 and h_scan >=271 and h_scan <= 285) or
(v_scan = 289 and h_scan >=302 and h_scan <= 316) or
(v_scan = 289 and h_scan >=324 and h_scan <= 336) or
(v_scan = 289 and h_scan >=364 and h_scan <= 378) or
(v_scan = 289 and h_scan >=402 and h_scan <= 415) or
(v_scan = 289 and h_scan >=426 and h_scan <= 440) or
(v_scan = 289 and h_scan >=450 and h_scan <= 457) or
(v_scan = 289 and h_scan >=514 and h_scan <= 526) or
(v_scan = 289 and h_scan >=570 and h_scan <= 574) or
(v_scan = 290 and h_scan >=206 and h_scan <= 210) or
(v_scan = 290 and h_scan >=271 and h_scan <= 285) or
(v_scan = 290 and h_scan >=301 and h_scan <= 315) or
(v_scan = 290 and h_scan >=324 and h_scan <= 336) or
(v_scan = 290 and h_scan >=364 and h_scan <= 378) or
(v_scan = 290 and h_scan >=402 and h_scan <= 415) or
(v_scan = 290 and h_scan >=426 and h_scan <= 440) or
(v_scan = 290 and h_scan >=449 and h_scan <= 456) or
(v_scan = 290 and h_scan >=512 and h_scan <= 526) or
(v_scan = 290 and h_scan >=570 and h_scan <= 575) or
(v_scan = 291 and h_scan >=206 and h_scan <= 210) or
(v_scan = 291 and h_scan >=271 and h_scan <= 284) or
(v_scan = 291 and h_scan >=299 and h_scan <= 314) or
(v_scan = 291 and h_scan >=324 and h_scan <= 336) or
(v_scan = 291 and h_scan >=364 and h_scan <= 378) or
(v_scan = 291 and h_scan >=401 and h_scan <= 414) or
(v_scan = 291 and h_scan >=426 and h_scan <= 439) or
(v_scan = 291 and h_scan >=448 and h_scan <= 455) or
(v_scan = 291 and h_scan >=509 and h_scan <= 526) or
(v_scan = 291 and h_scan >=571 and h_scan <= 575) or
(v_scan = 292 and h_scan >=206 and h_scan <= 210) or
(v_scan = 292 and h_scan >=271 and h_scan <= 284) or
(v_scan = 292 and h_scan >=298 and h_scan <= 312) or
(v_scan = 292 and h_scan >=324 and h_scan <= 336) or
(v_scan = 292 and h_scan >=364 and h_scan <= 377) or
(v_scan = 292 and h_scan >=401 and h_scan <= 414) or
(v_scan = 292 and h_scan >=426 and h_scan <= 439) or
(v_scan = 292 and h_scan >=447 and h_scan <= 454) or
(v_scan = 292 and h_scan >=481 and h_scan <= 494) or
(v_scan = 292 and h_scan >=506 and h_scan <= 534) or
(v_scan = 292 and h_scan >=571 and h_scan <= 575) or
(v_scan = 293 and h_scan >=206 and h_scan <= 210) or
(v_scan = 293 and h_scan >=270 and h_scan <= 284) or
(v_scan = 293 and h_scan >=296 and h_scan <= 311) or
(v_scan = 293 and h_scan >=323 and h_scan <= 335) or
(v_scan = 293 and h_scan >=363 and h_scan <= 377) or
(v_scan = 293 and h_scan >=401 and h_scan <= 413) or
(v_scan = 293 and h_scan >=425 and h_scan <= 439) or
(v_scan = 293 and h_scan >=446 and h_scan <= 453) or
(v_scan = 293 and h_scan >=480 and h_scan <= 494) or
(v_scan = 293 and h_scan >=505 and h_scan <= 534) or
(v_scan = 293 and h_scan >=571 and h_scan <= 575) or
(v_scan = 294 and h_scan >=206 and h_scan <= 210) or
(v_scan = 294 and h_scan >=270 and h_scan <= 283) or
(v_scan = 294 and h_scan >=294 and h_scan <= 309) or
(v_scan = 294 and h_scan >=323 and h_scan <= 335) or
(v_scan = 294 and h_scan >=363 and h_scan <= 377) or
(v_scan = 294 and h_scan >=400 and h_scan <= 413) or
(v_scan = 294 and h_scan >=425 and h_scan <= 439) or
(v_scan = 294 and h_scan >=445 and h_scan <= 457) or
(v_scan = 294 and h_scan >=480 and h_scan <= 494) or
(v_scan = 294 and h_scan >=505 and h_scan <= 533) or
(v_scan = 294 and h_scan >=571 and h_scan <= 575) or
(v_scan = 295 and h_scan >=206 and h_scan <= 210) or
(v_scan = 295 and h_scan >=270 and h_scan <= 283) or
(v_scan = 295 and h_scan >=291 and h_scan <= 308) or
(v_scan = 295 and h_scan >=323 and h_scan <= 335) or
(v_scan = 295 and h_scan >=363 and h_scan <= 376) or
(v_scan = 295 and h_scan >=400 and h_scan <= 412) or
(v_scan = 295 and h_scan >=425 and h_scan <= 438) or
(v_scan = 295 and h_scan >=444 and h_scan <= 460) or
(v_scan = 295 and h_scan >=480 and h_scan <= 493) or
(v_scan = 295 and h_scan >=505 and h_scan <= 532) or
(v_scan = 295 and h_scan >=571 and h_scan <= 575) or
(v_scan = 296 and h_scan >=206 and h_scan <= 210) or
(v_scan = 296 and h_scan >=269 and h_scan <= 283) or
(v_scan = 296 and h_scan >=288 and h_scan <= 306) or
(v_scan = 296 and h_scan >=322 and h_scan <= 334) or
(v_scan = 296 and h_scan >=362 and h_scan <= 376) or
(v_scan = 296 and h_scan >=399 and h_scan <= 412) or
(v_scan = 296 and h_scan >=424 and h_scan <= 438) or
(v_scan = 296 and h_scan >=443 and h_scan <= 460) or
(v_scan = 296 and h_scan >=479 and h_scan <= 493) or
(v_scan = 296 and h_scan >=504 and h_scan <= 531) or
(v_scan = 296 and h_scan >=570 and h_scan <= 575) or
(v_scan = 297 and h_scan >=206 and h_scan <= 210) or
(v_scan = 297 and h_scan >=269 and h_scan <= 304) or
(v_scan = 297 and h_scan >=322 and h_scan <= 334) or
(v_scan = 297 and h_scan >=362 and h_scan <= 376) or
(v_scan = 297 and h_scan >=399 and h_scan <= 411) or
(v_scan = 297 and h_scan >=424 and h_scan <= 438) or
(v_scan = 297 and h_scan >=442 and h_scan <= 461) or
(v_scan = 297 and h_scan >=479 and h_scan <= 493) or
(v_scan = 297 and h_scan >=504 and h_scan <= 528) or
(v_scan = 297 and h_scan >=570 and h_scan <= 574) or
(v_scan = 298 and h_scan >=206 and h_scan <= 210) or
(v_scan = 298 and h_scan >=269 and h_scan <= 301) or
(v_scan = 298 and h_scan >=322 and h_scan <= 334) or
(v_scan = 298 and h_scan >=362 and h_scan <= 375) or
(v_scan = 298 and h_scan >=398 and h_scan <= 410) or
(v_scan = 298 and h_scan >=424 and h_scan <= 437) or
(v_scan = 298 and h_scan >=441 and h_scan <= 461) or
(v_scan = 298 and h_scan >=479 and h_scan <= 492) or
(v_scan = 298 and h_scan >=510 and h_scan <= 523) or
(v_scan = 298 and h_scan >=570 and h_scan <= 574) or
(v_scan = 299 and h_scan >=206 and h_scan <= 210) or
(v_scan = 299 and h_scan >=268 and h_scan <= 299) or
(v_scan = 299 and h_scan >=321 and h_scan <= 333) or
(v_scan = 299 and h_scan >=361 and h_scan <= 375) or
(v_scan = 299 and h_scan >=398 and h_scan <= 410) or
(v_scan = 299 and h_scan >=423 and h_scan <= 437) or
(v_scan = 299 and h_scan >=440 and h_scan <= 461) or
(v_scan = 299 and h_scan >=478 and h_scan <= 492) or
(v_scan = 299 and h_scan >=509 and h_scan <= 523) or
(v_scan = 299 and h_scan >=570 and h_scan <= 574) or
(v_scan = 300 and h_scan >=206 and h_scan <= 210) or
(v_scan = 300 and h_scan >=268 and h_scan <= 296) or
(v_scan = 300 and h_scan >=321 and h_scan <= 333) or
(v_scan = 300 and h_scan >=361 and h_scan <= 375) or
(v_scan = 300 and h_scan >=397 and h_scan <= 409) or
(v_scan = 300 and h_scan >=423 and h_scan <= 437) or
(v_scan = 300 and h_scan >=439 and h_scan <= 461) or
(v_scan = 300 and h_scan >=478 and h_scan <= 492) or
(v_scan = 300 and h_scan >=509 and h_scan <= 523) or
(v_scan = 300 and h_scan >=570 and h_scan <= 574) or
(v_scan = 301 and h_scan >=206 and h_scan <= 211) or
(v_scan = 301 and h_scan >=268 and h_scan <= 293) or
(v_scan = 301 and h_scan >=321 and h_scan <= 333) or
(v_scan = 301 and h_scan >=361 and h_scan <= 374) or
(v_scan = 301 and h_scan >=396 and h_scan <= 408) or
(v_scan = 301 and h_scan >=423 and h_scan <= 444) or
(v_scan = 301 and h_scan >=447 and h_scan <= 460) or
(v_scan = 301 and h_scan >=478 and h_scan <= 491) or
(v_scan = 301 and h_scan >=509 and h_scan <= 522) or
(v_scan = 301 and h_scan >=570 and h_scan <= 574) or
(v_scan = 302 and h_scan >=207 and h_scan <= 211) or
(v_scan = 302 and h_scan >=267 and h_scan <= 290) or
(v_scan = 302 and h_scan >=320 and h_scan <= 333) or
(v_scan = 302 and h_scan >=361 and h_scan <= 374) or
(v_scan = 302 and h_scan >=395 and h_scan <= 407) or
(v_scan = 302 and h_scan >=422 and h_scan <= 443) or
(v_scan = 302 and h_scan >=446 and h_scan <= 460) or
(v_scan = 302 and h_scan >=477 and h_scan <= 491) or
(v_scan = 302 and h_scan >=508 and h_scan <= 522) or
(v_scan = 302 and h_scan >=569 and h_scan <= 574) or
(v_scan = 303 and h_scan >=207 and h_scan <= 211) or
(v_scan = 303 and h_scan >=267 and h_scan <= 286) or
(v_scan = 303 and h_scan >=320 and h_scan <= 332) or
(v_scan = 303 and h_scan >=360 and h_scan <= 374) or
(v_scan = 303 and h_scan >=394 and h_scan <= 406) or
(v_scan = 303 and h_scan >=422 and h_scan <= 442) or
(v_scan = 303 and h_scan >=446 and h_scan <= 460) or
(v_scan = 303 and h_scan >=477 and h_scan <= 491) or
(v_scan = 303 and h_scan >=508 and h_scan <= 522) or
(v_scan = 303 and h_scan >=569 and h_scan <= 573) or
(v_scan = 304 and h_scan >=207 and h_scan <= 211) or
(v_scan = 304 and h_scan >=267 and h_scan <= 282) or
(v_scan = 304 and h_scan >=320 and h_scan <= 332) or
(v_scan = 304 and h_scan >=360 and h_scan <= 374) or
(v_scan = 304 and h_scan >=393 and h_scan <= 405) or
(v_scan = 304 and h_scan >=422 and h_scan <= 441) or
(v_scan = 304 and h_scan >=446 and h_scan <= 460) or
(v_scan = 304 and h_scan >=477 and h_scan <= 491) or
(v_scan = 304 and h_scan >=508 and h_scan <= 521) or
(v_scan = 304 and h_scan >=569 and h_scan <= 573) or
(v_scan = 305 and h_scan >=208 and h_scan <= 212) or
(v_scan = 305 and h_scan >=267 and h_scan <= 280) or
(v_scan = 305 and h_scan >=320 and h_scan <= 332) or
(v_scan = 305 and h_scan >=360 and h_scan <= 373) or
(v_scan = 305 and h_scan >=392 and h_scan <= 404) or
(v_scan = 305 and h_scan >=422 and h_scan <= 440) or
(v_scan = 305 and h_scan >=446 and h_scan <= 459) or
(v_scan = 305 and h_scan >=477 and h_scan <= 490) or
(v_scan = 305 and h_scan >=508 and h_scan <= 521) or
(v_scan = 305 and h_scan >=569 and h_scan <= 573) or
(v_scan = 306 and h_scan >=208 and h_scan <= 212) or
(v_scan = 306 and h_scan >=266 and h_scan <= 280) or
(v_scan = 306 and h_scan >=319 and h_scan <= 331) or
(v_scan = 306 and h_scan >=359 and h_scan <= 373) or
(v_scan = 306 and h_scan >=391 and h_scan <= 403) or
(v_scan = 306 and h_scan >=421 and h_scan <= 439) or
(v_scan = 306 and h_scan >=445 and h_scan <= 459) or
(v_scan = 306 and h_scan >=476 and h_scan <= 490) or
(v_scan = 306 and h_scan >=507 and h_scan <= 521) or
(v_scan = 306 and h_scan >=568 and h_scan <= 572) or
(v_scan = 307 and h_scan >=208 and h_scan <= 212) or
(v_scan = 307 and h_scan >=266 and h_scan <= 280) or
(v_scan = 307 and h_scan >=319 and h_scan <= 331) or
(v_scan = 307 and h_scan >=359 and h_scan <= 373) or
(v_scan = 307 and h_scan >=390 and h_scan <= 402) or
(v_scan = 307 and h_scan >=421 and h_scan <= 438) or
(v_scan = 307 and h_scan >=445 and h_scan <= 459) or
(v_scan = 307 and h_scan >=476 and h_scan <= 490) or
(v_scan = 307 and h_scan >=507 and h_scan <= 521) or
(v_scan = 307 and h_scan >=568 and h_scan <= 572) or
(v_scan = 308 and h_scan >=209 and h_scan <= 213) or
(v_scan = 308 and h_scan >=266 and h_scan <= 279) or
(v_scan = 308 and h_scan >=319 and h_scan <= 331) or
(v_scan = 308 and h_scan >=359 and h_scan <= 372) or
(v_scan = 308 and h_scan >=388 and h_scan <= 400) or
(v_scan = 308 and h_scan >=421 and h_scan <= 437) or
(v_scan = 308 and h_scan >=445 and h_scan <= 458) or
(v_scan = 308 and h_scan >=476 and h_scan <= 489) or
(v_scan = 308 and h_scan >=507 and h_scan <= 520) or
(v_scan = 308 and h_scan >=567 and h_scan <= 572) or
(v_scan = 309 and h_scan >=209 and h_scan <= 213) or
(v_scan = 309 and h_scan >=265 and h_scan <= 279) or
(v_scan = 309 and h_scan >=318 and h_scan <= 330) or
(v_scan = 309 and h_scan >=358 and h_scan <= 372) or
(v_scan = 309 and h_scan >=387 and h_scan <= 399) or
(v_scan = 309 and h_scan >=420 and h_scan <= 436) or
(v_scan = 309 and h_scan >=444 and h_scan <= 458) or
(v_scan = 309 and h_scan >=475 and h_scan <= 489) or
(v_scan = 309 and h_scan >=506 and h_scan <= 520) or
(v_scan = 309 and h_scan >=567 and h_scan <= 571) or
(v_scan = 310 and h_scan >=209 and h_scan <= 214) or
(v_scan = 310 and h_scan >=265 and h_scan <= 279) or
(v_scan = 310 and h_scan >=318 and h_scan <= 330) or
(v_scan = 310 and h_scan >=358 and h_scan <= 372) or
(v_scan = 310 and h_scan >=385 and h_scan <= 397) or
(v_scan = 310 and h_scan >=420 and h_scan <= 435) or
(v_scan = 310 and h_scan >=444 and h_scan <= 458) or
(v_scan = 310 and h_scan >=475 and h_scan <= 489) or
(v_scan = 310 and h_scan >=506 and h_scan <= 520) or
(v_scan = 310 and h_scan >=566 and h_scan <= 571) or
(v_scan = 311 and h_scan >=210 and h_scan <= 214) or
(v_scan = 311 and h_scan >=265 and h_scan <= 278) or
(v_scan = 311 and h_scan >=318 and h_scan <= 330) or
(v_scan = 311 and h_scan >=358 and h_scan <= 371) or
(v_scan = 311 and h_scan >=382 and h_scan <= 396) or
(v_scan = 311 and h_scan >=420 and h_scan <= 433) or
(v_scan = 311 and h_scan >=444 and h_scan <= 457) or
(v_scan = 311 and h_scan >=475 and h_scan <= 488) or
(v_scan = 311 and h_scan >=506 and h_scan <= 519) or
(v_scan = 311 and h_scan >=566 and h_scan <= 570) or
(v_scan = 312 and h_scan >=210 and h_scan <= 215) or
(v_scan = 312 and h_scan >=264 and h_scan <= 278) or
(v_scan = 312 and h_scan >=317 and h_scan <= 329) or
(v_scan = 312 and h_scan >=357 and h_scan <= 371) or
(v_scan = 312 and h_scan >=379 and h_scan <= 394) or
(v_scan = 312 and h_scan >=419 and h_scan <= 432) or
(v_scan = 312 and h_scan >=443 and h_scan <= 457) or
(v_scan = 312 and h_scan >=474 and h_scan <= 488) or
(v_scan = 312 and h_scan >=505 and h_scan <= 519) or
(v_scan = 312 and h_scan >=565 and h_scan <= 570) or
(v_scan = 313 and h_scan >=211 and h_scan <= 216) or
(v_scan = 313 and h_scan >=264 and h_scan <= 278) or
(v_scan = 313 and h_scan >=317 and h_scan <= 346) or
(v_scan = 313 and h_scan >=357 and h_scan <= 391) or
(v_scan = 313 and h_scan >=419 and h_scan <= 431) or
(v_scan = 313 and h_scan >=443 and h_scan <= 503) or
(v_scan = 313 and h_scan >=505 and h_scan <= 539) or
(v_scan = 313 and h_scan >=565 and h_scan <= 569) or
(v_scan = 314 and h_scan >=212 and h_scan <= 216) or
(v_scan = 314 and h_scan >=264 and h_scan <= 278) or
(v_scan = 314 and h_scan >=317 and h_scan <= 346) or
(v_scan = 314 and h_scan >=357 and h_scan <= 389) or
(v_scan = 314 and h_scan >=419 and h_scan <= 430) or
(v_scan = 314 and h_scan >=443 and h_scan <= 472) or
(v_scan = 314 and h_scan >=474 and h_scan <= 503) or
(v_scan = 314 and h_scan >=505 and h_scan <= 539) or
(v_scan = 314 and h_scan >=564 and h_scan <= 569) or
(v_scan = 315 and h_scan >=212 and h_scan <= 217) or
(v_scan = 315 and h_scan >=264 and h_scan <= 277) or
(v_scan = 315 and h_scan >=317 and h_scan <= 345) or
(v_scan = 315 and h_scan >=357 and h_scan <= 386) or
(v_scan = 315 and h_scan >=419 and h_scan <= 429) or
(v_scan = 315 and h_scan >=443 and h_scan <= 471) or
(v_scan = 315 and h_scan >=474 and h_scan <= 502) or
(v_scan = 315 and h_scan >=505 and h_scan <= 538) or
(v_scan = 315 and h_scan >=563 and h_scan <= 568) or
(v_scan = 316 and h_scan >=213 and h_scan <= 218) or
(v_scan = 316 and h_scan >=263 and h_scan <= 277) or
(v_scan = 316 and h_scan >=317 and h_scan <= 344) or
(v_scan = 316 and h_scan >=356 and h_scan <= 383) or
(v_scan = 316 and h_scan >=418 and h_scan <= 428) or
(v_scan = 316 and h_scan >=443 and h_scan <= 470) or
(v_scan = 316 and h_scan >=475 and h_scan <= 501) or
(v_scan = 316 and h_scan >=505 and h_scan <= 537) or
(v_scan = 316 and h_scan >=563 and h_scan <= 568) or
(v_scan = 317 and h_scan >=213 and h_scan <= 218) or
(v_scan = 317 and h_scan >=263 and h_scan <= 277) or
(v_scan = 317 and h_scan >=318 and h_scan <= 342) or
(v_scan = 317 and h_scan >=356 and h_scan <= 379) or
(v_scan = 317 and h_scan >=418 and h_scan <= 426) or
(v_scan = 317 and h_scan >=444 and h_scan <= 468) or
(v_scan = 317 and h_scan >=476 and h_scan <= 499) or
(v_scan = 317 and h_scan >=506 and h_scan <= 535) or
(v_scan = 317 and h_scan >=562 and h_scan <= 567) or
(v_scan = 318 and h_scan >=214 and h_scan <= 219) or
(v_scan = 318 and h_scan >=263 and h_scan <= 276) or
(v_scan = 318 and h_scan >=321 and h_scan <= 338) or
(v_scan = 318 and h_scan >=356 and h_scan <= 371) or
(v_scan = 318 and h_scan >=418 and h_scan <= 423) or
(v_scan = 318 and h_scan >=447 and h_scan <= 464) or
(v_scan = 318 and h_scan >=478 and h_scan <= 496) or
(v_scan = 318 and h_scan >=509 and h_scan <= 532) or
(v_scan = 318 and h_scan >=561 and h_scan <= 566) or
(v_scan = 319 and h_scan >=215 and h_scan <= 220) or
(v_scan = 319 and h_scan >=560 and h_scan <= 565) or
(v_scan = 320 and h_scan >=215 and h_scan <= 221) or
(v_scan = 320 and h_scan >=560 and h_scan <= 565) or
(v_scan = 321 and h_scan >=216 and h_scan <= 222) or
(v_scan = 321 and h_scan >=559 and h_scan <= 564) or
(v_scan = 322 and h_scan >=217 and h_scan <= 222) or
(v_scan = 322 and h_scan >=558 and h_scan <= 563) or
(v_scan = 323 and h_scan >=218 and h_scan <= 223) or
(v_scan = 323 and h_scan >=557 and h_scan <= 562) or
(v_scan = 324 and h_scan >=219 and h_scan <= 224) or
(v_scan = 324 and h_scan >=556 and h_scan <= 561) or
(v_scan = 325 and h_scan >=220 and h_scan <= 225) or
(v_scan = 325 and h_scan >=555 and h_scan <= 561) or
(v_scan = 326 and h_scan >=221 and h_scan <= 226) or
(v_scan = 326 and h_scan >=554 and h_scan <= 560) or
(v_scan = 327 and h_scan >=222 and h_scan <= 228) or
(v_scan = 327 and h_scan >=553 and h_scan <= 559) or
(v_scan = 328 and h_scan >=223 and h_scan <= 229) or
(v_scan = 328 and h_scan >=551 and h_scan <= 558) or
(v_scan = 329 and h_scan >=224 and h_scan <= 230) or
(v_scan = 329 and h_scan >=550 and h_scan <= 557) or
(v_scan = 330 and h_scan >=225 and h_scan <= 231) or
(v_scan = 330 and h_scan >=549 and h_scan <= 555) or
(v_scan = 331 and h_scan >=226 and h_scan <= 232) or
(v_scan = 331 and h_scan >=548 and h_scan <= 554) or
(v_scan = 332 and h_scan >=227 and h_scan <= 234) or
(v_scan = 332 and h_scan >=546 and h_scan <= 553) or
(v_scan = 333 and h_scan >=228 and h_scan <= 235) or
(v_scan = 333 and h_scan >=545 and h_scan <= 552) or
(v_scan = 334 and h_scan >=229 and h_scan <= 236) or
(v_scan = 334 and h_scan >=544 and h_scan <= 551) or
(v_scan = 335 and h_scan >=231 and h_scan <= 238) or
(v_scan = 335 and h_scan >=542 and h_scan <= 550) or
(v_scan = 336 and h_scan >=232 and h_scan <= 239) or
(v_scan = 336 and h_scan >=541 and h_scan <= 548) or
(v_scan = 337 and h_scan >=233 and h_scan <= 241) or
(v_scan = 337 and h_scan >=539 and h_scan <= 547) or
(v_scan = 338 and h_scan >=235 and h_scan <= 243) or
(v_scan = 338 and h_scan >=538 and h_scan <= 545) or
(v_scan = 339 and h_scan >=236 and h_scan <= 244) or
(v_scan = 339 and h_scan >=536 and h_scan <= 544) or
(v_scan = 340 and h_scan >=238 and h_scan <= 246) or
(v_scan = 340 and h_scan >=534 and h_scan <= 543) or
(v_scan = 341 and h_scan >=239 and h_scan <= 248) or
(v_scan = 341 and h_scan >=533 and h_scan <= 541) or
(v_scan = 342 and h_scan >=241 and h_scan <= 250) or
(v_scan = 342 and h_scan >=531 and h_scan <= 539) or
(v_scan = 343 and h_scan >=242 and h_scan <= 252) or
(v_scan = 343 and h_scan >=529 and h_scan <= 538) or
(v_scan = 344 and h_scan >=244 and h_scan <= 254) or
(v_scan = 344 and h_scan >=527 and h_scan <= 536) or
(v_scan = 345 and h_scan >=246 and h_scan <= 255) or
(v_scan = 345 and h_scan >=525 and h_scan <= 534) or
(v_scan = 346 and h_scan >=248 and h_scan <= 257) or
(v_scan = 346 and h_scan >=523 and h_scan <= 533) or
(v_scan = 347 and h_scan >=250 and h_scan <= 260) or
(v_scan = 347 and h_scan >=520 and h_scan <= 531) or
(v_scan = 348 and h_scan >=252 and h_scan <= 262) or
(v_scan = 348 and h_scan >=518 and h_scan <= 529) or
(v_scan = 349 and h_scan >=253 and h_scan <= 265) or
(v_scan = 349 and h_scan >=516 and h_scan <= 527) or
(v_scan = 350 and h_scan >=255 and h_scan <= 267) or
(v_scan = 350 and h_scan >=514 and h_scan <= 525) or
(v_scan = 351 and h_scan >=257 and h_scan <= 269) or
(v_scan = 351 and h_scan >=511 and h_scan <= 523) or
(v_scan = 352 and h_scan >=260 and h_scan <= 272) or
(v_scan = 352 and h_scan >=508 and h_scan <= 520) or
(v_scan = 353 and h_scan >=262 and h_scan <= 275) or
(v_scan = 353 and h_scan >=506 and h_scan <= 518) or
(v_scan = 354 and h_scan >=265 and h_scan <= 278) or
(v_scan = 354 and h_scan >=503 and h_scan <= 516) or
(v_scan = 355 and h_scan >=267 and h_scan <= 280) or
(v_scan = 355 and h_scan >=500 and h_scan <= 513) or
(v_scan = 356 and h_scan >=269 and h_scan <= 283) or
(v_scan = 356 and h_scan >=497 and h_scan <= 511) or
(v_scan = 357 and h_scan >=272 and h_scan <= 287) or
(v_scan = 357 and h_scan >=494 and h_scan <= 508) or
(v_scan = 358 and h_scan >=275 and h_scan <= 290) or
(v_scan = 358 and h_scan >=490 and h_scan <= 506) or
(v_scan = 359 and h_scan >=278 and h_scan <= 294) or
(v_scan = 359 and h_scan >=487 and h_scan <= 503) or
(v_scan = 360 and h_scan >=281 and h_scan <= 298) or
(v_scan = 360 and h_scan >=483 and h_scan <= 500) or
(v_scan = 361 and h_scan >=283 and h_scan <= 301) or
(v_scan = 361 and h_scan >=479 and h_scan <= 497) or
(v_scan = 362 and h_scan >=287 and h_scan <= 302) or
(v_scan = 362 and h_scan >=475 and h_scan <= 493) or
(v_scan = 363 and h_scan >=290 and h_scan <= 302) or
(v_scan = 363 and h_scan >=470 and h_scan <= 490) or
(v_scan = 364 and h_scan >=294 and h_scan <= 303) or
(v_scan = 364 and h_scan >=465 and h_scan <= 487) or
(v_scan = 365 and h_scan >=298 and h_scan <= 303) or
(v_scan = 365 and h_scan >=460 and h_scan <= 483) or
(v_scan = 366 and h_scan >=299 and h_scan <= 304) or
(v_scan = 366 and h_scan >=454 and h_scan <= 479) or
(v_scan = 367 and h_scan >=300 and h_scan <= 304) or
(v_scan = 367 and h_scan >=448 and h_scan <= 475) or
(v_scan = 368 and h_scan >=300 and h_scan <= 305) or
(v_scan = 368 and h_scan >=441 and h_scan <= 470) or
(v_scan = 369 and h_scan >=301 and h_scan <= 305) or
(v_scan = 369 and h_scan >=432 and h_scan <= 465) or
(v_scan = 370 and h_scan >=301 and h_scan <= 306) or
(v_scan = 370 and h_scan >=421 and h_scan <= 460) or
(v_scan = 371 and h_scan >=302 and h_scan <= 306) or
(v_scan = 371 and h_scan >=365 and h_scan <= 386) or
(v_scan = 371 and h_scan >=398 and h_scan <= 455) or
(v_scan = 372 and h_scan >=302 and h_scan <= 306) or
(v_scan = 372 and h_scan >=363 and h_scan <= 449) or
(v_scan = 373 and h_scan >=303 and h_scan <= 307) or
(v_scan = 373 and h_scan >=360 and h_scan <= 441) or
(v_scan = 374 and h_scan >=303 and h_scan <= 307) or
(v_scan = 374 and h_scan >=358 and h_scan <= 433) or
(v_scan = 375 and h_scan >=304 and h_scan <= 308) or
(v_scan = 375 and h_scan >=355 and h_scan <= 422) or
(v_scan = 376 and h_scan >=304 and h_scan <= 308) or
(v_scan = 376 and h_scan >=353 and h_scan <= 365) or
(v_scan = 376 and h_scan >=377 and h_scan <= 405) or
(v_scan = 377 and h_scan >=304 and h_scan <= 309) or
(v_scan = 377 and h_scan >=350 and h_scan <= 363) or
(v_scan = 378 and h_scan >=305 and h_scan <= 309) or
(v_scan = 378 and h_scan >=348 and h_scan <= 360) or
(v_scan = 379 and h_scan >=305 and h_scan <= 310) or
(v_scan = 379 and h_scan >=345 and h_scan <= 358) or
(v_scan = 380 and h_scan >=306 and h_scan <= 310) or
(v_scan = 380 and h_scan >=343 and h_scan <= 355) or
(v_scan = 381 and h_scan >=306 and h_scan <= 311) or
(v_scan = 381 and h_scan >=340 and h_scan <= 353) or
(v_scan = 382 and h_scan >=307 and h_scan <= 311) or
(v_scan = 382 and h_scan >=338 and h_scan <= 350) or
(v_scan = 383 and h_scan >=307 and h_scan <= 311) or
(v_scan = 383 and h_scan >=335 and h_scan <= 348) or
(v_scan = 384 and h_scan >=308 and h_scan <= 312) or
(v_scan = 384 and h_scan >=333 and h_scan <= 345) or
(v_scan = 385 and h_scan >=308 and h_scan <= 312) or
(v_scan = 385 and h_scan >=330 and h_scan <= 343) or
(v_scan = 386 and h_scan >=308 and h_scan <= 313) or
(v_scan = 386 and h_scan >=328 and h_scan <= 340) or
(v_scan = 387 and h_scan >=309 and h_scan <= 313) or
(v_scan = 387 and h_scan >=325 and h_scan <= 337) or
(v_scan = 388 and h_scan >=309 and h_scan <= 314) or
(v_scan = 388 and h_scan >=322 and h_scan <= 335) or
(v_scan = 389 and h_scan >=310 and h_scan <= 314) or
(v_scan = 389 and h_scan >=320 and h_scan <= 332) or
(v_scan = 390 and h_scan >=310 and h_scan <= 315) or
(v_scan = 390 and h_scan >=317 and h_scan <= 330) or
(v_scan = 391 and h_scan >=311 and h_scan <= 327) or
(v_scan = 392 and h_scan >=311 and h_scan <= 325) or
(v_scan = 393 and h_scan >=312 and h_scan <= 322) or
(v_scan = 394 and h_scan >=312 and h_scan <= 320) or
(v_scan = 395 and h_scan >=313 and h_scan <= 317) or
(v_scan = 396 and h_scan >=314 and h_scan <= 315)
else '0';

www <= '1' when 
(v_scan = 446 and h_scan >=241 and h_scan <= 243) or
(v_scan = 446 and h_scan >=251 and h_scan <= 254) or
(v_scan = 446 and h_scan >=262 and h_scan <= 264) or
(v_scan = 446 and h_scan >=267 and h_scan <= 269) or
(v_scan = 446 and h_scan >=277 and h_scan <= 280) or
(v_scan = 446 and h_scan >=288 and h_scan <= 290) or
(v_scan = 446 and h_scan >=293 and h_scan <= 295) or
(v_scan = 446 and h_scan >=303 and h_scan <= 306) or
(v_scan = 446 and h_scan >=314 and h_scan <= 316) or
(v_scan = 446 and h_scan >=328 and h_scan <= 336) or
(v_scan = 446 and h_scan >=343 and h_scan <= 346) or
(v_scan = 446 and h_scan >=355 and h_scan <= 364) or
(v_scan = 446 and h_scan >=373 and h_scan <= 376) or
(v_scan = 446 and h_scan >=382 and h_scan <= 385) or
(v_scan = 446 and h_scan >=389 and h_scan <= 392) or
(v_scan = 446 and h_scan >=395 and h_scan <= 408) or
(v_scan = 446 and h_scan >=423 and h_scan <= 428) or
(v_scan = 446 and h_scan >=439 and h_scan <= 445) or
(v_scan = 446 and h_scan >=454 and h_scan <= 459) or
(v_scan = 446 and h_scan >=469 and h_scan <= 474) or
(v_scan = 447 and h_scan >=241 and h_scan <= 244) or
(v_scan = 447 and h_scan >=251 and h_scan <= 254) or
(v_scan = 447 and h_scan >=262 and h_scan <= 264) or
(v_scan = 447 and h_scan >=267 and h_scan <= 270) or
(v_scan = 447 and h_scan >=277 and h_scan <= 280) or
(v_scan = 447 and h_scan >=288 and h_scan <= 290) or
(v_scan = 447 and h_scan >=293 and h_scan <= 296) or
(v_scan = 447 and h_scan >=303 and h_scan <= 306) or
(v_scan = 447 and h_scan >=314 and h_scan <= 316) or
(v_scan = 447 and h_scan >=328 and h_scan <= 337) or
(v_scan = 447 and h_scan >=343 and h_scan <= 346) or
(v_scan = 447 and h_scan >=355 and h_scan <= 366) or
(v_scan = 447 and h_scan >=373 and h_scan <= 376) or
(v_scan = 447 and h_scan >=382 and h_scan <= 385) or
(v_scan = 447 and h_scan >=389 and h_scan <= 392) or
(v_scan = 447 and h_scan >=395 and h_scan <= 408) or
(v_scan = 447 and h_scan >=422 and h_scan <= 430) or
(v_scan = 447 and h_scan >=437 and h_scan <= 447) or
(v_scan = 447 and h_scan >=454 and h_scan <= 459) or
(v_scan = 447 and h_scan >=469 and h_scan <= 474) or
(v_scan = 448 and h_scan >=241 and h_scan <= 244) or
(v_scan = 448 and h_scan >=251 and h_scan <= 255) or
(v_scan = 448 and h_scan >=262 and h_scan <= 264) or
(v_scan = 448 and h_scan >=267 and h_scan <= 270) or
(v_scan = 448 and h_scan >=277 and h_scan <= 281) or
(v_scan = 448 and h_scan >=288 and h_scan <= 290) or
(v_scan = 448 and h_scan >=293 and h_scan <= 296) or
(v_scan = 448 and h_scan >=303 and h_scan <= 307) or
(v_scan = 448 and h_scan >=314 and h_scan <= 316) or
(v_scan = 448 and h_scan >=328 and h_scan <= 338) or
(v_scan = 448 and h_scan >=343 and h_scan <= 346) or
(v_scan = 448 and h_scan >=355 and h_scan <= 367) or
(v_scan = 448 and h_scan >=373 and h_scan <= 376) or
(v_scan = 448 and h_scan >=381 and h_scan <= 384) or
(v_scan = 448 and h_scan >=389 and h_scan <= 392) or
(v_scan = 448 and h_scan >=395 and h_scan <= 408) or
(v_scan = 448 and h_scan >=420 and h_scan <= 430) or
(v_scan = 448 and h_scan >=436 and h_scan <= 448) or
(v_scan = 448 and h_scan >=454 and h_scan <= 460) or
(v_scan = 448 and h_scan >=468 and h_scan <= 474) or
(v_scan = 449 and h_scan >=241 and h_scan <= 244) or
(v_scan = 449 and h_scan >=251 and h_scan <= 255) or
(v_scan = 449 and h_scan >=261 and h_scan <= 264) or
(v_scan = 449 and h_scan >=267 and h_scan <= 270) or
(v_scan = 449 and h_scan >=277 and h_scan <= 281) or
(v_scan = 449 and h_scan >=287 and h_scan <= 290) or
(v_scan = 449 and h_scan >=293 and h_scan <= 296) or
(v_scan = 449 and h_scan >=303 and h_scan <= 307) or
(v_scan = 449 and h_scan >=313 and h_scan <= 316) or
(v_scan = 449 and h_scan >=328 and h_scan <= 331) or
(v_scan = 449 and h_scan >=335 and h_scan <= 339) or
(v_scan = 449 and h_scan >=343 and h_scan <= 346) or
(v_scan = 449 and h_scan >=355 and h_scan <= 358) or
(v_scan = 449 and h_scan >=364 and h_scan <= 368) or
(v_scan = 449 and h_scan >=373 and h_scan <= 376) or
(v_scan = 449 and h_scan >=380 and h_scan <= 383) or
(v_scan = 449 and h_scan >=389 and h_scan <= 392) or
(v_scan = 449 and h_scan >=400 and h_scan <= 403) or
(v_scan = 449 and h_scan >=420 and h_scan <= 423) or
(v_scan = 449 and h_scan >=429 and h_scan <= 430) or
(v_scan = 449 and h_scan >=435 and h_scan <= 439) or
(v_scan = 449 and h_scan >=445 and h_scan <= 449) or
(v_scan = 449 and h_scan >=454 and h_scan <= 460) or
(v_scan = 449 and h_scan >=468 and h_scan <= 474) or
(v_scan = 450 and h_scan >=242 and h_scan <= 244) or
(v_scan = 450 and h_scan >=250 and h_scan <= 255) or
(v_scan = 450 and h_scan >=261 and h_scan <= 263) or
(v_scan = 450 and h_scan >=268 and h_scan <= 270) or
(v_scan = 450 and h_scan >=276 and h_scan <= 281) or
(v_scan = 450 and h_scan >=287 and h_scan <= 289) or
(v_scan = 450 and h_scan >=294 and h_scan <= 296) or
(v_scan = 450 and h_scan >=302 and h_scan <= 307) or
(v_scan = 450 and h_scan >=313 and h_scan <= 315) or
(v_scan = 450 and h_scan >=328 and h_scan <= 331) or
(v_scan = 450 and h_scan >=336 and h_scan <= 339) or
(v_scan = 450 and h_scan >=343 and h_scan <= 346) or
(v_scan = 450 and h_scan >=355 and h_scan <= 358) or
(v_scan = 450 and h_scan >=365 and h_scan <= 368) or
(v_scan = 450 and h_scan >=373 and h_scan <= 376) or
(v_scan = 450 and h_scan >=380 and h_scan <= 382) or
(v_scan = 450 and h_scan >=389 and h_scan <= 392) or
(v_scan = 450 and h_scan >=400 and h_scan <= 403) or
(v_scan = 450 and h_scan >=419 and h_scan <= 422) or
(v_scan = 450 and h_scan >=434 and h_scan <= 437) or
(v_scan = 450 and h_scan >=446 and h_scan <= 449) or
(v_scan = 450 and h_scan >=454 and h_scan <= 461) or
(v_scan = 450 and h_scan >=468 and h_scan <= 474) or
(v_scan = 451 and h_scan >=242 and h_scan <= 245) or
(v_scan = 451 and h_scan >=250 and h_scan <= 255) or
(v_scan = 451 and h_scan >=261 and h_scan <= 263) or
(v_scan = 451 and h_scan >=268 and h_scan <= 271) or
(v_scan = 451 and h_scan >=276 and h_scan <= 281) or
(v_scan = 451 and h_scan >=287 and h_scan <= 289) or
(v_scan = 451 and h_scan >=294 and h_scan <= 297) or
(v_scan = 451 and h_scan >=302 and h_scan <= 307) or
(v_scan = 451 and h_scan >=313 and h_scan <= 315) or
(v_scan = 451 and h_scan >=328 and h_scan <= 331) or
(v_scan = 451 and h_scan >=336 and h_scan <= 339) or
(v_scan = 451 and h_scan >=343 and h_scan <= 346) or
(v_scan = 451 and h_scan >=355 and h_scan <= 358) or
(v_scan = 451 and h_scan >=366 and h_scan <= 369) or
(v_scan = 451 and h_scan >=373 and h_scan <= 376) or
(v_scan = 451 and h_scan >=379 and h_scan <= 382) or
(v_scan = 451 and h_scan >=389 and h_scan <= 392) or
(v_scan = 451 and h_scan >=400 and h_scan <= 403) or
(v_scan = 451 and h_scan >=419 and h_scan <= 422) or
(v_scan = 451 and h_scan >=434 and h_scan <= 437) or
(v_scan = 451 and h_scan >=446 and h_scan <= 449) or
(v_scan = 451 and h_scan >=454 and h_scan <= 456) or
(v_scan = 451 and h_scan >=458 and h_scan <= 461) or
(v_scan = 451 and h_scan >=467 and h_scan <= 470) or
(v_scan = 451 and h_scan >=472 and h_scan <= 474) or
(v_scan = 452 and h_scan >=242 and h_scan <= 245) or
(v_scan = 452 and h_scan >=250 and h_scan <= 256) or
(v_scan = 452 and h_scan >=261 and h_scan <= 263) or
(v_scan = 452 and h_scan >=268 and h_scan <= 271) or
(v_scan = 452 and h_scan >=276 and h_scan <= 282) or
(v_scan = 452 and h_scan >=287 and h_scan <= 289) or
(v_scan = 452 and h_scan >=294 and h_scan <= 297) or
(v_scan = 452 and h_scan >=302 and h_scan <= 308) or
(v_scan = 452 and h_scan >=313 and h_scan <= 315) or
(v_scan = 452 and h_scan >=328 and h_scan <= 331) or
(v_scan = 452 and h_scan >=336 and h_scan <= 339) or
(v_scan = 452 and h_scan >=343 and h_scan <= 346) or
(v_scan = 452 and h_scan >=355 and h_scan <= 358) or
(v_scan = 452 and h_scan >=366 and h_scan <= 369) or
(v_scan = 452 and h_scan >=373 and h_scan <= 376) or
(v_scan = 452 and h_scan >=378 and h_scan <= 381) or
(v_scan = 452 and h_scan >=389 and h_scan <= 392) or
(v_scan = 452 and h_scan >=400 and h_scan <= 403) or
(v_scan = 452 and h_scan >=418 and h_scan <= 421) or
(v_scan = 452 and h_scan >=434 and h_scan <= 436) or
(v_scan = 452 and h_scan >=447 and h_scan <= 450) or
(v_scan = 452 and h_scan >=454 and h_scan <= 456) or
(v_scan = 452 and h_scan >=459 and h_scan <= 461) or
(v_scan = 452 and h_scan >=467 and h_scan <= 469) or
(v_scan = 452 and h_scan >=472 and h_scan <= 474) or
(v_scan = 453 and h_scan >=242 and h_scan <= 245) or
(v_scan = 453 and h_scan >=250 and h_scan <= 252) or
(v_scan = 453 and h_scan >=254 and h_scan <= 256) or
(v_scan = 453 and h_scan >=260 and h_scan <= 263) or
(v_scan = 453 and h_scan >=268 and h_scan <= 271) or
(v_scan = 453 and h_scan >=276 and h_scan <= 278) or
(v_scan = 453 and h_scan >=280 and h_scan <= 282) or
(v_scan = 453 and h_scan >=286 and h_scan <= 289) or
(v_scan = 453 and h_scan >=294 and h_scan <= 297) or
(v_scan = 453 and h_scan >=302 and h_scan <= 304) or
(v_scan = 453 and h_scan >=306 and h_scan <= 308) or
(v_scan = 453 and h_scan >=312 and h_scan <= 315) or
(v_scan = 453 and h_scan >=328 and h_scan <= 331) or
(v_scan = 453 and h_scan >=336 and h_scan <= 339) or
(v_scan = 453 and h_scan >=343 and h_scan <= 346) or
(v_scan = 453 and h_scan >=355 and h_scan <= 358) or
(v_scan = 453 and h_scan >=366 and h_scan <= 369) or
(v_scan = 453 and h_scan >=373 and h_scan <= 380) or
(v_scan = 453 and h_scan >=389 and h_scan <= 392) or
(v_scan = 453 and h_scan >=400 and h_scan <= 403) or
(v_scan = 453 and h_scan >=418 and h_scan <= 421) or
(v_scan = 453 and h_scan >=433 and h_scan <= 436) or
(v_scan = 453 and h_scan >=447 and h_scan <= 450) or
(v_scan = 453 and h_scan >=454 and h_scan <= 456) or
(v_scan = 453 and h_scan >=459 and h_scan <= 462) or
(v_scan = 453 and h_scan >=467 and h_scan <= 469) or
(v_scan = 453 and h_scan >=472 and h_scan <= 474) or
(v_scan = 454 and h_scan >=243 and h_scan <= 245) or
(v_scan = 454 and h_scan >=249 and h_scan <= 251) or
(v_scan = 454 and h_scan >=254 and h_scan <= 256) or
(v_scan = 454 and h_scan >=260 and h_scan <= 262) or
(v_scan = 454 and h_scan >=269 and h_scan <= 271) or
(v_scan = 454 and h_scan >=275 and h_scan <= 277) or
(v_scan = 454 and h_scan >=280 and h_scan <= 282) or
(v_scan = 454 and h_scan >=286 and h_scan <= 288) or
(v_scan = 454 and h_scan >=295 and h_scan <= 297) or
(v_scan = 454 and h_scan >=301 and h_scan <= 303) or
(v_scan = 454 and h_scan >=306 and h_scan <= 308) or
(v_scan = 454 and h_scan >=312 and h_scan <= 314) or
(v_scan = 454 and h_scan >=328 and h_scan <= 331) or
(v_scan = 454 and h_scan >=335 and h_scan <= 339) or
(v_scan = 454 and h_scan >=343 and h_scan <= 346) or
(v_scan = 454 and h_scan >=355 and h_scan <= 358) or
(v_scan = 454 and h_scan >=366 and h_scan <= 369) or
(v_scan = 454 and h_scan >=373 and h_scan <= 380) or
(v_scan = 454 and h_scan >=389 and h_scan <= 392) or
(v_scan = 454 and h_scan >=400 and h_scan <= 403) or
(v_scan = 454 and h_scan >=418 and h_scan <= 421) or
(v_scan = 454 and h_scan >=433 and h_scan <= 436) or
(v_scan = 454 and h_scan >=447 and h_scan <= 450) or
(v_scan = 454 and h_scan >=454 and h_scan <= 456) or
(v_scan = 454 and h_scan >=460 and h_scan <= 462) or
(v_scan = 454 and h_scan >=466 and h_scan <= 468) or
(v_scan = 454 and h_scan >=472 and h_scan <= 474) or
(v_scan = 455 and h_scan >=243 and h_scan <= 246) or
(v_scan = 455 and h_scan >=249 and h_scan <= 251) or
(v_scan = 455 and h_scan >=254 and h_scan <= 256) or
(v_scan = 455 and h_scan >=260 and h_scan <= 262) or
(v_scan = 455 and h_scan >=269 and h_scan <= 272) or
(v_scan = 455 and h_scan >=275 and h_scan <= 277) or
(v_scan = 455 and h_scan >=280 and h_scan <= 282) or
(v_scan = 455 and h_scan >=286 and h_scan <= 288) or
(v_scan = 455 and h_scan >=295 and h_scan <= 298) or
(v_scan = 455 and h_scan >=301 and h_scan <= 303) or
(v_scan = 455 and h_scan >=306 and h_scan <= 308) or
(v_scan = 455 and h_scan >=312 and h_scan <= 314) or
(v_scan = 455 and h_scan >=328 and h_scan <= 338) or
(v_scan = 455 and h_scan >=343 and h_scan <= 346) or
(v_scan = 455 and h_scan >=355 and h_scan <= 358) or
(v_scan = 455 and h_scan >=366 and h_scan <= 369) or
(v_scan = 455 and h_scan >=373 and h_scan <= 380) or
(v_scan = 455 and h_scan >=389 and h_scan <= 392) or
(v_scan = 455 and h_scan >=400 and h_scan <= 403) or
(v_scan = 455 and h_scan >=418 and h_scan <= 421) or
(v_scan = 455 and h_scan >=433 and h_scan <= 436) or
(v_scan = 455 and h_scan >=447 and h_scan <= 450) or
(v_scan = 455 and h_scan >=454 and h_scan <= 456) or
(v_scan = 455 and h_scan >=460 and h_scan <= 462) or
(v_scan = 455 and h_scan >=466 and h_scan <= 468) or
(v_scan = 455 and h_scan >=472 and h_scan <= 474) or
(v_scan = 456 and h_scan >=243 and h_scan <= 246) or
(v_scan = 456 and h_scan >=249 and h_scan <= 251) or
(v_scan = 456 and h_scan >=254 and h_scan <= 257) or
(v_scan = 456 and h_scan >=260 and h_scan <= 262) or
(v_scan = 456 and h_scan >=269 and h_scan <= 272) or
(v_scan = 456 and h_scan >=275 and h_scan <= 277) or
(v_scan = 456 and h_scan >=280 and h_scan <= 283) or
(v_scan = 456 and h_scan >=286 and h_scan <= 288) or
(v_scan = 456 and h_scan >=295 and h_scan <= 298) or
(v_scan = 456 and h_scan >=301 and h_scan <= 303) or
(v_scan = 456 and h_scan >=306 and h_scan <= 309) or
(v_scan = 456 and h_scan >=312 and h_scan <= 314) or
(v_scan = 456 and h_scan >=328 and h_scan <= 337) or
(v_scan = 456 and h_scan >=343 and h_scan <= 346) or
(v_scan = 456 and h_scan >=355 and h_scan <= 358) or
(v_scan = 456 and h_scan >=366 and h_scan <= 369) or
(v_scan = 456 and h_scan >=373 and h_scan <= 376) or
(v_scan = 456 and h_scan >=378 and h_scan <= 381) or
(v_scan = 456 and h_scan >=389 and h_scan <= 392) or
(v_scan = 456 and h_scan >=400 and h_scan <= 403) or
(v_scan = 456 and h_scan >=418 and h_scan <= 421) or
(v_scan = 456 and h_scan >=433 and h_scan <= 436) or
(v_scan = 456 and h_scan >=447 and h_scan <= 450) or
(v_scan = 456 and h_scan >=454 and h_scan <= 456) or
(v_scan = 456 and h_scan >=460 and h_scan <= 463) or
(v_scan = 456 and h_scan >=466 and h_scan <= 468) or
(v_scan = 456 and h_scan >=472 and h_scan <= 474) or
(v_scan = 457 and h_scan >=244 and h_scan <= 246) or
(v_scan = 457 and h_scan >=249 and h_scan <= 251) or
(v_scan = 457 and h_scan >=255 and h_scan <= 257) or
(v_scan = 457 and h_scan >=260 and h_scan <= 262) or
(v_scan = 457 and h_scan >=270 and h_scan <= 272) or
(v_scan = 457 and h_scan >=275 and h_scan <= 277) or
(v_scan = 457 and h_scan >=281 and h_scan <= 283) or
(v_scan = 457 and h_scan >=286 and h_scan <= 288) or
(v_scan = 457 and h_scan >=296 and h_scan <= 298) or
(v_scan = 457 and h_scan >=301 and h_scan <= 303) or
(v_scan = 457 and h_scan >=307 and h_scan <= 309) or
(v_scan = 457 and h_scan >=312 and h_scan <= 314) or
(v_scan = 457 and h_scan >=328 and h_scan <= 335) or
(v_scan = 457 and h_scan >=343 and h_scan <= 346) or
(v_scan = 457 and h_scan >=355 and h_scan <= 358) or
(v_scan = 457 and h_scan >=366 and h_scan <= 369) or
(v_scan = 457 and h_scan >=373 and h_scan <= 376) or
(v_scan = 457 and h_scan >=379 and h_scan <= 382) or
(v_scan = 457 and h_scan >=389 and h_scan <= 392) or
(v_scan = 457 and h_scan >=400 and h_scan <= 403) or
(v_scan = 457 and h_scan >=418 and h_scan <= 421) or
(v_scan = 457 and h_scan >=433 and h_scan <= 436) or
(v_scan = 457 and h_scan >=447 and h_scan <= 449) or
(v_scan = 457 and h_scan >=454 and h_scan <= 456) or
(v_scan = 457 and h_scan >=461 and h_scan <= 463) or
(v_scan = 457 and h_scan >=465 and h_scan <= 467) or
(v_scan = 457 and h_scan >=472 and h_scan <= 474) or
(v_scan = 458 and h_scan >=244 and h_scan <= 246) or
(v_scan = 458 and h_scan >=248 and h_scan <= 250) or
(v_scan = 458 and h_scan >=255 and h_scan <= 257) or
(v_scan = 458 and h_scan >=259 and h_scan <= 261) or
(v_scan = 458 and h_scan >=270 and h_scan <= 272) or
(v_scan = 458 and h_scan >=274 and h_scan <= 276) or
(v_scan = 458 and h_scan >=281 and h_scan <= 283) or
(v_scan = 458 and h_scan >=285 and h_scan <= 287) or
(v_scan = 458 and h_scan >=296 and h_scan <= 298) or
(v_scan = 458 and h_scan >=300 and h_scan <= 302) or
(v_scan = 458 and h_scan >=307 and h_scan <= 309) or
(v_scan = 458 and h_scan >=311 and h_scan <= 313) or
(v_scan = 458 and h_scan >=328 and h_scan <= 331) or
(v_scan = 458 and h_scan >=343 and h_scan <= 346) or
(v_scan = 458 and h_scan >=355 and h_scan <= 358) or
(v_scan = 458 and h_scan >=366 and h_scan <= 368) or
(v_scan = 458 and h_scan >=373 and h_scan <= 376) or
(v_scan = 458 and h_scan >=379 and h_scan <= 382) or
(v_scan = 458 and h_scan >=389 and h_scan <= 392) or
(v_scan = 458 and h_scan >=400 and h_scan <= 403) or
(v_scan = 458 and h_scan >=419 and h_scan <= 422) or
(v_scan = 458 and h_scan >=434 and h_scan <= 437) or
(v_scan = 458 and h_scan >=446 and h_scan <= 449) or
(v_scan = 458 and h_scan >=454 and h_scan <= 456) or
(v_scan = 458 and h_scan >=461 and h_scan <= 467) or
(v_scan = 458 and h_scan >=472 and h_scan <= 474) or
(v_scan = 459 and h_scan >=244 and h_scan <= 250) or
(v_scan = 459 and h_scan >=255 and h_scan <= 261) or
(v_scan = 459 and h_scan >=270 and h_scan <= 276) or
(v_scan = 459 and h_scan >=281 and h_scan <= 287) or
(v_scan = 459 and h_scan >=296 and h_scan <= 302) or
(v_scan = 459 and h_scan >=307 and h_scan <= 313) or
(v_scan = 459 and h_scan >=328 and h_scan <= 331) or
(v_scan = 459 and h_scan >=343 and h_scan <= 346) or
(v_scan = 459 and h_scan >=355 and h_scan <= 358) or
(v_scan = 459 and h_scan >=365 and h_scan <= 368) or
(v_scan = 459 and h_scan >=373 and h_scan <= 376) or
(v_scan = 459 and h_scan >=380 and h_scan <= 383) or
(v_scan = 459 and h_scan >=389 and h_scan <= 392) or
(v_scan = 459 and h_scan >=400 and h_scan <= 403) or
(v_scan = 459 and h_scan >=419 and h_scan <= 422) or
(v_scan = 459 and h_scan >=434 and h_scan <= 437) or
(v_scan = 459 and h_scan >=446 and h_scan <= 449) or
(v_scan = 459 and h_scan >=454 and h_scan <= 456) or
(v_scan = 459 and h_scan >=461 and h_scan <= 467) or
(v_scan = 459 and h_scan >=472 and h_scan <= 474) or
(v_scan = 460 and h_scan >=244 and h_scan <= 250) or
(v_scan = 460 and h_scan >=255 and h_scan <= 261) or
(v_scan = 460 and h_scan >=270 and h_scan <= 276) or
(v_scan = 460 and h_scan >=281 and h_scan <= 287) or
(v_scan = 460 and h_scan >=296 and h_scan <= 302) or
(v_scan = 460 and h_scan >=307 and h_scan <= 313) or
(v_scan = 460 and h_scan >=320 and h_scan <= 323) or
(v_scan = 460 and h_scan >=328 and h_scan <= 331) or
(v_scan = 460 and h_scan >=343 and h_scan <= 346) or
(v_scan = 460 and h_scan >=355 and h_scan <= 358) or
(v_scan = 460 and h_scan >=364 and h_scan <= 368) or
(v_scan = 460 and h_scan >=373 and h_scan <= 376) or
(v_scan = 460 and h_scan >=381 and h_scan <= 384) or
(v_scan = 460 and h_scan >=389 and h_scan <= 392) or
(v_scan = 460 and h_scan >=400 and h_scan <= 403) or
(v_scan = 460 and h_scan >=411 and h_scan <= 414) or
(v_scan = 460 and h_scan >=419 and h_scan <= 423) or
(v_scan = 460 and h_scan >=434 and h_scan <= 438) or
(v_scan = 460 and h_scan >=444 and h_scan <= 448) or
(v_scan = 460 and h_scan >=454 and h_scan <= 456) or
(v_scan = 460 and h_scan >=462 and h_scan <= 466) or
(v_scan = 460 and h_scan >=472 and h_scan <= 474) or
(v_scan = 461 and h_scan >=245 and h_scan <= 250) or
(v_scan = 461 and h_scan >=256 and h_scan <= 260) or
(v_scan = 461 and h_scan >=271 and h_scan <= 276) or
(v_scan = 461 and h_scan >=282 and h_scan <= 286) or
(v_scan = 461 and h_scan >=297 and h_scan <= 302) or
(v_scan = 461 and h_scan >=308 and h_scan <= 312) or
(v_scan = 461 and h_scan >=320 and h_scan <= 323) or
(v_scan = 461 and h_scan >=328 and h_scan <= 331) or
(v_scan = 461 and h_scan >=343 and h_scan <= 352) or
(v_scan = 461 and h_scan >=355 and h_scan <= 367) or
(v_scan = 461 and h_scan >=373 and h_scan <= 376) or
(v_scan = 461 and h_scan >=381 and h_scan <= 384) or
(v_scan = 461 and h_scan >=389 and h_scan <= 392) or
(v_scan = 461 and h_scan >=400 and h_scan <= 403) or
(v_scan = 461 and h_scan >=411 and h_scan <= 414) or
(v_scan = 461 and h_scan >=420 and h_scan <= 430) or
(v_scan = 461 and h_scan >=435 and h_scan <= 448) or
(v_scan = 461 and h_scan >=454 and h_scan <= 456) or
(v_scan = 461 and h_scan >=462 and h_scan <= 466) or
(v_scan = 461 and h_scan >=472 and h_scan <= 474) or
(v_scan = 462 and h_scan >=245 and h_scan <= 249) or
(v_scan = 462 and h_scan >=256 and h_scan <= 260) or
(v_scan = 462 and h_scan >=271 and h_scan <= 275) or
(v_scan = 462 and h_scan >=282 and h_scan <= 286) or
(v_scan = 462 and h_scan >=297 and h_scan <= 301) or
(v_scan = 462 and h_scan >=308 and h_scan <= 312) or
(v_scan = 462 and h_scan >=320 and h_scan <= 323) or
(v_scan = 462 and h_scan >=328 and h_scan <= 331) or
(v_scan = 462 and h_scan >=343 and h_scan <= 352) or
(v_scan = 462 and h_scan >=355 and h_scan <= 366) or
(v_scan = 462 and h_scan >=373 and h_scan <= 376) or
(v_scan = 462 and h_scan >=382 and h_scan <= 385) or
(v_scan = 462 and h_scan >=389 and h_scan <= 392) or
(v_scan = 462 and h_scan >=400 and h_scan <= 403) or
(v_scan = 462 and h_scan >=411 and h_scan <= 414) or
(v_scan = 462 and h_scan >=421 and h_scan <= 430) or
(v_scan = 462 and h_scan >=436 and h_scan <= 446) or
(v_scan = 462 and h_scan >=454 and h_scan <= 456) or
(v_scan = 462 and h_scan >=462 and h_scan <= 466) or
(v_scan = 462 and h_scan >=472 and h_scan <= 474) or
(v_scan = 463 and h_scan >=245 and h_scan <= 249) or
(v_scan = 463 and h_scan >=256 and h_scan <= 260) or
(v_scan = 463 and h_scan >=271 and h_scan <= 275) or
(v_scan = 463 and h_scan >=282 and h_scan <= 286) or
(v_scan = 463 and h_scan >=297 and h_scan <= 301) or
(v_scan = 463 and h_scan >=308 and h_scan <= 312) or
(v_scan = 463 and h_scan >=320 and h_scan <= 323) or
(v_scan = 463 and h_scan >=328 and h_scan <= 331) or
(v_scan = 463 and h_scan >=343 and h_scan <= 352) or
(v_scan = 463 and h_scan >=355 and h_scan <= 363) or
(v_scan = 463 and h_scan >=373 and h_scan <= 376) or
(v_scan = 463 and h_scan >=383 and h_scan <= 385) or
(v_scan = 463 and h_scan >=389 and h_scan <= 392) or
(v_scan = 463 and h_scan >=400 and h_scan <= 403) or
(v_scan = 463 and h_scan >=411 and h_scan <= 414) or
(v_scan = 463 and h_scan >=423 and h_scan <= 429) or
(v_scan = 463 and h_scan >=438 and h_scan <= 444) or
(v_scan = 463 and h_scan >=454 and h_scan <= 456) or
(v_scan = 463 and h_scan >=463 and h_scan <= 465) or
(v_scan = 463 and h_scan >=472 and h_scan <= 474)
else '0';

red(0) <= '1' when ((v_scan > 500 and v_scan < 550 and h_scan > 200 and h_scan < 240) or (logo='1') or (www='1')) else '0';
grn(0) <= '1' when ((v_scan > 500 and v_scan < 550 and h_scan > 240 and h_scan < 280) or (logo='1') or (www='1')) else '0';
blu(0) <= '1' when ((v_scan > 500 and v_scan < 550 and h_scan > 280 and h_scan < 320) or (logo='1') or (www='1')) else '0';
red(1) <= '1' when (v_scan > 500 and v_scan < 550 and h_scan > 320 and h_scan < 360) else '0';
grn(1) <= '1' when (v_scan > 500 and v_scan < 550 and h_scan > 360 and h_scan < 400) else '0';
blu(1) <= '1' when (v_scan > 500 and v_scan < 550 and h_scan > 400 and h_scan < 440) else '0';
red(2) <= '1' when (v_scan > 500 and v_scan < 550 and h_scan > 440 and h_scan < 480) else '0';
grn(2) <= '1' when (v_scan > 500 and v_scan < 550 and h_scan > 480 and h_scan < 520) else '0';
blu(2) <= '1' when (v_scan > 500 and v_scan < 550 and h_scan > 520 and h_scan < 560) else '0';

end Behavioral;