------------------------------------------------------------------------------
--$Date: 2010/03/05 10:19:34 $
--$Revision: 1.3 $
------------------------------------------------------------------------------
--   ____  ____
--  /   /\/   /
-- /___/  \  /
-- \   \   \/     Vendor : Xilinx
--  \   \         Version : 2.1
--  /   /         Application : RocketIO GTP Transceiver Wizard
-- /___/   /\     Filename : loop_test.vho
-- \   \  /  \
--  \___\/\___\
--
--
-- Instantiation Template
-- Generated by Xilinx RocketIO GTP Transceiver Wizard
-- 
-- 
-- (c) Copyright 2006-2010 Xilinx, Inc. All rights reserved.
-- 
-- This file contains confidential and proprietary information
-- of Xilinx, Inc. and is protected under U.S. and
-- international copyright and other intellectual property
-- laws.
-- 
-- DISCLAIMER
-- This disclaimer is not a license and does not grant any
-- rights to the materials distributed herewith. Except as
-- otherwise provided in a valid license issued to you by
-- Xilinx, and to the maximum extent permitted by applicable
-- law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
-- WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
-- AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
-- BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
-- INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
-- (2) Xilinx shall not be liable (whether in contract or tort,
-- including negligence, or under any other theory of
-- liability) for any loss or damage of any kind or nature
-- related to, arising under or in connection with these
-- materials, including for any direct, or any indirect,
-- special, incidental, or consequential loss or damage
-- (including loss of data, profits, goodwill, or any type of
-- loss or damage suffered as a result of any action brought
-- by a third party) even if such damage or loss was
-- reasonably foreseeable or Xilinx had been advised of the
-- possibility of the same.
-- 
-- CRITICAL APPLICATIONS
-- Xilinx products are not designed or intended to be fail-
-- safe, or for use in any application requiring fail-safe
-- performance, such as life-support or safety devices or
-- systems, Class III medical devices, nuclear facilities,
-- applications related to the deployment of airbags, or any
-- other applications that could lead to death, personal
-- injury, or severe property or environmental damage
-- (individually and collectively, "Critical
-- Applications"). Customer assumes the sole risk and
-- liability of any use of Xilinx products in Critical
-- Applications, subject only to applicable laws and
-- regulations governing limitations on product liability.
-- 
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
-- PART OF THIS FILE AT ALL TIMES. 


--**************************Component Declarations*****************************


component LOOP_TEST 
generic
(
    -- Simulation attributes
    WRAPPER_SIM_GTPRESET_SPEEDUP    : integer   := 0; -- Set to 1 to speed up sim reset
    WRAPPER_SIM_PLL_PERDIV2         : bit_vector:= x"14d" -- Set to the VCO Unit Interval time
);
port
(
    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE0  (Location)

    ------------------------ Loopback and Powerdown Ports ----------------------
    TILE0_RXPOWERDOWN0_IN                   : in   std_logic_vector(1 downto 0);
    TILE0_RXPOWERDOWN1_IN                   : in   std_logic_vector(1 downto 0);
    TILE0_TXPOWERDOWN0_IN                   : in   std_logic_vector(1 downto 0);
    TILE0_TXPOWERDOWN1_IN                   : in   std_logic_vector(1 downto 0);
    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    TILE0_RXCHARISCOMMA0_OUT                : out  std_logic;
    TILE0_RXCHARISCOMMA1_OUT                : out  std_logic;
    TILE0_RXCHARISK0_OUT                    : out  std_logic;
    TILE0_RXCHARISK1_OUT                    : out  std_logic;
    TILE0_RXDISPERR0_OUT                    : out  std_logic;
    TILE0_RXDISPERR1_OUT                    : out  std_logic;
    TILE0_RXNOTINTABLE0_OUT                 : out  std_logic;
    TILE0_RXNOTINTABLE1_OUT                 : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    TILE0_RXCLKCORCNT0_OUT                  : out  std_logic_vector(2 downto 0);
    TILE0_RXCLKCORCNT1_OUT                  : out  std_logic_vector(2 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    TILE0_RXENMCOMMAALIGN0_IN               : in   std_logic;
    TILE0_RXENMCOMMAALIGN1_IN               : in   std_logic;
    TILE0_RXENPCOMMAALIGN0_IN               : in   std_logic;
    TILE0_RXENPCOMMAALIGN1_IN               : in   std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE0_RXDATA0_OUT                       : out  std_logic_vector(7 downto 0);
    TILE0_RXDATA1_OUT                       : out  std_logic_vector(7 downto 0);
    TILE0_RXRECCLK0_OUT                     : out  std_logic;
    TILE0_RXRECCLK1_OUT                     : out  std_logic;
    TILE0_RXRESET0_IN                       : in   std_logic;
    TILE0_RXRESET1_IN                       : in   std_logic;
    TILE0_RXUSRCLK0_IN                      : in   std_logic;
    TILE0_RXUSRCLK1_IN                      : in   std_logic;
    TILE0_RXUSRCLK20_IN                     : in   std_logic;
    TILE0_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE0_RXCDRRESET0_IN                    : in   std_logic;
    TILE0_RXCDRRESET1_IN                    : in   std_logic;
    TILE0_RXELECIDLE0_OUT                   : out  std_logic;
    TILE0_RXELECIDLE1_OUT                   : out  std_logic;
    TILE0_RXEQMIX0_IN                       : in   std_logic_vector(1 downto 0);
    TILE0_RXEQMIX1_IN                       : in   std_logic_vector(1 downto 0);
    TILE0_RXEQPOLE0_IN                      : in   std_logic_vector(3 downto 0);
    TILE0_RXEQPOLE1_IN                      : in   std_logic_vector(3 downto 0);
    TILE0_RXN0_IN                           : in   std_logic;
    TILE0_RXN1_IN                           : in   std_logic;
    TILE0_RXP0_IN                           : in   std_logic;
    TILE0_RXP1_IN                           : in   std_logic;
    -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
    TILE0_RXBUFRESET0_IN                    : in   std_logic;
    TILE0_RXBUFRESET1_IN                    : in   std_logic;
    TILE0_RXSTATUS0_OUT                     : out  std_logic_vector(2 downto 0);
    TILE0_RXSTATUS1_OUT                     : out  std_logic_vector(2 downto 0);
    --------------------- Shared Ports - Tile and PLL Ports --------------------
    TILE0_CLKIN_IN                          : in   std_logic;
    TILE0_GTPRESET_IN                       : in   std_logic;
    TILE0_PLLLKDET_OUT                      : out  std_logic;
    TILE0_REFCLKOUT_OUT                     : out  std_logic;
    TILE0_RESETDONE0_OUT                    : out  std_logic;
    TILE0_RESETDONE1_OUT                    : out  std_logic;
    ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
    TILE0_TXCHARISK0_IN                     : in   std_logic;
    TILE0_TXCHARISK1_IN                     : in   std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE0_TXDATA0_IN                        : in   std_logic_vector(7 downto 0);
    TILE0_TXDATA1_IN                        : in   std_logic_vector(7 downto 0);
    TILE0_TXOUTCLK0_OUT                     : out  std_logic;
    TILE0_TXOUTCLK1_OUT                     : out  std_logic;
    TILE0_TXRESET0_IN                       : in   std_logic;
    TILE0_TXRESET1_IN                       : in   std_logic;
    TILE0_TXUSRCLK0_IN                      : in   std_logic;
    TILE0_TXUSRCLK1_IN                      : in   std_logic;
    TILE0_TXUSRCLK20_IN                     : in   std_logic;
    TILE0_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE0_TXDIFFCTRL0_IN                    : in   std_logic_vector(2 downto 0);
    TILE0_TXDIFFCTRL1_IN                    : in   std_logic_vector(2 downto 0);
    TILE0_TXN0_OUT                          : out  std_logic;
    TILE0_TXN1_OUT                          : out  std_logic;
    TILE0_TXP0_OUT                          : out  std_logic;
    TILE0_TXP1_OUT                          : out  std_logic;
    ----------------- Transmit Ports - TX Ports for PCI Express ----------------
    TILE0_TXELECIDLE0_IN                    : in   std_logic;
    TILE0_TXELECIDLE1_IN                    : in   std_logic;
    --------------------- Transmit Ports - TX Ports for SATA -------------------
    TILE0_TXCOMSTART0_IN                    : in   std_logic;
    TILE0_TXCOMSTART1_IN                    : in   std_logic;
    TILE0_TXCOMTYPE0_IN                     : in   std_logic;
    TILE0_TXCOMTYPE1_IN                     : in   std_logic;


    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE1  (Location)

    ------------------------ Loopback and Powerdown Ports ----------------------
    TILE1_RXPOWERDOWN0_IN                   : in   std_logic_vector(1 downto 0);
    TILE1_RXPOWERDOWN1_IN                   : in   std_logic_vector(1 downto 0);
    TILE1_TXPOWERDOWN0_IN                   : in   std_logic_vector(1 downto 0);
    TILE1_TXPOWERDOWN1_IN                   : in   std_logic_vector(1 downto 0);
    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    TILE1_RXCHARISCOMMA0_OUT                : out  std_logic;
    TILE1_RXCHARISCOMMA1_OUT                : out  std_logic;
    TILE1_RXCHARISK0_OUT                    : out  std_logic;
    TILE1_RXCHARISK1_OUT                    : out  std_logic;
    TILE1_RXDISPERR0_OUT                    : out  std_logic;
    TILE1_RXDISPERR1_OUT                    : out  std_logic;
    TILE1_RXNOTINTABLE0_OUT                 : out  std_logic;
    TILE1_RXNOTINTABLE1_OUT                 : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    TILE1_RXCLKCORCNT0_OUT                  : out  std_logic_vector(2 downto 0);
    TILE1_RXCLKCORCNT1_OUT                  : out  std_logic_vector(2 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    TILE1_RXENMCOMMAALIGN0_IN               : in   std_logic;
    TILE1_RXENMCOMMAALIGN1_IN               : in   std_logic;
    TILE1_RXENPCOMMAALIGN0_IN               : in   std_logic;
    TILE1_RXENPCOMMAALIGN1_IN               : in   std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE1_RXDATA0_OUT                       : out  std_logic_vector(7 downto 0);
    TILE1_RXDATA1_OUT                       : out  std_logic_vector(7 downto 0);
    TILE1_RXRECCLK0_OUT                     : out  std_logic;
    TILE1_RXRECCLK1_OUT                     : out  std_logic;
    TILE1_RXRESET0_IN                       : in   std_logic;
    TILE1_RXRESET1_IN                       : in   std_logic;
    TILE1_RXUSRCLK0_IN                      : in   std_logic;
    TILE1_RXUSRCLK1_IN                      : in   std_logic;
    TILE1_RXUSRCLK20_IN                     : in   std_logic;
    TILE1_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE1_RXCDRRESET0_IN                    : in   std_logic;
    TILE1_RXCDRRESET1_IN                    : in   std_logic;
    TILE1_RXELECIDLE0_OUT                   : out  std_logic;
    TILE1_RXELECIDLE1_OUT                   : out  std_logic;
    TILE1_RXEQMIX0_IN                       : in   std_logic_vector(1 downto 0);
    TILE1_RXEQMIX1_IN                       : in   std_logic_vector(1 downto 0);
    TILE1_RXEQPOLE0_IN                      : in   std_logic_vector(3 downto 0);
    TILE1_RXEQPOLE1_IN                      : in   std_logic_vector(3 downto 0);
    TILE1_RXN0_IN                           : in   std_logic;
    TILE1_RXN1_IN                           : in   std_logic;
    TILE1_RXP0_IN                           : in   std_logic;
    TILE1_RXP1_IN                           : in   std_logic;
    -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
    TILE1_RXBUFRESET0_IN                    : in   std_logic;
    TILE1_RXBUFRESET1_IN                    : in   std_logic;
    TILE1_RXSTATUS0_OUT                     : out  std_logic_vector(2 downto 0);
    TILE1_RXSTATUS1_OUT                     : out  std_logic_vector(2 downto 0);
    --------------------- Shared Ports - Tile and PLL Ports --------------------
    TILE1_CLKIN_IN                          : in   std_logic;
    TILE1_GTPRESET_IN                       : in   std_logic;
    TILE1_PLLLKDET_OUT                      : out  std_logic;
    TILE1_REFCLKOUT_OUT                     : out  std_logic;
    TILE1_RESETDONE0_OUT                    : out  std_logic;
    TILE1_RESETDONE1_OUT                    : out  std_logic;
    ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
    TILE1_TXCHARISK0_IN                     : in   std_logic;
    TILE1_TXCHARISK1_IN                     : in   std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE1_TXDATA0_IN                        : in   std_logic_vector(7 downto 0);
    TILE1_TXDATA1_IN                        : in   std_logic_vector(7 downto 0);
    TILE1_TXOUTCLK0_OUT                     : out  std_logic;
    TILE1_TXOUTCLK1_OUT                     : out  std_logic;
    TILE1_TXRESET0_IN                       : in   std_logic;
    TILE1_TXRESET1_IN                       : in   std_logic;
    TILE1_TXUSRCLK0_IN                      : in   std_logic;
    TILE1_TXUSRCLK1_IN                      : in   std_logic;
    TILE1_TXUSRCLK20_IN                     : in   std_logic;
    TILE1_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE1_TXDIFFCTRL0_IN                    : in   std_logic_vector(2 downto 0);
    TILE1_TXDIFFCTRL1_IN                    : in   std_logic_vector(2 downto 0);
    TILE1_TXN0_OUT                          : out  std_logic;
    TILE1_TXN1_OUT                          : out  std_logic;
    TILE1_TXP0_OUT                          : out  std_logic;
    TILE1_TXP1_OUT                          : out  std_logic;
    ----------------- Transmit Ports - TX Ports for PCI Express ----------------
    TILE1_TXELECIDLE0_IN                    : in   std_logic;
    TILE1_TXELECIDLE1_IN                    : in   std_logic;
    --------------------- Transmit Ports - TX Ports for SATA -------------------
    TILE1_TXCOMSTART0_IN                    : in   std_logic;
    TILE1_TXCOMSTART1_IN                    : in   std_logic;
    TILE1_TXCOMTYPE0_IN                     : in   std_logic;
    TILE1_TXCOMTYPE1_IN                     : in   std_logic;


    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE2  (Location)

    ------------------------ Loopback and Powerdown Ports ----------------------
    TILE2_RXPOWERDOWN0_IN                   : in   std_logic_vector(1 downto 0);
    TILE2_RXPOWERDOWN1_IN                   : in   std_logic_vector(1 downto 0);
    TILE2_TXPOWERDOWN0_IN                   : in   std_logic_vector(1 downto 0);
    TILE2_TXPOWERDOWN1_IN                   : in   std_logic_vector(1 downto 0);
    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    TILE2_RXCHARISCOMMA0_OUT                : out  std_logic;
    TILE2_RXCHARISCOMMA1_OUT                : out  std_logic;
    TILE2_RXCHARISK0_OUT                    : out  std_logic;
    TILE2_RXCHARISK1_OUT                    : out  std_logic;
    TILE2_RXDISPERR0_OUT                    : out  std_logic;
    TILE2_RXDISPERR1_OUT                    : out  std_logic;
    TILE2_RXNOTINTABLE0_OUT                 : out  std_logic;
    TILE2_RXNOTINTABLE1_OUT                 : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    TILE2_RXCLKCORCNT0_OUT                  : out  std_logic_vector(2 downto 0);
    TILE2_RXCLKCORCNT1_OUT                  : out  std_logic_vector(2 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    TILE2_RXENMCOMMAALIGN0_IN               : in   std_logic;
    TILE2_RXENMCOMMAALIGN1_IN               : in   std_logic;
    TILE2_RXENPCOMMAALIGN0_IN               : in   std_logic;
    TILE2_RXENPCOMMAALIGN1_IN               : in   std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE2_RXDATA0_OUT                       : out  std_logic_vector(7 downto 0);
    TILE2_RXDATA1_OUT                       : out  std_logic_vector(7 downto 0);
    TILE2_RXRECCLK0_OUT                     : out  std_logic;
    TILE2_RXRECCLK1_OUT                     : out  std_logic;
    TILE2_RXRESET0_IN                       : in   std_logic;
    TILE2_RXRESET1_IN                       : in   std_logic;
    TILE2_RXUSRCLK0_IN                      : in   std_logic;
    TILE2_RXUSRCLK1_IN                      : in   std_logic;
    TILE2_RXUSRCLK20_IN                     : in   std_logic;
    TILE2_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE2_RXCDRRESET0_IN                    : in   std_logic;
    TILE2_RXCDRRESET1_IN                    : in   std_logic;
    TILE2_RXELECIDLE0_OUT                   : out  std_logic;
    TILE2_RXELECIDLE1_OUT                   : out  std_logic;
    TILE2_RXEQMIX0_IN                       : in   std_logic_vector(1 downto 0);
    TILE2_RXEQMIX1_IN                       : in   std_logic_vector(1 downto 0);
    TILE2_RXEQPOLE0_IN                      : in   std_logic_vector(3 downto 0);
    TILE2_RXEQPOLE1_IN                      : in   std_logic_vector(3 downto 0);
    TILE2_RXN0_IN                           : in   std_logic;
    TILE2_RXN1_IN                           : in   std_logic;
    TILE2_RXP0_IN                           : in   std_logic;
    TILE2_RXP1_IN                           : in   std_logic;
    -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
    TILE2_RXBUFRESET0_IN                    : in   std_logic;
    TILE2_RXBUFRESET1_IN                    : in   std_logic;
    TILE2_RXSTATUS0_OUT                     : out  std_logic_vector(2 downto 0);
    TILE2_RXSTATUS1_OUT                     : out  std_logic_vector(2 downto 0);
    --------------------- Shared Ports - Tile and PLL Ports --------------------
    TILE2_CLKIN_IN                          : in   std_logic;
    TILE2_GTPRESET_IN                       : in   std_logic;
    TILE2_PLLLKDET_OUT                      : out  std_logic;
    TILE2_REFCLKOUT_OUT                     : out  std_logic;
    TILE2_RESETDONE0_OUT                    : out  std_logic;
    TILE2_RESETDONE1_OUT                    : out  std_logic;
    ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
    TILE2_TXCHARISK0_IN                     : in   std_logic;
    TILE2_TXCHARISK1_IN                     : in   std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE2_TXDATA0_IN                        : in   std_logic_vector(7 downto 0);
    TILE2_TXDATA1_IN                        : in   std_logic_vector(7 downto 0);
    TILE2_TXOUTCLK0_OUT                     : out  std_logic;
    TILE2_TXOUTCLK1_OUT                     : out  std_logic;
    TILE2_TXRESET0_IN                       : in   std_logic;
    TILE2_TXRESET1_IN                       : in   std_logic;
    TILE2_TXUSRCLK0_IN                      : in   std_logic;
    TILE2_TXUSRCLK1_IN                      : in   std_logic;
    TILE2_TXUSRCLK20_IN                     : in   std_logic;
    TILE2_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE2_TXDIFFCTRL0_IN                    : in   std_logic_vector(2 downto 0);
    TILE2_TXDIFFCTRL1_IN                    : in   std_logic_vector(2 downto 0);
    TILE2_TXN0_OUT                          : out  std_logic;
    TILE2_TXN1_OUT                          : out  std_logic;
    TILE2_TXP0_OUT                          : out  std_logic;
    TILE2_TXP1_OUT                          : out  std_logic;
    ----------------- Transmit Ports - TX Ports for PCI Express ----------------
    TILE2_TXELECIDLE0_IN                    : in   std_logic;
    TILE2_TXELECIDLE1_IN                    : in   std_logic;
    --------------------- Transmit Ports - TX Ports for SATA -------------------
    TILE2_TXCOMSTART0_IN                    : in   std_logic;
    TILE2_TXCOMSTART1_IN                    : in   std_logic;
    TILE2_TXCOMTYPE0_IN                     : in   std_logic;
    TILE2_TXCOMTYPE1_IN                     : in   std_logic;


    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE3  (Location)

    ------------------------ Loopback and Powerdown Ports ----------------------
    TILE3_RXPOWERDOWN0_IN                   : in   std_logic_vector(1 downto 0);
    TILE3_RXPOWERDOWN1_IN                   : in   std_logic_vector(1 downto 0);
    TILE3_TXPOWERDOWN0_IN                   : in   std_logic_vector(1 downto 0);
    TILE3_TXPOWERDOWN1_IN                   : in   std_logic_vector(1 downto 0);
    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    TILE3_RXCHARISCOMMA0_OUT                : out  std_logic;
    TILE3_RXCHARISCOMMA1_OUT                : out  std_logic;
    TILE3_RXCHARISK0_OUT                    : out  std_logic;
    TILE3_RXCHARISK1_OUT                    : out  std_logic;
    TILE3_RXDISPERR0_OUT                    : out  std_logic;
    TILE3_RXDISPERR1_OUT                    : out  std_logic;
    TILE3_RXNOTINTABLE0_OUT                 : out  std_logic;
    TILE3_RXNOTINTABLE1_OUT                 : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    TILE3_RXCLKCORCNT0_OUT                  : out  std_logic_vector(2 downto 0);
    TILE3_RXCLKCORCNT1_OUT                  : out  std_logic_vector(2 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    TILE3_RXENMCOMMAALIGN0_IN               : in   std_logic;
    TILE3_RXENMCOMMAALIGN1_IN               : in   std_logic;
    TILE3_RXENPCOMMAALIGN0_IN               : in   std_logic;
    TILE3_RXENPCOMMAALIGN1_IN               : in   std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE3_RXDATA0_OUT                       : out  std_logic_vector(7 downto 0);
    TILE3_RXDATA1_OUT                       : out  std_logic_vector(7 downto 0);
    TILE3_RXRECCLK0_OUT                     : out  std_logic;
    TILE3_RXRECCLK1_OUT                     : out  std_logic;
    TILE3_RXRESET0_IN                       : in   std_logic;
    TILE3_RXRESET1_IN                       : in   std_logic;
    TILE3_RXUSRCLK0_IN                      : in   std_logic;
    TILE3_RXUSRCLK1_IN                      : in   std_logic;
    TILE3_RXUSRCLK20_IN                     : in   std_logic;
    TILE3_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE3_RXCDRRESET0_IN                    : in   std_logic;
    TILE3_RXCDRRESET1_IN                    : in   std_logic;
    TILE3_RXELECIDLE0_OUT                   : out  std_logic;
    TILE3_RXELECIDLE1_OUT                   : out  std_logic;
    TILE3_RXEQMIX0_IN                       : in   std_logic_vector(1 downto 0);
    TILE3_RXEQMIX1_IN                       : in   std_logic_vector(1 downto 0);
    TILE3_RXEQPOLE0_IN                      : in   std_logic_vector(3 downto 0);
    TILE3_RXEQPOLE1_IN                      : in   std_logic_vector(3 downto 0);
    TILE3_RXN0_IN                           : in   std_logic;
    TILE3_RXN1_IN                           : in   std_logic;
    TILE3_RXP0_IN                           : in   std_logic;
    TILE3_RXP1_IN                           : in   std_logic;
    -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
    TILE3_RXBUFRESET0_IN                    : in   std_logic;
    TILE3_RXBUFRESET1_IN                    : in   std_logic;
    TILE3_RXSTATUS0_OUT                     : out  std_logic_vector(2 downto 0);
    TILE3_RXSTATUS1_OUT                     : out  std_logic_vector(2 downto 0);
    --------------------- Shared Ports - Tile and PLL Ports --------------------
    TILE3_CLKIN_IN                          : in   std_logic;
    TILE3_GTPRESET_IN                       : in   std_logic;
    TILE3_PLLLKDET_OUT                      : out  std_logic;
    TILE3_REFCLKOUT_OUT                     : out  std_logic;
    TILE3_RESETDONE0_OUT                    : out  std_logic;
    TILE3_RESETDONE1_OUT                    : out  std_logic;
    ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
    TILE3_TXCHARISK0_IN                     : in   std_logic;
    TILE3_TXCHARISK1_IN                     : in   std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE3_TXDATA0_IN                        : in   std_logic_vector(7 downto 0);
    TILE3_TXDATA1_IN                        : in   std_logic_vector(7 downto 0);
    TILE3_TXOUTCLK0_OUT                     : out  std_logic;
    TILE3_TXOUTCLK1_OUT                     : out  std_logic;
    TILE3_TXRESET0_IN                       : in   std_logic;
    TILE3_TXRESET1_IN                       : in   std_logic;
    TILE3_TXUSRCLK0_IN                      : in   std_logic;
    TILE3_TXUSRCLK1_IN                      : in   std_logic;
    TILE3_TXUSRCLK20_IN                     : in   std_logic;
    TILE3_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE3_TXDIFFCTRL0_IN                    : in   std_logic_vector(2 downto 0);
    TILE3_TXDIFFCTRL1_IN                    : in   std_logic_vector(2 downto 0);
    TILE3_TXN0_OUT                          : out  std_logic;
    TILE3_TXN1_OUT                          : out  std_logic;
    TILE3_TXP0_OUT                          : out  std_logic;
    TILE3_TXP1_OUT                          : out  std_logic;
    ----------------- Transmit Ports - TX Ports for PCI Express ----------------
    TILE3_TXELECIDLE0_IN                    : in   std_logic;
    TILE3_TXELECIDLE1_IN                    : in   std_logic;
    --------------------- Transmit Ports - TX Ports for SATA -------------------
    TILE3_TXCOMSTART0_IN                    : in   std_logic;
    TILE3_TXCOMSTART1_IN                    : in   std_logic;
    TILE3_TXCOMTYPE0_IN                     : in   std_logic;
    TILE3_TXCOMTYPE1_IN                     : in   std_logic


);
end component;










    ----------------------------- The GTP Wrapper -----------------------------


    loop_test_i : LOOP_TEST
    generic map
    (
        WRAPPER_SIM_GTPRESET_SPEEDUP    =>      1,
        WRAPPER_SIM_PLL_PERDIV2         =>      x"14d"
    )
    port map
    (
        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE0  (X0Y2)

        ------------------------ Loopback and Powerdown Ports ----------------------
        TILE0_RXPOWERDOWN0_IN           =>      ,
        TILE0_RXPOWERDOWN1_IN           =>      ,
        TILE0_TXPOWERDOWN0_IN           =>      ,
        TILE0_TXPOWERDOWN1_IN           =>      ,
        ----------------------- Receive Ports - 8b10b Decoder ----------------------
        TILE0_RXCHARISCOMMA0_OUT        =>      ,
        TILE0_RXCHARISCOMMA1_OUT        =>      ,
        TILE0_RXCHARISK0_OUT            =>      ,
        TILE0_RXCHARISK1_OUT            =>      ,
        TILE0_RXDISPERR0_OUT            =>      ,
        TILE0_RXDISPERR1_OUT            =>      ,
        TILE0_RXNOTINTABLE0_OUT         =>      ,
        TILE0_RXNOTINTABLE1_OUT         =>      ,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        TILE0_RXCLKCORCNT0_OUT          =>      ,
        TILE0_RXCLKCORCNT1_OUT          =>      ,
        --------------- Receive Ports - Comma Detection and Alignment --------------
        TILE0_RXENMCOMMAALIGN0_IN       =>      ,
        TILE0_RXENMCOMMAALIGN1_IN       =>      ,
        TILE0_RXENPCOMMAALIGN0_IN       =>      ,
        TILE0_RXENPCOMMAALIGN1_IN       =>      ,
        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE0_RXDATA0_OUT               =>      ,
        TILE0_RXDATA1_OUT               =>      ,
        TILE0_RXRECCLK0_OUT             =>      ,
        TILE0_RXRECCLK1_OUT             =>      ,
        TILE0_RXRESET0_IN               =>      ,
        TILE0_RXRESET1_IN               =>      ,
        TILE0_RXUSRCLK0_IN              =>      ,
        TILE0_RXUSRCLK1_IN              =>      ,
        TILE0_RXUSRCLK20_IN             =>      ,
        TILE0_RXUSRCLK21_IN             =>      ,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE0_RXCDRRESET0_IN            =>      ,
        TILE0_RXCDRRESET1_IN            =>      ,
        TILE0_RXELECIDLE0_OUT           =>      ,
        TILE0_RXELECIDLE1_OUT           =>      ,
        TILE0_RXEQMIX0_IN               =>      ,
        TILE0_RXEQMIX1_IN               =>      ,
        TILE0_RXEQPOLE0_IN              =>      ,
        TILE0_RXEQPOLE1_IN              =>      ,
        TILE0_RXN0_IN                   =>      ,
        TILE0_RXN1_IN                   =>      ,
        TILE0_RXP0_IN                   =>      ,
        TILE0_RXP1_IN                   =>      ,
        -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
        TILE0_RXBUFRESET0_IN            =>      ,
        TILE0_RXBUFRESET1_IN            =>      ,
        TILE0_RXSTATUS0_OUT             =>      ,
        TILE0_RXSTATUS1_OUT             =>      ,
        --------------------- Shared Ports - Tile and PLL Ports --------------------
        TILE0_CLKIN_IN                  =>      ,
        TILE0_GTPRESET_IN               =>      ,
        TILE0_PLLLKDET_OUT              =>      ,
        TILE0_REFCLKOUT_OUT             =>      ,
        TILE0_RESETDONE0_OUT            =>      ,
        TILE0_RESETDONE1_OUT            =>      ,
        ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
        TILE0_TXCHARISK0_IN             =>      ,
        TILE0_TXCHARISK1_IN             =>      ,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE0_TXDATA0_IN                =>      ,
        TILE0_TXDATA1_IN                =>      ,
        TILE0_TXOUTCLK0_OUT             =>      ,
        TILE0_TXOUTCLK1_OUT             =>      ,
        TILE0_TXRESET0_IN               =>      ,
        TILE0_TXRESET1_IN               =>      ,
        TILE0_TXUSRCLK0_IN              =>      ,
        TILE0_TXUSRCLK1_IN              =>      ,
        TILE0_TXUSRCLK20_IN             =>      ,
        TILE0_TXUSRCLK21_IN             =>      ,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE0_TXDIFFCTRL0_IN            =>      ,
        TILE0_TXDIFFCTRL1_IN            =>      ,
        TILE0_TXN0_OUT                  =>      ,
        TILE0_TXN1_OUT                  =>      ,
        TILE0_TXP0_OUT                  =>      ,
        TILE0_TXP1_OUT                  =>      ,
        ----------------- Transmit Ports - TX Ports for PCI Express ----------------
        TILE0_TXELECIDLE0_IN            =>      ,
        TILE0_TXELECIDLE1_IN            =>      ,
        --------------------- Transmit Ports - TX Ports for SATA -------------------
        TILE0_TXCOMSTART0_IN            =>      ,
        TILE0_TXCOMSTART1_IN            =>      ,
        TILE0_TXCOMTYPE0_IN             =>      ,
        TILE0_TXCOMTYPE1_IN             =>      ,


        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE1  (X0Y3)

        ------------------------ Loopback and Powerdown Ports ----------------------
        TILE1_RXPOWERDOWN0_IN           =>      ,
        TILE1_RXPOWERDOWN1_IN           =>      ,
        TILE1_TXPOWERDOWN0_IN           =>      ,
        TILE1_TXPOWERDOWN1_IN           =>      ,
        ----------------------- Receive Ports - 8b10b Decoder ----------------------
        TILE1_RXCHARISCOMMA0_OUT        =>      ,
        TILE1_RXCHARISCOMMA1_OUT        =>      ,
        TILE1_RXCHARISK0_OUT            =>      ,
        TILE1_RXCHARISK1_OUT            =>      ,
        TILE1_RXDISPERR0_OUT            =>      ,
        TILE1_RXDISPERR1_OUT            =>      ,
        TILE1_RXNOTINTABLE0_OUT         =>      ,
        TILE1_RXNOTINTABLE1_OUT         =>      ,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        TILE1_RXCLKCORCNT0_OUT          =>      ,
        TILE1_RXCLKCORCNT1_OUT          =>      ,
        --------------- Receive Ports - Comma Detection and Alignment --------------
        TILE1_RXENMCOMMAALIGN0_IN       =>      ,
        TILE1_RXENMCOMMAALIGN1_IN       =>      ,
        TILE1_RXENPCOMMAALIGN0_IN       =>      ,
        TILE1_RXENPCOMMAALIGN1_IN       =>      ,
        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE1_RXDATA0_OUT               =>      ,
        TILE1_RXDATA1_OUT               =>      ,
        TILE1_RXRECCLK0_OUT             =>      ,
        TILE1_RXRECCLK1_OUT             =>      ,
        TILE1_RXRESET0_IN               =>      ,
        TILE1_RXRESET1_IN               =>      ,
        TILE1_RXUSRCLK0_IN              =>      ,
        TILE1_RXUSRCLK1_IN              =>      ,
        TILE1_RXUSRCLK20_IN             =>      ,
        TILE1_RXUSRCLK21_IN             =>      ,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE1_RXCDRRESET0_IN            =>      ,
        TILE1_RXCDRRESET1_IN            =>      ,
        TILE1_RXELECIDLE0_OUT           =>      ,
        TILE1_RXELECIDLE1_OUT           =>      ,
        TILE1_RXEQMIX0_IN               =>      ,
        TILE1_RXEQMIX1_IN               =>      ,
        TILE1_RXEQPOLE0_IN              =>      ,
        TILE1_RXEQPOLE1_IN              =>      ,
        TILE1_RXN0_IN                   =>      ,
        TILE1_RXN1_IN                   =>      ,
        TILE1_RXP0_IN                   =>      ,
        TILE1_RXP1_IN                   =>      ,
        -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
        TILE1_RXBUFRESET0_IN            =>      ,
        TILE1_RXBUFRESET1_IN            =>      ,
        TILE1_RXSTATUS0_OUT             =>      ,
        TILE1_RXSTATUS1_OUT             =>      ,
        --------------------- Shared Ports - Tile and PLL Ports --------------------
        TILE1_CLKIN_IN                  =>      ,
        TILE1_GTPRESET_IN               =>      ,
        TILE1_PLLLKDET_OUT              =>      ,
        TILE1_REFCLKOUT_OUT             =>      ,
        TILE1_RESETDONE0_OUT            =>      ,
        TILE1_RESETDONE1_OUT            =>      ,
        ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
        TILE1_TXCHARISK0_IN             =>      ,
        TILE1_TXCHARISK1_IN             =>      ,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE1_TXDATA0_IN                =>      ,
        TILE1_TXDATA1_IN                =>      ,
        TILE1_TXOUTCLK0_OUT             =>      ,
        TILE1_TXOUTCLK1_OUT             =>      ,
        TILE1_TXRESET0_IN               =>      ,
        TILE1_TXRESET1_IN               =>      ,
        TILE1_TXUSRCLK0_IN              =>      ,
        TILE1_TXUSRCLK1_IN              =>      ,
        TILE1_TXUSRCLK20_IN             =>      ,
        TILE1_TXUSRCLK21_IN             =>      ,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE1_TXDIFFCTRL0_IN            =>      ,
        TILE1_TXDIFFCTRL1_IN            =>      ,
        TILE1_TXN0_OUT                  =>      ,
        TILE1_TXN1_OUT                  =>      ,
        TILE1_TXP0_OUT                  =>      ,
        TILE1_TXP1_OUT                  =>      ,
        ----------------- Transmit Ports - TX Ports for PCI Express ----------------
        TILE1_TXELECIDLE0_IN            =>      ,
        TILE1_TXELECIDLE1_IN            =>      ,
        --------------------- Transmit Ports - TX Ports for SATA -------------------
        TILE1_TXCOMSTART0_IN            =>      ,
        TILE1_TXCOMSTART1_IN            =>      ,
        TILE1_TXCOMTYPE0_IN             =>      ,
        TILE1_TXCOMTYPE1_IN             =>      ,


        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE2  (X0Y4)

        ------------------------ Loopback and Powerdown Ports ----------------------
        TILE2_RXPOWERDOWN0_IN           =>      ,
        TILE2_RXPOWERDOWN1_IN           =>      ,
        TILE2_TXPOWERDOWN0_IN           =>      ,
        TILE2_TXPOWERDOWN1_IN           =>      ,
        ----------------------- Receive Ports - 8b10b Decoder ----------------------
        TILE2_RXCHARISCOMMA0_OUT        =>      ,
        TILE2_RXCHARISCOMMA1_OUT        =>      ,
        TILE2_RXCHARISK0_OUT            =>      ,
        TILE2_RXCHARISK1_OUT            =>      ,
        TILE2_RXDISPERR0_OUT            =>      ,
        TILE2_RXDISPERR1_OUT            =>      ,
        TILE2_RXNOTINTABLE0_OUT         =>      ,
        TILE2_RXNOTINTABLE1_OUT         =>      ,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        TILE2_RXCLKCORCNT0_OUT          =>      ,
        TILE2_RXCLKCORCNT1_OUT          =>      ,
        --------------- Receive Ports - Comma Detection and Alignment --------------
        TILE2_RXENMCOMMAALIGN0_IN       =>      ,
        TILE2_RXENMCOMMAALIGN1_IN       =>      ,
        TILE2_RXENPCOMMAALIGN0_IN       =>      ,
        TILE2_RXENPCOMMAALIGN1_IN       =>      ,
        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE2_RXDATA0_OUT               =>      ,
        TILE2_RXDATA1_OUT               =>      ,
        TILE2_RXRECCLK0_OUT             =>      ,
        TILE2_RXRECCLK1_OUT             =>      ,
        TILE2_RXRESET0_IN               =>      ,
        TILE2_RXRESET1_IN               =>      ,
        TILE2_RXUSRCLK0_IN              =>      ,
        TILE2_RXUSRCLK1_IN              =>      ,
        TILE2_RXUSRCLK20_IN             =>      ,
        TILE2_RXUSRCLK21_IN             =>      ,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE2_RXCDRRESET0_IN            =>      ,
        TILE2_RXCDRRESET1_IN            =>      ,
        TILE2_RXELECIDLE0_OUT           =>      ,
        TILE2_RXELECIDLE1_OUT           =>      ,
        TILE2_RXEQMIX0_IN               =>      ,
        TILE2_RXEQMIX1_IN               =>      ,
        TILE2_RXEQPOLE0_IN              =>      ,
        TILE2_RXEQPOLE1_IN              =>      ,
        TILE2_RXN0_IN                   =>      ,
        TILE2_RXN1_IN                   =>      ,
        TILE2_RXP0_IN                   =>      ,
        TILE2_RXP1_IN                   =>      ,
        -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
        TILE2_RXBUFRESET0_IN            =>      ,
        TILE2_RXBUFRESET1_IN            =>      ,
        TILE2_RXSTATUS0_OUT             =>      ,
        TILE2_RXSTATUS1_OUT             =>      ,
        --------------------- Shared Ports - Tile and PLL Ports --------------------
        TILE2_CLKIN_IN                  =>      ,
        TILE2_GTPRESET_IN               =>      ,
        TILE2_PLLLKDET_OUT              =>      ,
        TILE2_REFCLKOUT_OUT             =>      ,
        TILE2_RESETDONE0_OUT            =>      ,
        TILE2_RESETDONE1_OUT            =>      ,
        ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
        TILE2_TXCHARISK0_IN             =>      ,
        TILE2_TXCHARISK1_IN             =>      ,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE2_TXDATA0_IN                =>      ,
        TILE2_TXDATA1_IN                =>      ,
        TILE2_TXOUTCLK0_OUT             =>      ,
        TILE2_TXOUTCLK1_OUT             =>      ,
        TILE2_TXRESET0_IN               =>      ,
        TILE2_TXRESET1_IN               =>      ,
        TILE2_TXUSRCLK0_IN              =>      ,
        TILE2_TXUSRCLK1_IN              =>      ,
        TILE2_TXUSRCLK20_IN             =>      ,
        TILE2_TXUSRCLK21_IN             =>      ,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE2_TXDIFFCTRL0_IN            =>      ,
        TILE2_TXDIFFCTRL1_IN            =>      ,
        TILE2_TXN0_OUT                  =>      ,
        TILE2_TXN1_OUT                  =>      ,
        TILE2_TXP0_OUT                  =>      ,
        TILE2_TXP1_OUT                  =>      ,
        ----------------- Transmit Ports - TX Ports for PCI Express ----------------
        TILE2_TXELECIDLE0_IN            =>      ,
        TILE2_TXELECIDLE1_IN            =>      ,
        --------------------- Transmit Ports - TX Ports for SATA -------------------
        TILE2_TXCOMSTART0_IN            =>      ,
        TILE2_TXCOMSTART1_IN            =>      ,
        TILE2_TXCOMTYPE0_IN             =>      ,
        TILE2_TXCOMTYPE1_IN             =>      ,


        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE3  (X0Y5)

        ------------------------ Loopback and Powerdown Ports ----------------------
        TILE3_RXPOWERDOWN0_IN           =>      ,
        TILE3_RXPOWERDOWN1_IN           =>      ,
        TILE3_TXPOWERDOWN0_IN           =>      ,
        TILE3_TXPOWERDOWN1_IN           =>      ,
        ----------------------- Receive Ports - 8b10b Decoder ----------------------
        TILE3_RXCHARISCOMMA0_OUT        =>      ,
        TILE3_RXCHARISCOMMA1_OUT        =>      ,
        TILE3_RXCHARISK0_OUT            =>      ,
        TILE3_RXCHARISK1_OUT            =>      ,
        TILE3_RXDISPERR0_OUT            =>      ,
        TILE3_RXDISPERR1_OUT            =>      ,
        TILE3_RXNOTINTABLE0_OUT         =>      ,
        TILE3_RXNOTINTABLE1_OUT         =>      ,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        TILE3_RXCLKCORCNT0_OUT          =>      ,
        TILE3_RXCLKCORCNT1_OUT          =>      ,
        --------------- Receive Ports - Comma Detection and Alignment --------------
        TILE3_RXENMCOMMAALIGN0_IN       =>      ,
        TILE3_RXENMCOMMAALIGN1_IN       =>      ,
        TILE3_RXENPCOMMAALIGN0_IN       =>      ,
        TILE3_RXENPCOMMAALIGN1_IN       =>      ,
        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE3_RXDATA0_OUT               =>      ,
        TILE3_RXDATA1_OUT               =>      ,
        TILE3_RXRECCLK0_OUT             =>      ,
        TILE3_RXRECCLK1_OUT             =>      ,
        TILE3_RXRESET0_IN               =>      ,
        TILE3_RXRESET1_IN               =>      ,
        TILE3_RXUSRCLK0_IN              =>      ,
        TILE3_RXUSRCLK1_IN              =>      ,
        TILE3_RXUSRCLK20_IN             =>      ,
        TILE3_RXUSRCLK21_IN             =>      ,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE3_RXCDRRESET0_IN            =>      ,
        TILE3_RXCDRRESET1_IN            =>      ,
        TILE3_RXELECIDLE0_OUT           =>      ,
        TILE3_RXELECIDLE1_OUT           =>      ,
        TILE3_RXEQMIX0_IN               =>      ,
        TILE3_RXEQMIX1_IN               =>      ,
        TILE3_RXEQPOLE0_IN              =>      ,
        TILE3_RXEQPOLE1_IN              =>      ,
        TILE3_RXN0_IN                   =>      ,
        TILE3_RXN1_IN                   =>      ,
        TILE3_RXP0_IN                   =>      ,
        TILE3_RXP1_IN                   =>      ,
        -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
        TILE3_RXBUFRESET0_IN            =>      ,
        TILE3_RXBUFRESET1_IN            =>      ,
        TILE3_RXSTATUS0_OUT             =>      ,
        TILE3_RXSTATUS1_OUT             =>      ,
        --------------------- Shared Ports - Tile and PLL Ports --------------------
        TILE3_CLKIN_IN                  =>      ,
        TILE3_GTPRESET_IN               =>      ,
        TILE3_PLLLKDET_OUT              =>      ,
        TILE3_REFCLKOUT_OUT             =>      ,
        TILE3_RESETDONE0_OUT            =>      ,
        TILE3_RESETDONE1_OUT            =>      ,
        ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
        TILE3_TXCHARISK0_IN             =>      ,
        TILE3_TXCHARISK1_IN             =>      ,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE3_TXDATA0_IN                =>      ,
        TILE3_TXDATA1_IN                =>      ,
        TILE3_TXOUTCLK0_OUT             =>      ,
        TILE3_TXOUTCLK1_OUT             =>      ,
        TILE3_TXRESET0_IN               =>      ,
        TILE3_TXRESET1_IN               =>      ,
        TILE3_TXUSRCLK0_IN              =>      ,
        TILE3_TXUSRCLK1_IN              =>      ,
        TILE3_TXUSRCLK20_IN             =>      ,
        TILE3_TXUSRCLK21_IN             =>      ,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE3_TXDIFFCTRL0_IN            =>      ,
        TILE3_TXDIFFCTRL1_IN            =>      ,
        TILE3_TXN0_OUT                  =>      ,
        TILE3_TXN1_OUT                  =>      ,
        TILE3_TXP0_OUT                  =>      ,
        TILE3_TXP1_OUT                  =>      ,
        ----------------- Transmit Ports - TX Ports for PCI Express ----------------
        TILE3_TXELECIDLE0_IN            =>      ,
        TILE3_TXELECIDLE1_IN            =>      ,
        --------------------- Transmit Ports - TX Ports for SATA -------------------
        TILE3_TXCOMSTART0_IN            =>      ,
        TILE3_TXCOMSTART1_IN            =>      ,
        TILE3_TXCOMTYPE0_IN             =>      ,
        TILE3_TXCOMTYPE1_IN             =>      


    );





    -----------------------Dedicated GTP Reference Clock Inputs ---------------
    -- Each dedicated refclk you are using in your design will need its own IBUFDS instance
    
    tile2_refclk_ibufds_i : IBUFDS
    port map
    (
        O                               =>      ,
        I                               =>      ,  -- Connect to package pin V4
        IB                              =>        -- Connect to package pin V3
    );




















