LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

ENTITY music IS
  PORT(
		clk 		: IN std_logic;
		rst	 	: IN std_logic;
		addr		: IN std_logic_vector(7 downto 0);
		speaker 	: OUT std_logic
		);
END music;

ARCHITECTURE logic OF music IS

	COMPONENT notes
	PORT(
		clk_i : IN std_logic;
		rst_i : IN std_logic;          
		note : OUT std_logic_vector(47 downto 0)
		);
	END COMPONENT;
	
	COMPONENT melody1
	PORT(
		note : IN std_logic_vector(47 downto 0);
		beat : IN std_logic_vector(9 downto 0);          
		sound : OUT std_logic
		);
	END COMPONENT;
	
	COMPONENT melody2
	PORT(
		note : IN std_logic_vector(47 downto 0);
		beat : IN std_logic_vector(9 downto 0);          
		sound : OUT std_logic
		);
	END COMPONENT;
	
	COMPONENT melody3
	PORT(
		note : IN std_logic_vector(47 downto 0);
		beat : IN std_logic_vector(9 downto 0);          
		sound : OUT std_logic
		);
	END COMPONENT;
	
	COMPONENT melody4
	PORT(
		note : IN std_logic_vector(47 downto 0);
		beat : IN std_logic_vector(9 downto 0);          
		sound : OUT std_logic
		);
	END COMPONENT;
	
	COMPONENT melody5
	PORT(
		note : IN std_logic_vector(47 downto 0);
		beat : IN std_logic_vector(9 downto 0);          
		sound : OUT std_logic
		);
	END COMPONENT;
	
	COMPONENT melody6
	PORT(
		note : IN std_logic_vector(47 downto 0);
		beat : IN std_logic_vector(9 downto 0);          
		sound : OUT std_logic
		);
	END COMPONENT;
	
	COMPONENT melody7
	PORT(
		note : IN std_logic_vector(47 downto 0);
		beat : IN std_logic_vector(9 downto 0);          
		sound : OUT std_logic
		);
	END COMPONENT;
	
	COMPONENT melody8
	PORT(
		note : IN std_logic_vector(47 downto 0);
		beat : IN std_logic_vector(9 downto 0);          
		sound : OUT std_logic
		);
	END COMPONENT;
	
	COMPONENT melody9
	PORT(
		note : IN std_logic_vector(47 downto 0);
		beat : IN std_logic_vector(9 downto 0);          
		sound : OUT std_logic
		);
	END COMPONENT;

signal note		:STD_LOGIC_VECTOR(47 downto 0);
signal timer	:STD_LOGIC_VECTOR(36 downto 0);
signal spkr1,spkr2,spkr3,spkr4,spkr5,spkr6,spkr7,spkr8,spkr9 :STD_LOGIC;

BEGIN

		Inst_notes: notes PORT MAP(
		clk_i => clk,
		rst_i => rst,
		note => note
	);
	
		Inst_melody1: melody1 PORT MAP(
		note => note,
		beat => timer(30 downto 21),
		sound => spkr1
	);
	
		Inst_melody2: melody2 PORT MAP(
		note => note,
		beat => timer(29 downto 20),
		sound => spkr2
	);
	
		Inst_melody3: melody3 PORT MAP(
		note => note,
		beat => timer(32 downto 23),
		sound => spkr3
	);
	
		Inst_melody4: melody4 PORT MAP(
		note => note,
		beat => timer(32 downto 23),
		sound => spkr4
	);
	
		Inst_melody5: melody5 PORT MAP(
		note => note,
		beat => timer(30 downto 21),
		sound => spkr5
	);
	
		Inst_melody6: melody6 PORT MAP(
		note => note,
		beat => timer(31 downto 22),
		sound => spkr6
	);
	
		Inst_melody7: melody7 PORT MAP(
		note => note,
		beat => timer(31 downto 22),
		sound => spkr7
	);
	
		Inst_melody8: melody8 PORT MAP(
		note => note,
		beat => timer(30 downto 21),
		sound => spkr8
	);
	
		Inst_melody9: melody9 PORT MAP(
		note => note,
		beat => timer(32 downto 23),
		sound => spkr9
	);
	
	process(clk,rst)
	begin
	  if (rst='0') then
    timer <= (others => '0');
  elsif (clk'event and clk = '1') then 
			timer <= timer + '1';
		end if;
	end process;
	
process(addr,spkr1,spkr2,spkr3,spkr4,spkr5,spkr6,spkr7,spkr8,spkr9)
begin
   case addr is 
      when "11111110" => speaker <= spkr1;
		when "11111101" => speaker <= spkr2;
		when "11111011" => speaker <= spkr3;
		when "11110111" => speaker <= spkr4;
		when "11101111" => speaker <= spkr5;
		when "11011111" => speaker <= spkr6;
		when "10111111" => speaker <= spkr7;
		when "01111111" => speaker <= spkr8;
      when others => speaker <= spkr9;
   end case;
end process;

END logic;
