library ieee;
use ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

entity notes is
port(
    clk_i	:in std_logic:='0';			--50 MHZ
	 rst_i	:in std_logic;					--reset
	 note		:out std_logic_vector(47 downto 0)
);
end notes;

architecture Behavioral of notes is

signal count_C,count_Db,count_D,count_Eb,count_E,count_F,count_Gb,count_G,count_Ab,count_A,count_Bb,count_B	:STD_LOGIC_VECTOR(2 downto 0);
signal	 C4	:STD_LOGIC;	--262 HZ
signal	 C5	:STD_LOGIC;	--523 HZ
signal	 C6	:STD_LOGIC;	--1047 HZ
signal	 C7	:STD_LOGIC;	--2093 HZ
signal	 Db4	:STD_LOGIC;	--277 HZ
signal	 Db5	:STD_LOGIC;	--554 HZ
signal	 Db6	:STD_LOGIC;	--1109 HZ
signal	 Db7	:STD_LOGIC;	--2217 HZ
signal	 D4	:STD_LOGIC;	--294 HZ
signal	 D5	:STD_LOGIC;	--587 HZ
signal	 D6	:STD_LOGIC;	--1175 HZ
signal	 D7	:STD_LOGIC;	--2349 HZ
signal	 Eb4	:STD_LOGIC;	--311 HZ
signal	 Eb5	:STD_LOGIC;	--622 HZ
signal	 Eb6	:STD_LOGIC;	--1245 HZ
signal	 Eb7	:STD_LOGIC;	--2489 HZ
signal	 E4	:STD_LOGIC;	--330 HZ
signal	 E5	:STD_LOGIC;	--659 HZ
signal	 E6	:STD_LOGIC;	--1319 HZ
signal	 E7	:STD_LOGIC;	--2637 HZ
signal	 F4	:STD_LOGIC;	--349 HZ
signal	 F5	:STD_LOGIC;	--698 HZ
signal	 F6	:STD_LOGIC;	--1397 HZ
signal	 F7	:STD_LOGIC;	--2794 HZ
signal	 Gb4	:STD_LOGIC;	--370 HZ
signal	 Gb5	:STD_LOGIC;	--740 HZ
signal	 Gb6	:STD_LOGIC;	--1480 HZ
signal	 Gb7	:STD_LOGIC;	--2960 HZ
signal	 G4	:STD_LOGIC;	--392 HZ
signal	 G5	:STD_LOGIC;	--784 HZ
signal	 G6	:STD_LOGIC;	--1568 HZ
signal	 G7	:STD_LOGIC;	--3136 HZ
signal	 Ab4	:STD_LOGIC;	--415 HZ
signal	 Ab5	:STD_LOGIC;	--831 HZ
signal	 Ab6	:STD_LOGIC;	--1661 HZ
signal	 Ab7	:STD_LOGIC;	--3322 HZ
signal	 A4	:STD_LOGIC;	--440 HZ
signal	 A5	:STD_LOGIC;	--880 HZ
signal	 A6	:STD_LOGIC;	--1760 HZ
signal	 A7	:STD_LOGIC;	--3520 HZ
signal	 Bb4	:STD_LOGIC;	--466 HZ
signal	 Bb5	:STD_LOGIC;	--932 HZ
signal	 Bb6	:STD_LOGIC;	--1865 HZ
signal	 Bb7	:STD_LOGIC;	--3729 HZ
signal	 B4	:STD_LOGIC;	--494 HZ
signal	 B5	:STD_LOGIC;	--988 HZ
signal	 B6	:STD_LOGIC;	--1975 HZ
signal	 B7	:STD_LOGIC;	--3951 HZ

begin

process(clk_i,rst_i)
variable d_C7:integer range 0 to 12000:=0;
begin
if (rst_i='0') then d_C7:=0;
elsif(clk_i'event and clk_i = '1')then d_C7:=d_C7+1;
if(d_C7>=11945)then C7<=not C7;
d_C7:=0;
end if;
end if;
end process;

	process(C7,rst_i)
	begin
	  if (rst_i='0') then
    count_C <= (others => '0');
  elsif (C7'event and C7 = '1') then
			count_C <= count_C + '1';
		end if;
	end process;

C6 <= count_C(0);
C5 <= count_C(1);
C4 <= count_C(2);
-----------------
process(clk_i,rst_i)
variable d_Db7:integer range 0 to 12000:=0;
begin
if (rst_i='0') then d_Db7:=0;
elsif(clk_i'event and clk_i = '1')then d_Db7:=d_Db7+1;
if(d_Db7>=11274)then Db7<=not Db7;
d_Db7:=0;
end if;
end if;
end process;

	process(Db7,rst_i)
	begin
	  if (rst_i='0') then
    count_Db <= (others => '0');
  elsif (Db7'event and Db7 = '1') then
			count_Db <= count_Db + '1';
		end if;
	end process;

Db6 <= count_Db(0);
Db5 <= count_Db(1);
Db4 <= count_Db(2);
-------------------
process(clk_i,rst_i)
variable d_D7:integer range 0 to 12000:=0;
begin
if (rst_i='0') then d_D7:=0;
elsif(clk_i'event and clk_i = '1')then d_D7:=d_D7+1;
if(d_D7>=10641)then D7<=not D7;
d_D7:=0;
end if;
end if;
end process;

	process(D7,rst_i)
	begin
	  if (rst_i='0') then
    count_D <= (others => '0');
  elsif (D7'event and D7 = '1') then
			count_D <= count_D + '1';
		end if;
	end process;

D6 <= count_D(0);
D5 <= count_D(1);
D4 <= count_D(2);
-----------------
process(clk_i,rst_i)
variable d_Eb7:integer range 0 to 12000:=0;
begin
if (rst_i='0') then d_Eb7:=0;
elsif(clk_i'event and clk_i = '1')then d_Eb7:=d_Eb7+1;
if(d_Eb7>=10044)then Eb7<=not Eb7;
d_Eb7:=0;
end if;
end if;
end process;

	process(Eb7,rst_i)
	begin
	  if (rst_i='0') then
    count_Eb <= (others => '0');
  elsif (Eb7'event and Eb7 = '1') then
			count_Eb <= count_Eb + '1';
		end if;
	end process;

Eb6 <= count_Eb(0);
Eb5 <= count_Eb(1);
Eb4 <= count_Eb(2);
-------------------
process(clk_i,rst_i)
variable d_E7:integer range 0 to 12000:=0;
begin
if (rst_i='0') then d_E7:=0;
elsif(clk_i'event and clk_i = '1')then d_E7:=d_E7+1;
if(d_E7>=9480)then E7<=not E7;
d_E7:=0;
end if;
end if;
end process;

	process(E7,rst_i)
	begin
	  if (rst_i='0') then
    count_E <= (others => '0');
  elsif (E7'event and E7 = '1') then
			count_E <= count_E + '1';
		end if;
	end process;

E6 <= count_E(0);
E5 <= count_E(1);
E4 <= count_E(2);
-----------------
process(clk_i,rst_i)
variable d_F7:integer range 0 to 12000:=0;
begin
if (rst_i='0') then d_F7:=0;
elsif(clk_i'event and clk_i = '1')then d_F7:=d_F7+1;
if(d_F7>=8948)then F7<=not F7;
d_F7:=0;
end if;
end if;
end process;

	process(F7,rst_i)
	begin
	  if (rst_i='0') then
    count_F <= (others => '0');
  elsif (F7'event and F7 = '1') then
			count_F <= count_F + '1';
		end if;
	end process;

F6 <= count_F(0);
F5 <= count_F(1);
F4 <= count_F(2);
-----------------
process(clk_i,rst_i)
variable d_Gb7:integer range 0 to 12000:=0;
begin
if (rst_i='0') then d_Gb7:=0;
elsif(clk_i'event and clk_i = '1')then d_Gb7:=d_Gb7+1;
if(d_Gb7>=8446)then Gb7<=not Gb7;
d_Gb7:=0;
end if;
end if;
end process;

	process(Gb7,rst_i)
	begin
	  if (rst_i='0') then
    count_Gb <= (others => '0');
  elsif (Gb7'event and Gb7 = '1') then
			count_Gb <= count_Gb + '1';
		end if;
	end process;

Gb6 <= count_Gb(0);
Gb5 <= count_Gb(1);
Gb4 <= count_Gb(2);
-------------------
process(clk_i,rst_i)
variable d_G7:integer range 0 to 12000:=0;
begin
if (rst_i='0') then d_G7:=0;
elsif(clk_i'event and clk_i = '1')then d_G7:=d_G7+1;
if(d_G7>=7972)then G7<=not G7;
d_G7:=0;
end if;
end if;
end process;

	process(G7,rst_i)
	begin
	  if (rst_i='0') then
    count_G <= (others => '0');
  elsif (G7'event and G7 = '1') then
			count_G <= count_G + '1';
		end if;
	end process;

G6 <= count_G(0);
G5 <= count_G(1);
G4 <= count_G(2);
-----------------
process(clk_i,rst_i)
variable d_Ab7:integer range 0 to 12000:=0;
begin
if (rst_i='0') then d_Ab7:=0;
elsif(clk_i'event and clk_i = '1')then d_Ab7:=d_Ab7+1;
if(d_Ab7>=7525)then Ab7<=not Ab7;
d_Ab7:=0;
end if;
end if;
end process;

	process(Ab7,rst_i)
	begin
	  if (rst_i='0') then
    count_Ab <= (others => '0');
  elsif (Ab7'event and Ab7 = '1') then
			count_Ab <= count_Ab + '1';
		end if;
	end process;

Ab6 <= count_Ab(0);
Ab5 <= count_Ab(1);
Ab4 <= count_Ab(2);
-------------------
process(clk_i,rst_i)
variable d_A7:integer range 0 to 12000:=0;
begin
if (rst_i='0') then d_A7:=0;
elsif(clk_i'event and clk_i = '1')then d_A7:=d_A7+1;
if(d_A7>=7102)then A7<=not A7;
d_A7:=0;
end if;
end if;
end process;

	process(A7,rst_i)
	begin
	  if (rst_i='0') then
    count_A <= (others => '0');
  elsif (A7'event and A7 = '1') then
			count_A <= count_A + '1';
		end if;
	end process;

A6 <= count_A(0);
A5 <= count_A(1);
A4 <= count_A(2);
-----------------
process(clk_i,rst_i)
variable d_Bb7:integer range 0 to 12000:=0;
begin
if (rst_i='0') then d_Bb7:=0;
elsif(clk_i'event and clk_i = '1')then d_Bb7:=d_Bb7+1;
if(d_Bb7>=6704)then Bb7<=not Bb7;
d_Bb7:=0;
end if;
end if;
end process;

	process(Bb7,rst_i)
	begin
	  if (rst_i='0') then
    count_Bb <= (others => '0');
  elsif (Bb7'event and Bb7 = '1') then
			count_Bb <= count_Bb + '1';
		end if;
	end process;

Bb6 <= count_Bb(0);
Bb5 <= count_Bb(1);
Bb4 <= count_Bb(2);
-------------------
process(clk_i,rst_i)
variable d_B7:integer range 0 to 12000:=0;
begin
if (rst_i='0') then d_B7:=0;
elsif(clk_i'event and clk_i = '1')then d_B7:=d_B7+1;
if(d_B7>=6327)then B7<=not B7;
d_B7:=0;
end if;
end if;
end process;

	process(B7,rst_i)
	begin
	  if (rst_i='0') then
    count_B <= (others => '0');
  elsif (B7'event and B7 = '1') then
			count_B <= count_B + '1';
		end if;
	end process;

B6 <= count_B(0);
B5 <= count_B(1);
B4 <= count_B(2);
-----------------
note(0)<=C4;
note(1)<=C5;
note(2)<=C6;
note(3)<=C7;
note(4)<=Db4;
note(5)<=Db5;
note(6)<=Db6;
note(7)<=Db7;
note(8)<=D4;
note(9)<=D5;
note(10)<=D6;
note(11)<=D7;
note(12)<=Eb4;
note(13)<=Eb5;
note(14)<=Eb6;
note(15)<=Eb7;
note(16)<=E4;
note(17)<=E5;
note(18)<=E6;
note(19)<=E7;
note(20)<=F4;
note(21)<=F5;
note(22)<=F6;
note(23)<=F7;
note(24)<=Gb4;
note(25)<=Gb5;
note(26)<=Gb6;
note(27)<=Gb7;
note(28)<=G4;
note(29)<=G5;
note(30)<=G6;
note(31)<=G7;
note(32)<=Ab4;
note(33)<=Ab5;
note(34)<=Ab6;
note(35)<=Ab7;
note(36)<=A4;
note(37)<=A5;
note(38)<=A6;
note(39)<=A7;
note(40)<=Bb4;
note(41)<=Bb5;
note(42)<=Bb6;
note(43)<=Bb7;
note(44)<=B4;
note(45)<=B5;
note(46)<=B6;
note(47)<=B7;

end Behavioral;