-- Example project for "XKF5-220-512-256-16 Rev.A" FPGA kit
-- www.PLDkit.com
-- firmware version: 1.0
-- 26.05.2022

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity top_level is

Port (CLK								: IN  STD_LOGIC;
		mpmc_0_SDRAM_Clk_pin 		: OUT STD_LOGIC;
		mpmc_0_SDRAM_CE_pin  		: OUT STD_LOGIC;
		mpmc_0_SDRAM_CS_n_pin 		: OUT STD_LOGIC;
		mpmc_0_SDRAM_RAS_n_pin 		: OUT STD_LOGIC;
		mpmc_0_SDRAM_CAS_n_pin 		: OUT STD_LOGIC;
		mpmc_0_SDRAM_WE_n_pin 		: OUT STD_LOGIC;
		mpmc_0_SDRAM_BankAddr_pin 	: OUT STD_LOGIC_VECTOR(1 downto 0);
		mpmc_0_SDRAM_Addr_pin 		: OUT STD_LOGIC_VECTOR(12 downto 0);
		mpmc_0_SDRAM_DQ 				: INOUT STD_LOGIC_VECTOR(15 downto 0);
		mpmc_0_SDRAM_DM_pin 			: OUT STD_LOGIC_VECTOR(1 downto 0);
		J9									: IN 	STD_LOGIC_VECTOR(64 downto 0);
		J10								: IN 	STD_LOGIC_VECTOR(64 downto 0);
		J5									: IN 	STD_LOGIC_VECTOR(7 downto 0);
		BTN	  	    					: IN  STD_LOGIC;
		DIP								: IN 	STD_LOGIC_VECTOR(7 downto 0);
		LED								: OUT STD_LOGIC_VECTOR(7 downto 0);
		SPKR   	    					: OUT STD_LOGIC;
		ACBUS0  	    					: IN  STD_LOGIC; -- TXDEN
		ACBUS1  	    					: IN  STD_LOGIC; -- SLEEP#
		ACBUS2  	    					: IN  STD_LOGIC; -- RXLED#
		ACBUS3  	    					: IN  STD_LOGIC; -- TXLED#
		ADBUS0  	    					: IN  STD_LOGIC; -- TXD
		ADBUS1  	    					: OUT STD_LOGIC; -- RXD
		ADBUS2  	    					: IN  STD_LOGIC; -- RTS#
		ADBUS3  	    					: OUT STD_LOGIC; -- CTS#
		ADBUS4  	    					: IN  STD_LOGIC; -- DTR#
		ADBUS5  	    					: OUT STD_LOGIC; -- DSR#
		ADBUS6  	    					: OUT STD_LOGIC; -- DCD#
		ADBUS7  	    					: OUT STD_LOGIC; -- RI#
		BCBUS0  	    					: IN  STD_LOGIC; -- TXDEN
		BCBUS1  	    					: IN  STD_LOGIC; -- SLEEP#
		BCBUS2  	    					: IN  STD_LOGIC; -- RXLED#
		BCBUS3  	    					: IN  STD_LOGIC; -- TXLED#
		BDBUS0  	    					: IN  STD_LOGIC; -- TXD
		BDBUS1  	    					: OUT STD_LOGIC; -- RXD
		BDBUS2  	    					: IN  STD_LOGIC; -- RTS#
		BDBUS3  	    					: OUT STD_LOGIC; -- CTS#
		BDBUS4  	    					: IN  STD_LOGIC; -- DTR#
		BDBUS5  	    					: OUT STD_LOGIC; -- DSR#
		BDBUS6  	    					: OUT STD_LOGIC; -- DCD#
		BDBUS7  	    					: OUT STD_LOGIC; -- RI#
		NAND_R_B2	  	    			: IN  STD_LOGIC;
		NAND_R_B1	  	    			: IN  STD_LOGIC;
		NAND_RE 	  	    				: OUT STD_LOGIC;
		NAND_CE1 	  	    			: OUT STD_LOGIC;
		NAND_CE2 	  	    			: OUT STD_LOGIC;
		NAND_CLE 	  	    			: OUT STD_LOGIC;
		NAND_ALE 	  	    			: OUT STD_LOGIC;
		NAND_WE 		  	  				: OUT STD_LOGIC;
		NAND_WP 		  	    			: OUT STD_LOGIC;
		NAND_IO 	  	    				: INOUT  STD_LOGIC_VECTOR(7 downto 0);
		EE_SDA   	    				: INOUT  STD_LOGIC;
		EE_SCL	       				: INOUT  STD_LOGIC;
		VGA_RED							: OUT STD_LOGIC_VECTOR(2 downto 0);
		VGA_GREEN						: OUT STD_LOGIC_VECTOR(2 downto 0);
		VGA_BLUE							: OUT STD_LOGIC_VECTOR(2 downto 0);
		VGA_HS 	  	    				: OUT STD_LOGIC;
		VGA_VS 	  	    				: OUT STD_LOGIC;
		VGA_ID0							: IN  STD_LOGIC;
		VGA_ID2							: IN  STD_LOGIC;
		VGA_SDA							: INOUT  STD_LOGIC;
		VGA_SCL							: INOUT  STD_LOGIC;
		REFCLK_N_IN 					: IN STD_LOGIC;
		REFCLK_P_IN 					: IN STD_LOGIC;
		RXN_IN                     : IN   STD_LOGIC_VECTOR(7 downto 0);
		RXP_IN                     : IN   STD_LOGIC_VECTOR(7 downto 0);
		TXN_OUT                    : OUT  STD_LOGIC_VECTOR(7 downto 0);
		TXP_OUT                    : OUT  STD_LOGIC_VECTOR(7 downto 0));
		
end top_level;

architecture Behavioral of top_level is
----------------------------------------------
	COMPONENT LOOP_TEST_TOP
	PORT(
		REFCLK_PAD_N_IN : IN std_logic;
		REFCLK_PAD_P_IN : IN std_logic;
		GTPRESET_IN : IN std_logic;
		POWERDOWN : IN std_logic;
		RXN_IN : IN std_logic_vector(7 downto 0);
		RXP_IN : IN std_logic_vector(7 downto 0);          
		TILE_0_1_2_3_PLLLKDET_OUT : OUT std_logic;
		TRACK_DATA_OUT : OUT std_logic_vector(3 downto 0);
		TXN_OUT : OUT std_logic_vector(7 downto 0);
		TXP_OUT : OUT std_logic_vector(7 downto 0)
		);
	END COMPONENT;

	COMPONENT system
	PORT(
		fpga_0_RS232_RX_pin : IN std_logic;
		fpga_0_clk_1_sys_clk_pin : IN std_logic;
		fpga_0_rst_1_sys_rst_pin : IN std_logic;    
		mpmc_0_SDRAM_DQ : INOUT std_logic_vector(15 downto 0);      
		DCM_lock : OUT std_logic;
		fpga_0_RS232_TX_pin : OUT std_logic;
		mpmc_0_SDRAM_Clk_pin : OUT std_logic;
		mpmc_0_SDRAM_CE_pin : OUT std_logic;
		mpmc_0_SDRAM_CS_n_pin : OUT std_logic;
		mpmc_0_SDRAM_RAS_n_pin : OUT std_logic;
		mpmc_0_SDRAM_CAS_n_pin : OUT std_logic;
		mpmc_0_SDRAM_WE_n_pin : OUT std_logic;
		mpmc_0_SDRAM_BankAddr_pin : OUT std_logic_vector(1 downto 0);
		mpmc_0_SDRAM_Addr_pin : OUT std_logic_vector(12 downto 0);
		mpmc_0_SDRAM_DM_pin : OUT std_logic_vector(1 downto 0);
		mpmc_0_MPMC_InitDone_pin : OUT std_logic
		);
	END COMPONENT;

attribute box_type : string;
attribute box_type of system : component is "user_black_box";
	
	component uart_tx
	port (
    i_clk       : in  std_logic;
    i_tx_dv     : in  std_logic;
    i_tx_byte   : in  std_logic_vector(7 downto 0);
    o_tx_active : out std_logic;
    o_tx_serial : out std_logic;
    o_tx_done   : out std_logic
    );
	END component;

	component uart_rx
	port (
    i_clk       : in  std_logic;
    i_rx_serial : in  std_logic;
    o_rx_dv     : out std_logic;
    o_rx_byte   : out std_logic_vector(7 downto 0)
    );
	END component;

	COMPONENT i2c_master
	PORT(
		clk 			: IN std_logic;
		reset_n 		: IN std_logic;
		ena 			: IN std_logic;
		addr 			: IN std_logic_vector(6 downto 0);
		rw 			: IN std_logic;
		data_wr 		: IN std_logic_vector(7 downto 0);    
		sda 			: INOUT std_logic;
		scl 			: INOUT std_logic;      
		busy 			: OUT std_logic;
		data_rd 		: OUT std_logic_vector(7 downto 0);
		ack_error	: OUT std_logic
		);
	END COMPONENT;
	
	COMPONENT debounce
	PORT(
		clk : IN std_logic;
		button : IN std_logic;          
		result : OUT std_logic
		);
	END COMPONENT;
	
	COMPONENT music
	PORT(
		clk 		: IN std_logic;
		rst	 	: IN std_logic;
		addr		: IN std_logic_vector(7 downto 0);
		speaker 	: OUT std_logic
		);
	END COMPONENT;
	
	COMPONENT vga
	PORT(
		clk : IN std_logic;
		rst : IN std_logic;
		red : OUT std_logic_vector(2 downto 0);
		grn : OUT std_logic_vector(2 downto 0);
		blu : OUT std_logic_vector(2 downto 0);
		hs : OUT std_logic;
		vs : OUT std_logic
		);
	END COMPONENT;
	
	COMPONENT NAND_FLASH
	PORT(
		R_B2 : IN std_logic;
		R_B1 : IN std_logic;
		rst : IN std_logic;
		id_chk : IN  STD_LOGIC;
		clock : IN std_logic;
		prog : IN std_logic;
		n_mode : IN std_logic;
		IO : INOUT std_logic_vector(7 downto 0);   
		ID_OK : OUT std_logic;
		RE : OUT std_logic;
		CE1 : OUT std_logic;
		CE2 : OUT std_logic;
		CLE : OUT std_logic;
		ALE : OUT std_logic;
		WE : OUT std_logic;
		WP : OUT std_logic
		);
	END COMPONENT;
	
	COMPONENT PFX_MultiBoot_Module
	PORT(
		TRIGGER : IN std_logic;
		SYSCLK : IN std_logic);
	END COMPONENT;
---------------------------------------------
signal i_o					:STD_LOGIC_VECTOR(145 downto 0);
signal timer				:STD_LOGIC_VECTOR(35 downto 0);
signal count_d			 	:STD_LOGIC_VECTOR(24 DOWNTO 0);
signal count_pwr,count_vga	:STD_LOGIC_VECTOR(26 DOWNTO 0);
signal rx_data,i2c_data_rd,EE_i2c_data_rd,VGA_i2c_data_rd,i2c_data_mode,o_rx_data,io_sum,i2c_data_write,i2c_data_result,dip1,dip3,dip4,led0,led1,led2,led3,led4,led5,led6,led7,led8,led9 :STD_LOGIC_VECTOR(7 DOWNTO 0);
signal mode :STD_LOGIC_VECTOR(8 DOWNTO 0);
signal rx_dv,s_1,s_2,s_3,s_4,s_5,s_6,s_7,s_8,s_9,tx_dv,ena_i2c_write,power_up,reset,tx_dv_en,lock_rx,ram_mode,prog_mode,MPMC_InitDone,microblaze_ok,
music_out,Dcm_all_locked,thirty_five_sec,io_test_mode,gtp_mode,music_mode,nand_mode,tx_serial,five_sec,ena_i2c,ena_i2c_read,stop_iic,trig,clk_mode,
i2c_busy,rw_i2c,microblaze_tx,five_min,VGA_sound,VGA_CE,play_sound,count_start,start_iic,rx_serial,vga_mode,EE_i2c_busy,VGA_i2c_busy,EE_ena_i2c,VGA_ena_i2c,
CE,sixty_five_sec,ten_min,rx_data_switch,ok,NAND_test_result,microblaze_reset,ftdi_mode,VGA_event,read_vga,NAND_ID_OK :STD_LOGIC;
---------------------------------------------
begin

	Inst_LOOP_TEST_TOP: LOOP_TEST_TOP PORT MAP(
		REFCLK_PAD_N_IN => REFCLK_N_IN,
		REFCLK_PAD_P_IN => REFCLK_P_IN,
		GTPRESET_IN => reset,
		POWERDOWN => not gtp_mode,
		TILE_0_1_2_3_PLLLKDET_OUT => LED7(0),
		TRACK_DATA_OUT => LED7(4 downto 1),
		RXN_IN => RXN_IN,
		RXP_IN => RXP_IN,
		TXN_OUT => TXN_OUT,
		TXP_OUT => TXP_OUT
	);

	Inst_system: system PORT MAP(
		DCM_lock => Dcm_all_locked,
		fpga_0_RS232_RX_pin => '1',
		fpga_0_RS232_TX_pin => microblaze_tx,
		fpga_0_clk_1_sys_clk_pin => CLK,
		fpga_0_rst_1_sys_rst_pin => microblaze_reset,
      mpmc_0_SDRAM_Clk_pin => mpmc_0_SDRAM_Clk_pin,
      mpmc_0_SDRAM_CE_pin => mpmc_0_SDRAM_CE_pin,
      mpmc_0_SDRAM_CS_n_pin => mpmc_0_SDRAM_CS_n_pin,
      mpmc_0_SDRAM_RAS_n_pin => mpmc_0_SDRAM_RAS_n_pin,
      mpmc_0_SDRAM_CAS_n_pin => mpmc_0_SDRAM_CAS_n_pin,
      mpmc_0_SDRAM_WE_n_pin => mpmc_0_SDRAM_WE_n_pin,
      mpmc_0_SDRAM_BankAddr_pin => mpmc_0_SDRAM_BankAddr_pin,
      mpmc_0_SDRAM_Addr_pin => mpmc_0_SDRAM_Addr_pin,
      mpmc_0_SDRAM_DQ => mpmc_0_SDRAM_DQ,
      mpmc_0_SDRAM_DM_pin => mpmc_0_SDRAM_DM_pin,
		mpmc_0_MPMC_InitDone_pin => MPMC_InitDone
	);

	uarttx: uart_tx
	port map(	i_clk			=> clk,
					i_tx_dv		=> tx_dv,
					i_tx_byte	=> i2c_data_rd,
					o_tx_active => open,
					o_tx_done 	=> open,
					o_tx_serial	=> tx_serial);
					
	uartrx: uart_rx
	port map(	i_clk			=> clk,
					i_rx_serial => rx_serial,
					o_rx_dv 		=> rx_dv,
					o_rx_byte	=> o_rx_data);


	Inst_EE_i2c_master: i2c_master PORT MAP(
		clk => clk,
		reset_n => reset,
		ena => EE_ena_i2c,
		addr => "1010000", -- AT24C1024 EEPROM ADDRESS (set "1010001" for the "second half")
		rw => rw_i2c,
		data_wr => i2c_data_write,
		busy => EE_i2c_busy,
		data_rd => EE_i2c_data_rd,
		ack_error => open,
		sda => EE_SDA,
		scl => EE_SCL
	);
	
		Inst_VGA_i2c_master: i2c_master PORT MAP(
		clk => clk,
		reset_n => reset,
		ena => VGA_ena_i2c,
		addr => "1010000",
		rw => rw_i2c,
		data_wr => "00000000",
		busy => VGA_i2c_busy,
		data_rd => VGA_i2c_data_rd,
		ack_error => open,
		sda => VGA_SDA,
		scl => VGA_SCL
	);

	Inst_debounce: debounce PORT MAP(
		clk => clk,
		button => btn,
		result => reset
	);
	
	Inst_music: music PORT MAP(
		clk => clk,
		rst => play_sound,
		addr => dip4,
		speaker => music_out
	);
	
		Inst_vga: vga PORT MAP(
		clk => clk,
		rst => VGA_MODE,
		red => VGA_RED,
		grn => VGA_GREEN,
		blu => VGA_BLUE,
		hs => VGA_HS,
		vs => VGA_VS
	);
	
		Inst_NAND_FLASH: NAND_FLASH PORT MAP(
		R_B2 => NAND_R_B2,
		R_B1 => NAND_R_B1,
		rst => reset,
		id_chk => s_5,
		clock => clk,
		prog => prog_mode,
		n_mode => nand_mode,
		ID_OK => NAND_ID_OK,
		RE => NAND_RE,
		CE1 => NAND_CE1,
		CE2 => NAND_CE2,
		CLE => NAND_CLE,
		ALE => NAND_ALE,
		WE => NAND_WE,
		WP => NAND_WP,
		IO => NAND_IO
	);
	
		Inst_PFX_MultiBoot_Module: PFX_MultiBoot_Module PORT MAP(
		TRIGGER => trig,
		SYSCLK => clk
	);
---------------------------------------------------------
	
	process(clk,reset,CE)
	begin
	  if (reset='0') then
    count_pwr <= (others => '0');
  elsif (clk'event and clk = '1') then
      if (CE='0') then
			count_pwr <= count_pwr + '1';
		end if;
		end if;
	end process;
	
CE <= '1' when count_pwr= X"5F5E101" else '0';
power_up <= '1' when (count_pwr= X"3FFFE" or count_pwr= X"5F5E100") else '0';
rx_data_switch  <= power_up or five_sec or thirty_five_sec or sixty_five_sec or ten_min or five_min or NAND_test_result or not reset;

process(rx_data_switch,rx_dv,o_rx_data)
begin
  if (rx_data_switch = '1') then
      rx_data <= "00000000";
  elsif (rx_dv = '1') then
		rx_data <= o_rx_data;
  end if;
end process;

tx_dv <= not i2c_busy and tx_dv_en;
	
s_1 <= '1' when o_rx_data= "00110001" and rx_dv='1' else '0';
s_2 <= '1' when o_rx_data= "00110010" and rx_dv='1' else '0';
s_3 <= '1' when o_rx_data= "00110011" and rx_dv='1' else '0';
s_4 <= '1' when o_rx_data= "00110100" and rx_dv='1' else '0';
s_5 <= '1' when o_rx_data= "00110101" and rx_dv='1' else '0';
s_6 <= '1' when o_rx_data= "00110110" and rx_dv='1' else '0';
s_7 <= '1' when o_rx_data= "00110111" and rx_dv='1' else '0';
s_8 <= '1' when o_rx_data= "00111000" and rx_dv='1' else '0';
s_9 <= '1' when o_rx_data= "00111001" and rx_dv='1' else '0';
	process(clk,rx_dv,reset)
	begin
	  if ((rx_dv='1') or (reset='0')) then
    timer <= (others => '0');
  elsif (clk'event and clk = '1') then 
			timer <= timer + '1';
		end if;
	end process;

five_sec <= '1' when timer= X"EE6B280" and (nand_mode = '1') else '0';
thirty_five_sec <= '1' when timer= X"684EE180" and ((music_mode = '1') or (vga_mode = '1')) else '0';
sixty_five_sec <= '1' when timer= X"C1B71080" and (ram_mode = '1') else '0';
ten_min  <= '1' when timer= X"6FC23AC00" and ((io_test_mode = '1') or (gtp_mode = '1')) else '0';
five_min <= '1' when timer= X"37E11D600" and ftdi_mode = '1' else '0';

process(s_1,five_min,power_up,reset)
begin
  if ((five_min = '1') or (power_up = '1') or (reset='0')) then
      ftdi_mode <= '0';
  elsif (s_1 = '1') then
		ftdi_mode <= '1';
  end if;
end process;

process(s_2,power_up,reset)
begin
  if ((power_up = '1') or (reset='0')) then
      prog_mode <= '0';
  elsif (s_2 = '1') then
		prog_mode <= '1';
  end if;
end process;

process(s_3,ten_min,power_up,reset)
begin
  if ((ten_min = '1') or (power_up = '1') or (reset='0')) then
      io_test_mode <= '0';
  elsif (s_3 = '1') then
		io_test_mode <= '1';
  end if;
end process;

process(s_4,thirty_five_sec,power_up,reset)
begin
  if ((thirty_five_sec = '1') or (power_up = '1') or (reset='0')) then
      music_mode <= '0';
  elsif (s_4 = '1') then
		music_mode <= '1';
  end if;
end process;

process(s_5,five_sec,power_up,reset)
begin
  if ((five_sec = '1') or (power_up = '1') or (reset='0')) then
      nand_mode <= '0';
  elsif (s_5 = '1') then
		nand_mode <= '1';
  end if;
end process;

process(s_6,sixty_five_sec,power_up,reset)
begin
  if ((sixty_five_sec = '1') or (power_up = '1') or (reset='0')) then
      ram_mode <= '0';
  elsif (s_6 = '1') then
		ram_mode <= '1';
  end if;
end process;

process(s_7,ten_min,power_up,reset)
begin
  if ((ten_min = '1') or (power_up = '1') or (reset='0')) then
      gtp_mode <= '0';
  elsif (s_7 = '1') then
		gtp_mode <= '1';
  end if;
end process;

process(s_8,thirty_five_sec,power_up,reset)
begin
  if ((thirty_five_sec = '1') or (power_up = '1') or (reset='0')) then
      vga_mode <= '0';
  elsif (s_8 = '1') then
		vga_mode <= '1';
  end if;
end process;

process(s_9,power_up,reset)
begin
  if ((power_up = '1') or (reset='0')) then
      clk_mode <= '0';
  elsif (s_9 = '1') then
		clk_mode <= '1';
  end if;
end process;

mode(0) <= ftdi_mode;
mode(1) <= prog_mode;
mode(2) <= io_test_mode;
mode(3) <= music_mode;
mode(4) <= nand_mode;
mode(5) <= ram_mode;
mode(6) <= gtp_mode;
mode(7) <= vga_mode;
mode(8) <= clk_mode;

process(mode,DIP,led0,led1,led2,led3,led4,led5,led6,led7,led8,led9)
begin
	   case mode is
		when "000000001" => led<=led1; dip1<=dip; dip3<=X"FF"; dip4<=X"FF";
      when "000000010" => led<=led2; dip1<=X"FF"; dip3<=X"FF"; dip4<=X"FF";
		when "000000100" => led<=led3; dip1<=X"FF"; dip3<=dip; dip4<=X"FF";
		when "000001000" => led<=led4; dip1<=X"FF"; dip3<=X"FF"; dip4<=dip;
		when "000010000" => led<=led5; dip1<=X"FF"; dip3<=X"FF"; dip4<=X"FF";
		when "000100000" => led<=led6; dip1<=X"FF"; dip3<=X"FF"; dip4<=X"FF";
		when "001000000" => led<=led7; dip1<=X"FF"; dip3<=X"FF"; dip4<=X"FF";
		when "010000000" => led<=led8; dip1<=X"FF"; dip3<=X"FF"; dip4<=X"FF";
		when "100000000" => led<=led9; dip1<=X"FF"; dip3<=X"FF"; dip4<=X"FF";
      when others => led<=led0; dip1<=X"FF"; dip3<=X"FF"; dip4<=X"FF";
   end case;
end process;

lock_rx <= ftdi_mode or prog_mode or io_test_mode or music_mode or nand_mode or ram_mode or gtp_mode or vga_mode or clk_mode or not ce;
rx_serial <= BDBUS0 when lock_rx = '0' else '1';

i2c_data_write <= "00000000" when (count_pwr > X"30000" and count_pwr < X"5F50000") else i2c_data_result;

process(rx_data)
begin
	   case rx_data is
		when "00000000" => i2c_data_mode <= "00000111"; --MENU
		when "00110001" => i2c_data_mode <= "00001110"; --FTDI
		when "00110010" => i2c_data_mode <= "00010101"; --PROG
		when "00110011" => i2c_data_mode <= "00011100"; --IO
		when "00110100" => i2c_data_mode <= "00100011"; --MUSIC
		when "00110101" => i2c_data_mode <= "00101010"; --NAND
		when "00110110" => i2c_data_mode <= "00111111"; --RAM
		when "00110111" => i2c_data_mode <= "01000110"; --GTP
		when "00111000" => i2c_data_mode <= "01001110"; --VGA
		when "00111001" => i2c_data_mode <= "01011100"; --CLK
      when others => i2c_data_mode <= "00000111"; --MENU
   end case;
end process;

start_iic <= rx_dv or power_up or five_sec or thirty_five_sec or sixty_five_sec or ten_min or five_min or NAND_test_result or read_vga;

process(start_iic,stop_iic,reset)
begin
  if ((stop_iic = '1') or (reset='0')) then
      count_start <= '0';
  elsif (start_iic = '1') then
		count_start <= '1';
  end if;
end process;

	process(clk,count_start,reset)
	begin
	  if ((count_start='0') or (reset='0')) then
    count_d <= (others => '0');
  elsif (clk'event and clk = '1') then 
			count_d <= count_d + '1';
		end if;
	end process;

stop_iic <= '1' when count_d > X"7FFFFF" and i2c_busy='0' else '0';
ena_i2c_write <= '1' when count_d > X"100" and count_d < X"3000" and count_start='1' else '0';
rw_i2c <= '0' when count_d < X"4000" else '1';
ena_i2c_read <= '1' when count_d > X"5000" else '0';
ena_i2c <= ena_i2c_write or ena_i2c_read;
tx_dv_en <= '1' when count_d > X"6000" else '0';

process(timer)
begin
   case timer(26 downto 23) is 
      when "0000" => led0 <= "00000001";
		when "0001" => led0 <= "00000001";
		when "0010" => led0 <= "00000010";
		when "0011" => led0 <= "00000100";
		when "0100" => led0 <= "00001000";
		when "0101" => led0 <= "00010000";
		when "0110" => led0 <= "00100000";
		when "0111" => led0 <= "01000000";
		when "1000" => led0 <= "10000000";
		when "1001" => led0 <= "10000000";
		when "1010" => led0 <= "01000000";
		when "1011" => led0 <= "00100000";
		when "1100" => led0 <= "00010000";
		when "1101" => led0 <= "00001000";
		when "1110" => led0 <= "00000100";
		when "1111" => led0 <= "00000010";
      when others => led0 <= "00000000";
   end case;
end process;

microblaze_reset <= '1' when ram_mode='1' and count_start='0' else '0';

microblaze_ok <= Dcm_all_locked and MPMC_InitDone and microblaze_reset;

LED6(0) <= '1' when microblaze_ok='1' and timer > X"165A0BC0" and ram_mode = '1' else '0'; --12.5%
LED6(1) <= '1' when microblaze_ok='1' and timer > X"2CB41780" and ram_mode = '1' else '0'; --25%
LED6(2) <= '1' when microblaze_ok='1' and timer > X"430E2340" and ram_mode = '1' else '0'; --37.5%
LED6(3) <= '1' when microblaze_ok='1' and timer > X"59682F00" and ram_mode = '1' else '0'; --50%
LED6(4) <= '1' when microblaze_ok='1' and timer > X"6FC23AC0" and ram_mode = '1' else '0'; --62.5%
LED6(5) <= '1' when microblaze_ok='1' and timer > X"861C4680" and ram_mode = '1' else '0'; --75%
LED6(6) <= '1' when microblaze_ok='1' and timer > X"9C765240" and ram_mode = '1' else '0'; --87.5%
LED6(7) <= '1' when microblaze_ok='1' and timer > X"B2D05E00" and ram_mode = '1' else '0'; --100%

BDBUS1 <= ADBUS0 when ftdi_mode='1' and ram_mode='0' and count_start='0' else microblaze_tx when ftdi_mode='0' and ram_mode='1' and count_start='0' else tx_serial;
ADBUS1 <= BDBUS0;
BDBUS3 <= ADBUS2;
ADBUS3 <= BDBUS2;
BDBUS5 <= ADBUS4;
BDBUS6 <= ADBUS4;
BDBUS7 <= ADBUS4 when dip1(0)='1' else '0';
ADBUS5 <= BDBUS4;
ADBUS6 <= BDBUS4;
ADBUS7 <= BDBUS4 when dip1(1)='1' else '0';

LED1(0) <= ACBUS0;
LED1(1) <= not ACBUS1;
LED1(2) <= not ACBUS2;
LED1(3) <= not ACBUS3;
LED1(4) <= BCBUS0;
LED1(5) <= not BCBUS1;
LED1(6) <= not BCBUS2;
LED1(7) <= not BCBUS3;

LED2(0) <= EE_SCL;
LED2(1) <= EE_SDA;
LED2(2) <= '0';
LED2(3) <= '0';
LED2(4) <= '0';
LED2(5) <= '0';
LED2(6) <= NAND_R_B1;
LED2(7) <= NAND_R_B2;

i_o <= (J9&J10&J5)&(not dip3);

io_sum <=
("0000000"&i_o(	0	))
+("0000000"&i_o(	1	))
+("0000000"&i_o(	2	))
+("0000000"&i_o(	3	))
+("0000000"&i_o(	4	))
+("0000000"&i_o(	5	))
+("0000000"&i_o(	6	))
+("0000000"&i_o(	7	))
+("0000000"&i_o(	8	))
+("0000000"&i_o(	9	))
+("0000000"&i_o(	10	))
+("0000000"&i_o(	11	))
+("0000000"&i_o(	12	))
+("0000000"&i_o(	13	))
+("0000000"&i_o(	14	))
+("0000000"&i_o(	15	))
+("0000000"&i_o(	16	))
+("0000000"&i_o(	17	))
+("0000000"&i_o(	18	))
+("0000000"&i_o(	19	))
+("0000000"&i_o(	20	))
+("0000000"&i_o(	21	))
+("0000000"&i_o(	22	))
+("0000000"&i_o(	23	))
+("0000000"&i_o(	24	))
+("0000000"&i_o(	25	))
+("0000000"&i_o(	26	))
+("0000000"&i_o(	27	))
+("0000000"&i_o(	28	))
+("0000000"&i_o(	29	))
+("0000000"&i_o(	30	))
+("0000000"&i_o(	31	))
+("0000000"&i_o(	32	))
+("0000000"&i_o(	33	))
+("0000000"&i_o(	34	))
+("0000000"&i_o(	35	))
+("0000000"&i_o(	36	))
+("0000000"&i_o(	37	))
+("0000000"&i_o(	38	))
+("0000000"&i_o(	39	))
+("0000000"&i_o(	40	))
+("0000000"&i_o(	41	))
+("0000000"&i_o(	42	))
+("0000000"&i_o(	43	))
+("0000000"&i_o(	44	))
+("0000000"&i_o(	45	))
+("0000000"&i_o(	46	))
+("0000000"&i_o(	47	))
+("0000000"&i_o(	48	))
+("0000000"&i_o(	49	))
+("0000000"&i_o(	50	))
+("0000000"&i_o(	51	))
+("0000000"&i_o(	52	))
+("0000000"&i_o(	53	))
+("0000000"&i_o(	54	))
+("0000000"&i_o(	55	))
+("0000000"&i_o(	56	))
+("0000000"&i_o(	57	))
+("0000000"&i_o(	58	))
+("0000000"&i_o(	59	))
+("0000000"&i_o(	60	))
+("0000000"&i_o(	61	))
+("0000000"&i_o(	62	))
+("0000000"&i_o(	63	))
+("0000000"&i_o(	64	))
+("0000000"&i_o(	65	))
+("0000000"&i_o(	66	))
+("0000000"&i_o(	67	))
+("0000000"&i_o(	68	))
+("0000000"&i_o(	69	))
+("0000000"&i_o(	70	))
+("0000000"&i_o(	71	))
+("0000000"&i_o(	72	))
+("0000000"&i_o(	73	))
+("0000000"&i_o(	74	))
+("0000000"&i_o(	75	))
+("0000000"&i_o(	76	))
+("0000000"&i_o(	77	))
+("0000000"&i_o(	78	))
+("0000000"&i_o(	79	))
+("0000000"&i_o(	80	))
+("0000000"&i_o(	81	))
+("0000000"&i_o(	82	))
+("0000000"&i_o(	83	))
+("0000000"&i_o(	84	))
+("0000000"&i_o(	85	))
+("0000000"&i_o(	86	))
+("0000000"&i_o(	87	))
+("0000000"&i_o(	88	))
+("0000000"&i_o(	89	))
+("0000000"&i_o(	90	))
+("0000000"&i_o(	91	))
+("0000000"&i_o(	92	))
+("0000000"&i_o(	93	))
+("0000000"&i_o(	94	))
+("0000000"&i_o(	95	))
+("0000000"&i_o(	96	))
+("0000000"&i_o(	97	))
+("0000000"&i_o(	98	))
+("0000000"&i_o(	99	))
+("0000000"&i_o(	100	))
+("0000000"&i_o(	101	))
+("0000000"&i_o(	102	))
+("0000000"&i_o(	103	))
+("0000000"&i_o(	104	))
+("0000000"&i_o(	105	))
+("0000000"&i_o(	106	))
+("0000000"&i_o(	107	))
+("0000000"&i_o(	108	))
+("0000000"&i_o(	109	))
+("0000000"&i_o(	110	))
+("0000000"&i_o(	111	))
+("0000000"&i_o(	112	))
+("0000000"&i_o(	113	))
+("0000000"&i_o(	114	))
+("0000000"&i_o(	115	))
+("0000000"&i_o(	116	))
+("0000000"&i_o(	117	))
+("0000000"&i_o(	118	))
+("0000000"&i_o(	119	))
+("0000000"&i_o(	120	))
+("0000000"&i_o(	121	))
+("0000000"&i_o(	122	))
+("0000000"&i_o(	123	))
+("0000000"&i_o(	124	))
+("0000000"&i_o(	125	))
+("0000000"&i_o(	126	))
+("0000000"&i_o(	127	))
+("0000000"&i_o(	128	))
+("0000000"&i_o(	129	))
+("0000000"&i_o(	130	))
+("0000000"&i_o(	131	))
+("0000000"&i_o(	132	))
+("0000000"&i_o(	133	))
+("0000000"&i_o(	134	))
+("0000000"&i_o(	135	))
+("0000000"&i_o(	136	))
+("0000000"&i_o(	137	))
+("0000000"&i_o(	138	))
+("0000000"&i_o(	139	))
+("0000000"&i_o(	140	))
+("0000000"&i_o(	141	))
+("0000000"&i_o(	142	))
+("0000000"&i_o(	143	))
+("0000000"&i_o(	144	))
+("0000000"&i_o(	145	));

ok <= '1' WHEN io_sum = "00000001" ELSE '0';

spkr <= music_out or (timer(13) and ok and io_test_mode);

led3 <= X"FF" when ok='1' else X"00";
led4 <= not dip4;

process(timer,NAND_ID_OK)
begin
if (NAND_ID_OK = '0') then led5 <= "11111111";
else
   case timer(23 downto 22) is 
      when "00" => led5 <= "00011000";
		when "01" => led5 <= "00100100";
		when "10" => led5 <= "01000010";
		when "11" => led5 <= "10000001";
      when others => led5 <= "00000000";
   end case;
	end if;
end process;

NAND_test_result <= '1' when (timer = X"808888" and nand_mode = '1') else '0';

i2c_data_result <= "00110001" when (NAND_ID_OK='1' and timer > X"808000" and timer < X"870000" and nand_mode='1') else
"00111000" when (NAND_ID_OK='0' and timer > X"808000" and timer < X"870000" and nand_mode='1') else "01010101" when 
((VGA_ID0='1') and (VGA_ID2='1') and (vga_mode='1') and (timer > X"BEBC200")) else i2c_data_mode;

VGA_event <= VGA_ID0 xor VGA_ID2;

	process(clk,VGA_CE,VGA_event)
	begin
	  if (VGA_event = '1') then
    count_vga <= (others => '0');
  elsif (clk'event and clk = '1') then
      if (VGA_CE='1') then
			count_vga <= count_vga + '1';
		end if;
		end if;
	end process;

VGA_sound <= '1' when (count_vga >= X"2FAF080") and (count_vga <= X"5F5E100") else '0';
VGA_CE <= '0' when count_vga >= X"5F5E101" else '1';

play_sound <= VGA_sound or music_mode;

LED8(0) <= VGA_ID0;
LED8(1) <= VGA_ID0;
LED8(2) <= VGA_ID2;
LED8(3) <= VGA_ID2;
LED8(4) <= VGA_SDA;
LED8(5) <= VGA_SDA;
LED8(6) <= VGA_SCL;
LED8(7) <= VGA_SCL;

i2c_busy <= VGA_i2c_busy when ((VGA_ID0='0') and (VGA_ID2='0') and (vga_mode='1') and (timer > X"5F5E100")) else EE_i2c_busy;

EE_ena_i2c <= '0' when ((VGA_ID0='0') and (VGA_ID2='0') and (vga_mode='1') and (timer > X"5F5E100")) else ena_i2c;

VGA_ena_i2c <= ena_i2c when ((VGA_ID0='0') and (VGA_ID2='0') and (vga_mode='1') and (timer > X"5F5E100")) else '0';

i2c_data_rd <= VGA_i2c_data_rd when ((VGA_ID0='0') and (VGA_ID2='0') and (vga_mode='1') and (timer > X"5F5E100")) else EE_i2c_data_rd;

read_vga <= '1' when (vga_mode = '1') and (timer= X"5F5E200" or timer= X"EE6B280" or timer= X"1DCD6500"
or timer= X"2CB41780" or timer= X"3B9ACA00" or timer= X"4A817C80" or timer= X"59682F00") else '0';

trig <= '1' when (clk_mode = '1') and (timer= X"A0EEBB0") else '0';

LED9(0) <= '1' when timer > X"11E1A30" and clk_mode = '1' else '0'; --12.5%
LED9(1) <= '1' when timer > X"23C3460" and clk_mode = '1' else '0'; --25%
LED9(2) <= '1' when timer > X"35A4E90" and clk_mode = '1' else '0'; --37.5%
LED9(3) <= '1' when timer > X"47868C0" and clk_mode = '1' else '0'; --50%
LED9(4) <= '1' when timer > X"59682F0" and clk_mode = '1' else '0'; --62.5%
LED9(5) <= '1' when timer > X"6B49D20" and clk_mode = '1' else '0'; --75%
LED9(6) <= '1' when timer > X"7D2B750" and clk_mode = '1' else '0'; --87.5%
LED9(7) <= '1' when timer > X"8F0D180" and clk_mode = '1' else '0'; --100%

end Behavioral;