------------------------------------------------------------------------------
--$Date: 2010/06/25 15:58:07 $
--$Revision: 1.7 $
------------------------------------------------------------------------------
--   ____  ____
--  /   /\/   /
-- /___/  \  /
-- \   \   \/     Vendor : Xilinx
--  \   \         Version : 2.1
--  /   /         Application : RocketIO GTP Transceiver Wizard
-- /___/   /\     Filename : loop_test_top.vhd
-- \   \  /  \
--  \___\/\___\
--
--
-- Module LOOP_TEST_TOP
-- Generated by Xilinx RocketIO GTP Transceiver Wizard
-- 
-- 
-- (c) Copyright 2006-2010 Xilinx, Inc. All rights reserved.
-- 
-- This file contains confidential and proprietary information
-- of Xilinx, Inc. and is protected under U.S. and
-- international copyright and other intellectual property
-- laws.
-- 
-- DISCLAIMER
-- This disclaimer is not a license and does not grant any
-- rights to the materials distributed herewith. Except as
-- otherwise provided in a valid license issued to you by
-- Xilinx, and to the maximum extent permitted by applicable
-- law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
-- WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
-- AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
-- BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
-- INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
-- (2) Xilinx shall not be liable (whether in contract or tort,
-- including negligence, or under any other theory of
-- liability) for any loss or damage of any kind or nature
-- related to, arising under or in connection with these
-- materials, including for any direct, or any indirect,
-- special, incidental, or consequential loss or damage
-- (including loss of data, profits, goodwill, or any type of
-- loss or damage suffered as a result of any action brought
-- by a third party) even if such damage or loss was
-- reasonably foreseeable or Xilinx had been advised of the
-- possibility of the same.
-- 
-- CRITICAL APPLICATIONS
-- Xilinx products are not designed or intended to be fail-
-- safe, or for use in any application requiring fail-safe
-- performance, such as life-support or safety devices or
-- systems, Class III medical devices, nuclear facilities,
-- applications related to the deployment of airbags, or any
-- other applications that could lead to death, personal
-- injury, or severe property or environmental damage
-- (individually and collectively, "Critical
-- Applications"). Customer assumes the sole risk and
-- liability of any use of Xilinx products in Critical
-- Applications, subject only to applicable laws and
-- regulations governing limitations on product liability.
-- 
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
-- PART OF THIS FILE AT ALL TIMES. 


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;


--***********************************Entity Declaration************************

entity LOOP_TEST_TOP is
generic
(
    EXAMPLE_CONFIG_INDEPENDENT_LANES        : integer   := 1;
    EXAMPLE_LANE_WITH_START_CHAR            : integer   := 0;
    EXAMPLE_WORDS_IN_BRAM                   : integer   := 512;
    EXAMPLE_SIM_MODE                        : string    := "FAST";
    EXAMPLE_SIM_GTPRESET_SPEEDUP            : integer   := 1;
    EXAMPLE_SIM_PLL_PERDIV2                 : bit_vector:= x"14d";
    EXAMPLE_USE_CHIPSCOPE                   : integer   := 1     -- Set to 1 to use Chipscope to drive resets
);
port
(
	 REFCLK_PAD_N_IN 								  : in   std_logic;
	 REFCLK_PAD_P_IN 								  : in   std_logic;
    GTPRESET_IN                             : in   std_logic;
	 POWERDOWN	                             : in   std_logic;
	 TILE_0_1_2_3_PLLLKDET_OUT               : out  std_logic;
	 TRACK_DATA_OUT								  : out	std_logic_vector(3 downto 0);
    RXN_IN                                  : in   std_logic_vector(7 downto 0);
    RXP_IN                                  : in   std_logic_vector(7 downto 0);
    TXN_OUT                                 : out  std_logic_vector(7 downto 0);
    TXP_OUT                                 : out  std_logic_vector(7 downto 0)
    
);

    attribute X_CORE_INFO : string;
    attribute X_CORE_INFO of LOOP_TEST_TOP : entity is "v5_gtpwizard_v2_1, Coregen v12.1";

end LOOP_TEST_TOP;
    
architecture RTL of LOOP_TEST_TOP is

--**************************Component Declarations*****************************


component LOOP_TEST 
generic
(
    -- Simulation attributes
    WRAPPER_SIM_MODE                : string    := "FAST"; -- Set to Fast Functional Simulation Model    
    WRAPPER_SIM_GTPRESET_SPEEDUP    : integer   := 0; -- Set to 1 to speed up sim reset
    WRAPPER_SIM_PLL_PERDIV2         : bit_vector:= x"14d" -- Set to the VCO Unit Interval time
);
port
(
    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE0  (Location)

    ------------------------ Loopback and Powerdown Ports ----------------------
	 TILE0_PLLPOWERDOWN_IN                   : in   std_logic;
    TILE0_RXPOWERDOWN0_IN                   : in   std_logic_vector(1 downto 0);
    TILE0_RXPOWERDOWN1_IN                   : in   std_logic_vector(1 downto 0);
    TILE0_TXPOWERDOWN0_IN                   : in   std_logic_vector(1 downto 0);
    TILE0_TXPOWERDOWN1_IN                   : in   std_logic_vector(1 downto 0);
    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    TILE0_RXCHARISCOMMA0_OUT                : out  std_logic;
    TILE0_RXCHARISCOMMA1_OUT                : out  std_logic;
    TILE0_RXCHARISK0_OUT                    : out  std_logic;
    TILE0_RXCHARISK1_OUT                    : out  std_logic;
    TILE0_RXDISPERR0_OUT                    : out  std_logic;
    TILE0_RXDISPERR1_OUT                    : out  std_logic;
    TILE0_RXNOTINTABLE0_OUT                 : out  std_logic;
    TILE0_RXNOTINTABLE1_OUT                 : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    TILE0_RXCLKCORCNT0_OUT                  : out  std_logic_vector(2 downto 0);
    TILE0_RXCLKCORCNT1_OUT                  : out  std_logic_vector(2 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    TILE0_RXENMCOMMAALIGN0_IN               : in   std_logic;
    TILE0_RXENMCOMMAALIGN1_IN               : in   std_logic;
    TILE0_RXENPCOMMAALIGN0_IN               : in   std_logic;
    TILE0_RXENPCOMMAALIGN1_IN               : in   std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE0_RXDATA0_OUT                       : out  std_logic_vector(7 downto 0);
    TILE0_RXDATA1_OUT                       : out  std_logic_vector(7 downto 0);
    TILE0_RXRECCLK0_OUT                     : out  std_logic;
    TILE0_RXRECCLK1_OUT                     : out  std_logic;
    TILE0_RXRESET0_IN                       : in   std_logic;
    TILE0_RXRESET1_IN                       : in   std_logic;
    TILE0_RXUSRCLK0_IN                      : in   std_logic;
    TILE0_RXUSRCLK1_IN                      : in   std_logic;
    TILE0_RXUSRCLK20_IN                     : in   std_logic;
    TILE0_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE0_RXCDRRESET0_IN                    : in   std_logic;
    TILE0_RXCDRRESET1_IN                    : in   std_logic;
    TILE0_RXELECIDLE0_OUT                   : out  std_logic;
    TILE0_RXELECIDLE1_OUT                   : out  std_logic;
    TILE0_RXEQMIX0_IN                       : in   std_logic_vector(1 downto 0);
    TILE0_RXEQMIX1_IN                       : in   std_logic_vector(1 downto 0);
    TILE0_RXEQPOLE0_IN                      : in   std_logic_vector(3 downto 0);
    TILE0_RXEQPOLE1_IN                      : in   std_logic_vector(3 downto 0);
    TILE0_RXN0_IN                           : in   std_logic;
    TILE0_RXN1_IN                           : in   std_logic;
    TILE0_RXP0_IN                           : in   std_logic;
    TILE0_RXP1_IN                           : in   std_logic;
    -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
    TILE0_RXBUFRESET0_IN                    : in   std_logic;
    TILE0_RXBUFRESET1_IN                    : in   std_logic;
    TILE0_RXSTATUS0_OUT                     : out  std_logic_vector(2 downto 0);
    TILE0_RXSTATUS1_OUT                     : out  std_logic_vector(2 downto 0);
    --------------------- Shared Ports - Tile and PLL Ports --------------------
    TILE0_CLKIN_IN                          : in   std_logic;
    TILE0_GTPRESET_IN                       : in   std_logic;
    TILE0_PLLLKDET_OUT                      : out  std_logic;
    TILE0_REFCLKOUT_OUT                     : out  std_logic;
    TILE0_RESETDONE0_OUT                    : out  std_logic;
    TILE0_RESETDONE1_OUT                    : out  std_logic;
    ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
    TILE0_TXCHARISK0_IN                     : in   std_logic;
    TILE0_TXCHARISK1_IN                     : in   std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE0_TXDATA0_IN                        : in   std_logic_vector(7 downto 0);
    TILE0_TXDATA1_IN                        : in   std_logic_vector(7 downto 0);
    TILE0_TXOUTCLK0_OUT                     : out  std_logic;
    TILE0_TXOUTCLK1_OUT                     : out  std_logic;
    TILE0_TXRESET0_IN                       : in   std_logic;
    TILE0_TXRESET1_IN                       : in   std_logic;
    TILE0_TXUSRCLK0_IN                      : in   std_logic;
    TILE0_TXUSRCLK1_IN                      : in   std_logic;
    TILE0_TXUSRCLK20_IN                     : in   std_logic;
    TILE0_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE0_TXDIFFCTRL0_IN                    : in   std_logic_vector(2 downto 0);
    TILE0_TXDIFFCTRL1_IN                    : in   std_logic_vector(2 downto 0);
    TILE0_TXN0_OUT                          : out  std_logic;
    TILE0_TXN1_OUT                          : out  std_logic;
    TILE0_TXP0_OUT                          : out  std_logic;
    TILE0_TXP1_OUT                          : out  std_logic;
    ----------------- Transmit Ports - TX Ports for PCI Express ----------------
    TILE0_TXELECIDLE0_IN                    : in   std_logic;
    TILE0_TXELECIDLE1_IN                    : in   std_logic;
    --------------------- Transmit Ports - TX Ports for SATA -------------------
    TILE0_TXCOMSTART0_IN                    : in   std_logic;
    TILE0_TXCOMSTART1_IN                    : in   std_logic;
    TILE0_TXCOMTYPE0_IN                     : in   std_logic;
    TILE0_TXCOMTYPE1_IN                     : in   std_logic;


    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE1  (Location)

    ------------------------ Loopback and Powerdown Ports ----------------------
	 TILE1_PLLPOWERDOWN_IN                   : in   std_logic;
    TILE1_RXPOWERDOWN0_IN                   : in   std_logic_vector(1 downto 0);
    TILE1_RXPOWERDOWN1_IN                   : in   std_logic_vector(1 downto 0);
    TILE1_TXPOWERDOWN0_IN                   : in   std_logic_vector(1 downto 0);
    TILE1_TXPOWERDOWN1_IN                   : in   std_logic_vector(1 downto 0);
    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    TILE1_RXCHARISCOMMA0_OUT                : out  std_logic;
    TILE1_RXCHARISCOMMA1_OUT                : out  std_logic;
    TILE1_RXCHARISK0_OUT                    : out  std_logic;
    TILE1_RXCHARISK1_OUT                    : out  std_logic;
    TILE1_RXDISPERR0_OUT                    : out  std_logic;
    TILE1_RXDISPERR1_OUT                    : out  std_logic;
    TILE1_RXNOTINTABLE0_OUT                 : out  std_logic;
    TILE1_RXNOTINTABLE1_OUT                 : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    TILE1_RXCLKCORCNT0_OUT                  : out  std_logic_vector(2 downto 0);
    TILE1_RXCLKCORCNT1_OUT                  : out  std_logic_vector(2 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    TILE1_RXENMCOMMAALIGN0_IN               : in   std_logic;
    TILE1_RXENMCOMMAALIGN1_IN               : in   std_logic;
    TILE1_RXENPCOMMAALIGN0_IN               : in   std_logic;
    TILE1_RXENPCOMMAALIGN1_IN               : in   std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE1_RXDATA0_OUT                       : out  std_logic_vector(7 downto 0);
    TILE1_RXDATA1_OUT                       : out  std_logic_vector(7 downto 0);
    TILE1_RXRECCLK0_OUT                     : out  std_logic;
    TILE1_RXRECCLK1_OUT                     : out  std_logic;
    TILE1_RXRESET0_IN                       : in   std_logic;
    TILE1_RXRESET1_IN                       : in   std_logic;
    TILE1_RXUSRCLK0_IN                      : in   std_logic;
    TILE1_RXUSRCLK1_IN                      : in   std_logic;
    TILE1_RXUSRCLK20_IN                     : in   std_logic;
    TILE1_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE1_RXCDRRESET0_IN                    : in   std_logic;
    TILE1_RXCDRRESET1_IN                    : in   std_logic;
    TILE1_RXELECIDLE0_OUT                   : out  std_logic;
    TILE1_RXELECIDLE1_OUT                   : out  std_logic;
    TILE1_RXEQMIX0_IN                       : in   std_logic_vector(1 downto 0);
    TILE1_RXEQMIX1_IN                       : in   std_logic_vector(1 downto 0);
    TILE1_RXEQPOLE0_IN                      : in   std_logic_vector(3 downto 0);
    TILE1_RXEQPOLE1_IN                      : in   std_logic_vector(3 downto 0);
    TILE1_RXN0_IN                           : in   std_logic;
    TILE1_RXN1_IN                           : in   std_logic;
    TILE1_RXP0_IN                           : in   std_logic;
    TILE1_RXP1_IN                           : in   std_logic;
    -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
    TILE1_RXBUFRESET0_IN                    : in   std_logic;
    TILE1_RXBUFRESET1_IN                    : in   std_logic;
    TILE1_RXSTATUS0_OUT                     : out  std_logic_vector(2 downto 0);
    TILE1_RXSTATUS1_OUT                     : out  std_logic_vector(2 downto 0);
    --------------------- Shared Ports - Tile and PLL Ports --------------------
    TILE1_CLKIN_IN                          : in   std_logic;
    TILE1_GTPRESET_IN                       : in   std_logic;
    TILE1_PLLLKDET_OUT                      : out  std_logic;
    TILE1_REFCLKOUT_OUT                     : out  std_logic;
    TILE1_RESETDONE0_OUT                    : out  std_logic;
    TILE1_RESETDONE1_OUT                    : out  std_logic;
    ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
    TILE1_TXCHARISK0_IN                     : in   std_logic;
    TILE1_TXCHARISK1_IN                     : in   std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE1_TXDATA0_IN                        : in   std_logic_vector(7 downto 0);
    TILE1_TXDATA1_IN                        : in   std_logic_vector(7 downto 0);
    TILE1_TXOUTCLK0_OUT                     : out  std_logic;
    TILE1_TXOUTCLK1_OUT                     : out  std_logic;
    TILE1_TXRESET0_IN                       : in   std_logic;
    TILE1_TXRESET1_IN                       : in   std_logic;
    TILE1_TXUSRCLK0_IN                      : in   std_logic;
    TILE1_TXUSRCLK1_IN                      : in   std_logic;
    TILE1_TXUSRCLK20_IN                     : in   std_logic;
    TILE1_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE1_TXDIFFCTRL0_IN                    : in   std_logic_vector(2 downto 0);
    TILE1_TXDIFFCTRL1_IN                    : in   std_logic_vector(2 downto 0);
    TILE1_TXN0_OUT                          : out  std_logic;
    TILE1_TXN1_OUT                          : out  std_logic;
    TILE1_TXP0_OUT                          : out  std_logic;
    TILE1_TXP1_OUT                          : out  std_logic;
    ----------------- Transmit Ports - TX Ports for PCI Express ----------------
    TILE1_TXELECIDLE0_IN                    : in   std_logic;
    TILE1_TXELECIDLE1_IN                    : in   std_logic;
    --------------------- Transmit Ports - TX Ports for SATA -------------------
    TILE1_TXCOMSTART0_IN                    : in   std_logic;
    TILE1_TXCOMSTART1_IN                    : in   std_logic;
    TILE1_TXCOMTYPE0_IN                     : in   std_logic;
    TILE1_TXCOMTYPE1_IN                     : in   std_logic;


    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE2  (Location)

    ------------------------ Loopback and Powerdown Ports ----------------------
	 TILE2_PLLPOWERDOWN_IN                   : in   std_logic;
    TILE2_RXPOWERDOWN0_IN                   : in   std_logic_vector(1 downto 0);
    TILE2_RXPOWERDOWN1_IN                   : in   std_logic_vector(1 downto 0);
    TILE2_TXPOWERDOWN0_IN                   : in   std_logic_vector(1 downto 0);
    TILE2_TXPOWERDOWN1_IN                   : in   std_logic_vector(1 downto 0);
    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    TILE2_RXCHARISCOMMA0_OUT                : out  std_logic;
    TILE2_RXCHARISCOMMA1_OUT                : out  std_logic;
    TILE2_RXCHARISK0_OUT                    : out  std_logic;
    TILE2_RXCHARISK1_OUT                    : out  std_logic;
    TILE2_RXDISPERR0_OUT                    : out  std_logic;
    TILE2_RXDISPERR1_OUT                    : out  std_logic;
    TILE2_RXNOTINTABLE0_OUT                 : out  std_logic;
    TILE2_RXNOTINTABLE1_OUT                 : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    TILE2_RXCLKCORCNT0_OUT                  : out  std_logic_vector(2 downto 0);
    TILE2_RXCLKCORCNT1_OUT                  : out  std_logic_vector(2 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    TILE2_RXENMCOMMAALIGN0_IN               : in   std_logic;
    TILE2_RXENMCOMMAALIGN1_IN               : in   std_logic;
    TILE2_RXENPCOMMAALIGN0_IN               : in   std_logic;
    TILE2_RXENPCOMMAALIGN1_IN               : in   std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE2_RXDATA0_OUT                       : out  std_logic_vector(7 downto 0);
    TILE2_RXDATA1_OUT                       : out  std_logic_vector(7 downto 0);
    TILE2_RXRECCLK0_OUT                     : out  std_logic;
    TILE2_RXRECCLK1_OUT                     : out  std_logic;
    TILE2_RXRESET0_IN                       : in   std_logic;
    TILE2_RXRESET1_IN                       : in   std_logic;
    TILE2_RXUSRCLK0_IN                      : in   std_logic;
    TILE2_RXUSRCLK1_IN                      : in   std_logic;
    TILE2_RXUSRCLK20_IN                     : in   std_logic;
    TILE2_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE2_RXCDRRESET0_IN                    : in   std_logic;
    TILE2_RXCDRRESET1_IN                    : in   std_logic;
    TILE2_RXELECIDLE0_OUT                   : out  std_logic;
    TILE2_RXELECIDLE1_OUT                   : out  std_logic;
    TILE2_RXEQMIX0_IN                       : in   std_logic_vector(1 downto 0);
    TILE2_RXEQMIX1_IN                       : in   std_logic_vector(1 downto 0);
    TILE2_RXEQPOLE0_IN                      : in   std_logic_vector(3 downto 0);
    TILE2_RXEQPOLE1_IN                      : in   std_logic_vector(3 downto 0);
    TILE2_RXN0_IN                           : in   std_logic;
    TILE2_RXN1_IN                           : in   std_logic;
    TILE2_RXP0_IN                           : in   std_logic;
    TILE2_RXP1_IN                           : in   std_logic;
    -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
    TILE2_RXBUFRESET0_IN                    : in   std_logic;
    TILE2_RXBUFRESET1_IN                    : in   std_logic;
    TILE2_RXSTATUS0_OUT                     : out  std_logic_vector(2 downto 0);
    TILE2_RXSTATUS1_OUT                     : out  std_logic_vector(2 downto 0);
    --------------------- Shared Ports - Tile and PLL Ports --------------------
    TILE2_CLKIN_IN                          : in   std_logic;
    TILE2_GTPRESET_IN                       : in   std_logic;
    TILE2_PLLLKDET_OUT                      : out  std_logic;
    TILE2_REFCLKOUT_OUT                     : out  std_logic;
    TILE2_RESETDONE0_OUT                    : out  std_logic;
    TILE2_RESETDONE1_OUT                    : out  std_logic;
    ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
    TILE2_TXCHARISK0_IN                     : in   std_logic;
    TILE2_TXCHARISK1_IN                     : in   std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE2_TXDATA0_IN                        : in   std_logic_vector(7 downto 0);
    TILE2_TXDATA1_IN                        : in   std_logic_vector(7 downto 0);
    TILE2_TXOUTCLK0_OUT                     : out  std_logic;
    TILE2_TXOUTCLK1_OUT                     : out  std_logic;
    TILE2_TXRESET0_IN                       : in   std_logic;
    TILE2_TXRESET1_IN                       : in   std_logic;
    TILE2_TXUSRCLK0_IN                      : in   std_logic;
    TILE2_TXUSRCLK1_IN                      : in   std_logic;
    TILE2_TXUSRCLK20_IN                     : in   std_logic;
    TILE2_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE2_TXDIFFCTRL0_IN                    : in   std_logic_vector(2 downto 0);
    TILE2_TXDIFFCTRL1_IN                    : in   std_logic_vector(2 downto 0);
    TILE2_TXN0_OUT                          : out  std_logic;
    TILE2_TXN1_OUT                          : out  std_logic;
    TILE2_TXP0_OUT                          : out  std_logic;
    TILE2_TXP1_OUT                          : out  std_logic;
    ----------------- Transmit Ports - TX Ports for PCI Express ----------------
    TILE2_TXELECIDLE0_IN                    : in   std_logic;
    TILE2_TXELECIDLE1_IN                    : in   std_logic;
    --------------------- Transmit Ports - TX Ports for SATA -------------------
    TILE2_TXCOMSTART0_IN                    : in   std_logic;
    TILE2_TXCOMSTART1_IN                    : in   std_logic;
    TILE2_TXCOMTYPE0_IN                     : in   std_logic;
    TILE2_TXCOMTYPE1_IN                     : in   std_logic;


    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE3  (Location)

    ------------------------ Loopback and Powerdown Ports ----------------------
	 TILE3_PLLPOWERDOWN_IN                   : in   std_logic;
    TILE3_RXPOWERDOWN0_IN                   : in   std_logic_vector(1 downto 0);
    TILE3_RXPOWERDOWN1_IN                   : in   std_logic_vector(1 downto 0);
    TILE3_TXPOWERDOWN0_IN                   : in   std_logic_vector(1 downto 0);
    TILE3_TXPOWERDOWN1_IN                   : in   std_logic_vector(1 downto 0);
    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    TILE3_RXCHARISCOMMA0_OUT                : out  std_logic;
    TILE3_RXCHARISCOMMA1_OUT                : out  std_logic;
    TILE3_RXCHARISK0_OUT                    : out  std_logic;
    TILE3_RXCHARISK1_OUT                    : out  std_logic;
    TILE3_RXDISPERR0_OUT                    : out  std_logic;
    TILE3_RXDISPERR1_OUT                    : out  std_logic;
    TILE3_RXNOTINTABLE0_OUT                 : out  std_logic;
    TILE3_RXNOTINTABLE1_OUT                 : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    TILE3_RXCLKCORCNT0_OUT                  : out  std_logic_vector(2 downto 0);
    TILE3_RXCLKCORCNT1_OUT                  : out  std_logic_vector(2 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    TILE3_RXENMCOMMAALIGN0_IN               : in   std_logic;
    TILE3_RXENMCOMMAALIGN1_IN               : in   std_logic;
    TILE3_RXENPCOMMAALIGN0_IN               : in   std_logic;
    TILE3_RXENPCOMMAALIGN1_IN               : in   std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE3_RXDATA0_OUT                       : out  std_logic_vector(7 downto 0);
    TILE3_RXDATA1_OUT                       : out  std_logic_vector(7 downto 0);
    TILE3_RXRECCLK0_OUT                     : out  std_logic;
    TILE3_RXRECCLK1_OUT                     : out  std_logic;
    TILE3_RXRESET0_IN                       : in   std_logic;
    TILE3_RXRESET1_IN                       : in   std_logic;
    TILE3_RXUSRCLK0_IN                      : in   std_logic;
    TILE3_RXUSRCLK1_IN                      : in   std_logic;
    TILE3_RXUSRCLK20_IN                     : in   std_logic;
    TILE3_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE3_RXCDRRESET0_IN                    : in   std_logic;
    TILE3_RXCDRRESET1_IN                    : in   std_logic;
    TILE3_RXELECIDLE0_OUT                   : out  std_logic;
    TILE3_RXELECIDLE1_OUT                   : out  std_logic;
    TILE3_RXEQMIX0_IN                       : in   std_logic_vector(1 downto 0);
    TILE3_RXEQMIX1_IN                       : in   std_logic_vector(1 downto 0);
    TILE3_RXEQPOLE0_IN                      : in   std_logic_vector(3 downto 0);
    TILE3_RXEQPOLE1_IN                      : in   std_logic_vector(3 downto 0);
    TILE3_RXN0_IN                           : in   std_logic;
    TILE3_RXN1_IN                           : in   std_logic;
    TILE3_RXP0_IN                           : in   std_logic;
    TILE3_RXP1_IN                           : in   std_logic;
    -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
    TILE3_RXBUFRESET0_IN                    : in   std_logic;
    TILE3_RXBUFRESET1_IN                    : in   std_logic;
    TILE3_RXSTATUS0_OUT                     : out  std_logic_vector(2 downto 0);
    TILE3_RXSTATUS1_OUT                     : out  std_logic_vector(2 downto 0);
    --------------------- Shared Ports - Tile and PLL Ports --------------------
    TILE3_CLKIN_IN                          : in   std_logic;
    TILE3_GTPRESET_IN                       : in   std_logic;
    TILE3_PLLLKDET_OUT                      : out  std_logic;
    TILE3_REFCLKOUT_OUT                     : out  std_logic;
    TILE3_RESETDONE0_OUT                    : out  std_logic;
    TILE3_RESETDONE1_OUT                    : out  std_logic;
    ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
    TILE3_TXCHARISK0_IN                     : in   std_logic;
    TILE3_TXCHARISK1_IN                     : in   std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE3_TXDATA0_IN                        : in   std_logic_vector(7 downto 0);
    TILE3_TXDATA1_IN                        : in   std_logic_vector(7 downto 0);
    TILE3_TXOUTCLK0_OUT                     : out  std_logic;
    TILE3_TXOUTCLK1_OUT                     : out  std_logic;
    TILE3_TXRESET0_IN                       : in   std_logic;
    TILE3_TXRESET1_IN                       : in   std_logic;
    TILE3_TXUSRCLK0_IN                      : in   std_logic;
    TILE3_TXUSRCLK1_IN                      : in   std_logic;
    TILE3_TXUSRCLK20_IN                     : in   std_logic;
    TILE3_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE3_TXDIFFCTRL0_IN                    : in   std_logic_vector(2 downto 0);
    TILE3_TXDIFFCTRL1_IN                    : in   std_logic_vector(2 downto 0);
    TILE3_TXN0_OUT                          : out  std_logic;
    TILE3_TXN1_OUT                          : out  std_logic;
    TILE3_TXP0_OUT                          : out  std_logic;
    TILE3_TXP1_OUT                          : out  std_logic;
    ----------------- Transmit Ports - TX Ports for PCI Express ----------------
    TILE3_TXELECIDLE0_IN                    : in   std_logic;
    TILE3_TXELECIDLE1_IN                    : in   std_logic;
    --------------------- Transmit Ports - TX Ports for SATA -------------------
    TILE3_TXCOMSTART0_IN                    : in   std_logic;
    TILE3_TXCOMSTART1_IN                    : in   std_logic;
    TILE3_TXCOMTYPE0_IN                     : in   std_logic;
    TILE3_TXCOMTYPE1_IN                     : in   std_logic


);
end component;


component MGT_USRCLK_SOURCE 
generic
(
    FREQUENCY_MODE   : string   := "LOW";    
    PERFORMANCE_MODE : string   := "MAX_SPEED"    
);
port
(
    DIV1_OUT                : out std_logic;
    DIV2_OUT                : out std_logic;
    DCM_LOCKED_OUT          : out std_logic;
    CLK_IN                  : in  std_logic;
    DCM_RESET_IN            : in  std_logic

);
end component;

component FRAME_GEN 
generic
(
    WORDS_IN_BRAM : integer    :=   256;
    MEM_00       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_01       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_02       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_03       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_04       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_05       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_06       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_07       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_08       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_09       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0A       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0B       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0C       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0D       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0E       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0F       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_10       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_11       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_12       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_13       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_14       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_15       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_16       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_17       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_18       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_19       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1A       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1B       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1C       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1D       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1E       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1F       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_20       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_21       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_22       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_23       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_24       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_25       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_26       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_27       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_28       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_29       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2A       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2B       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2C       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2D       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2E       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2F       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_30       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_31       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_32       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_33       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_34       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_35       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_36       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_37       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_38       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_39       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3A       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3B       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3C       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3D       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3E       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3F       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_00      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_01      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_02      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_03      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_04      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_05      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_06      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_07      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000"
);    
port
(
    -- User Interface
    TX_DATA             : out   std_logic_vector(31 downto 0);
    TX_CHARISK          : out   std_logic_vector(3 downto 0); 

    -- System Interface
    USER_CLK            : in    std_logic;
    SYSTEM_RESET        : in    std_logic
); 
end component;

component FRAME_CHECK 
generic
(
    RX_DATA_WIDTH            : integer := 16;
    USE_COMMA                : integer := 1;
    WORDS_IN_BRAM            : integer := 256;
    CONFIG_INDEPENDENT_LANES : integer := 0;
    START_OF_PACKET_CHAR     : std_logic_vector := x"55fb";
    MEM_00       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_01       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_02       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_03       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_04       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_05       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_06       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_07       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_08       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_09       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0A       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0B       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0C       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0D       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0E       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0F       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_10       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_11       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_12       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_13       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_14       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_15       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_16       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_17       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_18       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_19       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1A       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1B       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1C       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1D       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1E       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1F       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_20       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_21       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_22       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_23       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_24       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_25       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_26       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_27       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_28       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_29       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2A       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2B       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2C       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2D       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2E       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2F       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_30       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_31       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_32       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_33       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_34       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_35       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_36       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_37       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_38       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_39       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3A       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3B       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3C       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3D       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3E       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3F       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_00      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_01      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_02      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_03      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_04      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_05      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_06      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_07      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000"
);
port
(
    -- User Interface
    RX_DATA                  : in  std_logic_vector((RX_DATA_WIDTH-1) downto 0); 
    RX_ENMCOMMA_ALIGN        : out std_logic;
    RX_ENPCOMMA_ALIGN        : out std_logic;
    RX_ENCHAN_SYNC           : out std_logic; 

    -- Control Interface
    INC_IN                   : in std_logic; 
    INC_OUT                  : out std_logic; 
    PATTERN_MATCH_N          : out std_logic;
    RESET_ON_ERROR           : in std_logic; 
    
    -- Error Monitoring
    ERROR_COUNT              : out std_logic_vector(7 downto 0);

    -- System Interface
    USER_CLK                 : in std_logic;
    SYSTEM_RESET             : in std_logic;
    TRACK_DATA               : out std_logic     
  
);
end component;

component MGT_USRCLK_SOURCE_PLL 
generic
(
    MULT                 : integer          := 2;
    DIVIDE               : integer          := 2;    
    CLK_PERIOD           : real             := 13.33;
    OUT0_DIVIDE          : integer          := 2;
    OUT1_DIVIDE          : integer          := 2;
    OUT2_DIVIDE          : integer          := 2;
    OUT3_DIVIDE          : integer          := 2;
    SIMULATION_P         : integer          := 1;
    LOCK_WAIT_COUNT      : std_logic_vector := "1000001000110101"    
);
port
( 
    CLK0_OUT                : out std_logic;
    CLK1_OUT                : out std_logic;
    CLK2_OUT                : out std_logic;
    CLK3_OUT                : out std_logic;
    CLK_IN                  : in  std_logic;
    PLL_LOCKED_OUT          : out std_logic;
    PLL_RESET_IN            : in  std_logic
);
end component;





-- Chipscope modules
attribute syn_black_box                : boolean;
attribute syn_noprune                  : boolean;


component shared_vio
port
(
    control                 : in  std_logic_vector(35 downto 0);
    async_in                : in  std_logic_vector(31 downto 0);
    async_out               : out std_logic_vector(31 downto 0)
);
end component;
attribute syn_black_box of shared_vio : component is TRUE;
attribute syn_noprune of shared_vio   : component is TRUE;


component icon
port
(
    control0                : out std_logic_vector(35 downto 0);
    control1                : out std_logic_vector(35 downto 0);
    control2                : out std_logic_vector(35 downto 0);
    control3                : out std_logic_vector(35 downto 0);
    control4                : out std_logic_vector(35 downto 0);
    control5                : out std_logic_vector(35 downto 0);
    control6                : out std_logic_vector(35 downto 0)
);
end component;
attribute syn_black_box of icon : component is TRUE;
attribute syn_noprune of icon   : component is TRUE;


component ila
port
(
    control                 : in  std_logic_vector(35 downto 0);
    clk                     : in  std_logic;
    trig0                   : in  std_logic_vector(63 downto 0)
);
end component;
attribute syn_black_box of ila : component is TRUE;
attribute syn_noprune of ila   : component is TRUE;


--***********************************Parameter Declarations********************

    constant DLY : time := 1 ns;
    
--************************** Register Declarations ****************************

    signal     tile0_tx_resetdone0_r           : std_logic;
    signal     tile0_tx_resetdone0_r2          : std_logic;
    signal     tile0_tx_resetdone1_r           : std_logic;
    signal     tile0_tx_resetdone1_r2          : std_logic;
    signal     tile1_tx_resetdone0_r           : std_logic;
    signal     tile1_tx_resetdone0_r2          : std_logic;
    signal     tile1_tx_resetdone1_r           : std_logic;
    signal     tile1_tx_resetdone1_r2          : std_logic;
    signal     tile2_tx_resetdone0_r           : std_logic;
    signal     tile2_tx_resetdone0_r2          : std_logic;
    signal     tile2_tx_resetdone1_r           : std_logic;
    signal     tile2_tx_resetdone1_r2          : std_logic;
    signal     tile3_tx_resetdone0_r           : std_logic;
    signal     tile3_tx_resetdone0_r2          : std_logic;
    signal     tile3_tx_resetdone1_r           : std_logic;
    signal     tile3_tx_resetdone1_r2          : std_logic;
    signal     tile0_rx_resetdone0_r           : std_logic;
    signal     tile0_rx_resetdone0_r2          : std_logic;
    signal     tile0_rx_resetdone1_r           : std_logic;
    signal     tile0_rx_resetdone1_r2          : std_logic;
    signal     tile1_rx_resetdone0_r           : std_logic;
    signal     tile1_rx_resetdone0_r2          : std_logic;
    signal     tile1_rx_resetdone1_r           : std_logic;
    signal     tile1_rx_resetdone1_r2          : std_logic;
    signal     tile2_rx_resetdone0_r           : std_logic;
    signal     tile2_rx_resetdone0_r2          : std_logic;
    signal     tile2_rx_resetdone1_r           : std_logic;
    signal     tile2_rx_resetdone1_r2          : std_logic;
    signal     tile3_rx_resetdone0_r           : std_logic;
    signal     tile3_rx_resetdone0_r2          : std_logic;
    signal     tile3_rx_resetdone1_r           : std_logic;
    signal     tile3_rx_resetdone1_r2          : std_logic;
 
    

--**************************** Wire Declarations ******************************

    -------------------------- MGT Wrapper Wires ------------------------------
    --________________________________________________________________________
    --________________________________________________________________________
    --TILE0   (X0Y2)

    ------------------------ Loopback and Powerdown Ports ----------------------
    signal  powerdown_i         				  : std_logic_vector(1 downto 0);
--    signal  tile0_rxpowerdown0_i            : std_logic_vector(1 downto 0);
--    signal  tile0_rxpowerdown1_i            : std_logic_vector(1 downto 0);
--    signal  tile0_txpowerdown0_i            : std_logic_vector(1 downto 0);
--    signal  tile0_txpowerdown1_i            : std_logic_vector(1 downto 0);
    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    signal  tile0_rxchariscomma0_i          : std_logic;
    signal  tile0_rxchariscomma1_i          : std_logic;
    signal  tile0_rxcharisk0_i              : std_logic;
    signal  tile0_rxcharisk1_i              : std_logic;
    signal  tile0_rxdisperr0_i              : std_logic;
    signal  tile0_rxdisperr1_i              : std_logic;
    signal  tile0_rxnotintable0_i           : std_logic;
    signal  tile0_rxnotintable1_i           : std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    signal  tile0_rxclkcorcnt0_i            : std_logic_vector(2 downto 0);
    signal  tile0_rxclkcorcnt1_i            : std_logic_vector(2 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    signal  tile0_rxenmcommaalign0_i        : std_logic;
    signal  tile0_rxenmcommaalign1_i        : std_logic;
    signal  tile0_rxenpcommaalign0_i        : std_logic;
    signal  tile0_rxenpcommaalign1_i        : std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    signal  tile0_rxdata0_i                 : std_logic_vector(7 downto 0);
    signal  tile0_rxdata1_i                 : std_logic_vector(7 downto 0);
    signal  tile0_rxrecclk0_i               : std_logic;
    signal  tile0_rxrecclk1_i               : std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    signal  tile0_rxcdrreset0_i             : std_logic;
    signal  tile0_rxcdrreset1_i             : std_logic;
    signal  tile0_rxelecidle0_i             : std_logic;
    signal  tile0_rxelecidle1_i             : std_logic;
    signal  tile0_rxeqmix0_i                : std_logic_vector(1 downto 0);
    signal  tile0_rxeqmix1_i                : std_logic_vector(1 downto 0);
    signal  tile0_rxeqpole0_i               : std_logic_vector(3 downto 0);
    signal  tile0_rxeqpole1_i               : std_logic_vector(3 downto 0);
    -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
    signal  tile0_rxbufreset0_i             : std_logic;
    signal  tile0_rxbufreset1_i             : std_logic;
    signal  tile0_rxstatus0_i               : std_logic_vector(2 downto 0);
    signal  tile0_rxstatus1_i               : std_logic_vector(2 downto 0);
    --------------------- Shared Ports - Tile and PLL Ports --------------------
    signal  tile0_gtpreset_i                : std_logic;
    signal  tile0_plllkdet_i                : std_logic;
    signal  tile0_refclkout_i               : std_logic;
    signal  tile0_resetdone0_i              : std_logic;
    signal  tile0_resetdone1_i              : std_logic;
    ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
    signal  tile0_txcharisk0_i              : std_logic;
    signal  tile0_txcharisk1_i              : std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    signal  tile0_txdata0_i                 : std_logic_vector(7 downto 0);
    signal  tile0_txdata1_i                 : std_logic_vector(7 downto 0);
    signal  tile0_txoutclk0_i               : std_logic;
    signal  tile0_txoutclk1_i               : std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    signal  tile0_txdiffctrl0_i             : std_logic_vector(2 downto 0);
    signal  tile0_txdiffctrl1_i             : std_logic_vector(2 downto 0);
    ----------------- Transmit Ports - TX Ports for PCI Express ----------------
--    signal  tile0_txelecidle0_i             : std_logic;
--    signal  tile0_txelecidle1_i             : std_logic;
    --------------------- Transmit Ports - TX Ports for SATA -------------------
    signal  tile0_txcomstart0_i             : std_logic;
    signal  tile0_txcomstart1_i             : std_logic;
    signal  tile0_txcomtype0_i              : std_logic;
    signal  tile0_txcomtype1_i              : std_logic;


    --________________________________________________________________________
    --________________________________________________________________________
    --TILE1   (X0Y3)

    ------------------------ Loopback and Powerdown Ports ----------------------
--    signal  tile1_rxpowerdown0_i            : std_logic_vector(1 downto 0);
--    signal  tile1_rxpowerdown1_i            : std_logic_vector(1 downto 0);
--    signal  tile1_txpowerdown0_i            : std_logic_vector(1 downto 0);
--    signal  tile1_txpowerdown1_i            : std_logic_vector(1 downto 0);
    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    signal  tile1_rxchariscomma0_i          : std_logic;
    signal  tile1_rxchariscomma1_i          : std_logic;
    signal  tile1_rxcharisk0_i              : std_logic;
    signal  tile1_rxcharisk1_i              : std_logic;
    signal  tile1_rxdisperr0_i              : std_logic;
    signal  tile1_rxdisperr1_i              : std_logic;
    signal  tile1_rxnotintable0_i           : std_logic;
    signal  tile1_rxnotintable1_i           : std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    signal  tile1_rxclkcorcnt0_i            : std_logic_vector(2 downto 0);
    signal  tile1_rxclkcorcnt1_i            : std_logic_vector(2 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    signal  tile1_rxenmcommaalign0_i        : std_logic;
    signal  tile1_rxenmcommaalign1_i        : std_logic;
    signal  tile1_rxenpcommaalign0_i        : std_logic;
    signal  tile1_rxenpcommaalign1_i        : std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    signal  tile1_rxdata0_i                 : std_logic_vector(7 downto 0);
    signal  tile1_rxdata1_i                 : std_logic_vector(7 downto 0);
    signal  tile1_rxrecclk0_i               : std_logic;
    signal  tile1_rxrecclk1_i               : std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    signal  tile1_rxcdrreset0_i             : std_logic;
    signal  tile1_rxcdrreset1_i             : std_logic;
    signal  tile1_rxelecidle0_i             : std_logic;
    signal  tile1_rxelecidle1_i             : std_logic;
    signal  tile1_rxeqmix0_i                : std_logic_vector(1 downto 0);
    signal  tile1_rxeqmix1_i                : std_logic_vector(1 downto 0);
    signal  tile1_rxeqpole0_i               : std_logic_vector(3 downto 0);
    signal  tile1_rxeqpole1_i               : std_logic_vector(3 downto 0);
    -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
    signal  tile1_rxbufreset0_i             : std_logic;
    signal  tile1_rxbufreset1_i             : std_logic;
    signal  tile1_rxstatus0_i               : std_logic_vector(2 downto 0);
    signal  tile1_rxstatus1_i               : std_logic_vector(2 downto 0);
    --------------------- Shared Ports - Tile and PLL Ports --------------------
    signal  tile1_gtpreset_i                : std_logic;
    signal  tile1_plllkdet_i                : std_logic;
    signal  tile1_refclkout_i               : std_logic;
    signal  tile1_resetdone0_i              : std_logic;
    signal  tile1_resetdone1_i              : std_logic;
    ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
    signal  tile1_txcharisk0_i              : std_logic;
    signal  tile1_txcharisk1_i              : std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    signal  tile1_txdata0_i                 : std_logic_vector(7 downto 0);
    signal  tile1_txdata1_i                 : std_logic_vector(7 downto 0);
    signal  tile1_txoutclk0_i               : std_logic;
    signal  tile1_txoutclk1_i               : std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    signal  tile1_txdiffctrl0_i             : std_logic_vector(2 downto 0);
    signal  tile1_txdiffctrl1_i             : std_logic_vector(2 downto 0);
    ----------------- Transmit Ports - TX Ports for PCI Express ----------------
--    signal  tile1_txelecidle0_i             : std_logic;
--    signal  tile1_txelecidle1_i             : std_logic;
    --------------------- Transmit Ports - TX Ports for SATA -------------------
    signal  tile1_txcomstart0_i             : std_logic;
    signal  tile1_txcomstart1_i             : std_logic;
    signal  tile1_txcomtype0_i              : std_logic;
    signal  tile1_txcomtype1_i              : std_logic;


    --________________________________________________________________________
    --________________________________________________________________________
    --TILE2   (X0Y4)

    ------------------------ Loopback and Powerdown Ports ----------------------
--    signal  tile2_rxpowerdown0_i            : std_logic_vector(1 downto 0);
--    signal  tile2_rxpowerdown1_i            : std_logic_vector(1 downto 0);
--    signal  tile2_txpowerdown0_i            : std_logic_vector(1 downto 0);
--    signal  tile2_txpowerdown1_i            : std_logic_vector(1 downto 0);
    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    signal  tile2_rxchariscomma0_i          : std_logic;
    signal  tile2_rxchariscomma1_i          : std_logic;
    signal  tile2_rxcharisk0_i              : std_logic;
    signal  tile2_rxcharisk1_i              : std_logic;
    signal  tile2_rxdisperr0_i              : std_logic;
    signal  tile2_rxdisperr1_i              : std_logic;
    signal  tile2_rxnotintable0_i           : std_logic;
    signal  tile2_rxnotintable1_i           : std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    signal  tile2_rxclkcorcnt0_i            : std_logic_vector(2 downto 0);
    signal  tile2_rxclkcorcnt1_i            : std_logic_vector(2 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    signal  tile2_rxenmcommaalign0_i        : std_logic;
    signal  tile2_rxenmcommaalign1_i        : std_logic;
    signal  tile2_rxenpcommaalign0_i        : std_logic;
    signal  tile2_rxenpcommaalign1_i        : std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    signal  tile2_rxdata0_i                 : std_logic_vector(7 downto 0);
    signal  tile2_rxdata1_i                 : std_logic_vector(7 downto 0);
    signal  tile2_rxrecclk0_i               : std_logic;
    signal  tile2_rxrecclk1_i               : std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    signal  tile2_rxcdrreset0_i             : std_logic;
    signal  tile2_rxcdrreset1_i             : std_logic;
    signal  tile2_rxelecidle0_i             : std_logic;
    signal  tile2_rxelecidle1_i             : std_logic;
    signal  tile2_rxeqmix0_i                : std_logic_vector(1 downto 0);
    signal  tile2_rxeqmix1_i                : std_logic_vector(1 downto 0);
    signal  tile2_rxeqpole0_i               : std_logic_vector(3 downto 0);
    signal  tile2_rxeqpole1_i               : std_logic_vector(3 downto 0);
    -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
    signal  tile2_rxbufreset0_i             : std_logic;
    signal  tile2_rxbufreset1_i             : std_logic;
    signal  tile2_rxstatus0_i               : std_logic_vector(2 downto 0);
    signal  tile2_rxstatus1_i               : std_logic_vector(2 downto 0);
    --------------------- Shared Ports - Tile and PLL Ports --------------------
    signal  tile2_gtpreset_i                : std_logic;
    signal  tile2_plllkdet_i                : std_logic;
    signal  tile2_refclkout_i               : std_logic;
    signal  tile2_resetdone0_i              : std_logic;
    signal  tile2_resetdone1_i              : std_logic;
    ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
    signal  tile2_txcharisk0_i              : std_logic;
    signal  tile2_txcharisk1_i              : std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    signal  tile2_txdata0_i                 : std_logic_vector(7 downto 0);
    signal  tile2_txdata1_i                 : std_logic_vector(7 downto 0);
    signal  tile2_txoutclk0_i               : std_logic;
    signal  tile2_txoutclk1_i               : std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    signal  tile2_txdiffctrl0_i             : std_logic_vector(2 downto 0);
    signal  tile2_txdiffctrl1_i             : std_logic_vector(2 downto 0);
    ----------------- Transmit Ports - TX Ports for PCI Express ----------------
--    signal  tile2_txelecidle0_i             : std_logic;
--    signal  tile2_txelecidle1_i             : std_logic;
    --------------------- Transmit Ports - TX Ports for SATA -------------------
    signal  tile2_txcomstart0_i             : std_logic;
    signal  tile2_txcomstart1_i             : std_logic;
    signal  tile2_txcomtype0_i              : std_logic;
    signal  tile2_txcomtype1_i              : std_logic;


    --________________________________________________________________________
    --________________________________________________________________________
    --TILE3   (X0Y5)

    ------------------------ Loopback and Powerdown Ports ----------------------
--    signal  tile3_rxpowerdown0_i            : std_logic_vector(1 downto 0);
--    signal  tile3_rxpowerdown1_i            : std_logic_vector(1 downto 0);
--    signal  tile3_txpowerdown0_i            : std_logic_vector(1 downto 0);
--    signal  tile3_txpowerdown1_i            : std_logic_vector(1 downto 0);
    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    signal  tile3_rxchariscomma0_i          : std_logic;
    signal  tile3_rxchariscomma1_i          : std_logic;
    signal  tile3_rxcharisk0_i              : std_logic;
    signal  tile3_rxcharisk1_i              : std_logic;
    signal  tile3_rxdisperr0_i              : std_logic;
    signal  tile3_rxdisperr1_i              : std_logic;
    signal  tile3_rxnotintable0_i           : std_logic;
    signal  tile3_rxnotintable1_i           : std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    signal  tile3_rxclkcorcnt0_i            : std_logic_vector(2 downto 0);
    signal  tile3_rxclkcorcnt1_i            : std_logic_vector(2 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    signal  tile3_rxenmcommaalign0_i        : std_logic;
    signal  tile3_rxenmcommaalign1_i        : std_logic;
    signal  tile3_rxenpcommaalign0_i        : std_logic;
    signal  tile3_rxenpcommaalign1_i        : std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    signal  tile3_rxdata0_i                 : std_logic_vector(7 downto 0);
    signal  tile3_rxdata1_i                 : std_logic_vector(7 downto 0);
    signal  tile3_rxrecclk0_i               : std_logic;
    signal  tile3_rxrecclk1_i               : std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    signal  tile3_rxcdrreset0_i             : std_logic;
    signal  tile3_rxcdrreset1_i             : std_logic;
    signal  tile3_rxelecidle0_i             : std_logic;
    signal  tile3_rxelecidle1_i             : std_logic;
    signal  tile3_rxeqmix0_i                : std_logic_vector(1 downto 0);
    signal  tile3_rxeqmix1_i                : std_logic_vector(1 downto 0);
    signal  tile3_rxeqpole0_i               : std_logic_vector(3 downto 0);
    signal  tile3_rxeqpole1_i               : std_logic_vector(3 downto 0);
    -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
    signal  tile3_rxbufreset0_i             : std_logic;
    signal  tile3_rxbufreset1_i             : std_logic;
    signal  tile3_rxstatus0_i               : std_logic_vector(2 downto 0);
    signal  tile3_rxstatus1_i               : std_logic_vector(2 downto 0);
    --------------------- Shared Ports - Tile and PLL Ports --------------------
    signal  tile3_gtpreset_i                : std_logic;
    signal  tile3_plllkdet_i                : std_logic;
    signal  tile3_refclkout_i               : std_logic;
    signal  tile3_resetdone0_i              : std_logic;
    signal  tile3_resetdone1_i              : std_logic;
    ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
    signal  tile3_txcharisk0_i              : std_logic;
    signal  tile3_txcharisk1_i              : std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    signal  tile3_txdata0_i                 : std_logic_vector(7 downto 0);
    signal  tile3_txdata1_i                 : std_logic_vector(7 downto 0);
    signal  tile3_txoutclk0_i               : std_logic;
    signal  tile3_txoutclk1_i               : std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    signal  tile3_txdiffctrl0_i             : std_logic_vector(2 downto 0);
    signal  tile3_txdiffctrl1_i             : std_logic_vector(2 downto 0);
    ----------------- Transmit Ports - TX Ports for PCI Express ----------------
--    signal  tile3_txelecidle0_i             : std_logic;
--    signal  tile3_txelecidle1_i             : std_logic;
    --------------------- Transmit Ports - TX Ports for SATA -------------------
    signal  tile3_txcomstart0_i             : std_logic;
    signal  tile3_txcomstart1_i             : std_logic;
    signal  tile3_txcomtype0_i              : std_logic;
    signal  tile3_txcomtype1_i              : std_logic;


    ------------------------------- Global Signals -----------------------------
    signal  tile0_tx_system_reset0_c        : std_logic;
    signal  tile0_rx_system_reset0_c        : std_logic;
    signal  tile0_rxreset0_i                : std_logic;
    signal  tile0_txreset0_i                : std_logic;
    signal  tile0_tx_system_reset1_c        : std_logic;
    signal  tile0_rx_system_reset1_c        : std_logic;
    signal  tile0_rxreset1_i                : std_logic;
    signal  tile0_txreset1_i                : std_logic;
    signal  tile1_tx_system_reset0_c        : std_logic;
    signal  tile1_rx_system_reset0_c        : std_logic;
    signal  tile1_rxreset0_i                : std_logic;
    signal  tile1_txreset0_i                : std_logic;
    signal  tile1_tx_system_reset1_c        : std_logic;
    signal  tile1_rx_system_reset1_c        : std_logic;
    signal  tile1_rxreset1_i                : std_logic;
    signal  tile1_txreset1_i                : std_logic;
    signal  tile2_tx_system_reset0_c        : std_logic;
    signal  tile2_rx_system_reset0_c        : std_logic;
    signal  tile2_rxreset0_i                : std_logic;
    signal  tile2_txreset0_i                : std_logic;
    signal  tile2_tx_system_reset1_c        : std_logic;
    signal  tile2_rx_system_reset1_c        : std_logic;
    signal  tile2_rxreset1_i                : std_logic;
    signal  tile2_txreset1_i                : std_logic;
    signal  tile3_tx_system_reset0_c        : std_logic;
    signal  tile3_rx_system_reset0_c        : std_logic;
    signal  tile3_rxreset0_i                : std_logic;
    signal  tile3_txreset0_i                : std_logic;
    signal  tile3_tx_system_reset1_c        : std_logic;
    signal  tile3_rx_system_reset1_c        : std_logic;
    signal  tile3_rxreset1_i                : std_logic;
    signal  tile3_txreset1_i                : std_logic;
    signal  tied_to_ground_i                : std_logic;
    signal  tied_to_ground_vec_i            : std_logic_vector(63 downto 0);
    signal  tied_to_vcc_i                   : std_logic;
    signal  tied_to_vcc_vec_i               : std_logic_vector(7 downto 0);
    signal  drp_clk_in_i                    : std_logic;
    signal  tile0_refclkout_bufg_i          : std_logic;
    
    
    ----------------------------- User Clocks ---------------------------------
    signal  tile0_txusrclk0_i               : std_logic;
    signal  refclkout_pll0_locked_i         : std_logic;
    signal  refclkout_pll0_reset_i          : std_logic;
    signal  tile0_refclkout_to_cmt_i        : std_logic;


    ----------------------- Frame check/gen Module Signals --------------------
    signal  tile0_matchn0_i                 : std_logic;
    signal  tile0_track_data0_i             : std_logic;    
    signal  tile0_txcharisk0_float_i        : std_logic_vector(2 downto 0);
    signal  tile0_txdata0_float_i           : std_logic_vector(23 downto 0);
    signal  tile0_error_count0_i            : std_logic_vector(7 downto 0);
    signal  tile0_frame_check0_reset_i      : std_logic;
    signal  tile0_inc_in0_i                 : std_logic;
    signal  tile0_inc_out0_i                : std_logic;
    signal  tile0_matchn1_i                 : std_logic;
    signal  tile0_track_data1_i             : std_logic;    
    signal  tile0_txcharisk1_float_i        : std_logic_vector(2 downto 0);
    signal  tile0_txdata1_float_i           : std_logic_vector(23 downto 0);
    signal  tile0_error_count1_i            : std_logic_vector(7 downto 0);
    signal  tile0_frame_check1_reset_i      : std_logic;
    signal  tile0_inc_in1_i                 : std_logic;
    signal  tile0_inc_out1_i                : std_logic;

    signal  tile1_matchn0_i                 : std_logic;
    signal  tile1_track_data0_i             : std_logic;    
    signal  tile1_txcharisk0_float_i        : std_logic_vector(2 downto 0);
    signal  tile1_txdata0_float_i           : std_logic_vector(23 downto 0);
    signal  tile1_error_count0_i            : std_logic_vector(7 downto 0);
    signal  tile1_frame_check0_reset_i      : std_logic;
    signal  tile1_inc_in0_i                 : std_logic;
    signal  tile1_inc_out0_i                : std_logic;
    signal  tile1_matchn1_i                 : std_logic;
    signal  tile1_track_data1_i             : std_logic;    
    signal  tile1_txcharisk1_float_i        : std_logic_vector(2 downto 0);
    signal  tile1_txdata1_float_i           : std_logic_vector(23 downto 0);
    signal  tile1_error_count1_i            : std_logic_vector(7 downto 0);
    signal  tile1_frame_check1_reset_i      : std_logic;
    signal  tile1_inc_in1_i                 : std_logic;
    signal  tile1_inc_out1_i                : std_logic;

    signal  tile2_refclk_i                  : std_logic;
    signal  tile2_matchn0_i                 : std_logic;
    signal  tile2_track_data0_i             : std_logic;    
    signal  tile2_txcharisk0_float_i        : std_logic_vector(2 downto 0);
    signal  tile2_txdata0_float_i           : std_logic_vector(23 downto 0);
    signal  tile2_error_count0_i            : std_logic_vector(7 downto 0);
    signal  tile2_frame_check0_reset_i      : std_logic;
    signal  tile2_inc_in0_i                 : std_logic;
    signal  tile2_inc_out0_i                : std_logic;
    signal  tile2_matchn1_i                 : std_logic;
    signal  tile2_track_data1_i             : std_logic;    
    signal  tile2_txcharisk1_float_i        : std_logic_vector(2 downto 0);
    signal  tile2_txdata1_float_i           : std_logic_vector(23 downto 0);
    signal  tile2_error_count1_i            : std_logic_vector(7 downto 0);
    signal  tile2_frame_check1_reset_i      : std_logic;
    signal  tile2_inc_in1_i                 : std_logic;
    signal  tile2_inc_out1_i                : std_logic;

    signal  tile3_matchn0_i                 : std_logic;
    signal  tile3_track_data0_i             : std_logic;    
    signal  tile3_txcharisk0_float_i        : std_logic_vector(2 downto 0);
    signal  tile3_txdata0_float_i           : std_logic_vector(23 downto 0);
    signal  tile3_error_count0_i            : std_logic_vector(7 downto 0);
    signal  tile3_frame_check0_reset_i      : std_logic;
    signal  tile3_inc_in0_i                 : std_logic;
    signal  tile3_inc_out0_i                : std_logic;
    signal  tile3_matchn1_i                 : std_logic;
    signal  tile3_track_data1_i             : std_logic;    
    signal  tile3_txcharisk1_float_i        : std_logic_vector(2 downto 0);
    signal  tile3_txdata1_float_i           : std_logic_vector(23 downto 0);
    signal  tile3_error_count1_i            : std_logic_vector(7 downto 0);
    signal  tile3_frame_check1_reset_i      : std_logic;
    signal  tile3_inc_in1_i                 : std_logic;
    signal  tile3_inc_out1_i                : std_logic;

    signal  reset_on_data_error_i           : std_logic;
    
    ------------------------- Sync Module Signals -----------------------------
    signal  tx_sync_done_i                  : std_logic;
    
    signal  reset_txsync_c                  : std_logic;
    signal    track_data_out_i                : std_logic;

    ----------------------- Chipscope Signals ---------------------------------

    signal  shared_vio_control_i            : std_logic_vector(35 downto 0);
    signal  tx_data_vio_control0_i          : std_logic_vector(35 downto 0);
    signal  rx_data_vio_control0_i          : std_logic_vector(35 downto 0);
    signal  ila_control0_i                  : std_logic_vector(35 downto 0);
    signal  tx_data_vio_control1_i          : std_logic_vector(35 downto 0);
    signal  rx_data_vio_control1_i          : std_logic_vector(35 downto 0);
    signal  ila_control1_i                  : std_logic_vector(35 downto 0);
    signal  shared_vio_in_i                 : std_logic_vector(31 downto 0);
    signal  shared_vio_out_i                : std_logic_vector(31 downto 0);
    signal  tx_data_vio_in0_i               : std_logic_vector(31 downto 0);
    signal  tx_data_vio_out0_i              : std_logic_vector(31 downto 0);
    signal  tx_data_vio_in1_i               : std_logic_vector(31 downto 0);
    signal  tx_data_vio_out1_i              : std_logic_vector(31 downto 0);
    signal  rx_data_vio_in0_i               : std_logic_vector(31 downto 0);
    signal  rx_data_vio_out0_i              : std_logic_vector(31 downto 0);
    signal  rx_data_vio_in1_i               : std_logic_vector(31 downto 0);
    signal  rx_data_vio_out1_i              : std_logic_vector(31 downto 0);
    signal  ila_in0_i                       : std_logic_vector(63 downto 0);
    signal  ila_in1_i                       : std_logic_vector(63 downto 0);

    signal  tile0_tx_data_vio_in0_i         : std_logic_vector(31 downto 0);
    signal  tile0_tx_data_vio_out0_i        : std_logic_vector(31 downto 0);
    signal  tile0_rx_data_vio_in0_i         : std_logic_vector(31 downto 0);
    signal  tile0_rx_data_vio_out0_i        : std_logic_vector(31 downto 0);
    signal  tile0_ila_in0_i                 : std_logic_vector(63 downto 0);
    signal  tile0_tx_data_vio_in1_i         : std_logic_vector(31 downto 0);
    signal  tile0_tx_data_vio_out1_i        : std_logic_vector(31 downto 0);
    signal  tile0_rx_data_vio_in1_i         : std_logic_vector(31 downto 0);
    signal  tile0_rx_data_vio_out1_i        : std_logic_vector(31 downto 0);
    signal  tile0_ila_in1_i                 : std_logic_vector(63 downto 0);

    signal  tile1_tx_data_vio_in0_i         : std_logic_vector(31 downto 0);
    signal  tile1_tx_data_vio_out0_i        : std_logic_vector(31 downto 0);
    signal  tile1_rx_data_vio_in0_i         : std_logic_vector(31 downto 0);
    signal  tile1_rx_data_vio_out0_i        : std_logic_vector(31 downto 0);
    signal  tile1_ila_in0_i                 : std_logic_vector(63 downto 0);
    signal  tile1_tx_data_vio_in1_i         : std_logic_vector(31 downto 0);
    signal  tile1_tx_data_vio_out1_i        : std_logic_vector(31 downto 0);
    signal  tile1_rx_data_vio_in1_i         : std_logic_vector(31 downto 0);
    signal  tile1_rx_data_vio_out1_i        : std_logic_vector(31 downto 0);
    signal  tile1_ila_in1_i                 : std_logic_vector(63 downto 0);

    signal  tile2_tx_data_vio_in0_i         : std_logic_vector(31 downto 0);
    signal  tile2_tx_data_vio_out0_i        : std_logic_vector(31 downto 0);
    signal  tile2_rx_data_vio_in0_i         : std_logic_vector(31 downto 0);
    signal  tile2_rx_data_vio_out0_i        : std_logic_vector(31 downto 0);
    signal  tile2_ila_in0_i                 : std_logic_vector(63 downto 0);
    signal  tile2_tx_data_vio_in1_i         : std_logic_vector(31 downto 0);
    signal  tile2_tx_data_vio_out1_i        : std_logic_vector(31 downto 0);
    signal  tile2_rx_data_vio_in1_i         : std_logic_vector(31 downto 0);
    signal  tile2_rx_data_vio_out1_i        : std_logic_vector(31 downto 0);
    signal  tile2_ila_in1_i                 : std_logic_vector(63 downto 0);

    signal  tile3_tx_data_vio_in0_i         : std_logic_vector(31 downto 0);
    signal  tile3_tx_data_vio_out0_i        : std_logic_vector(31 downto 0);
    signal  tile3_rx_data_vio_in0_i         : std_logic_vector(31 downto 0);
    signal  tile3_rx_data_vio_out0_i        : std_logic_vector(31 downto 0);
    signal  tile3_ila_in0_i                 : std_logic_vector(63 downto 0);
    signal  tile3_tx_data_vio_in1_i         : std_logic_vector(31 downto 0);
    signal  tile3_tx_data_vio_out1_i        : std_logic_vector(31 downto 0);
    signal  tile3_rx_data_vio_in1_i         : std_logic_vector(31 downto 0);
    signal  tile3_rx_data_vio_out1_i        : std_logic_vector(31 downto 0);
    signal  tile3_ila_in1_i                 : std_logic_vector(63 downto 0);


    signal  gtpreset_i                      : std_logic;
    signal  mux_sel_i                       : std_logic_vector(1 downto 0);
    signal  not_mux_sel_i                   : std_logic_vector(1 downto 0);    
    signal  user_tx_reset_i                 : std_logic;
    signal  user_rx_reset_i                 : std_logic;
    signal  ila_clk0_i                      : std_logic;
    signal  ila_clk_mux_out0_i              : std_logic;
    signal  ila_clk1_i                      : std_logic;
    signal  ila_clk_mux_out1_i              : std_logic;


--**************************** Main Body of Code *******************************
begin

    --  Static signal Assigments
	 powerdown_i(0)								<= POWERDOWN;
	 powerdown_i(1)								<= POWERDOWN;
    tied_to_ground_i                        <= '0';
    tied_to_ground_vec_i                    <= x"0000000000000000";
    tied_to_vcc_i                           <= '1';
    tied_to_vcc_vec_i                       <= x"ff";


    



    -----------------------Dedicated GTP Reference Clock Inputs ---------------
    -- The dedicated reference clock inputs you selected in the GUI are implemented using
    -- IBUFDS instances.
    --
    -- In the UCF file for this example design, you will see that each of
    -- these IBUFDS instances has been LOCed to a particular set of pins. By LOCing to these
    -- locations, we tell the tools to use the dedicated input buffers to the GTP reference
    -- clock network, rather than general purpose IOs. To select other pins, consult the 
    -- Implementation chapter of UG196, or rerun the wizard.
    --
    -- This network is the highest performace (lowest jitter) option for providing clocks
    -- to the GTP transceivers.
    
    tile2_refclk_ibufds_i : IBUFDS
    port map
    (
        O                               =>      tile2_refclk_i,
        I                               =>      REFCLK_PAD_P_IN,
        IB                              =>      REFCLK_PAD_N_IN
    );


    ----------------------------------- User Clocks ---------------------------
    
    -- The clock resources in this section were added based on userclk source selections on
    -- the Latency, Buffering, and Clocking page of the GUI. A few notes about user clocks:
    -- * The userclk and userclk2 for each GTP datapath (TX and RX) must be phase aligned to 
    --   avoid data errors in the fabric interface whenever the datapath is wider than 10 bits
    -- * To minimize clock resources, you can share clocks between GTPs. GTPs using the same frequency
    --   or multiples of the same frequency can be accomadated using DCMs and PLLs. Use caution when
    --   using RXRECCLK as a clock source, however - these clocks can typically only be shared if all
    --   the channels using the clock are receiving data from TX channels that share a reference clock 
    --   source with each other.

    refclkout_pll0_bufg_i : BUFG
    port map
    (
        I                               =>      tile0_refclkout_i,
        O                               =>      tile0_refclkout_to_cmt_i
    );

    refclkout_pll0_reset_i                  <= not tile0_plllkdet_i;
    refclkout_pll0_i : MGT_USRCLK_SOURCE_PLL
    generic map
    (
        MULT                            =>      8,
        DIVIDE                          =>      1,
        CLK_PERIOD                      =>      13.333,
        OUT0_DIVIDE                     =>      2,
        OUT1_DIVIDE                     =>      1,
        OUT2_DIVIDE                     =>      1,
        OUT3_DIVIDE                     =>      1,
        SIMULATION_P                    =>      EXAMPLE_USE_CHIPSCOPE,
        LOCK_WAIT_COUNT                 =>      "0001110101001100"
    )
    port map
    (
        CLK0_OUT                        =>      tile0_txusrclk0_i,
        CLK1_OUT                        =>      open,
        CLK2_OUT                        =>      open,
        CLK3_OUT                        =>      open,
        CLK_IN                          =>      tile0_refclkout_to_cmt_i,
        PLL_LOCKED_OUT                  =>      refclkout_pll0_locked_i,
        PLL_RESET_IN                    =>      refclkout_pll0_reset_i
    );



    ----------------------------- The GTP Wrapper -----------------------------
    
    -- Use the instantiation template in the project directory to add the GTP wrapper to your design.
    -- In this example, the wrapper is wired up for basic operation with a frame generator and frame 
    -- checker. The GTPs will reset, then attempt to align and transmit data. If channel bonding is 
    -- enabled, bonding should occur after alignment.
    

    -- Wire all PLLLKDET signals to the top level as output ports
    TILE_0_1_2_3_PLLLKDET_OUT              <= tile0_plllkdet_i and tile1_plllkdet_i and tile2_plllkdet_i and tile3_plllkdet_i;

    -- Hold the TX in reset till the TX user clocks are stable
  
    tile0_txreset0_i                    <= not refclkout_pll0_locked_i;
  
    tile0_txreset1_i                    <= not refclkout_pll0_locked_i;
  
    tile1_txreset0_i                    <= not refclkout_pll0_locked_i;
  
    tile1_txreset1_i                    <= not refclkout_pll0_locked_i;
  
    tile2_txreset0_i                    <= not refclkout_pll0_locked_i;
  
    tile2_txreset1_i                    <= not refclkout_pll0_locked_i;
  
    tile3_txreset0_i                    <= not refclkout_pll0_locked_i;
  
    tile3_txreset1_i                    <= not refclkout_pll0_locked_i;

    -- Hold the RX in reset till the RX user clocks are stable
  
    tile0_rxreset0_i                    <= not refclkout_pll0_locked_i;
  
    tile0_rxreset1_i                    <= not refclkout_pll0_locked_i;
  
    tile1_rxreset0_i                    <= not refclkout_pll0_locked_i;
  
    tile1_rxreset1_i                    <= not refclkout_pll0_locked_i;
  
    tile2_rxreset0_i                    <= not refclkout_pll0_locked_i;
  
    tile2_rxreset1_i                    <= not refclkout_pll0_locked_i;
  
    tile3_rxreset0_i                    <= not refclkout_pll0_locked_i;
  
    tile3_rxreset1_i                    <= not refclkout_pll0_locked_i;

    loop_test_i : LOOP_TEST
    generic map
    (
        WRAPPER_SIM_MODE                =>      EXAMPLE_SIM_MODE,   
        WRAPPER_SIM_GTPRESET_SPEEDUP    =>      EXAMPLE_SIM_GTPRESET_SPEEDUP,
        WRAPPER_SIM_PLL_PERDIV2         =>      EXAMPLE_SIM_PLL_PERDIV2
    )
    port map
    (
    
 
 
 
 

 
 
 
 

        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE0  (X0Y2)

        ------------------------ Loopback and Powerdown Ports ----------------------
		  TILE0_PLLPOWERDOWN_IN           =>      POWERDOWN,
        TILE0_RXPOWERDOWN0_IN           =>      powerdown_i,
        TILE0_RXPOWERDOWN1_IN           =>      powerdown_i,
        TILE0_TXPOWERDOWN0_IN           =>      powerdown_i,
        TILE0_TXPOWERDOWN1_IN           =>      powerdown_i,
        ----------------------- Receive Ports - 8b10b Decoder ----------------------
        TILE0_RXCHARISCOMMA0_OUT        =>      tile0_rxchariscomma0_i,
        TILE0_RXCHARISCOMMA1_OUT        =>      tile0_rxchariscomma1_i,
        TILE0_RXCHARISK0_OUT            =>      tile0_rxcharisk0_i,
        TILE0_RXCHARISK1_OUT            =>      tile0_rxcharisk1_i,
        TILE0_RXDISPERR0_OUT            =>      tile0_rxdisperr0_i,
        TILE0_RXDISPERR1_OUT            =>      tile0_rxdisperr1_i,
        TILE0_RXNOTINTABLE0_OUT         =>      tile0_rxnotintable0_i,
        TILE0_RXNOTINTABLE1_OUT         =>      tile0_rxnotintable1_i,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        TILE0_RXCLKCORCNT0_OUT          =>      tile0_rxclkcorcnt0_i,
        TILE0_RXCLKCORCNT1_OUT          =>      tile0_rxclkcorcnt1_i,
        --------------- Receive Ports - Comma Detection and Alignment --------------
        TILE0_RXENMCOMMAALIGN0_IN       =>      tile0_rxenmcommaalign0_i,
        TILE0_RXENMCOMMAALIGN1_IN       =>      tile0_rxenmcommaalign1_i,
        TILE0_RXENPCOMMAALIGN0_IN       =>      tile0_rxenpcommaalign0_i,
        TILE0_RXENPCOMMAALIGN1_IN       =>      tile0_rxenpcommaalign1_i,
        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE0_RXDATA0_OUT               =>      tile0_rxdata0_i,
        TILE0_RXDATA1_OUT               =>      tile0_rxdata1_i,
        TILE0_RXRECCLK0_OUT             =>      tile0_rxrecclk0_i,
        TILE0_RXRECCLK1_OUT             =>      tile0_rxrecclk1_i,
        TILE0_RXRESET0_IN               =>      tile3_rxreset0_i,
        TILE0_RXRESET1_IN               =>      tile3_rxreset1_i,
        TILE0_RXUSRCLK0_IN              =>      tile0_txusrclk0_i,
        TILE0_RXUSRCLK1_IN              =>      tile0_txusrclk0_i,
        TILE0_RXUSRCLK20_IN             =>      tile0_txusrclk0_i,
        TILE0_RXUSRCLK21_IN             =>      tile0_txusrclk0_i,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE0_RXCDRRESET0_IN            =>      tile0_rxcdrreset0_i,
        TILE0_RXCDRRESET1_IN            =>      tile0_rxcdrreset1_i,
        TILE0_RXELECIDLE0_OUT           =>      tile0_rxelecidle0_i,
        TILE0_RXELECIDLE1_OUT           =>      tile0_rxelecidle1_i,
        TILE0_RXEQMIX0_IN               =>      tile0_rxeqmix0_i,
        TILE0_RXEQMIX1_IN               =>      tile0_rxeqmix1_i,
        TILE0_RXEQPOLE0_IN              =>      tile0_rxeqpole0_i,
        TILE0_RXEQPOLE1_IN              =>      tile0_rxeqpole1_i,
        TILE0_RXN0_IN                   =>      RXN_IN(0),
        TILE0_RXN1_IN                   =>      RXN_IN(1),
        TILE0_RXP0_IN                   =>      RXP_IN(0),
        TILE0_RXP1_IN                   =>      RXP_IN(1),
        -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
        TILE0_RXBUFRESET0_IN            =>      tile0_rxbufreset0_i,
        TILE0_RXBUFRESET1_IN            =>      tile0_rxbufreset1_i,
        TILE0_RXSTATUS0_OUT             =>      tile0_rxstatus0_i,
        TILE0_RXSTATUS1_OUT             =>      tile0_rxstatus1_i,
        --------------------- Shared Ports - Tile and PLL Ports --------------------
        TILE0_CLKIN_IN                  =>      tile2_refclk_i,
        TILE0_GTPRESET_IN               =>      tile0_gtpreset_i,
        TILE0_PLLLKDET_OUT              =>      tile0_plllkdet_i,
        TILE0_REFCLKOUT_OUT             =>      tile0_refclkout_i,
        TILE0_RESETDONE0_OUT            =>      tile0_resetdone0_i,
        TILE0_RESETDONE1_OUT            =>      tile0_resetdone1_i,
        ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
        TILE0_TXCHARISK0_IN             =>      tile0_txcharisk0_i,
        TILE0_TXCHARISK1_IN             =>      tile0_txcharisk1_i,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE0_TXDATA0_IN                =>      tile0_txdata0_i,
        TILE0_TXDATA1_IN                =>      tile0_txdata1_i,
        TILE0_TXOUTCLK0_OUT             =>      tile0_txoutclk0_i,
        TILE0_TXOUTCLK1_OUT             =>      tile0_txoutclk1_i,
        TILE0_TXRESET0_IN               =>      tile3_txreset0_i,
        TILE0_TXRESET1_IN               =>      tile3_txreset1_i,
        TILE0_TXUSRCLK0_IN              =>      tile0_txusrclk0_i,
        TILE0_TXUSRCLK1_IN              =>      tile0_txusrclk0_i,
        TILE0_TXUSRCLK20_IN             =>      tile0_txusrclk0_i,
        TILE0_TXUSRCLK21_IN             =>      tile0_txusrclk0_i,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE0_TXDIFFCTRL0_IN            =>      tile0_txdiffctrl0_i,
        TILE0_TXDIFFCTRL1_IN            =>      tile0_txdiffctrl1_i,
        TILE0_TXN0_OUT                  =>      TXN_OUT(0),
        TILE0_TXN1_OUT                  =>      TXN_OUT(1),
        TILE0_TXP0_OUT                  =>      TXP_OUT(0),
        TILE0_TXP1_OUT                  =>      TXP_OUT(1),
        ----------------- Transmit Ports - TX Ports for PCI Express ----------------
        TILE0_TXELECIDLE0_IN            =>      powerdown,
        TILE0_TXELECIDLE1_IN            =>      powerdown,
        --------------------- Transmit Ports - TX Ports for SATA -------------------
        TILE0_TXCOMSTART0_IN            =>      tile0_txcomstart0_i,
        TILE0_TXCOMSTART1_IN            =>      tile0_txcomstart1_i,
        TILE0_TXCOMTYPE0_IN             =>      tile0_txcomtype0_i,
        TILE0_TXCOMTYPE1_IN             =>      tile0_txcomtype1_i,


    
 
 
 
 

 
 
 
 

        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE1  (X0Y3)

        ------------------------ Loopback and Powerdown Ports ----------------------
		  TILE1_PLLPOWERDOWN_IN           =>      POWERDOWN,
        TILE1_RXPOWERDOWN0_IN           =>      powerdown_i,
        TILE1_RXPOWERDOWN1_IN           =>      powerdown_i,
        TILE1_TXPOWERDOWN0_IN           =>      powerdown_i,
        TILE1_TXPOWERDOWN1_IN           =>      powerdown_i,
        ----------------------- Receive Ports - 8b10b Decoder ----------------------
        TILE1_RXCHARISCOMMA0_OUT        =>      tile1_rxchariscomma0_i,
        TILE1_RXCHARISCOMMA1_OUT        =>      tile1_rxchariscomma1_i,
        TILE1_RXCHARISK0_OUT            =>      tile1_rxcharisk0_i,
        TILE1_RXCHARISK1_OUT            =>      tile1_rxcharisk1_i,
        TILE1_RXDISPERR0_OUT            =>      tile1_rxdisperr0_i,
        TILE1_RXDISPERR1_OUT            =>      tile1_rxdisperr1_i,
        TILE1_RXNOTINTABLE0_OUT         =>      tile1_rxnotintable0_i,
        TILE1_RXNOTINTABLE1_OUT         =>      tile1_rxnotintable1_i,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        TILE1_RXCLKCORCNT0_OUT          =>      tile1_rxclkcorcnt0_i,
        TILE1_RXCLKCORCNT1_OUT          =>      tile1_rxclkcorcnt1_i,
        --------------- Receive Ports - Comma Detection and Alignment --------------
        TILE1_RXENMCOMMAALIGN0_IN       =>      tile1_rxenmcommaalign0_i,
        TILE1_RXENMCOMMAALIGN1_IN       =>      tile1_rxenmcommaalign1_i,
        TILE1_RXENPCOMMAALIGN0_IN       =>      tile1_rxenpcommaalign0_i,
        TILE1_RXENPCOMMAALIGN1_IN       =>      tile1_rxenpcommaalign1_i,
        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE1_RXDATA0_OUT               =>      tile1_rxdata0_i,
        TILE1_RXDATA1_OUT               =>      tile1_rxdata1_i,
        TILE1_RXRECCLK0_OUT             =>      tile1_rxrecclk0_i,
        TILE1_RXRECCLK1_OUT             =>      tile1_rxrecclk1_i,
        TILE1_RXRESET0_IN               =>      tile3_rxreset0_i,
        TILE1_RXRESET1_IN               =>      tile3_rxreset1_i,
        TILE1_RXUSRCLK0_IN              =>      tile0_txusrclk0_i,
        TILE1_RXUSRCLK1_IN              =>      tile0_txusrclk0_i,
        TILE1_RXUSRCLK20_IN             =>      tile0_txusrclk0_i,
        TILE1_RXUSRCLK21_IN             =>      tile0_txusrclk0_i,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE1_RXCDRRESET0_IN            =>      tile1_rxcdrreset0_i,
        TILE1_RXCDRRESET1_IN            =>      tile1_rxcdrreset1_i,
        TILE1_RXELECIDLE0_OUT           =>      tile1_rxelecidle0_i,
        TILE1_RXELECIDLE1_OUT           =>      tile1_rxelecidle1_i,
        TILE1_RXEQMIX0_IN               =>      tile1_rxeqmix0_i,
        TILE1_RXEQMIX1_IN               =>      tile1_rxeqmix1_i,
        TILE1_RXEQPOLE0_IN              =>      tile1_rxeqpole0_i,
        TILE1_RXEQPOLE1_IN              =>      tile1_rxeqpole1_i,
        TILE1_RXN0_IN                   =>      RXN_IN(2),
        TILE1_RXN1_IN                   =>      RXN_IN(3),
        TILE1_RXP0_IN                   =>      RXP_IN(2),
        TILE1_RXP1_IN                   =>      RXP_IN(3),
        -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
        TILE1_RXBUFRESET0_IN            =>      tile1_rxbufreset0_i,
        TILE1_RXBUFRESET1_IN            =>      tile1_rxbufreset1_i,
        TILE1_RXSTATUS0_OUT             =>      tile1_rxstatus0_i,
        TILE1_RXSTATUS1_OUT             =>      tile1_rxstatus1_i,
        --------------------- Shared Ports - Tile and PLL Ports --------------------
        TILE1_CLKIN_IN                  =>      tile2_refclk_i,
        TILE1_GTPRESET_IN               =>      tile1_gtpreset_i,
        TILE1_PLLLKDET_OUT              =>      tile1_plllkdet_i,
        TILE1_REFCLKOUT_OUT             =>      tile1_refclkout_i,
        TILE1_RESETDONE0_OUT            =>      tile1_resetdone0_i,
        TILE1_RESETDONE1_OUT            =>      tile1_resetdone1_i,
        ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
        TILE1_TXCHARISK0_IN             =>      tile1_txcharisk0_i,
        TILE1_TXCHARISK1_IN             =>      tile1_txcharisk1_i,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE1_TXDATA0_IN                =>      tile1_txdata0_i,
        TILE1_TXDATA1_IN                =>      tile1_txdata1_i,
        TILE1_TXOUTCLK0_OUT             =>      tile1_txoutclk0_i,
        TILE1_TXOUTCLK1_OUT             =>      tile1_txoutclk1_i,
        TILE1_TXRESET0_IN               =>      tile3_txreset0_i,
        TILE1_TXRESET1_IN               =>      tile3_txreset1_i,
        TILE1_TXUSRCLK0_IN              =>      tile0_txusrclk0_i,
        TILE1_TXUSRCLK1_IN              =>      tile0_txusrclk0_i,
        TILE1_TXUSRCLK20_IN             =>      tile0_txusrclk0_i,
        TILE1_TXUSRCLK21_IN             =>      tile0_txusrclk0_i,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE1_TXDIFFCTRL0_IN            =>      tile1_txdiffctrl0_i,
        TILE1_TXDIFFCTRL1_IN            =>      tile1_txdiffctrl1_i,
        TILE1_TXN0_OUT                  =>      TXN_OUT(2),
        TILE1_TXN1_OUT                  =>      TXN_OUT(3),
        TILE1_TXP0_OUT                  =>      TXP_OUT(2),
        TILE1_TXP1_OUT                  =>      TXP_OUT(3),
        ----------------- Transmit Ports - TX Ports for PCI Express ----------------
        TILE1_TXELECIDLE0_IN            =>      powerdown,
        TILE1_TXELECIDLE1_IN            =>      powerdown,
        --------------------- Transmit Ports - TX Ports for SATA -------------------
        TILE1_TXCOMSTART0_IN            =>      tile1_txcomstart0_i,
        TILE1_TXCOMSTART1_IN            =>      tile1_txcomstart1_i,
        TILE1_TXCOMTYPE0_IN             =>      tile1_txcomtype0_i,
        TILE1_TXCOMTYPE1_IN             =>      tile1_txcomtype1_i,


    
 
 
 
 

 
 
 
 

        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE2  (X0Y4)

        ------------------------ Loopback and Powerdown Ports ----------------------
		  TILE2_PLLPOWERDOWN_IN           =>      POWERDOWN,
        TILE2_RXPOWERDOWN0_IN           =>      powerdown_i,
        TILE2_RXPOWERDOWN1_IN           =>      powerdown_i,
        TILE2_TXPOWERDOWN0_IN           =>      powerdown_i,
        TILE2_TXPOWERDOWN1_IN           =>      powerdown_i,
        ----------------------- Receive Ports - 8b10b Decoder ----------------------
        TILE2_RXCHARISCOMMA0_OUT        =>      tile2_rxchariscomma0_i,
        TILE2_RXCHARISCOMMA1_OUT        =>      tile2_rxchariscomma1_i,
        TILE2_RXCHARISK0_OUT            =>      tile2_rxcharisk0_i,
        TILE2_RXCHARISK1_OUT            =>      tile2_rxcharisk1_i,
        TILE2_RXDISPERR0_OUT            =>      tile2_rxdisperr0_i,
        TILE2_RXDISPERR1_OUT            =>      tile2_rxdisperr1_i,
        TILE2_RXNOTINTABLE0_OUT         =>      tile2_rxnotintable0_i,
        TILE2_RXNOTINTABLE1_OUT         =>      tile2_rxnotintable1_i,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        TILE2_RXCLKCORCNT0_OUT          =>      tile2_rxclkcorcnt0_i,
        TILE2_RXCLKCORCNT1_OUT          =>      tile2_rxclkcorcnt1_i,
        --------------- Receive Ports - Comma Detection and Alignment --------------
        TILE2_RXENMCOMMAALIGN0_IN       =>      tile2_rxenmcommaalign0_i,
        TILE2_RXENMCOMMAALIGN1_IN       =>      tile2_rxenmcommaalign1_i,
        TILE2_RXENPCOMMAALIGN0_IN       =>      tile2_rxenpcommaalign0_i,
        TILE2_RXENPCOMMAALIGN1_IN       =>      tile2_rxenpcommaalign1_i,
        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE2_RXDATA0_OUT               =>      tile2_rxdata0_i,
        TILE2_RXDATA1_OUT               =>      tile2_rxdata1_i,
        TILE2_RXRECCLK0_OUT             =>      tile2_rxrecclk0_i,
        TILE2_RXRECCLK1_OUT             =>      tile2_rxrecclk1_i,
        TILE2_RXRESET0_IN               =>      tile3_rxreset0_i,
        TILE2_RXRESET1_IN               =>      tile3_rxreset1_i,
        TILE2_RXUSRCLK0_IN              =>      tile0_txusrclk0_i,
        TILE2_RXUSRCLK1_IN              =>      tile0_txusrclk0_i,
        TILE2_RXUSRCLK20_IN             =>      tile0_txusrclk0_i,
        TILE2_RXUSRCLK21_IN             =>      tile0_txusrclk0_i,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE2_RXCDRRESET0_IN            =>      tile2_rxcdrreset0_i,
        TILE2_RXCDRRESET1_IN            =>      tile2_rxcdrreset1_i,
        TILE2_RXELECIDLE0_OUT           =>      tile2_rxelecidle0_i,
        TILE2_RXELECIDLE1_OUT           =>      tile2_rxelecidle1_i,
        TILE2_RXEQMIX0_IN               =>      tile2_rxeqmix0_i,
        TILE2_RXEQMIX1_IN               =>      tile2_rxeqmix1_i,
        TILE2_RXEQPOLE0_IN              =>      tile2_rxeqpole0_i,
        TILE2_RXEQPOLE1_IN              =>      tile2_rxeqpole1_i,
        TILE2_RXN0_IN                   =>      RXN_IN(4),
        TILE2_RXN1_IN                   =>      RXN_IN(5),
        TILE2_RXP0_IN                   =>      RXP_IN(4),
        TILE2_RXP1_IN                   =>      RXP_IN(5),
        -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
        TILE2_RXBUFRESET0_IN            =>      tile2_rxbufreset0_i,
        TILE2_RXBUFRESET1_IN            =>      tile2_rxbufreset1_i,
        TILE2_RXSTATUS0_OUT             =>      tile2_rxstatus0_i,
        TILE2_RXSTATUS1_OUT             =>      tile2_rxstatus1_i,
        --------------------- Shared Ports - Tile and PLL Ports --------------------
        TILE2_CLKIN_IN                  =>      tile2_refclk_i,
        TILE2_GTPRESET_IN               =>      tile2_gtpreset_i,
        TILE2_PLLLKDET_OUT              =>      tile2_plllkdet_i,
        TILE2_REFCLKOUT_OUT             =>      tile2_refclkout_i,
        TILE2_RESETDONE0_OUT            =>      tile2_resetdone0_i,
        TILE2_RESETDONE1_OUT            =>      tile2_resetdone1_i,
        ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
        TILE2_TXCHARISK0_IN             =>      tile2_txcharisk0_i,
        TILE2_TXCHARISK1_IN             =>      tile2_txcharisk1_i,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE2_TXDATA0_IN                =>      tile2_txdata0_i,
        TILE2_TXDATA1_IN                =>      tile2_txdata1_i,
        TILE2_TXOUTCLK0_OUT             =>      tile2_txoutclk0_i,
        TILE2_TXOUTCLK1_OUT             =>      tile2_txoutclk1_i,
        TILE2_TXRESET0_IN               =>      tile3_txreset0_i,
        TILE2_TXRESET1_IN               =>      tile3_txreset1_i,
        TILE2_TXUSRCLK0_IN              =>      tile0_txusrclk0_i,
        TILE2_TXUSRCLK1_IN              =>      tile0_txusrclk0_i,
        TILE2_TXUSRCLK20_IN             =>      tile0_txusrclk0_i,
        TILE2_TXUSRCLK21_IN             =>      tile0_txusrclk0_i,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE2_TXDIFFCTRL0_IN            =>      tile2_txdiffctrl0_i,
        TILE2_TXDIFFCTRL1_IN            =>      tile2_txdiffctrl1_i,
        TILE2_TXN0_OUT                  =>      TXN_OUT(4),
        TILE2_TXN1_OUT                  =>      TXN_OUT(5),
        TILE2_TXP0_OUT                  =>      TXP_OUT(4),
        TILE2_TXP1_OUT                  =>      TXP_OUT(5),
        ----------------- Transmit Ports - TX Ports for PCI Express ----------------
        TILE2_TXELECIDLE0_IN            =>      powerdown,
        TILE2_TXELECIDLE1_IN            =>      powerdown,
        --------------------- Transmit Ports - TX Ports for SATA -------------------
        TILE2_TXCOMSTART0_IN            =>      tile2_txcomstart0_i,
        TILE2_TXCOMSTART1_IN            =>      tile2_txcomstart1_i,
        TILE2_TXCOMTYPE0_IN             =>      tile2_txcomtype0_i,
        TILE2_TXCOMTYPE1_IN             =>      tile2_txcomtype1_i,


    
 
 
 
 

 
 
 
 

        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE3  (X0Y5)

        ------------------------ Loopback and Powerdown Ports ----------------------
		  TILE3_PLLPOWERDOWN_IN           =>      POWERDOWN,
        TILE3_RXPOWERDOWN0_IN           =>      powerdown_i,
        TILE3_RXPOWERDOWN1_IN           =>      powerdown_i,
        TILE3_TXPOWERDOWN0_IN           =>      powerdown_i,
        TILE3_TXPOWERDOWN1_IN           =>      powerdown_i,
        ----------------------- Receive Ports - 8b10b Decoder ----------------------
        TILE3_RXCHARISCOMMA0_OUT        =>      tile3_rxchariscomma0_i,
        TILE3_RXCHARISCOMMA1_OUT        =>      tile3_rxchariscomma1_i,
        TILE3_RXCHARISK0_OUT            =>      tile3_rxcharisk0_i,
        TILE3_RXCHARISK1_OUT            =>      tile3_rxcharisk1_i,
        TILE3_RXDISPERR0_OUT            =>      tile3_rxdisperr0_i,
        TILE3_RXDISPERR1_OUT            =>      tile3_rxdisperr1_i,
        TILE3_RXNOTINTABLE0_OUT         =>      tile3_rxnotintable0_i,
        TILE3_RXNOTINTABLE1_OUT         =>      tile3_rxnotintable1_i,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        TILE3_RXCLKCORCNT0_OUT          =>      tile3_rxclkcorcnt0_i,
        TILE3_RXCLKCORCNT1_OUT          =>      tile3_rxclkcorcnt1_i,
        --------------- Receive Ports - Comma Detection and Alignment --------------
        TILE3_RXENMCOMMAALIGN0_IN       =>      tile3_rxenmcommaalign0_i,
        TILE3_RXENMCOMMAALIGN1_IN       =>      tile3_rxenmcommaalign1_i,
        TILE3_RXENPCOMMAALIGN0_IN       =>      tile3_rxenpcommaalign0_i,
        TILE3_RXENPCOMMAALIGN1_IN       =>      tile3_rxenpcommaalign1_i,
        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE3_RXDATA0_OUT               =>      tile3_rxdata0_i,
        TILE3_RXDATA1_OUT               =>      tile3_rxdata1_i,
        TILE3_RXRECCLK0_OUT             =>      tile3_rxrecclk0_i,
        TILE3_RXRECCLK1_OUT             =>      tile3_rxrecclk1_i,
        TILE3_RXRESET0_IN               =>      tile3_rxreset0_i,
        TILE3_RXRESET1_IN               =>      tile3_rxreset1_i,
        TILE3_RXUSRCLK0_IN              =>      tile0_txusrclk0_i,
        TILE3_RXUSRCLK1_IN              =>      tile0_txusrclk0_i,
        TILE3_RXUSRCLK20_IN             =>      tile0_txusrclk0_i,
        TILE3_RXUSRCLK21_IN             =>      tile0_txusrclk0_i,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE3_RXCDRRESET0_IN            =>      tile3_rxcdrreset0_i,
        TILE3_RXCDRRESET1_IN            =>      tile3_rxcdrreset1_i,
        TILE3_RXELECIDLE0_OUT           =>      tile3_rxelecidle0_i,
        TILE3_RXELECIDLE1_OUT           =>      tile3_rxelecidle1_i,
        TILE3_RXEQMIX0_IN               =>      tile3_rxeqmix0_i,
        TILE3_RXEQMIX1_IN               =>      tile3_rxeqmix1_i,
        TILE3_RXEQPOLE0_IN              =>      tile3_rxeqpole0_i,
        TILE3_RXEQPOLE1_IN              =>      tile3_rxeqpole1_i,
        TILE3_RXN0_IN                   =>      RXN_IN(6),
        TILE3_RXN1_IN                   =>      RXN_IN(7),
        TILE3_RXP0_IN                   =>      RXP_IN(6),
        TILE3_RXP1_IN                   =>      RXP_IN(7),
        -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
        TILE3_RXBUFRESET0_IN            =>      tile3_rxbufreset0_i,
        TILE3_RXBUFRESET1_IN            =>      tile3_rxbufreset1_i,
        TILE3_RXSTATUS0_OUT             =>      tile3_rxstatus0_i,
        TILE3_RXSTATUS1_OUT             =>      tile3_rxstatus1_i,
        --------------------- Shared Ports - Tile and PLL Ports --------------------
        TILE3_CLKIN_IN                  =>      tile2_refclk_i,
        TILE3_GTPRESET_IN               =>      tile3_gtpreset_i,
        TILE3_PLLLKDET_OUT              =>      tile3_plllkdet_i,
        TILE3_REFCLKOUT_OUT             =>      tile3_refclkout_i,
        TILE3_RESETDONE0_OUT            =>      tile3_resetdone0_i,
        TILE3_RESETDONE1_OUT            =>      tile3_resetdone1_i,
        ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
        TILE3_TXCHARISK0_IN             =>      tile3_txcharisk0_i,
        TILE3_TXCHARISK1_IN             =>      tile3_txcharisk1_i,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE3_TXDATA0_IN                =>      tile3_txdata0_i,
        TILE3_TXDATA1_IN                =>      tile3_txdata1_i,
        TILE3_TXOUTCLK0_OUT             =>      tile3_txoutclk0_i,
        TILE3_TXOUTCLK1_OUT             =>      tile3_txoutclk1_i,
        TILE3_TXRESET0_IN               =>      tile3_txreset0_i,
        TILE3_TXRESET1_IN               =>      tile3_txreset1_i,
        TILE3_TXUSRCLK0_IN              =>      tile0_txusrclk0_i,
        TILE3_TXUSRCLK1_IN              =>      tile0_txusrclk0_i,
        TILE3_TXUSRCLK20_IN             =>      tile0_txusrclk0_i,
        TILE3_TXUSRCLK21_IN             =>      tile0_txusrclk0_i,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE3_TXDIFFCTRL0_IN            =>      tile3_txdiffctrl0_i,
        TILE3_TXDIFFCTRL1_IN            =>      tile3_txdiffctrl1_i,
        TILE3_TXN0_OUT                  =>      TXN_OUT(6),
        TILE3_TXN1_OUT                  =>      TXN_OUT(7),
        TILE3_TXP0_OUT                  =>      TXP_OUT(6),
        TILE3_TXP1_OUT                  =>      TXP_OUT(7),
        ----------------- Transmit Ports - TX Ports for PCI Express ----------------
        TILE3_TXELECIDLE0_IN            =>      powerdown,
        TILE3_TXELECIDLE1_IN            =>      powerdown,
        --------------------- Transmit Ports - TX Ports for SATA -------------------
        TILE3_TXCOMSTART0_IN            =>      tile3_txcomstart0_i,
        TILE3_TXCOMSTART1_IN            =>      tile3_txcomstart1_i,
        TILE3_TXCOMTYPE0_IN             =>      tile3_txcomtype0_i,
        TILE3_TXCOMTYPE1_IN             =>      tile3_txcomtype1_i


    );






    -------------------------- User Module Resets -----------------------------
    -- All the User Modules i.e. FRAME_GEN, FRAME_CHECK and the sync modules
    -- are held in reset till the RESETDONE goes high. 
    -- The RESETDONE is registered a couple of times on USRCLK2 and connected 
    -- to the reset of the modules
    
    process( tile0_txusrclk0_i,tile0_resetdone0_i)
    begin
        if(tile0_resetdone0_i = '0') then
            tile0_rx_resetdone0_r  <= '0'   after DLY;
            tile0_rx_resetdone0_r2 <= '0'   after DLY;
        elsif(tile0_txusrclk0_i'event and tile0_txusrclk0_i = '1') then
            tile0_rx_resetdone0_r  <= tile0_resetdone0_i   after DLY;
            tile0_rx_resetdone0_r2 <= tile0_rx_resetdone0_r   after DLY;
        end if;
    end process;
    
    process( tile0_txusrclk0_i,tile0_resetdone1_i)
    begin
        if(tile0_resetdone1_i = '0') then
            tile0_rx_resetdone1_r  <= '0'   after DLY;
            tile0_rx_resetdone1_r2 <= '0'   after DLY;
        elsif(tile0_txusrclk0_i'event and tile0_txusrclk0_i = '1') then
            tile0_rx_resetdone1_r  <= tile0_resetdone1_i   after DLY;
            tile0_rx_resetdone1_r2 <= tile0_rx_resetdone1_r   after DLY;
        end if;
    end process;
    
    process( tile0_txusrclk0_i,tile1_resetdone0_i)
    begin
        if(tile1_resetdone0_i = '0') then
            tile1_rx_resetdone0_r  <= '0'   after DLY;
            tile1_rx_resetdone0_r2 <= '0'   after DLY;
        elsif(tile0_txusrclk0_i'event and tile0_txusrclk0_i = '1') then
            tile1_rx_resetdone0_r  <= tile1_resetdone0_i   after DLY;
            tile1_rx_resetdone0_r2 <= tile1_rx_resetdone0_r   after DLY;
        end if;
    end process;
    
    process( tile0_txusrclk0_i,tile1_resetdone1_i)
    begin
        if(tile1_resetdone1_i = '0') then
            tile1_rx_resetdone1_r  <= '0'   after DLY;
            tile1_rx_resetdone1_r2 <= '0'   after DLY;
        elsif(tile0_txusrclk0_i'event and tile0_txusrclk0_i = '1') then
            tile1_rx_resetdone1_r  <= tile1_resetdone1_i   after DLY;
            tile1_rx_resetdone1_r2 <= tile1_rx_resetdone1_r   after DLY;
        end if;
    end process;
    
    process( tile0_txusrclk0_i,tile2_resetdone0_i)
    begin
        if(tile2_resetdone0_i = '0') then
            tile2_rx_resetdone0_r  <= '0'   after DLY;
            tile2_rx_resetdone0_r2 <= '0'   after DLY;
        elsif(tile0_txusrclk0_i'event and tile0_txusrclk0_i = '1') then
            tile2_rx_resetdone0_r  <= tile2_resetdone0_i   after DLY;
            tile2_rx_resetdone0_r2 <= tile2_rx_resetdone0_r   after DLY;
        end if;
    end process;
    
    process( tile0_txusrclk0_i,tile2_resetdone1_i)
    begin
        if(tile2_resetdone1_i = '0') then
            tile2_rx_resetdone1_r  <= '0'   after DLY;
            tile2_rx_resetdone1_r2 <= '0'   after DLY;
        elsif(tile0_txusrclk0_i'event and tile0_txusrclk0_i = '1') then
            tile2_rx_resetdone1_r  <= tile2_resetdone1_i   after DLY;
            tile2_rx_resetdone1_r2 <= tile2_rx_resetdone1_r   after DLY;
        end if;
    end process;
    
    process( tile0_txusrclk0_i,tile3_resetdone0_i)
    begin
        if(tile3_resetdone0_i = '0') then
            tile3_rx_resetdone0_r  <= '0'   after DLY;
            tile3_rx_resetdone0_r2 <= '0'   after DLY;
        elsif(tile0_txusrclk0_i'event and tile0_txusrclk0_i = '1') then
            tile3_rx_resetdone0_r  <= tile3_resetdone0_i   after DLY;
            tile3_rx_resetdone0_r2 <= tile3_rx_resetdone0_r   after DLY;
        end if;
    end process;
    process( tile0_txusrclk0_i,tile3_resetdone1_i)
    begin
        if(tile3_resetdone1_i = '0') then
            tile3_rx_resetdone1_r  <= '0'   after DLY;
            tile3_rx_resetdone1_r2 <= '0'   after DLY;
        elsif(tile0_txusrclk0_i'event and tile0_txusrclk0_i = '1') then
            tile3_rx_resetdone1_r  <= tile3_resetdone1_i   after DLY;
            tile3_rx_resetdone1_r2 <= tile3_rx_resetdone1_r   after DLY;
        end if;
    end process;
    
    process( tile0_txusrclk0_i,tile0_resetdone0_i)
    begin
        if (tile0_resetdone0_i = '0') then 
            tile0_tx_resetdone0_r    <=   '0'	after DLY ;
            tile0_tx_resetdone0_r2   <=   '0'	after DLY ;
        elsif(tile0_txusrclk0_i'event and tile0_txusrclk0_i = '1') then
            tile0_tx_resetdone0_r    <=   tile0_resetdone0_i	after DLY;
            tile0_tx_resetdone0_r2   <=   tile0_tx_resetdone0_r	after DLY;
        end if;
    end process; 
    process( tile0_txusrclk0_i,tile0_resetdone1_i)
    begin
        if (tile0_resetdone1_i = '0') then 
            tile0_tx_resetdone1_r    <=   '0'	after DLY ;
            tile0_tx_resetdone1_r2   <=   '0'	after DLY ;
        elsif(tile0_txusrclk0_i'event and tile0_txusrclk0_i = '1') then
            tile0_tx_resetdone1_r    <=   tile0_resetdone1_i	after DLY;
            tile0_tx_resetdone1_r2   <=   tile0_tx_resetdone1_r	after DLY;
        end if;
    end process; 
    process( tile0_txusrclk0_i,tile1_resetdone0_i)
    begin
        if (tile1_resetdone0_i = '0') then 
            tile1_tx_resetdone0_r    <=   '0'	after DLY ;
            tile1_tx_resetdone0_r2   <=   '0'	after DLY ;
        elsif(tile0_txusrclk0_i'event and tile0_txusrclk0_i = '1') then
            tile1_tx_resetdone0_r    <=   tile1_resetdone0_i	after DLY;
            tile1_tx_resetdone0_r2   <=   tile1_tx_resetdone0_r	after DLY;
        end if;
    end process; 
    process( tile0_txusrclk0_i,tile1_resetdone1_i)
    begin
        if (tile1_resetdone1_i = '0') then 
            tile1_tx_resetdone1_r    <=   '0'	after DLY ;
            tile1_tx_resetdone1_r2   <=   '0'	after DLY ;
        elsif(tile0_txusrclk0_i'event and tile0_txusrclk0_i = '1') then
            tile1_tx_resetdone1_r    <=   tile1_resetdone1_i	after DLY;
            tile1_tx_resetdone1_r2   <=   tile1_tx_resetdone1_r	after DLY;
        end if;
    end process; 
    process( tile0_txusrclk0_i,tile2_resetdone0_i)
    begin
        if (tile2_resetdone0_i = '0') then 
            tile2_tx_resetdone0_r    <=   '0'	after DLY ;
            tile2_tx_resetdone0_r2   <=   '0'	after DLY ;
        elsif(tile0_txusrclk0_i'event and tile0_txusrclk0_i = '1') then
            tile2_tx_resetdone0_r    <=   tile2_resetdone0_i	after DLY;
            tile2_tx_resetdone0_r2   <=   tile2_tx_resetdone0_r	after DLY;
        end if;
    end process; 
    process( tile0_txusrclk0_i,tile2_resetdone1_i)
    begin
        if (tile2_resetdone1_i = '0') then 
            tile2_tx_resetdone1_r    <=   '0'	after DLY ;
            tile2_tx_resetdone1_r2   <=   '0'	after DLY ;
        elsif(tile0_txusrclk0_i'event and tile0_txusrclk0_i = '1') then
            tile2_tx_resetdone1_r    <=   tile2_resetdone1_i	after DLY;
            tile2_tx_resetdone1_r2   <=   tile2_tx_resetdone1_r	after DLY;
        end if;
    end process; 
    process( tile0_txusrclk0_i,tile3_resetdone0_i)
    begin
        if (tile3_resetdone0_i = '0') then 
            tile3_tx_resetdone0_r    <=   '0'	after DLY ;
            tile3_tx_resetdone0_r2   <=   '0'	after DLY ;
        elsif(tile0_txusrclk0_i'event and tile0_txusrclk0_i = '1') then
            tile3_tx_resetdone0_r    <=   tile3_resetdone0_i	after DLY;
            tile3_tx_resetdone0_r2   <=   tile3_tx_resetdone0_r	after DLY;
        end if;
    end process; 
    process( tile0_txusrclk0_i,tile3_resetdone1_i)
    begin
        if (tile3_resetdone1_i = '0') then 
            tile3_tx_resetdone1_r    <=   '0'	after DLY ;
            tile3_tx_resetdone1_r2   <=   '0'	after DLY ;
        elsif(tile0_txusrclk0_i'event and tile0_txusrclk0_i = '1') then
            tile3_tx_resetdone1_r    <=   tile3_resetdone1_i	after DLY;
            tile3_tx_resetdone1_r2   <=   tile3_tx_resetdone1_r	after DLY;
        end if;
    end process; 
    



    ------------------------------ Frame Generators ---------------------------
    -- The example design uses Block RAM based frame generators to provide test
    -- data to the GTPs for transmission. By default the frame generators are 
    -- loaded with an incrementing data sequence that includes commas/alignment
    -- characters for alignment. If your protocol uses channel bonding, the 
    -- frame generator will also be preloaded with a channel bonding sequence.
    
    -- You can modify the data transmitted by changing the INIT values of the frame
    -- generator in this file. Pay careful attention to bit order and the spacing
    -- of your control and alignment characters.

    tile0_frame_gen0 : FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        MEM_00                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_01                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_02                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_03                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_04                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_05                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_06                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_07                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_08                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_09                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_0A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_0B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_0C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_0D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_0E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_0F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_10                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_11                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_12                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_13                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_14                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_15                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_16                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_17                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_18                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_19                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_1A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_1B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_1C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_1D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_1E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_1F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_20                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_21                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_22                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_23                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_24                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_25                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_26                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_27                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_28                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_29                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_2A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_2B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_2C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_2D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_2E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_2F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_30                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_31                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_32                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_33                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_34                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_35                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_36                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_37                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_38                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_39                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_3A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_3B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_3C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_3D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_3E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_3F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000000"
    )
    port map
    (
        -- User Interface
        TX_DATA(31 downto 8)            =>      tile0_txdata0_float_i,
        TX_DATA(7 downto 0)             =>      tile0_txdata0_i,
        TX_CHARISK(3 downto 1)          =>      tile0_txcharisk0_float_i,
        TX_CHARISK(0)                   =>      tile0_txcharisk0_i,
        -- System Interface
        USER_CLK                        =>      tile0_txusrclk0_i,
        SYSTEM_RESET                    =>      tile0_tx_system_reset0_c
    );
    
    tile0_frame_gen1 : FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        MEM_00                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_01                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_02                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_03                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_04                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_05                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_06                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_07                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_08                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_09                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_0A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_0B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_0C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_0D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_0E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_0F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_10                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_11                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_12                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_13                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_14                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_15                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_16                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_17                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_18                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_19                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_1A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_1B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_1C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_1D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_1E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_1F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_20                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_21                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_22                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_23                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_24                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_25                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_26                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_27                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_28                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_29                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_2A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_2B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_2C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_2D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_2E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_2F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_30                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_31                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_32                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_33                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_34                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_35                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_36                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_37                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_38                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_39                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_3A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_3B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_3C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_3D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_3E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_3F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000000"
    )
    port map
    (
        -- User Interface
        TX_DATA(31 downto 8)            =>      tile0_txdata1_float_i,
        TX_DATA(7 downto 0)             =>      tile0_txdata1_i,
        TX_CHARISK(3 downto 1)          =>      tile0_txcharisk1_float_i,
        TX_CHARISK(0)                   =>      tile0_txcharisk1_i,
        -- System Interface
        USER_CLK                        =>      tile0_txusrclk0_i,
        SYSTEM_RESET                    =>      tile0_tx_system_reset1_c
    );
    
    tile1_frame_gen0 : FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        MEM_00                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_01                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_02                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_03                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_04                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_05                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_06                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_07                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_08                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_09                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_0A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_0B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_0C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_0D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_0E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_0F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_10                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_11                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_12                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_13                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_14                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_15                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_16                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_17                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_18                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_19                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_1A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_1B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_1C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_1D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_1E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_1F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_20                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_21                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_22                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_23                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_24                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_25                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_26                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_27                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_28                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_29                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_2A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_2B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_2C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_2D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_2E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_2F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_30                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_31                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_32                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_33                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_34                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_35                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_36                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_37                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_38                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_39                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_3A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_3B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_3C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_3D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_3E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_3F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000000"
    )
    port map
    (
        -- User Interface
        TX_DATA(31 downto 8)            =>      tile1_txdata0_float_i,
        TX_DATA(7 downto 0)             =>      tile1_txdata0_i,
        TX_CHARISK(3 downto 1)          =>      tile1_txcharisk0_float_i,
        TX_CHARISK(0)                   =>      tile1_txcharisk0_i,
        -- System Interface
        USER_CLK                        =>      tile0_txusrclk0_i,
        SYSTEM_RESET                    =>      tile1_tx_system_reset0_c
    );
    
    tile1_frame_gen1 : FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        MEM_00                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_01                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_02                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_03                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_04                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_05                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_06                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_07                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_08                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_09                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_0A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_0B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_0C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_0D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_0E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_0F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_10                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_11                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_12                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_13                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_14                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_15                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_16                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_17                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_18                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_19                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_1A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_1B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_1C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_1D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_1E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_1F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_20                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_21                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_22                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_23                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_24                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_25                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_26                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_27                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_28                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_29                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_2A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_2B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_2C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_2D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_2E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_2F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_30                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_31                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_32                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_33                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_34                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_35                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_36                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_37                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_38                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_39                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_3A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_3B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_3C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_3D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_3E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_3F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000000"
    )
    port map
    (
        -- User Interface
        TX_DATA(31 downto 8)            =>      tile1_txdata1_float_i,
        TX_DATA(7 downto 0)             =>      tile1_txdata1_i,
        TX_CHARISK(3 downto 1)          =>      tile1_txcharisk1_float_i,
        TX_CHARISK(0)                   =>      tile1_txcharisk1_i,
        -- System Interface
        USER_CLK                        =>      tile0_txusrclk0_i,
        SYSTEM_RESET                    =>      tile1_tx_system_reset1_c
    );
    
    tile2_frame_gen0 : FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        MEM_00                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_01                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_02                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_03                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_04                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_05                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_06                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_07                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_08                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_09                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_0A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_0B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_0C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_0D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_0E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_0F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_10                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_11                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_12                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_13                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_14                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_15                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_16                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_17                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_18                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_19                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_1A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_1B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_1C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_1D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_1E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_1F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_20                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_21                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_22                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_23                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_24                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_25                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_26                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_27                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_28                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_29                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_2A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_2B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_2C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_2D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_2E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_2F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_30                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_31                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_32                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_33                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_34                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_35                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_36                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_37                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_38                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_39                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_3A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_3B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_3C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_3D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_3E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_3F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000000"
    )
    port map
    (
        -- User Interface
        TX_DATA(31 downto 8)            =>      tile2_txdata0_float_i,
        TX_DATA(7 downto 0)             =>      tile2_txdata0_i,
        TX_CHARISK(3 downto 1)          =>      tile2_txcharisk0_float_i,
        TX_CHARISK(0)                   =>      tile2_txcharisk0_i,
        -- System Interface
        USER_CLK                        =>      tile0_txusrclk0_i,
        SYSTEM_RESET                    =>      tile2_tx_system_reset0_c
    );
    
    tile2_frame_gen1 : FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        MEM_00                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_01                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_02                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_03                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_04                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_05                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_06                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_07                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_08                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_09                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_0A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_0B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_0C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_0D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_0E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_0F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_10                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_11                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_12                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_13                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_14                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_15                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_16                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_17                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_18                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_19                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_1A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_1B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_1C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_1D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_1E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_1F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_20                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_21                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_22                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_23                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_24                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_25                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_26                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_27                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_28                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_29                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_2A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_2B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_2C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_2D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_2E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_2F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_30                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_31                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_32                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_33                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_34                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_35                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_36                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_37                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_38                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_39                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_3A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_3B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_3C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_3D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_3E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_3F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000000"
    )
    port map
    (
        -- User Interface
        TX_DATA(31 downto 8)            =>      tile2_txdata1_float_i,
        TX_DATA(7 downto 0)             =>      tile2_txdata1_i,
        TX_CHARISK(3 downto 1)          =>      tile2_txcharisk1_float_i,
        TX_CHARISK(0)                   =>      tile2_txcharisk1_i,
        -- System Interface
        USER_CLK                        =>      tile0_txusrclk0_i,
        SYSTEM_RESET                    =>      tile2_tx_system_reset1_c
    );
    
    tile3_frame_gen0 : FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        MEM_00                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_01                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_02                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_03                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_04                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_05                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_06                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_07                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_08                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_09                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_0A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_0B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_0C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_0D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_0E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_0F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_10                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_11                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_12                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_13                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_14                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_15                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_16                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_17                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_18                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_19                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_1A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_1B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_1C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_1D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_1E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_1F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_20                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_21                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_22                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_23                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_24                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_25                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_26                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_27                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_28                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_29                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_2A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_2B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_2C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_2D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_2E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_2F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_30                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_31                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_32                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_33                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_34                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_35                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_36                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_37                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_38                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_39                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_3A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_3B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_3C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_3D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_3E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_3F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000000"
    )
    port map
    (
        -- User Interface
        TX_DATA(31 downto 8)            =>      tile3_txdata0_float_i,
        TX_DATA(7 downto 0)             =>      tile3_txdata0_i,
        TX_CHARISK(3 downto 1)          =>      tile3_txcharisk0_float_i,
        TX_CHARISK(0)                   =>      tile3_txcharisk0_i,
        -- System Interface
        USER_CLK                        =>      tile0_txusrclk0_i,
        SYSTEM_RESET                    =>      tile3_tx_system_reset0_c
    );
    
    tile3_frame_gen1 : FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        MEM_00                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_01                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_02                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_03                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_04                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_05                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_06                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_07                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_08                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_09                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_0A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_0B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_0C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_0D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_0E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_0F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_10                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_11                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_12                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_13                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_14                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_15                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_16                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_17                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_18                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_19                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_1A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_1B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_1C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_1D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_1E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_1F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_20                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_21                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_22                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_23                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_24                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_25                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_26                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_27                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_28                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_29                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_2A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_2B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_2C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_2D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_2E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_2F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_30                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_31                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_32                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_33                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_34                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_35                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_36                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_37                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_38                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_39                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_3A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_3B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_3C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_3D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_3E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_3F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000000"
    )
    port map
    (
        -- User Interface
        TX_DATA(31 downto 8)            =>      tile3_txdata1_float_i,
        TX_DATA(7 downto 0)             =>      tile3_txdata1_i,
        TX_CHARISK(3 downto 1)          =>      tile3_txcharisk1_float_i,
        TX_CHARISK(0)                   =>      tile3_txcharisk1_i,
        -- System Interface
        USER_CLK                        =>      tile0_txusrclk0_i,
        SYSTEM_RESET                    =>      tile3_tx_system_reset1_c
    );
    


    ---------------------------------- Frame Checkers -------------------------
    -- The example design uses Block RAM based frame checkers to verify incoming  
    -- data. By default the frame generators are loaded with a data sequence that 
    -- matches the outgoing sequence of the frame generators for the TX ports.
    
    -- You can modify the expected data sequence by changing the INIT values of the frame
    -- checkers in this file. Pay careful attention to bit order and the spacing
    -- of your control and alignment characters.
    
    -- When the frame checker receives data, it attempts to synchronise to the 
    -- incoming pattern by looking for the first sequence in the pattern. Once it 
    -- finds the first sequence, it increments through the sequence, and indicates an 
    -- error whenever the next value received does not match the expected value.

    tile0_frame_check0_reset_i              <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else tile0_matchn0_i;

    -- tile0_frame_check0 is always connected to the lane with the start of char
    -- and this lane starts off the data checking on all the other lanes. The INC_IN port is tied off
    tile0_inc_in0_i                         <= '0';

    tile0_frame_check0 : FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      8,
        USE_COMMA                       =>      1,
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        CONFIG_INDEPENDENT_LANES        =>      1,
        START_OF_PACKET_CHAR            =>      x"bc",
        MEM_00                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_01                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_02                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_03                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_04                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_05                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_06                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_07                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_08                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_09                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_0A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_0B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_0C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_0D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_0E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_0F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_10                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_11                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_12                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_13                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_14                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_15                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_16                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_17                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_18                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_19                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_1A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_1B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_1C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_1D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_1E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_1F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_20                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_21                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_22                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_23                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_24                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_25                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_26                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_27                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_28                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_29                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_2A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_2B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_2C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_2D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_2E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_2F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_30                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_31                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_32                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_33                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_34                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_35                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_36                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_37                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_38                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_39                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_3A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_3B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_3C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_3D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_3E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_3F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000000"
    )
    port map
    (
        -- MGT Interface
        RX_DATA                         =>      tile0_rxdata0_i,
        RX_ENMCOMMA_ALIGN               =>      tile0_rxenmcommaalign0_i,
        RX_ENPCOMMA_ALIGN               =>      tile0_rxenpcommaalign0_i,
        RX_ENCHAN_SYNC                  =>      open,
        -- Control Interface
        INC_IN                          =>      tile0_inc_in0_i,
        INC_OUT                         =>      tile0_inc_out0_i,
        PATTERN_MATCH_N                 =>      tile0_matchn0_i,
        RESET_ON_ERROR                  =>      tile0_frame_check0_reset_i,
        -- System Interface
        USER_CLK                        =>      tile0_txusrclk0_i,
        SYSTEM_RESET                    =>      tile0_rx_system_reset0_c,
        ERROR_COUNT                     =>      tile0_error_count0_i,
        TRACK_DATA                      =>      tile0_track_data0_i
    );
    
    tile0_frame_check1_reset_i              <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else tile0_matchn1_i;

    -- tile0_frame_check0 is always connected to the lane with the start of char
    -- and this lane starts off the data checking on all the other lanes. The INC_IN port is tied off
    tile0_inc_in1_i                         <= '0';

    tile0_frame_check1 : FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      8,
        USE_COMMA                       =>      1,
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        CONFIG_INDEPENDENT_LANES        =>      1,
        START_OF_PACKET_CHAR            =>      x"bc",
        MEM_00                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_01                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_02                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_03                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_04                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_05                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_06                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_07                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_08                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_09                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_0A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_0B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_0C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_0D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_0E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_0F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_10                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_11                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_12                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_13                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_14                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_15                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_16                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_17                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_18                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_19                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_1A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_1B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_1C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_1D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_1E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_1F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_20                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_21                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_22                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_23                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_24                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_25                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_26                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_27                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_28                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_29                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_2A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_2B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_2C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_2D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_2E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_2F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_30                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_31                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_32                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_33                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_34                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_35                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_36                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_37                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_38                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_39                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_3A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_3B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_3C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_3D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_3E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_3F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000000"
    )
    port map
    (
        -- MGT Interface
        RX_DATA                         =>      tile0_rxdata1_i,
        RX_ENMCOMMA_ALIGN               =>      tile0_rxenmcommaalign1_i,
        RX_ENPCOMMA_ALIGN               =>      tile0_rxenpcommaalign1_i,
        RX_ENCHAN_SYNC                  =>      open,
        -- Control Interface
        INC_IN                          =>      tile0_inc_in1_i,
        INC_OUT                         =>      tile0_inc_out1_i,
        PATTERN_MATCH_N                 =>      tile0_matchn1_i,
        RESET_ON_ERROR                  =>      tile0_frame_check1_reset_i,
        -- System Interface
        USER_CLK                        =>      tile0_txusrclk0_i,
        SYSTEM_RESET                    =>      tile0_rx_system_reset1_c,
        ERROR_COUNT                     =>      tile0_error_count1_i,
        TRACK_DATA                      =>      tile0_track_data1_i
    );
    
    tile1_frame_check0_reset_i              <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else tile1_matchn0_i;

    -- in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    -- in this case, the INC_IN port is tied off.
    -- Else, the data checking is triggered by the "master" lane
    tile1_inc_in0_i                         <= tile0_inc_out0_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else '0';

    tile1_frame_check0 : FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      8,
        USE_COMMA                       =>      1,
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        CONFIG_INDEPENDENT_LANES        =>      EXAMPLE_CONFIG_INDEPENDENT_LANES,
        START_OF_PACKET_CHAR            =>      x"bc",
        MEM_00                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_01                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_02                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_03                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_04                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_05                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_06                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_07                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_08                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_09                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_0A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_0B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_0C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_0D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_0E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_0F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_10                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_11                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_12                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_13                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_14                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_15                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_16                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_17                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_18                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_19                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_1A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_1B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_1C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_1D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_1E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_1F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_20                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_21                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_22                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_23                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_24                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_25                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_26                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_27                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_28                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_29                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_2A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_2B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_2C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_2D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_2E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_2F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_30                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_31                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_32                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_33                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_34                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_35                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_36                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_37                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_38                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_39                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_3A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_3B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_3C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_3D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_3E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_3F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000000"
    )
    port map
    (
        -- MGT Interface
        RX_DATA                         =>      tile1_rxdata0_i,
        RX_ENMCOMMA_ALIGN               =>      tile1_rxenmcommaalign0_i,
        RX_ENPCOMMA_ALIGN               =>      tile1_rxenpcommaalign0_i,
        RX_ENCHAN_SYNC                  =>      open,
        -- Control Interface
        INC_IN                          =>      tile1_inc_in0_i,
        INC_OUT                         =>      tile1_inc_out0_i,
        PATTERN_MATCH_N                 =>      tile1_matchn0_i,
        RESET_ON_ERROR                  =>      tile1_frame_check0_reset_i,
        -- System Interface
        USER_CLK                        =>      tile0_txusrclk0_i,
        SYSTEM_RESET                    =>      tile1_rx_system_reset0_c,
        ERROR_COUNT                     =>      tile1_error_count0_i,
        TRACK_DATA                      =>      tile1_track_data0_i
    );
    
    tile1_frame_check1_reset_i              <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else tile1_matchn1_i;

    -- in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    -- in this case, the INC_IN port is tied off.
    -- Else, the data checking is triggered by the "master" lane
    tile1_inc_in1_i                         <= tile0_inc_out1_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else '0';

    tile1_frame_check1 : FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      8,
        USE_COMMA                       =>      1,
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        CONFIG_INDEPENDENT_LANES        =>      EXAMPLE_CONFIG_INDEPENDENT_LANES,
        START_OF_PACKET_CHAR            =>      x"bc",
        MEM_00                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_01                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_02                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_03                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_04                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_05                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_06                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_07                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_08                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_09                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_0A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_0B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_0C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_0D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_0E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_0F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_10                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_11                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_12                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_13                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_14                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_15                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_16                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_17                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_18                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_19                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_1A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_1B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_1C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_1D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_1E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_1F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_20                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_21                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_22                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_23                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_24                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_25                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_26                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_27                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_28                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_29                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_2A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_2B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_2C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_2D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_2E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_2F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_30                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_31                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_32                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_33                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_34                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_35                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_36                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_37                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_38                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_39                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_3A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_3B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_3C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_3D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_3E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_3F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000000"
    )
    port map
    (
        -- MGT Interface
        RX_DATA                         =>      tile1_rxdata1_i,
        RX_ENMCOMMA_ALIGN               =>      tile1_rxenmcommaalign1_i,
        RX_ENPCOMMA_ALIGN               =>      tile1_rxenpcommaalign1_i,
        RX_ENCHAN_SYNC                  =>      open,
        -- Control Interface
        INC_IN                          =>      tile1_inc_in1_i,
        INC_OUT                         =>      tile1_inc_out1_i,
        PATTERN_MATCH_N                 =>      tile1_matchn1_i,
        RESET_ON_ERROR                  =>      tile1_frame_check1_reset_i,
        -- System Interface
        USER_CLK                        =>      tile0_txusrclk0_i,
        SYSTEM_RESET                    =>      tile1_rx_system_reset1_c,
        ERROR_COUNT                     =>      tile1_error_count1_i,
        TRACK_DATA                      =>      tile1_track_data1_i
    );
    
    tile2_frame_check0_reset_i              <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else tile2_matchn0_i;

    -- in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    -- in this case, the INC_IN port is tied off.
    -- Else, the data checking is triggered by the "master" lane
    tile2_inc_in0_i                         <= tile0_inc_out0_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else '0';

    tile2_frame_check0 : FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      8,
        USE_COMMA                       =>      1,
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        CONFIG_INDEPENDENT_LANES        =>      EXAMPLE_CONFIG_INDEPENDENT_LANES,
        START_OF_PACKET_CHAR            =>      x"bc",
        MEM_00                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_01                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_02                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_03                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_04                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_05                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_06                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_07                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_08                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_09                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_0A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_0B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_0C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_0D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_0E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_0F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_10                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_11                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_12                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_13                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_14                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_15                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_16                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_17                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_18                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_19                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_1A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_1B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_1C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_1D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_1E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_1F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_20                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_21                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_22                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_23                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_24                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_25                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_26                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_27                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_28                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_29                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_2A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_2B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_2C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_2D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_2E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_2F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_30                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_31                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_32                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_33                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_34                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_35                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_36                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_37                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_38                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_39                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_3A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_3B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_3C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_3D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_3E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_3F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000000"
    )
    port map
    (
        -- MGT Interface
        RX_DATA                         =>      tile2_rxdata0_i,
        RX_ENMCOMMA_ALIGN               =>      tile2_rxenmcommaalign0_i,
        RX_ENPCOMMA_ALIGN               =>      tile2_rxenpcommaalign0_i,
        RX_ENCHAN_SYNC                  =>      open,
        -- Control Interface
        INC_IN                          =>      tile2_inc_in0_i,
        INC_OUT                         =>      tile2_inc_out0_i,
        PATTERN_MATCH_N                 =>      tile2_matchn0_i,
        RESET_ON_ERROR                  =>      tile2_frame_check0_reset_i,
        -- System Interface
        USER_CLK                        =>      tile0_txusrclk0_i,
        SYSTEM_RESET                    =>      tile2_rx_system_reset0_c,
        ERROR_COUNT                     =>      tile2_error_count0_i,
        TRACK_DATA                      =>      tile2_track_data0_i
    );
    
    tile2_frame_check1_reset_i              <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else tile2_matchn1_i;

    -- in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    -- in this case, the INC_IN port is tied off.
    -- Else, the data checking is triggered by the "master" lane
    tile2_inc_in1_i                         <= tile0_inc_out1_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else '0';

    tile2_frame_check1 : FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      8,
        USE_COMMA                       =>      1,
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        CONFIG_INDEPENDENT_LANES        =>      EXAMPLE_CONFIG_INDEPENDENT_LANES,
        START_OF_PACKET_CHAR            =>      x"bc",
        MEM_00                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_01                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_02                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_03                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_04                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_05                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_06                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_07                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_08                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_09                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_0A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_0B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_0C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_0D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_0E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_0F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_10                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_11                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_12                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_13                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_14                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_15                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_16                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_17                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_18                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_19                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_1A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_1B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_1C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_1D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_1E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_1F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_20                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_21                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_22                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_23                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_24                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_25                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_26                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_27                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_28                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_29                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_2A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_2B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_2C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_2D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_2E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_2F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_30                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_31                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_32                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_33                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_34                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_35                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_36                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_37                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_38                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_39                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_3A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_3B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_3C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_3D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_3E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_3F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000000"
    )
    port map
    (
        -- MGT Interface
        RX_DATA                         =>      tile2_rxdata1_i,
        RX_ENMCOMMA_ALIGN               =>      tile2_rxenmcommaalign1_i,
        RX_ENPCOMMA_ALIGN               =>      tile2_rxenpcommaalign1_i,
        RX_ENCHAN_SYNC                  =>      open,
        -- Control Interface
        INC_IN                          =>      tile2_inc_in1_i,
        INC_OUT                         =>      tile2_inc_out1_i,
        PATTERN_MATCH_N                 =>      tile2_matchn1_i,
        RESET_ON_ERROR                  =>      tile2_frame_check1_reset_i,
        -- System Interface
        USER_CLK                        =>      tile0_txusrclk0_i,
        SYSTEM_RESET                    =>      tile2_rx_system_reset1_c,
        ERROR_COUNT                     =>      tile2_error_count1_i,
        TRACK_DATA                      =>      tile2_track_data1_i
    );
    
    tile3_frame_check0_reset_i              <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else tile3_matchn0_i;

    -- in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    -- in this case, the INC_IN port is tied off.
    -- Else, the data checking is triggered by the "master" lane
    tile3_inc_in0_i                         <= tile0_inc_out0_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else '0';

    tile3_frame_check0 : FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      8,
        USE_COMMA                       =>      1,
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        CONFIG_INDEPENDENT_LANES        =>      EXAMPLE_CONFIG_INDEPENDENT_LANES,
        START_OF_PACKET_CHAR            =>      x"bc",
        MEM_00                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_01                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_02                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_03                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_04                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_05                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_06                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_07                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_08                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_09                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_0A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_0B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_0C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_0D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_0E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_0F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_10                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_11                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_12                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_13                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_14                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_15                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_16                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_17                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_18                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_19                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_1A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_1B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_1C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_1D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_1E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_1F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_20                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_21                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_22                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_23                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_24                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_25                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_26                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_27                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_28                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_29                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_2A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_2B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_2C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_2D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_2E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_2F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_30                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_31                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_32                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_33                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_34                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_35                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_36                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_37                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_38                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_39                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_3A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_3B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_3C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_3D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_3E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_3F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000000"
    )
    port map
    (
        -- MGT Interface
        RX_DATA                         =>      tile3_rxdata0_i,
        RX_ENMCOMMA_ALIGN               =>      tile3_rxenmcommaalign0_i,
        RX_ENPCOMMA_ALIGN               =>      tile3_rxenpcommaalign0_i,
        RX_ENCHAN_SYNC                  =>      open,
        -- Control Interface
        INC_IN                          =>      tile3_inc_in0_i,
        INC_OUT                         =>      tile3_inc_out0_i,
        PATTERN_MATCH_N                 =>      tile3_matchn0_i,
        RESET_ON_ERROR                  =>      tile3_frame_check0_reset_i,
        -- System Interface
        USER_CLK                        =>      tile0_txusrclk0_i,
        SYSTEM_RESET                    =>      tile3_rx_system_reset0_c,
        ERROR_COUNT                     =>      tile3_error_count0_i,
        TRACK_DATA                      =>      tile3_track_data0_i
    );
    
    tile3_frame_check1_reset_i              <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else tile3_matchn1_i;

    -- in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    -- in this case, the INC_IN port is tied off.
    -- Else, the data checking is triggered by the "master" lane
    tile3_inc_in1_i                         <= tile0_inc_out1_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else '0';

    tile3_frame_check1 : FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      8,
        USE_COMMA                       =>      1,
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        CONFIG_INDEPENDENT_LANES        =>      EXAMPLE_CONFIG_INDEPENDENT_LANES,
        START_OF_PACKET_CHAR            =>      x"bc",
        MEM_00                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_01                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_02                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_03                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_04                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_05                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_06                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_07                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_08                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_09                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_0A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_0B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_0C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_0D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_0E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_0F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_10                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_11                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_12                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_13                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_14                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_15                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_16                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_17                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_18                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_19                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_1A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_1B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_1C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_1D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_1E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_1F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_20                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_21                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_22                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_23                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_24                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_25                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_26                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_27                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_28                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_29                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_2A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_2B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_2C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_2D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_2E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_2F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEM_30                  =>  x"00000006000000050000000400000003000000020000000100000000000000bc",
        MEM_31                  =>  x"0000000e0000000d0000000c0000000b0000000a000000090000000800000007",
        MEM_32                  =>  x"000000160000001500000014000000130000001200000011000000100000000f",
        MEM_33                  =>  x"0000001e0000001d0000001c0000001b0000001a000000190000001800000017",
        MEM_34                  =>  x"000000260000002500000024000000230000002200000021000000200000001f",
        MEM_35                  =>  x"0000002e0000002d0000002c0000002b0000002a000000290000002800000027",
        MEM_36                  =>  x"000000360000003500000034000000330000003200000031000000300000002f",
        MEM_37                  =>  x"0000003e0000003d0000003c0000003b0000003a000000390000003800000037",
        MEM_38                  =>  x"000000460000004500000044000000430000004200000041000000400000003f",
        MEM_39                  =>  x"0000004e0000004d0000004c0000004b0000004a000000490000004800000047",
        MEM_3A                  =>  x"000000560000005500000054000000530000005200000051000000500000004f",
        MEM_3B                  =>  x"0000005e0000005d0000005c0000005b0000005a000000590000005800000057",
        MEM_3C                  =>  x"000000660000006500000064000000630000006200000061000000600000005f",
        MEM_3D                  =>  x"0000006e0000006d0000006c0000006b0000006a000000690000006800000067",
        MEM_3E                  =>  x"000000760000007500000074000000730000007200000071000000700000006f",
        MEM_3F                  =>  x"0000007e0000007d0000007c0000007b0000007a000000790000007800000077",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000000",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000001",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000000"
    )
    port map
    (
        -- MGT Interface
        RX_DATA                         =>      tile3_rxdata1_i,
        RX_ENMCOMMA_ALIGN               =>      tile3_rxenmcommaalign1_i,
        RX_ENPCOMMA_ALIGN               =>      tile3_rxenpcommaalign1_i,
        RX_ENCHAN_SYNC                  =>      open,
        -- Control Interface
        INC_IN                          =>      tile3_inc_in1_i,
        INC_OUT                         =>      tile3_inc_out1_i,
        PATTERN_MATCH_N                 =>      tile3_matchn1_i,
        RESET_ON_ERROR                  =>      tile3_frame_check1_reset_i,
        -- System Interface
        USER_CLK                        =>      tile0_txusrclk0_i,
        SYSTEM_RESET                    =>      tile3_rx_system_reset1_c,
        ERROR_COUNT                     =>      tile3_error_count1_i,
        TRACK_DATA                      =>      tile3_track_data1_i
    );
    



  TRACK_DATA_OUT(0) <=  tile0_track_data0_i and tile0_track_data1_i;
  TRACK_DATA_OUT(1) <= 	tile1_track_data0_i and tile1_track_data1_i;
  TRACK_DATA_OUT(2) <=  tile2_track_data0_i and tile2_track_data1_i;
  TRACK_DATA_OUT(3) <=  tile3_track_data0_i and tile3_track_data1_i;

    ----------------------------- Chipscope Connections -----------------------
    -- When the example design is run in hardware, it uses chipscope to allow the
    -- example design and GTP wrapper to be controlled and monitored. The 
    -- EXAMPLE_USE_CHIPSCOPE parameter allows chipscope to be removed for simulation.
    
chipscope : if EXAMPLE_USE_CHIPSCOPE = 1 generate


    -- Shared VIO for all tiles
    shared_vio_i : shared_vio
    port map
    (
        control                         =>      shared_vio_control_i,
        async_in                        =>      shared_vio_in_i,
        async_out                       =>      shared_vio_out_i
    );

    
    -- ICON for all VIOs 
    i_icon : icon
    port map
    (
        control0                        =>      shared_vio_control_i,
        control1                        =>      tx_data_vio_control0_i,
        control2                        =>      rx_data_vio_control0_i,
        control3                        =>      ila_control0_i,
        control4                        =>      tx_data_vio_control1_i,
        control5                        =>      rx_data_vio_control1_i,
        control6                        =>      ila_control1_i
    );

    -- TX VIO 
    tx_data_vio0_i : shared_vio
    port map
    (
        control                         =>      tx_data_vio_control0_i,
        async_in                        =>      tx_data_vio_in0_i,
        async_out                       =>      tx_data_vio_out0_i
    );
    
    -- RX VIO 
    rx_data_vio0_i : shared_vio
    port map
    (
        control                         =>      rx_data_vio_control0_i,
        async_in                        =>      rx_data_vio_in0_i,
        async_out                       =>      rx_data_vio_out0_i
    );
    
    -- RX ILA
    ila0_i : ila
    port map
    (
        control                         =>      ila_control0_i,
        clk                             =>      ila_clk0_i,
        trig0                           =>      ila_in0_i
    );

    -- The RX ILA must use the same clock as the selected transceiver
    ila_clk0_bufg_i : BUFG
    port map
    (
        I => ila_clk_mux_out0_i,
        O => ila_clk0_i
    );

     ila_clk_mux_out0_i<= tile0_txusrclk0_i;

        
    -- TX VIO 
    tx_data_vio1_i : shared_vio
    port map
    (
        control                         =>      tx_data_vio_control1_i,
        async_in                        =>      tx_data_vio_in1_i,
        async_out                       =>      tx_data_vio_out1_i
    );
    
    -- RX VIO 
    rx_data_vio1_i : shared_vio
    port map
    (
        control                         =>      rx_data_vio_control1_i,
        async_in                        =>      rx_data_vio_in1_i,
        async_out                       =>      rx_data_vio_out1_i
    );
    
    -- RX ILA
    ila1_i : ila
    port map
    (
        control                         =>      ila_control1_i,
        clk                             =>      ila_clk1_i,
        trig0                           =>      ila_in1_i
    );

    -- The RX ILA must use the same clock as the selected transceiver
    ila_clk1_bufg_i : BUFG
    port map
    (
        I => ila_clk_mux_out1_i,
        O => ila_clk1_i
    );

     ila_clk_mux_out1_i<= tile0_txusrclk0_i;

        

    -- Connect resets for frame generators
    tile0_tx_system_reset0_c                <= not tile0_tx_resetdone0_r2 or user_tx_reset_i;
    tile0_tx_system_reset1_c                <= not tile0_tx_resetdone1_r2 or user_tx_reset_i;
    tile1_tx_system_reset0_c                <= not tile1_tx_resetdone0_r2 or user_tx_reset_i;
    tile1_tx_system_reset1_c                <= not tile1_tx_resetdone1_r2 or user_tx_reset_i;
    tile2_tx_system_reset0_c                <= not tile2_tx_resetdone0_r2 or user_tx_reset_i;
    tile2_tx_system_reset1_c                <= not tile2_tx_resetdone1_r2 or user_tx_reset_i;
    tile3_tx_system_reset0_c                <= not tile3_tx_resetdone0_r2 or user_tx_reset_i;
    tile3_tx_system_reset1_c                <= not tile3_tx_resetdone1_r2 or user_tx_reset_i;
    tile0_rx_system_reset0_c                <= not tile0_rx_resetdone0_r2 or user_rx_reset_i;
    tile0_rx_system_reset1_c                <= not tile0_rx_resetdone1_r2 or user_rx_reset_i;
    tile1_rx_system_reset0_c                <= not tile1_rx_resetdone0_r2 or user_rx_reset_i;
    tile1_rx_system_reset1_c                <= not tile1_rx_resetdone1_r2 or user_rx_reset_i;
    tile2_rx_system_reset0_c                <= not tile2_rx_resetdone0_r2 or user_rx_reset_i;
    tile2_rx_system_reset1_c                <= not tile2_rx_resetdone1_r2 or user_rx_reset_i;
    tile3_rx_system_reset0_c                <= not tile3_rx_resetdone0_r2 or user_rx_reset_i;
    tile3_rx_system_reset1_c                <= not tile3_rx_resetdone1_r2 or user_rx_reset_i;


    tile0_gtpreset_i                        <= gtpreset_i;
    tile1_gtpreset_i                        <= gtpreset_i;
    tile2_gtpreset_i                        <= gtpreset_i;
    tile3_gtpreset_i                        <= gtpreset_i;


    -- Shared VIO Outputs
    gtpreset_i                              <= shared_vio_out_i(31);
    user_tx_reset_i                         <= shared_vio_out_i(30);
    user_rx_reset_i                         <= shared_vio_out_i(29);
    mux_sel_i                               <= shared_vio_out_i(28 downto 27);

    -- Shared VIO Inputs
    shared_vio_in_i(31)                     <= tile0_plllkdet_i;
    shared_vio_in_i(30)                     <= tile1_plllkdet_i;
    shared_vio_in_i(29)                     <= tile2_plllkdet_i;
    shared_vio_in_i(28)                     <= tile3_plllkdet_i;
    shared_vio_in_i(27 downto 0)            <= "0000000000000000000000000000";

    -- Chipscope connections for GTP0 on Tile 0
    tile0_tx_data_vio_in0_i(31 downto 0)    <= "00000000000000000000000000000000";
--    tile0_txpowerdown0_i                    <= tx_data_vio_out0_i(31 downto 30);
    tile0_txdiffctrl0_i                     <= tx_data_vio_out0_i(29 downto 27);
--    tile0_txelecidle0_i                     <= tx_data_vio_out0_i(26);
    tile0_txcomstart0_i                     <= tx_data_vio_out0_i(25);
    tile0_txcomtype0_i                      <= tx_data_vio_out0_i(24);
    tile0_rx_data_vio_in0_i(31)             <= tile0_resetdone0_i;
    tile0_rx_data_vio_in0_i(30 downto 0)    <= "0000000000000000000000000000000";
--    tile0_rxpowerdown0_i                    <= rx_data_vio_out0_i(31 downto 30);
    tile0_rxcdrreset0_i                     <= rx_data_vio_out0_i(29);
    tile0_rxeqmix0_i                        <= rx_data_vio_out0_i(28 downto 27);
    tile0_rxeqpole0_i                       <= rx_data_vio_out0_i(26 downto 23);
    tile0_rxbufreset0_i                     <= rx_data_vio_out0_i(22);
    tile0_ila_in0_i(63)                     <= tile0_rxchariscomma0_i;
    tile0_ila_in0_i(62)                     <= tile0_rxcharisk0_i;
    tile0_ila_in0_i(61)                     <= tile0_rxdisperr0_i;
    tile0_ila_in0_i(60)                     <= tile0_rxnotintable0_i;
    tile0_ila_in0_i(59 downto 57)           <= tile0_rxclkcorcnt0_i;
    tile0_ila_in0_i(56 downto 49)           <= tile0_rxdata0_i;
    tile0_ila_in0_i(48)                     <= tile0_rxelecidle0_i;
    tile0_ila_in0_i(47 downto 45)           <= tile0_rxstatus0_i;
    tile0_ila_in0_i(44 downto 37)           <= tile0_error_count0_i;
    tile0_ila_in0_i(36 downto 0)            <= "0000000000000000000000000000000000000";

    -- Chipscope connections for GTP1 on Tile 0
    tile0_tx_data_vio_in1_i(31 downto 0)    <= "00000000000000000000000000000000";
--    tile0_txpowerdown1_i                    <= tx_data_vio_out1_i(31 downto 30);
    tile0_txdiffctrl1_i                     <= tx_data_vio_out1_i(29 downto 27);
--    tile0_txelecidle1_i                     <= tx_data_vio_out1_i(26);
    tile0_txcomstart1_i                     <= tx_data_vio_out1_i(25);
    tile0_txcomtype1_i                      <= tx_data_vio_out1_i(24);
    tile0_rx_data_vio_in1_i(31)             <= tile0_resetdone1_i;
    tile0_rx_data_vio_in1_i(30 downto 0)    <= "0000000000000000000000000000000";
--    tile0_rxpowerdown1_i                    <= rx_data_vio_out1_i(31 downto 30);
    tile0_rxcdrreset1_i                     <= rx_data_vio_out1_i(29);
    tile0_rxeqmix1_i                        <= rx_data_vio_out1_i(28 downto 27);
    tile0_rxeqpole1_i                       <= rx_data_vio_out1_i(26 downto 23);
    tile0_rxbufreset1_i                     <= rx_data_vio_out1_i(22);
    tile0_ila_in1_i(63)                     <= tile0_rxchariscomma1_i;
    tile0_ila_in1_i(62)                     <= tile0_rxcharisk1_i;
    tile0_ila_in1_i(61)                     <= tile0_rxdisperr1_i;
    tile0_ila_in1_i(60)                     <= tile0_rxnotintable1_i;
    tile0_ila_in1_i(59 downto 57)           <= tile0_rxclkcorcnt1_i;
    tile0_ila_in1_i(56 downto 49)           <= tile0_rxdata1_i;
    tile0_ila_in1_i(48)                     <= tile0_rxelecidle1_i;
    tile0_ila_in1_i(47 downto 45)           <= tile0_rxstatus1_i;
    tile0_ila_in1_i(44 downto 37)           <= tile0_error_count1_i;
    tile0_ila_in1_i(36 downto 0)            <= "0000000000000000000000000000000000000";

    -- Chipscope connections for GTP0 on Tile 1
    tile1_tx_data_vio_in0_i(31 downto 0)    <= "00000000000000000000000000000000";
--    tile1_txpowerdown0_i                    <= tx_data_vio_out0_i(31 downto 30);
    tile1_txdiffctrl0_i                     <= tx_data_vio_out0_i(29 downto 27);
--    tile1_txelecidle0_i                     <= tx_data_vio_out0_i(26);
    tile1_txcomstart0_i                     <= tx_data_vio_out0_i(25);
    tile1_txcomtype0_i                      <= tx_data_vio_out0_i(24);
    tile1_rx_data_vio_in0_i(31)             <= tile1_resetdone0_i;
    tile1_rx_data_vio_in0_i(30 downto 0)    <= "0000000000000000000000000000000";
--    tile1_rxpowerdown0_i                    <= rx_data_vio_out0_i(31 downto 30);
    tile1_rxcdrreset0_i                     <= rx_data_vio_out0_i(29);
    tile1_rxeqmix0_i                        <= rx_data_vio_out0_i(28 downto 27);
    tile1_rxeqpole0_i                       <= rx_data_vio_out0_i(26 downto 23);
    tile1_rxbufreset0_i                     <= rx_data_vio_out0_i(22);
    tile1_ila_in0_i(63)                     <= tile1_rxchariscomma0_i;
    tile1_ila_in0_i(62)                     <= tile1_rxcharisk0_i;
    tile1_ila_in0_i(61)                     <= tile1_rxdisperr0_i;
    tile1_ila_in0_i(60)                     <= tile1_rxnotintable0_i;
    tile1_ila_in0_i(59 downto 57)           <= tile1_rxclkcorcnt0_i;
    tile1_ila_in0_i(56 downto 49)           <= tile1_rxdata0_i;
    tile1_ila_in0_i(48)                     <= tile1_rxelecidle0_i;
    tile1_ila_in0_i(47 downto 45)           <= tile1_rxstatus0_i;
    tile1_ila_in0_i(44 downto 37)           <= tile1_error_count0_i;
    tile1_ila_in0_i(36 downto 0)            <= "0000000000000000000000000000000000000";

    -- Chipscope connections for GTP1 on Tile 1
    tile1_tx_data_vio_in1_i(31 downto 0)    <= "00000000000000000000000000000000";
--    tile1_txpowerdown1_i                    <= tx_data_vio_out1_i(31 downto 30);
    tile1_txdiffctrl1_i                     <= tx_data_vio_out1_i(29 downto 27);
--    tile1_txelecidle1_i                     <= tx_data_vio_out1_i(26);
    tile1_txcomstart1_i                     <= tx_data_vio_out1_i(25);
    tile1_txcomtype1_i                      <= tx_data_vio_out1_i(24);
    tile1_rx_data_vio_in1_i(31)             <= tile1_resetdone1_i;
    tile1_rx_data_vio_in1_i(30 downto 0)    <= "0000000000000000000000000000000";
--    tile1_rxpowerdown1_i                    <= rx_data_vio_out1_i(31 downto 30);
    tile1_rxcdrreset1_i                     <= rx_data_vio_out1_i(29);
    tile1_rxeqmix1_i                        <= rx_data_vio_out1_i(28 downto 27);
    tile1_rxeqpole1_i                       <= rx_data_vio_out1_i(26 downto 23);
    tile1_rxbufreset1_i                     <= rx_data_vio_out1_i(22);
    tile1_ila_in1_i(63)                     <= tile1_rxchariscomma1_i;
    tile1_ila_in1_i(62)                     <= tile1_rxcharisk1_i;
    tile1_ila_in1_i(61)                     <= tile1_rxdisperr1_i;
    tile1_ila_in1_i(60)                     <= tile1_rxnotintable1_i;
    tile1_ila_in1_i(59 downto 57)           <= tile1_rxclkcorcnt1_i;
    tile1_ila_in1_i(56 downto 49)           <= tile1_rxdata1_i;
    tile1_ila_in1_i(48)                     <= tile1_rxelecidle1_i;
    tile1_ila_in1_i(47 downto 45)           <= tile1_rxstatus1_i;
    tile1_ila_in1_i(44 downto 37)           <= tile1_error_count1_i;
    tile1_ila_in1_i(36 downto 0)            <= "0000000000000000000000000000000000000";

    -- Chipscope connections for GTP0 on Tile 2
    tile2_tx_data_vio_in0_i(31 downto 0)    <= "00000000000000000000000000000000";
--    tile2_txpowerdown0_i                    <= tx_data_vio_out0_i(31 downto 30);
    tile2_txdiffctrl0_i                     <= tx_data_vio_out0_i(29 downto 27);
--    tile2_txelecidle0_i                     <= tx_data_vio_out0_i(26);
    tile2_txcomstart0_i                     <= tx_data_vio_out0_i(25);
    tile2_txcomtype0_i                      <= tx_data_vio_out0_i(24);
    tile2_rx_data_vio_in0_i(31)             <= tile2_resetdone0_i;
    tile2_rx_data_vio_in0_i(30 downto 0)    <= "0000000000000000000000000000000";
--    tile2_rxpowerdown0_i                    <= rx_data_vio_out0_i(31 downto 30);
    tile2_rxcdrreset0_i                     <= rx_data_vio_out0_i(29);
    tile2_rxeqmix0_i                        <= rx_data_vio_out0_i(28 downto 27);
    tile2_rxeqpole0_i                       <= rx_data_vio_out0_i(26 downto 23);
    tile2_rxbufreset0_i                     <= rx_data_vio_out0_i(22);
    tile2_ila_in0_i(63)                     <= tile2_rxchariscomma0_i;
    tile2_ila_in0_i(62)                     <= tile2_rxcharisk0_i;
    tile2_ila_in0_i(61)                     <= tile2_rxdisperr0_i;
    tile2_ila_in0_i(60)                     <= tile2_rxnotintable0_i;
    tile2_ila_in0_i(59 downto 57)           <= tile2_rxclkcorcnt0_i;
    tile2_ila_in0_i(56 downto 49)           <= tile2_rxdata0_i;
    tile2_ila_in0_i(48)                     <= tile2_rxelecidle0_i;
    tile2_ila_in0_i(47 downto 45)           <= tile2_rxstatus0_i;
    tile2_ila_in0_i(44 downto 37)           <= tile2_error_count0_i;
    tile2_ila_in0_i(36 downto 0)            <= "0000000000000000000000000000000000000";

    -- Chipscope connections for GTP1 on Tile 2
    tile2_tx_data_vio_in1_i(31 downto 0)    <= "00000000000000000000000000000000";
--    tile2_txpowerdown1_i                    <= tx_data_vio_out1_i(31 downto 30);
    tile2_txdiffctrl1_i                     <= tx_data_vio_out1_i(29 downto 27);
--    tile2_txelecidle1_i                     <= tx_data_vio_out1_i(26);
    tile2_txcomstart1_i                     <= tx_data_vio_out1_i(25);
    tile2_txcomtype1_i                      <= tx_data_vio_out1_i(24);
    tile2_rx_data_vio_in1_i(31)             <= tile2_resetdone1_i;
    tile2_rx_data_vio_in1_i(30 downto 0)    <= "0000000000000000000000000000000";
--    tile2_rxpowerdown1_i                    <= rx_data_vio_out1_i(31 downto 30);
    tile2_rxcdrreset1_i                     <= rx_data_vio_out1_i(29);
    tile2_rxeqmix1_i                        <= rx_data_vio_out1_i(28 downto 27);
    tile2_rxeqpole1_i                       <= rx_data_vio_out1_i(26 downto 23);
    tile2_rxbufreset1_i                     <= rx_data_vio_out1_i(22);
    tile2_ila_in1_i(63)                     <= tile2_rxchariscomma1_i;
    tile2_ila_in1_i(62)                     <= tile2_rxcharisk1_i;
    tile2_ila_in1_i(61)                     <= tile2_rxdisperr1_i;
    tile2_ila_in1_i(60)                     <= tile2_rxnotintable1_i;
    tile2_ila_in1_i(59 downto 57)           <= tile2_rxclkcorcnt1_i;
    tile2_ila_in1_i(56 downto 49)           <= tile2_rxdata1_i;
    tile2_ila_in1_i(48)                     <= tile2_rxelecidle1_i;
    tile2_ila_in1_i(47 downto 45)           <= tile2_rxstatus1_i;
    tile2_ila_in1_i(44 downto 37)           <= tile2_error_count1_i;
    tile2_ila_in1_i(36 downto 0)            <= "0000000000000000000000000000000000000";

    -- Chipscope connections for GTP0 on Tile 3
    tile3_tx_data_vio_in0_i(31 downto 0)    <= "00000000000000000000000000000000";
--    tile3_txpowerdown0_i                    <= tx_data_vio_out0_i(31 downto 30);
    tile3_txdiffctrl0_i                     <= tx_data_vio_out0_i(29 downto 27);
--    tile3_txelecidle0_i                     <= tx_data_vio_out0_i(26);
    tile3_txcomstart0_i                     <= tx_data_vio_out0_i(25);
    tile3_txcomtype0_i                      <= tx_data_vio_out0_i(24);
    tile3_rx_data_vio_in0_i(31)             <= tile3_resetdone0_i;
    tile3_rx_data_vio_in0_i(30 downto 0)    <= "0000000000000000000000000000000";
--    tile3_rxpowerdown0_i                    <= rx_data_vio_out0_i(31 downto 30);
    tile3_rxcdrreset0_i                     <= rx_data_vio_out0_i(29);
    tile3_rxeqmix0_i                        <= rx_data_vio_out0_i(28 downto 27);
    tile3_rxeqpole0_i                       <= rx_data_vio_out0_i(26 downto 23);
    tile3_rxbufreset0_i                     <= rx_data_vio_out0_i(22);
    tile3_ila_in0_i(63)                     <= tile3_rxchariscomma0_i;
    tile3_ila_in0_i(62)                     <= tile3_rxcharisk0_i;
    tile3_ila_in0_i(61)                     <= tile3_rxdisperr0_i;
    tile3_ila_in0_i(60)                     <= tile3_rxnotintable0_i;
    tile3_ila_in0_i(59 downto 57)           <= tile3_rxclkcorcnt0_i;
    tile3_ila_in0_i(56 downto 49)           <= tile3_rxdata0_i;
    tile3_ila_in0_i(48)                     <= tile3_rxelecidle0_i;
    tile3_ila_in0_i(47 downto 45)           <= tile3_rxstatus0_i;
    tile3_ila_in0_i(44 downto 37)           <= tile3_error_count0_i;
    tile3_ila_in0_i(36 downto 0)            <= "0000000000000000000000000000000000000";

    -- Chipscope connections for GTP1 on Tile 3
    tile3_tx_data_vio_in1_i(31 downto 0)    <= "00000000000000000000000000000000";
--    tile3_txpowerdown1_i                    <= tx_data_vio_out1_i(31 downto 30);
    tile3_txdiffctrl1_i                     <= tx_data_vio_out1_i(29 downto 27);
--    tile3_txelecidle1_i                     <= tx_data_vio_out1_i(26);
    tile3_txcomstart1_i                     <= tx_data_vio_out1_i(25);
    tile3_txcomtype1_i                      <= tx_data_vio_out1_i(24);
    tile3_rx_data_vio_in1_i(31)             <= tile3_resetdone1_i;
    tile3_rx_data_vio_in1_i(30 downto 0)    <= "0000000000000000000000000000000";
--    tile3_rxpowerdown1_i                    <= rx_data_vio_out1_i(31 downto 30);
    tile3_rxcdrreset1_i                     <= rx_data_vio_out1_i(29);
    tile3_rxeqmix1_i                        <= rx_data_vio_out1_i(28 downto 27);
    tile3_rxeqpole1_i                       <= rx_data_vio_out1_i(26 downto 23);
    tile3_rxbufreset1_i                     <= rx_data_vio_out1_i(22);
    tile3_ila_in1_i(63)                     <= tile3_rxchariscomma1_i;
    tile3_ila_in1_i(62)                     <= tile3_rxcharisk1_i;
    tile3_ila_in1_i(61)                     <= tile3_rxdisperr1_i;
    tile3_ila_in1_i(60)                     <= tile3_rxnotintable1_i;
    tile3_ila_in1_i(59 downto 57)           <= tile3_rxclkcorcnt1_i;
    tile3_ila_in1_i(56 downto 49)           <= tile3_rxdata1_i;
    tile3_ila_in1_i(48)                     <= tile3_rxelecidle1_i;
    tile3_ila_in1_i(47 downto 45)           <= tile3_rxstatus1_i;
    tile3_ila_in1_i(44 downto 37)           <= tile3_error_count1_i;
    tile3_ila_in1_i(36 downto 0)            <= "0000000000000000000000000000000000000";


    --Mux inputs to Chipscope modules based on mux_sel_i
    tx_data_vio_in0_i                   <=      tile0_tx_data_vio_in0_i when (mux_sel_i = "00")
                                        else    tile1_tx_data_vio_in0_i when (mux_sel_i = "01")
                                        else    tile2_tx_data_vio_in0_i when (mux_sel_i = "10")
                                        else    tile3_tx_data_vio_in0_i;


    rx_data_vio_in0_i                   <=      tile0_rx_data_vio_in0_i when (mux_sel_i = "00")
                                        else    tile1_rx_data_vio_in0_i when (mux_sel_i = "01")
                                        else    tile2_rx_data_vio_in0_i when (mux_sel_i = "10")
                                        else    tile3_rx_data_vio_in0_i;


    ila_in0_i                           <=      tile0_ila_in0_i when (mux_sel_i = "00")
                                        else    tile1_ila_in0_i when (mux_sel_i = "01")
                                        else    tile2_ila_in0_i when (mux_sel_i = "10")
                                        else    tile3_ila_in0_i;


    tx_data_vio_in1_i                   <=      tile0_tx_data_vio_in1_i when (mux_sel_i = "00")
                                        else    tile1_tx_data_vio_in1_i when (mux_sel_i = "01")
                                        else    tile2_tx_data_vio_in1_i when (mux_sel_i = "10")
                                        else    tile3_tx_data_vio_in1_i;


    rx_data_vio_in1_i                   <=      tile0_rx_data_vio_in1_i when (mux_sel_i = "00")
                                        else    tile1_rx_data_vio_in1_i when (mux_sel_i = "01")
                                        else    tile2_rx_data_vio_in1_i when (mux_sel_i = "10")
                                        else    tile3_rx_data_vio_in1_i;


    ila_in1_i                           <=      tile0_ila_in1_i when (mux_sel_i = "00")
                                        else    tile1_ila_in1_i when (mux_sel_i = "01")
                                        else    tile2_ila_in1_i when (mux_sel_i = "10")
                                        else    tile3_ila_in1_i;




   
end generate chipscope;


no_chipscope : if EXAMPLE_USE_CHIPSCOPE = 0 generate

    -- If Chipscope is not being used, drive GTP reset signal
    -- from the top level ports
    tile0_gtpreset_i                        <= GTPRESET_IN;
    tile1_gtpreset_i                        <= GTPRESET_IN;
    tile2_gtpreset_i                        <= GTPRESET_IN;
    tile3_gtpreset_i                        <= GTPRESET_IN;

    -- assign resets for frame_gen and frame_check modules
    tile0_tx_system_reset0_c                <= not tile0_tx_resetdone0_r2;
    tile0_tx_system_reset1_c                <= not tile0_tx_resetdone1_r2;
    tile1_tx_system_reset0_c                <= not tile1_tx_resetdone0_r2;
    tile1_tx_system_reset1_c                <= not tile1_tx_resetdone1_r2;
    tile2_tx_system_reset0_c                <= not tile2_tx_resetdone0_r2;
    tile2_tx_system_reset1_c                <= not tile2_tx_resetdone1_r2;
    tile3_tx_system_reset0_c                <= not tile3_tx_resetdone0_r2;
    tile3_tx_system_reset1_c                <= not tile3_tx_resetdone1_r2;
    tile0_rx_system_reset0_c                <= not tile0_rx_resetdone0_r2;
    tile0_rx_system_reset1_c                <= not tile0_rx_resetdone1_r2;
    tile1_rx_system_reset0_c                <= not tile1_rx_resetdone0_r2;
    tile1_rx_system_reset1_c                <= not tile1_rx_resetdone1_r2;
    tile2_rx_system_reset0_c                <= not tile2_rx_resetdone0_r2;
    tile2_rx_system_reset1_c                <= not tile2_rx_resetdone1_r2;
    tile3_rx_system_reset0_c                <= not tile3_rx_resetdone0_r2;
    tile3_rx_system_reset1_c                <= not tile3_rx_resetdone1_r2;


--    tile0_rxpowerdown0_i    <=   tied_to_ground_vec_i(1 downto 0);
--    tile0_rxpowerdown1_i    <=   tied_to_ground_vec_i(1 downto 0);
--    tile1_rxpowerdown0_i    <=   tied_to_ground_vec_i(1 downto 0);
--    tile1_rxpowerdown1_i    <=   tied_to_ground_vec_i(1 downto 0);
--    tile2_rxpowerdown0_i    <=   tied_to_ground_vec_i(1 downto 0);
--    tile2_rxpowerdown1_i    <=   tied_to_ground_vec_i(1 downto 0);
--    tile3_rxpowerdown0_i    <=   tied_to_ground_vec_i(1 downto 0);
--    tile3_rxpowerdown1_i    <=   tied_to_ground_vec_i(1 downto 0);
--
--    tile0_txpowerdown0_i    <=   tied_to_ground_vec_i(1 downto 0);
--    tile0_txpowerdown1_i    <=   tied_to_ground_vec_i(1 downto 0);
--    tile1_txpowerdown0_i    <=   tied_to_ground_vec_i(1 downto 0);
--    tile1_txpowerdown1_i    <=   tied_to_ground_vec_i(1 downto 0);
--    tile2_txpowerdown0_i    <=   tied_to_ground_vec_i(1 downto 0);
--    tile2_txpowerdown1_i    <=   tied_to_ground_vec_i(1 downto 0);
--    tile3_txpowerdown0_i    <=   tied_to_ground_vec_i(1 downto 0);
--    tile3_txpowerdown1_i    <=   tied_to_ground_vec_i(1 downto 0);
    gtpreset_i                              <= tied_to_ground_i;
    user_tx_reset_i                         <= tied_to_ground_i;
    user_rx_reset_i                         <= tied_to_ground_i;
    mux_sel_i                               <= tied_to_ground_vec_i(1 downto 0);
    tile0_txdiffctrl0_i                     <= tied_to_ground_vec_i(2 downto 0);
--    tile0_txelecidle0_i                     <= tied_to_ground_i;
    tile0_txcomstart0_i                     <= tied_to_ground_i;
    tile0_txcomtype0_i                      <= tied_to_ground_i;
    tile0_rxcdrreset0_i                     <= tied_to_ground_i;
    tile0_rxeqmix0_i                        <= tied_to_ground_vec_i(1 downto 0);
    tile0_rxeqpole0_i                       <= tied_to_ground_vec_i(3 downto 0);
    tile0_rxbufreset0_i                     <= tied_to_ground_i;
    tile0_txdiffctrl1_i                     <= tied_to_ground_vec_i(2 downto 0);
--    tile0_txelecidle1_i                     <= tied_to_ground_i;
    tile0_txcomstart1_i                     <= tied_to_ground_i;
    tile0_txcomtype1_i                      <= tied_to_ground_i;
    tile0_rxcdrreset1_i                     <= tied_to_ground_i;
    tile0_rxeqmix1_i                        <= tied_to_ground_vec_i(1 downto 0);
    tile0_rxeqpole1_i                       <= tied_to_ground_vec_i(3 downto 0);
    tile0_rxbufreset1_i                     <= tied_to_ground_i;
    tile1_txdiffctrl0_i                     <= tied_to_ground_vec_i(2 downto 0);
--    tile1_txelecidle0_i                     <= tied_to_ground_i;
    tile1_txcomstart0_i                     <= tied_to_ground_i;
    tile1_txcomtype0_i                      <= tied_to_ground_i;
    tile1_rxcdrreset0_i                     <= tied_to_ground_i;
    tile1_rxeqmix0_i                        <= tied_to_ground_vec_i(1 downto 0);
    tile1_rxeqpole0_i                       <= tied_to_ground_vec_i(3 downto 0);
    tile1_rxbufreset0_i                     <= tied_to_ground_i;
    tile1_txdiffctrl1_i                     <= tied_to_ground_vec_i(2 downto 0);
--    tile1_txelecidle1_i                     <= tied_to_ground_i;
    tile1_txcomstart1_i                     <= tied_to_ground_i;
    tile1_txcomtype1_i                      <= tied_to_ground_i;
    tile1_rxcdrreset1_i                     <= tied_to_ground_i;
    tile1_rxeqmix1_i                        <= tied_to_ground_vec_i(1 downto 0);
    tile1_rxeqpole1_i                       <= tied_to_ground_vec_i(3 downto 0);
    tile1_rxbufreset1_i                     <= tied_to_ground_i;
    tile2_txdiffctrl0_i                     <= tied_to_ground_vec_i(2 downto 0);
--    tile2_txelecidle0_i                     <= tied_to_ground_i;
    tile2_txcomstart0_i                     <= tied_to_ground_i;
    tile2_txcomtype0_i                      <= tied_to_ground_i;
    tile2_rxcdrreset0_i                     <= tied_to_ground_i;
    tile2_rxeqmix0_i                        <= tied_to_ground_vec_i(1 downto 0);
    tile2_rxeqpole0_i                       <= tied_to_ground_vec_i(3 downto 0);
    tile2_rxbufreset0_i                     <= tied_to_ground_i;
    tile2_txdiffctrl1_i                     <= tied_to_ground_vec_i(2 downto 0);
--    tile2_txelecidle1_i                     <= tied_to_ground_i;
    tile2_txcomstart1_i                     <= tied_to_ground_i;
    tile2_txcomtype1_i                      <= tied_to_ground_i;
    tile2_rxcdrreset1_i                     <= tied_to_ground_i;
    tile2_rxeqmix1_i                        <= tied_to_ground_vec_i(1 downto 0);
    tile2_rxeqpole1_i                       <= tied_to_ground_vec_i(3 downto 0);
    tile2_rxbufreset1_i                     <= tied_to_ground_i;
    tile3_txdiffctrl0_i                     <= tied_to_ground_vec_i(2 downto 0);
--    tile3_txelecidle0_i                     <= tied_to_ground_i;
    tile3_txcomstart0_i                     <= tied_to_ground_i;
    tile3_txcomtype0_i                      <= tied_to_ground_i;
    tile3_rxcdrreset0_i                     <= tied_to_ground_i;
    tile3_rxeqmix0_i                        <= tied_to_ground_vec_i(1 downto 0);
    tile3_rxeqpole0_i                       <= tied_to_ground_vec_i(3 downto 0);
    tile3_rxbufreset0_i                     <= tied_to_ground_i;
    tile3_txdiffctrl1_i                     <= tied_to_ground_vec_i(2 downto 0);
--    tile3_txelecidle1_i                     <= tied_to_ground_i;
    tile3_txcomstart1_i                     <= tied_to_ground_i;
    tile3_txcomtype1_i                      <= tied_to_ground_i;
    tile3_rxcdrreset1_i                     <= tied_to_ground_i;
    tile3_rxeqmix1_i                        <= tied_to_ground_vec_i(1 downto 0);
    tile3_rxeqpole1_i                       <= tied_to_ground_vec_i(3 downto 0);
    tile3_rxbufreset1_i                     <= tied_to_ground_i;



end generate no_chipscope;


end RTL;

